/* autogenerated by Processing revision 1292 on 2023-06-06 */
import processing.core.*;
import processing.data.*;
import processing.event.*;
import processing.opengl.*;

import java.util.*;
import java.io.*;
import java.math.BigDecimal;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.io.File;
import java.io.IOException;
import java.awt.Component;
import java.util.List;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.StringSelection;
import java.awt.Toolkit;

import java.util.HashMap;
import java.util.ArrayList;
import java.io.File;
import java.io.BufferedReader;
import java.io.PrintWriter;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

public class RE_Decoder extends PApplet {

// \u30ed\u30fc\u30bf\u30ea\u30fc\u30a8\u30f3\u30b3\u30fc\u30c0\u30fc\u4fe1\u53f7\u306e\u30c7\u30b3\u30fc\u30c9
// Created by Tatsuya Shirai
// National Institute of Technology, Suzuka college
// Mechanical Department
//
// Ver. 1.0 : 2023.05.17
// Ver. 2.0 : 2023.05.23\uff08\u4f7f\u7528\u4e0d\u53ef\uff09/Crowbar\u5bfe\u5fdc
// Ver. 2.1, Ver. 2.2, Ver. 2.3 : 2023.05.24\uff1a\u7e70\u308a\u8fd4\u3057\u5b9f\u884c\uff0c\u79fb\u52d5\u5e73\u5747\u6a5f\u80fd\u8ffd\u52a0\uff0c\u4fe1\u53f7\u30c1\u30a7\u30c3\u30af\u6a5f\u80fd\u8ffd\u52a0
// Ver. 2.4.0 : 2023.05.24 CDS\uff08\u89d2\u901f\u5ea6\uff09\u8a08\u7b97\u5468\u8fba\u306e\u6a5f\u80fd\u5f37\u5316
// Ver. 2.5.0 : 2023.05.30 acc\uff08\u7d2f\u7a4d\u5024\uff09\u3092int\u304b\u3089float\u306b\u5909\u66f4
// Ver. 2.6.0 : 2023.06.02 \u89e3\u6790\u7d50\u679c\u306e\u629c\u304d\u53d6\u308a\u6a5f\u80fd\u306e\u8ffd\u52a0
// Ver. 2.7.0 : 2023.06.05 \u7d4c\u904e\u6642\u9593\u306e\u5217\u306e\u8ffd\u52a0\uff08\u51fa\u529b\u30c7\u30fc\u30bf\uff09

// \u30b0\u30ed\u30fc\u30d0\u30eb\u5909\u6570\uff08\u30b7\u30b9\u30c6\u30e0\u7ba1\u7406\uff09
boolean waitingProcess;  // \u30d5\u30a1\u30a4\u30eb\u30aa\u30fc\u30d7\u30f3\u5f8c\uff0c\u51e6\u7406\u306e\u7d42\u4e86\u3092\u5f85\u3064
File    selected;        // fileselector()\u3067\u958b\u304b\u308c\u305f\u30d5\u30a1\u30a4\u30eb\u306e\u30dd\u30a4\u30f3\u30bf\u30fc\uff08\u672a\u9078\u629e\u72b6\u614b\u306fnull\uff09

// \u5909\u6570\u521d\u671f\u5316
public void variableInitialize() {
  waitingProcess = false;
  selected       = null;
}

public void Setup()
{
  variableInitialize();
  
  // \u753b\u9762\u4f4d\u7f6e\u3092\u5909\u66f4\u3059\u308b
  surface.setLocation(Init_PosX, Init_PosY);

  programComment("\u30ed\u30fc\u30bf\u30ea\u30fc\u30a8\u30f3\u30b3\u30fc\u30c0\u30fc\u306e\u30c7\u30b3\u30fc\u30c9\uff08Ver." + Version + ")");
  crowbar.disableTextArea();
  parameter("\u4e2d\u5fc3\u5dee\u5206\u8fd1\u4f3c\uff08\u89d2\u901f\u5ea6\uff09\u306e\u524d\u5f8c\u30c7\u30fc\u30bf\u8ddd\u96e2\uff1an >= 1").setInt(CDS).label("CDS");
  parameter("\u30d1\u30eb\u30b9\u7d2f\u7a4d\u306e\u79fb\u52d5\u5e73\u5747\uff08\u524d\u5f8cn\u9805\uff1an=0\u306e\u6642\u306f\u79fb\u52d5\u5e73\u5747\u3057\u306a\u3044").setInt(MApulse).label("MApulse");
  parameter("\u89d2\u901f\u5ea6\u306e\u79fb\u52d5\u5e73\u5747\uff08\u524d\u5f8cn\u9805\uff1an=0\u306e\u6642\u306f\u79fb\u52d5\u5e73\u5747\u3057\u306a\u3044").setInt(MAav).label("MAav");
  parameter("\u8a08\u7b97\u7d50\u679c\u306e\u629c\u304d\u53d6\u308a\u9593\u9694\uff08*.txt\u30d5\u30a1\u30a4\u30eb\u3092\u51fa\u529b\uff0fn=0\u306e\u6642\u306f\u629c\u304d\u53d6\u3089\u306a\u3044").setInt(Extract).label("Extract");
  parameter("\u95be\u5024High").setFloat(SH_H).label("SH_H");
  parameter("\u95be\u5024Low"). setFloat(SH_L).label("SH_L");
  parameter("CW/CCW\u3092\u53cd\u8ee2\u3057\u307e\u3059\u304b\uff1f(0:false, 1:true)").setBoolean(REVERSE).label("REVERSE");
  parameter("\u30b5\u30f3\u30d7\u30ea\u30f3\u30b0\u9593\u9694[ms]").setFloat(DeltaT).label("DeltaT");
  parameter("\u30ed\u30fc\u30bf\u30ea\u30fc\u30a8\u30f3\u30b3\u30fc\u30c0\u30fc\u306e\u30ab\u30a6\u30f3\u30c8\u6570").setInt(EncCount).label("EncCount");
//drop_init();
}

public void Main()
{
  SH_H     = crowbar.getFloat("SH_H");
  SH_L     = crowbar.getFloat("SH_L");
  REVERSE  = crowbar.getBoolean("REVERSE");
  CDS      = crowbar.getInt("CDS");
  DeltaT   = crowbar.getFloat("DeltaT");
  EncCount = crowbar.getInt("EncCount");
  MApulse  = crowbar.getInt("MApulse");
  MAav     = crowbar.getInt("MAav");
  Extract  = crowbar.getInt("Extract");

  display_notice();
  // \u5165\u529b\u3055\u308c\u305f\u30d1\u30e9\u30e1\u30fc\u30bf\u30fc\u306e\u5024\u57df\u306e\u30c1\u30a7\u30c3\u30af
  if (CDS <= 0) {
    msg.setError("CDS\u306e\u5024\u306f1\u4ee5\u4e0a\u3092\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044\uff1a" + CDS);
  } else if (DeltaT <= 0.0f) {
    msg.setError("\u30b5\u30f3\u30d7\u30ea\u30f3\u30b0\u9593\u9694\u306e\u5024\u306f0\u3088\u308a\u5927\u304d\u306a\u5024\u3092\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044\uff1a" + DeltaT);
  } else if (EncCount <= 0) {
    msg.setError("\u30ed\u30fc\u30bf\u30ea\u30fc\u30a8\u30f3\u30b3\u30fc\u30c0\u30fc\u306e\u30ab\u30a6\u30f3\u30c8\u6570\u306f0\u3088\u308a\u5927\u304d\u306a\u5024\u3092\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044\uff1a" + EncCount);
  } else if ((MApulse < 0) || (MAav < 0)) {
    msg.setError("\u79fb\u52d5\u5e73\u5747\u306e\u9805\u6570\u306f0\u4ee5\u4e0a\u306e\u5024\u3092\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044\uff08\u30d1\u30eb\u30b9\u7d2f\u7a4d\uff1a\u89d2\u901f\u5ea6\uff09\uff1a\uff08" + MApulse + "\uff1a" + MAav + "\uff09");
  } else if (Extract < 0) {
    msg.setError("\u629c\u304d\u53d6\u308a\u9593\u9694\u6570\u306f0\u4ee5\u4e0a\u306e\u5024\u3092\u6307\u5b9a\u3057\u3066\u304f\u3060\u3055\u3044\uff1a" + Extract);
  } else {
    return;  // \u6b63\u5e38\u6642
  }
  crowbar.stop();  // \u7570\u5e38\u6642
}

// \u6ce8\u610f\u306e\u8868\u793a
public void display_notice() {
  int tx = 10, ty = 10;
  int dy = 32;

  crowbar.clrscr();
  crowbar.textColor(0xFF000000);
  writeln("\u3010\u30d5\u30a1\u30a4\u30eb\u5f62\u5f0f\u3011");
  writeln("\u30fb\u30ab\u30f3\u30de\u533a\u5207\u308a\u306eCSV\u30d5\u30a1\u30a4\u30eb");
  writeln("\u30fb\u898b\u51fa\u3057\u884c\u306a\u3057\uff08\uff11\u884c\u76ee\u304b\u3089\u30c7\u30fc\u30bf\uff09");
  writeln("\u30fb\u7a7a\u884c\u7121\u3057");
  writeln("\u30fb\u30c7\u30fc\u30bf\uff11,\u30c7\u30fc\u30bf\uff12");
  writeln("\u3000\uff08\uff13\u5217\u76ee\u4ee5\u964d\u306a\u3057\uff09");
  writeln("\u30fb\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u30ad\u30e3\u30f3\u30bb\u30eb or ESC or Q \u3067\u7d42\u4e86");
  writeln("\u30fb\u51fa\u529b\u30d5\u30a1\u30a4\u30eb\u306f\u7121\u6761\u4ef6\u3067\u4e0a\u66f8\u304d\u3055\u308c\u307e\u3059\u306e\u3067\u6ce8\u610f\u3057\u3066\u4e0b\u3055\u3044");
  writeln("\u30fb\u51fa\u529b\u30d5\u30a1\u30a4\u30eb\u304c\u5225\u306e\u30a2\u30d7\u30ea\u30b1\u30fc\u30b7\u30e7\u30f3\u3067\u958b\u304b\u308c\u3066\u3044\u308b\u3068\u7570\u5e38\u7d42\u4e86\u3057\u307e\u3059");
  writeln("\u30fb\u30c7\u30fc\u30bf\u5192\u982d\u3068\u672b\u5c3eCDS\u500b\u5206\u306e\u79fb\u52d5\u5e73\u5747(pps)\u306e\u30c7\u30fc\u30bf\u306f\u4e0d\u6b63\u78ba\u3067\u3059");
  // \u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u8868\u793a
  crowbar.textColor(0xFFFF0000);
  writeln("CSV\u30d5\u30a1\u30a4\u30eb\u3092\u9078\u629e\u3057\u3066\u4e0b\u3055\u3044");
  crowbar.textColor(0xFF000000);
  writeln("");
}

Message msg = new Message();

// \u8aad\u307f\u8fbc\u307f\u53ef\u80fd\u306a\u30c7\u30fc\u30bf\u5f62\u5f0f\uff08\u30ab\u30f3\u30de\u533a\u5207\u308a\u306eCSV\uff09
// \u4e00\u884c\u76ee\u304b\u3089\u30c7\u30fc\u30bf\u304c\u3042\u308b\uff08\u898b\u51fa\u3057\u306f\u524a\u9664\u3057\u3066\u4e0b\u3055\u3044\uff09
// \u4e00\u884c\u306b\u5c11\u306a\u304f\u3068\u3082\uff12\u30c7\u30fc\u30bf\u3042\u308b
// \u30c7\u30fc\u30bf\u306e\u7121\u3044\u884c\u3092\u767a\u898b\u3057\u305f\u3089\u30a8\u30e9\u30fc\u7d42\u4e86

// \u30d5\u30a1\u30a4\u30eb\u306e\u5165\u529b\u95a2\u4fc2
class ImportData {
  String fullpathname;  // \u8aad\u307f\u8fbc\u3080CSV\u30d5\u30a1\u30a4\u30eb
  String filename;      // \u30d5\u30a1\u30a4\u30eb\u540d\u306e\u90e8\u5206\uff08\u62e1\u5f35\u5b50\u542b\u3080\uff09
  
  float   [] Af;        // A\u76f8\u306e\u96fb\u5727\uff08\u52ff\u8ad6\uff0c0/1\u3067\u3082\u69cb\u308f\u306a\u3044\uff09
  float   [] Bf;        // B\u76f8\u306e\u96fb\u5727\uff08\u52ff\u8ad6\uff0c0/1\u3067\u3082\u69cb\u308f\u306a\u3044\uff09
  int        max_num;   // \u30c7\u30fc\u30bf\u6570
  String  [] lines;     // \u8aad\u307f\u8fbc\u3093\u3060\u30c6\u30ad\u30b9\u30c8\u30c7\u30fc\u30bf

  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf\u30fc
  ImportData() {
    max_num = 0;
  }

  // \u30d5\u30a1\u30a4\u30eb\u5f62\u5f0f\u304c\u6b63\u3057\u3044\u304b\u3069\u3046\u304b\u3092\u30c1\u30a7\u30c3\u30af
  public boolean validation() {
    CsvStrings csv;

    for (int i = 0; i < max_num; i++) {
      csv = new CsvStrings(lines[i]);
      // \uff12\u5217\u306e\u30c7\u30fc\u30bf\u304c\u6d6e\u52d5\u5c0f\u6570\u70b9\u6570\u304b\u30c1\u30a7\u30c3\u30af
      for (int j = 0; j < 2; j++) {
        if (! csv.next()) {
          msg.setError(i + "\u884c\u76ee\u306e\u30c7\u30fc\u30bf\u306e" + (j + 1) + "\u5217\u76ee\u306e\u30c7\u30fc\u30bf\u304c\u5b58\u5728\u3057\u307e\u305b\u3093");
          return false;
        }
        if (! csv.is_float()) {
          msg.setError(i + "\u884c\u76ee\u306e\u30c7\u30fc\u30bf\u306e" + (j + 1) + "\u5217\u76ee\u306e\u30c7\u30fc\u30bf\u304c\u6d6e\u52d5\u5c0f\u6570\u70b9\u6570\u3067\u306f\u3042\u308a\u307e\u305b\u3093");
          return false;
        }
      }
      if (csv.next()) {
        msg.setError(i + "\u884c\u76ee\u306e\u30c7\u30fc\u30bf\u306b\uff13\u5217\u76ee\u4ee5\u964d\u306e\u30c7\u30fc\u30bf\u304c\u5b58\u5728\u3057\u307e\u3059");
        return false;
      }
    }
    return true;
  }

  // \u9078\u629e\u3055\u308c\u305f\u30d5\u30a1\u30a4\u30eb\u3092\u8aad\u307f\u8fbc\u3080
  public boolean readData(File F) {
    CsvStrings csv;      // CSV\u30c7\u30fc\u30bf\u3092\u5206\u5272\u3059\u308b\u30af\u30e9\u30b9

    // \u30d5\u30a1\u30a4\u30eb\u306e\u60c5\u5831\u3092\u8aad\u307f\u51fa\u3059
    fullpathname = F.getAbsolutePath();
    filename     = F.getName();
    // \u30d5\u30a1\u30a4\u30eb\u3092\u8aad\u307f\u8fbc\u3080
    if ((lines = loadStrings(fullpathname)) == null) {
      msg.setError("\u6307\u5b9a\u3055\u308c\u305f\u30d5\u30a1\u30a4\u30eb\u306f\u8aad\u307f\u8fbc\u3081\u307e\u305b\u3093");
      return false;
    }
    msg.set(filename + " \u3092\u8aad\u307f\u8fbc\u307f\u307e\u3059");
    // \u4e00\u884c\u3082\u8aad\u307f\u8fbc\u3081\u306a\u304b\u3063\u305f
    if ((max_num = lines.length) == 0) {
      msg.setError("\u30c7\u30fc\u30bf\u304c\u3042\u308a\u307e\u305b\u3093\uff08\u30c6\u30ad\u30b9\u30c8\u30d5\u30a1\u30a4\u30eb\u3067\u306f\u306a\u3044\u306e\u304b\u3082\u77e5\u308c\u307e\u305b\u3093\uff09");
      return false;
    }
    // \u8aad\u307f\u8fbc\u3093\u3060\u30d5\u30a1\u30a4\u30eb\u306e\u30c1\u30a7\u30c3\u30af
    if (! validation()) {
      msg.setError("\u30d5\u30a1\u30a4\u30eb\u5f62\u5f0f\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093");
      return false;
    }
    msg.set(max_num + "\u884c\u306e\u30c7\u30fc\u30bf\u3092\u8aad\u307f\u8fbc\u307f\u307e\u3059");
    // \u751f\u30c7\u30fc\u30bf\u306e\u8aad\u307f\u8fbc\u307f\uff08\u96fb\u5727\uff09
    // \u30c7\u30fc\u30bf\u9818\u57df\u3092\u78ba\u4fdd
    Af  = new float[max_num];
    Bf  = new float[max_num];
    // \u30c7\u30fc\u30bf\u9818\u57df\u306b\u8aad\u307f\u8fbc\u3080
    for (int i = 0; i < max_num; i++) {
      csv = new CsvStrings(lines[i]);
      csv.next();
      Af[i] = csv.value;
      csv.next();
      Bf[i] = csv.value;
    }
    return true;
  }
}

ImportData im_data = new ImportData(); 



public String convert2SJIS(String str) {
  String ret="";
  try{
    byte[] bytes=str.getBytes("SJIS");
    ret = new String(bytes,"SHIFT_JIS");
  }catch(UnsupportedEncodingException e){
    //\u5909\u63db\u5931\u6557\u6642\u306e\u51e6\u7406\u9069\u5b9c
    println("\u6587\u5b57\u30b3\u30fc\u30c9\u5909\u63db\u30a8\u30e9\u30fc");
  }
  return ret;
}



// \u30d5\u30a1\u30a4\u30eb\u51fa\u529b\u95a2\u4fc2
class ExportFile {
  String      dest_filename;
  PrintWriter output;
  boolean exporting;
  
  ExportFile() {
    dest_filename = "";
    output        = null;
    exporting     = false;
  }
  // \u30d5\u30a1\u30a4\u30eb\u3078\u51fa\u529b
  // ext = true\u306e\u6642\u3001\u629c\u304d\u53d6\u308a\u51fa\u529b
  public boolean export_data(boolean ext) {
    exporting = true;  // \u4f8b\u5916\u51e6\u7406\u7528\u30d5\u30e9\u30b0
    dest_filename = im_data.fullpathname + ".csv";  // \u62e1\u5f35\u5b50\u306e\u5206\u89e3\u306f\u9762\u5012\u304f\u3055\u3044\u306e\u3067\uff0c\u5358\u7d14\u306b\u62e1\u5f35\u5b50\u3092\u8ffd\u52a0\u3059\u308b
    if (ext && (Extract > 0)) dest_filename += ".txt";       // \u629c\u304d\u53d6\u308a\u51fa\u529b\u6642\u306f\u66f4\u306b".txt"\u3092\u8ffd\u52a0\u3059\u308b
    output = createWriter(dest_filename);
    exporting = false;
    if (output == null) {
      msg.setError("\u30d5\u30a1\u30a4\u30eb\u3078\u306e\u4fdd\u5b58\u306b\u5931\u6557\uff1a" + dest_filename);
      return false;
    }
    String headerString, dataString;
    // \u30d5\u30a1\u30a4\u30eb\u30d8\u30c3\u30c0\u30fc\u306e\u51fa\u529b
    headerString  = im_data.filename + ",";
    headerString += year() + "/" + nf(month(),2) + "/"  + nf(day(), 2) + "," + nf(hour(), 2) + ":" + nf(minute(), 2) + ":" + nf(second(), 2);
    output.println(headerString);
    // \u30d1\u30e9\u30e1\u30fc\u30bf\u30fc\u306e\u51fa\u529b
    headerString = "SH_H,SH_L,REVERS,CDS,DeltaT,EncCount,MApulse,MAav";
    output.println(headerString);
    headerString = SH_H + "," + SH_L + "," + REVERSE + "," + CDS + "," + DeltaT + "," + EncCount + "," + MApulse + "," + MAav;
    output.println(headerString);
    // \u898b\u51fa\u3057\u884c\u306e\u51fa\u529b
    headerString = "No,Time, A-Phase(raw),B-Phase(raw),A-Phase(01),B-Phase(01),CW/CCW,Accumulation,Round,Differential(pps),AngularVelocity(rpm),AngularVelocity(rad/s)";
    headerString = convert2SJIS(headerString);
    output.println(headerString);

    // \u30c7\u30fc\u30bf\u672c\u4f53\u306e\u51fa\u529b
    int cnt  = 0;  // \u901a\u3057\u306e\u30ab\u30a6\u30f3\u30bf\u30fc
    int skip = 0;  // Extract > 0\uff08\u629c\u304d\u53d6\u308a\u6709\u52b9\uff09\u306e\u6642\u306e\u8aad\u307f\u98db\u3070\u3057\u7528\u30ab\u30a6\u30f3\u30bf\u30fc
    // \u6642\u9593\u306e\u8a08\u7b97\u306b\u8aa4\u5dee\u304c\u751f\u3058\u308b\u305f\u3081
    BigDecimal bd1 = new BigDecimal(nf(DeltaT));
    BigDecimal bd2 = new BigDecimal("1000");
    BigDecimal bd3 = bd1.divide(bd2);
    for (cnt = 0; cnt < data.max_num; cnt++) {
      // \u629c\u304d\u53d6\u308a\u51fa\u529b\u6642\u306e\u30b9\u30ad\u30c3\u30d7\u52d5\u4f5c
      if (ext && (Extract > 0)) {
        if (++skip < Extract) {
          continue;
        }
        skip = 0;  // \u51fa\u529b\u6642\uff1a\u30ab\u30a6\u30f3\u30bf\u30fc\u3092\u30bc\u30ed\u306b\u623b\u3059
      }
      dataString  = (cnt + 1) + ",";                 // Ver.2.6.0\u304b\u3089\u8ffd\u52a0
      bd1 = bd3.multiply(new BigDecimal(nf(cnt)));
      dataString += nf(bd1.floatValue()) + ",";      // Ver.2.7.0\u304b\u3089\u8ffd\u52a0
      dataString += nf(data.Af[cnt]) + "," + nf(data.Bf[cnt]) + ",";
      dataString += (data.A[cnt] ? "1" : "0") + "," + (data.B[cnt] ? "1" : "0") + ",";
      dataString += data.enc[cnt] + ",";
      dataString += data.acc[cnt] + ",";
      dataString += data.acc[cnt] / (EncCount * 4.0f) + ",";  // Ver.2.7.1\u304b\u3089\u8ffd\u52a0
      dataString += data.pps[cnt] + "," + data.rpm[cnt] + "," + data.radps[cnt];
      output.println(dataString);
    }
    output.flush();
    output.close();
    if (! ext) msg.set("\u89e3\u6790\u7d50\u679c\u3092" + dest_filename + "\u306b\u4fdd\u5b58\u3057\u307e\u3057\u305f");
      else     msg.set("\u629c\u304d\u53d6\u308a\u3092" + dest_filename + "\u306b\u4fdd\u5b58\u3057\u307e\u3057\u305f");
    return true;
  }
}

ExportFile ex_file = new ExportFile();

//// \u30d5\u30a1\u30a4\u30eb\u30fb\u30d5\u30a9\u30eb\u30c0\u30fc\u9078\u629e\u30c0\u30a4\u30a2\u30ed\u30b0\u30dc\u30c3\u30af\u30b9\u95a2\u4fc2\u306e\u95a2\u6570
// \u30d5\u30a1\u30a4\u30eb\u9078\u629e\u30c0\u30a4\u30a2\u30ed\u30b0\u30dc\u30c3\u30af\u30b9\u306e\u547c\u3073\u51fa\u3057
public void open_fileselector()
{
  selectInput("Select CSV file", "fileSelected");
}
// \u30d5\u30a1\u30a4\u30eb\u9078\u629e\u5f8c\u306e\u51e6\u7406
public void fileSelected(File selection) 
{
  selected = selection;
  if (selected == null) {
    msg.set("\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u304c\u30ad\u30e3\u30f3\u30bb\u30eb\u3055\u308c\u307e\u3057\u305f");
    waitingProcess = false;
    crowbar.stop();
    return;
  }
}
////////////////////////////////////////////////////////////////
// Processing\u306b\u3088\u308b\u53e4\u5178\u7684\u306a\u5bfe\u8a71\u5f0f\u30d7\u30ed\u30b0\u30e9\u30e0\u958b\u767a\u7528\u30d5\u30ec\u30fc\u30e0\u30ef\u30fc\u30af
//               Crowbar\uff08\u30af\u30ed\u30a6\u30d0\u30fc\uff09
//    with \u9ad8\u6a5f\u80fd\u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30b9\u30e9\u30a4\u30d6\u30e9\u30eaTomahawk\uff08\u30c8\u30de\u30db\u30fc\u30af\uff09
//                                  \u767d\u4e95\u3000\u9054\u4e5f\uff08Tatsuya Shirai)
//                       shirai\uff20mech.suzuka-ct.ac.jp, @tatsuva
//                                       2012/04/20    Ver. 0.9
//                                       2012/05/14    Ver. 1.0
//                                       2012/05/15    Ver. 1.1
//                                       2012/05/24    Ver. 1.2
//                                       2012/05/26    Ver. 1.3
//                          2012/05/27 - 2012/06/01    Ver. 2.0
//                          2012/06/04 - 2012/06/04    Ver. 2.1
//                          2012/06/05 - 2012/06/21    Ver. 3.0
//                          2012/06/21 - 2012/07/02    Ver. 3.1
//                          2012/07/02 - 2012/07/05    Ver. 3.2
//                          2012/07/05 - 2012/07/11    Ver. 3.3
//                          2012/07/11 - 2012/07/16    Ver. 3.4
//                          2012/07/16 - 2012/08/02    Ver. 3.5
//                          2012/08/02 - 2012/10/10    Ver. 4.0
//                          2012/10/10 - 2018/05/08    Ver. 5.0 (P3\u5bfe\u5fdc\uff09
////////////////////////////////////////////////////////////////
// \u6700\u65b0\u7248\u306e\u516c\u958b\u306f\u4ee5\u4e0b\u306eSourceForge.JP\u306b\u3066\u884c\u3063\u3066\u3044\u307e\u3059\uff0e
// http://sourceforge.jp/projects/crowbar/
// \u30c9\u30ad\u30e5\u30e1\u30f3\u30c8\u306f\u4ee5\u4e0b\u306eMoodle\u30b5\u30a4\u30c8\u4e0a\u306eWiki\u306b\u3066\u516c\u958b\u3057\u3066\u3044\u307e\u3059\uff0e
// http://www.suzuka-ct.ac.jp/mech/moodle/mod/wiki/view.php?id=1739&page=Crowbar
// \u8cea\u554f\u306a\u3069\u306f\u4e0a\u8a18SourceForge.JP\u3042\u308b\u3044\u306fmechMoodle\u4e0a\u306e\u30d5\u30a9\u30fc\u30e9\u30e0\u306b
// \u6295\u7a3f\u3059\u308b\u304b\uff0c\u3042\u308b\u3044\u306fTwitter\uff0c\u307e\u305f\u306f\u30e1\u30fc\u30eb\u3067\u304a\u554f\u3044\u5408\u308f\u305b\u4e0b\u3055\u3044\uff0e

// \u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30b9\u30e9\u30a4\u30d6\u30e9\u30eaTomahawk\u3092\u4f7f\u7528\u3057\u306a\u3044\u5834\u5408\u306f\uff0c\u30bf\u30d6TomahawkClass\u3092Delete\u3057\u305f\u4e0a\u3067\uff0c\u4ee5\u4e0b\u306e\u30b3\u30e1\u30f3\u30c8\u30a2\u30a6\u30c8\u3055\u308c\u305f\u4e00\u884c\u306e\u30b3\u30fc\u30c9\u306e\u884c\u982d\u306e\u30b3\u30e1\u30f3\u30c8\u8a18\u53f7\uff08//\uff09\u3092\u5916\u3059\uff0e
// \u3055\u3089\u306bvoid initCrowbar()\u4e2d\u306ecrow = startCrowbar.generate(50, 30, 2);\u304c\u7b2c3\u5f15\u6570\u3092\u6301\u3064\u5834\u5408\u306f\u524a\u9664\u3059\u308b\u3053\u3068\uff0e\u4f8b\uff09 startCrowbar.generate(50, 30);
// class tomahawkClass { tomahawkClass(int mode) {} protected int tomahawkMode = 0; void backupViewports() {} void restoreViewports() {} void refreshView() {} void resetView(boolean flag) {} }

// \u30c7\u30d0\u30c3\u30b0\u7528\uff1aP2D\u3068jAVA2D\u306e\u5207\u308a\u66ff\u3048
boolean _JAVA2D = true;

// ------------------------------------------------------------------------------------------
// \u30e6\u30fc\u30b6\u304c\u81ea\u7531\u306a\u30a4\u30f3\u30b9\u30bf\u30f3\u30b9\u540d\u3092\u4f7f\u3048\u308b\u3088\u3046\u306b\uff0c
// crowbarClass.pde\u3068tomahawkClass.pde\u3067\u4f7f\u7528\u3059\u308b\u30a4\u30f3\u30b9\u30bf\u30f3\u30b9crowbar\u306e\u30b7\u30e3\u30ed\u30a6\u30b3\u30d4\u30fc\u3092\u63d0\u4f9b\u3059\u308b
// ------------------------------------------------------------------------------------------
crowbarClass crowbar;
class generateCrowbar {
  // Tomahawk\u3092\u4f7f\u7528\u3057\u306a\u3044\u5834\u5408
  public crowbarClass generate(int x, int y) {
    return generate(x, y, 0);
  }
  // Tomahawk\u3092\u4f7f\u7528\u3059\u308b\u5834\u5408
  public crowbarClass generate(int x, int y, int mode) {
    crowbar = new crowbarClass(x, y, mode);
    return crowbar;
  }
}
generateCrowbar startCrowbar = new generateCrowbar();

// \u30c7\u30d5\u30a9\u30eb\u30c8\u306e\u30c6\u30ad\u30b9\u30c8\u5c5e\u6027
protected int _FONTSIZE      = 14;
protected int _TEXTCOLOR     = 0xFF000002;  // PGraphics\u306e\u4ed5\u69d8\u4e0a\u306e\u554f\u984c\u70b9\u306e\u56de\u907f (#000000\u3084#000001\u3067\u306ftext()\u3067\u8cbc\u3063\u305f\u969b\u306b\u8272\u304c#000000\u306b\u306a\u3063\u3066\u80cc\u666f\u3068\u533a\u5225\u304c\u3064\u304b\u306a\u3044\uff09
protected int _BGCOLOR       = 0xFFFFFFEE;
protected int _SYSTEMCOLOR1  = 0xFF000002;  // \u30b7\u30b9\u30c6\u30e0\u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u6587\u5b57\u8272\uff08\u30ad\u30fc\u5165\u529b\u306a\u3069\uff09
protected int _SYSTEMCOLOR2  = 0xFFF04040;  // \u30b7\u30b9\u30c6\u30e0\u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u6587\u5b57\u8272\uff08\u898b\u51fa\u3057\uff09
protected int _SYSTEMCOLOR3  = 0xFF208020;  // \u30b7\u30b9\u30c6\u30e0\u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u6587\u5b57\u8272\uff08\u5165\u529b\u5f85\u3061\u7528\uff09
// \u30c7\u30d5\u30a9\u30eb\u30c8\u306e\u30b9\u30af\u30ea\u30fc\u30f3\u5c5e\u6027\uff08\u3044\u307e\u306e\u3068\u3053\u308d\u5909\u66f4\u4e88\u5b9a\u306a\u3057\uff09
protected float _HSTEP       = 1.2f;  // \u6587\u5b57\u9001\u308a
protected float _VSTEP       = 1.4f;  // \u884c\u9001\u308a
// \u30bf\u30d6\u8868\u793a\u306e\u521d\u671f\u5024
protected float _TABSIZE     = 10.0f;
// \u30d5\u30a9\u30f3\u30c8\u540d
// protected String _FONTNAME = "MS Gothic";
// protected String _FONTNAME = "ipam.ttf";  // \u30b9\u30b1\u30c3\u30c1\u306edata\u30d5\u30a9\u30eb\u30c0\u306bttf\u30d5\u30a9\u30f3\u30c8\u3092\u30b3\u30d4\u30fc\u3059\u308c\u3070\u4f7f\u7528\u53ef\u80fd
// \u4ee5\u4e0b\u306e\u30b3\u30fc\u30c9\u3067\u30d5\u30a9\u30f3\u30c8\u30d5\u30a1\u30a4\u30eb\u306e\u30ea\u30b9\u30c8\u3092\u5f97\u3089\u308c\u308b\uff08\u30a4\u30f3\u30b9\u30c8\u30fc\u30eb\u3055\u308c\u3066\u3044\u308b\u30d5\u30a9\u30f3\u30c8\u306e\u307f\uff0edata\u30d5\u30a9\u30eb\u30c0\u5185\u306f\u9664\u5916\uff09
// String[] fontList = PFont.list();
// println(fontList);
protected String _FONTNAME = "MS Gothic";
// \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u30c7\u30d5\u30a9\u30eb\u30c8\u306e\u30d5\u30a1\u30a4\u30eb\u540d
protected String _DEFAULT_LOG_FILENAME = "default.txt";

// \u30c7\u30d0\u30c3\u30b0\u7528
protected boolean _DEBUGFLAG = false;

///////////////////////////
// \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u306e\u30af\u30e9\u30b9
// \uff08\u30b9\u30af\u30ed\u30fc\u30eb\u5bfe\u5fdc\u7528\uff09
///////////////////////////
// \u30e1\u30e2\u30ea\u306e\u78ba\u4fdd\u306f\u5358\u4e00\u65b9\u5411\u30ea\u30b9\u30c8\u69cb\u9020\u3068\u3059\u308b\uff0e
// \u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u3057\u3066\u6298\u308a\u8fd4\u3059\u5206\u306f\u6b21\u306e\u30e9\u30a4\u30f3\u30c7\u30fc\u30bf\u306b\u5165\u308c\u308b\uff0e\u5f8c\u65e5\uff0c\u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\u306e\u30b5\u30a4\u30ba\u5909\u66f4\u306b
// \u5bfe\u5fdc\u3059\u308b\u969b\u306b\u306f\uff0c\u4e00\u65e6\uff0c\u6539\u884c\u3055\u308c\u305f\u30e9\u30a4\u30f3\u30c7\u30fc\u30bf\u3092\u7e4b\u3052\u76f4\u3057\u3066\uff0c\u305d\u308c\u304b\u3089\u307e\u305f\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u3057\u76f4\u3059\uff0e
// \u305d\u306e\u969b\u306b\u884c\u6570\u304c\u6e1b\u308b\u304b\u3082\u77e5\u308c\u306a\u3044\uff0e\u4e0d\u8981\u306b\u306a\u3063\u305f\u30e9\u30a4\u30f3\u30c7\u30fc\u30bf\u306f\u30ea\u30b9\u30c8\u69cb\u9020\u304b\u3089\u5207\u308a\u96e2\u3057\uff0cGC\u306b\u958b\u653e\u3055\u305b\u308b\uff0e
// Ver.1.04.00\u3067\u6587\u5b57\u8272\u306e\u5909\u66f4\u306b\u5bfe\u5fdc\u3059\u308b\u305f\u3081\u306b\uff0cwrite()\u3067\u51fa\u529b\u3055\u308c\u305f\u5358\u4f4d\u3067\u4e00\u3064\u306eclass\u3068\u3057\u3066\u6587\u5b57\u60c5\u5831\u3068\u3057\u305f\uff0e
// \u4e00\u5fdc\uff0c\u5c06\u6765\u7684\u306a\u62e1\u5f35\u3092\u8003\u616e\u306b\u5165\u308c\u3066\u80cc\u666f\u8272\u3082\u8003\u616e\u3059\u308b\uff0eclass\u3068\u3057\u3066\u306f\u4ed6\u306e\u62e1\u5f35\u5c5e\u6027\u306e\u3082\u5bfe\u5fdc\u3067\u304d\u308b\u3088\u3046\u306b\u8003\u3048\u305f\u4e0a\u3067\u5b9f\u88c5\u3059\u308b\uff0e

// \u30c6\u30ad\u30b9\u30c8\u60c5\u5831\u306e\u5c5e\u6027
class textAttrClass {
  protected int  textColor;  // \u6587\u5b57\u8272        \uff1a\u5909\u66f4\u53ef
  protected int  bgColor;    // \u80cc\u666f\u8272        \uff1a\u57fa\u672c\u7684\u306b\u5909\u3048\u306a\u3044
  protected int  fontSize;   // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba\uff1a\u57fa\u672c\u7684\u306b\u5909\u3048\u306a\u3044
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  textAttrClass () {
    init();
  }
  // \u30b7\u30b9\u30c6\u30e0\u30c7\u30d5\u30a9\u30eb\u30c8\u5024\u3067\u521d\u671f\u5316
  public void init() {
    fontSize   = _FONTSIZE;
    textColor  = _TEXTCOLOR;
    bgColor    = _BGCOLOR;
  }
  // \u30c6\u30ad\u30b9\u30c8\u5c5e\u6027\u306e\u8907\u88fd
  public void clone(textAttrClass attr) {
    fontSize  = attr.fontSize;    // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba 
    textColor = attr.textColor;   // \u6587\u5b57\u8272
    bgColor   = attr.bgColor;     // \u80cc\u666f\u8272
  }
  // \u5f15\u6570\u3067\u4e0e\u3048\u3089\u308c\u305f\u30c6\u30ad\u30b9\u30c8\u5c5e\u6027\u3068\u73fe\u30c6\u30ad\u30b9\u30c8\u5c5e\u6027\u306e\u6bd4\u8f03\uff08\u7b49\u3057\u3051\u308c\u3070true\u3092\u8fd4\u3059\uff09
  public boolean checkTextAttr(textAttrClass attr) {
    if (attr.fontSize   != fontSize)  return false;
    if (attr.textColor  != textColor) return false;
    if (attr.bgColor    != bgColor)   return false;
    return true;
  }
}

// \u30c6\u30ad\u30b9\u30c8\u306e\u6700\u5c0f\u5358\u4f4d\uff08\u30bb\u30f3\u30c6\u30f3\u30b9\uff09\uff1awrite()\u3059\u308b\u5ea6\u306b\u30d0\u30c3\u30d5\u30a1\u306b\u8ffd\u52a0\u3055\u308c\u308b
class sentenceClass {
  protected String sentence;   // \u540c\u3058\u6587\u5b57\u5c5e\u6027\u306e\u4e00\u9023\u306a\u308a\u306e\u6587\u5b57\u5217
  textAttrClass    attr;       // \u6587\u5b57\u5c5e\u6027
  sentenceClass    next;       // \u6b21\u306e\u30bb\u30f3\u30c6\u30f3\u30b9\u3078\u306e\u30dd\u30a4\u30f3\u30bf
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  sentenceClass(String str, textAttrClass attribute) {
    sentence = str;
    attr     = new textAttrClass();
    next     = null;
    attr.clone(attribute);
  }
  // \u3053\u306e\u30bb\u30f3\u30c6\u30f3\u30b9\u306e\u307f\u3092\u521d\u671f\u5316\uff08\u30ea\u30b9\u30c8\u69cb\u9020\u3092\u4e0b\u6d41\u306b\u4e0b\u3089\u306a\u3044\uff09
  public void clearSentence(textAttrClass attribute) {
    sentence = "";
    attr.clone(attribute);
    next     = null;
  }
  // \u30bb\u30f3\u30c6\u30f3\u30b9\u306e\u30ea\u30b9\u30c8\u6700\u5f8c\u90e8\u3078\u306e\u8ffd\u52a0
  public void addSentence(String str, textAttrClass attr) {
    if (next == null) next = new sentenceClass(str, attr);  // \u7d42\u4e86\u6761\u4ef6
      else            next.addSentence(str, attr);          // \u518d\u5e30\u547c\u3073\u51fa\u3057
  }
  // \u6587\u5b57\u5c5e\u6027\u3092\u8003\u616e\u306b\u5165\u308c\u3066\u540c\u3058\u5c5e\u6027\u306e\u5834\u5408\u306f\u6587\u5b57\u5217\u3092\u30de\u30fc\u30b8\u3059\u308b
  // \u518d\u5e30\u547c\u3073\u51fa\u3057\u3067\u306f\u306a\u3044\u304c\uff0c\u30ea\u30b9\u30c8\u672b\u5c3e\u307e\u3067\u300c\u3053\u308c\u3068\u305d\u306e\u6b21\u3092\u6bd4\u8f03\u3057\u3066\u3053\u308c\u306b\u6b21\u3092\u30de\u30fc\u30b8\u300d\u3092\u7e70\u308a\u8fd4\u3059\uff0e
  public void merge() {
    if (next == null) return;  // \uff11\u500b\u3057\u304b\u7121\u3044\uff08\u3042\u308b\u3044\u306f\u7d42\u7aef\u3092\u547c\u3070\u308c\u305f\uff09\u306a\u3089\u3070\u30de\u30fc\u30b8\u306f\u4e0d\u8981\uff0e\u7279\u306b\u7a7a\u884c\u306e\u3053\u3068\u3092\u8003\u616e\u306b\u3044\u308c\u305f\u7279\u4f8b
    sentenceClass current = this;
    while (current.next != null) {
      if (current.attr.checkTextAttr(current.next.attr) || (current.sentence.length() == 0)) {
        // \u3082\u3057\u3053\u308c\u3068\u6b21\u306e\u30bb\u30f3\u30c6\u30f3\u30b9\u306e\u30c6\u30ad\u30b9\u30c8\u5c5e\u6027\u304c\u7b49\u3057\u3044\u306a\u3089\u3070\u6b21\u306e\u6587\u5b57\u5217\u3092\u3053\u308c\u306e\u6587\u5b57\u5217\u306b\u8ffd\u52a0
        current.sentence += current.next.sentence;
        // \u6587\u5b57\u5217\u6570\u30bc\u30ed\u306e\u30bb\u30f3\u30c6\u30f3\u30b9\u3092\u5f8c\u308d\u306e\u6587\u5b57\u5217\u3068\u5408\u4f53\u3055\u305b\u308b\u305f\u3081\u306b\u5c5e\u6027\u3092\u5f8c\u308d\u304b\u3089\u30b3\u30d4\u30fc
        current.attr.clone(current.next.attr);
        // \u6b21\u306e\u30bb\u30f3\u30c6\u30f3\u30b9\u3092\u7121\u8996\u3057\u3066\u305d\u306e\u6b21\u3068\u7e4b\u3052\u76f4\u3059\uff08current.netxt.next\u306fnull\u304b\u3082\u77e5\u308c\u306a\u3044\u304c\uff0c\u305d\u308c\u306f\u6b21\u306ewhile\u306e\u7d42\u4e86\u6761\u4ef6\u3067\u30c1\u30a7\u30c3\u30af\u3055\u308c\u308b\uff09
        current.next = current.next.next;
        // \u30bf\u30fc\u30b2\u30c3\u30c8\u306f\u6b21\u3078\u79fb\u308b\u306e\u3067\u306f\u306a\u304f\uff0c\u3053\u308c\u306e\u307e\u307e\u3067\u3042\u308b\u306e\u304c\u30df\u30bd
      } else {
        // \u300c\u3053\u308c\u3068\u6b21\u304c\u7570\u306a\u308b\u300d\u306a\u3089\u3070\u30bf\u30fc\u30b2\u30c3\u30c8\u3092\u6b21\u306b\u79fb\u3059
        current = current.next;
      }
    }
  }
  // \u30bb\u30f3\u30c6\u30f3\u30b9\u3092\u6307\u5b9a\u3055\u308c\u305f\u9577\u3055\u3067\u5206\u5272\u3057\uff0c\u6b8b\u308a\u3092\u65b0\u305f\u306b\u78ba\u4fdd\u3057\u305f\u9818\u57df\u306b\u30b3\u30d4\u30fc\u3059\u308b
  // \u5206\u5272\u306e\u5fc5\u8981\u304c\u7121\u304b\u3063\u305f\u5834\u5408\u306f\u6587\u5b57\u5217\u6570\uff10\u306e\u30bb\u30f3\u30c6\u30f3\u30b9\u3092\u8fd4\u3059\uff08\u6271\u3044\u306f\u4e0a\u6d41\u306b\u4efb\u305b\u308b\uff09
  public sentenceClass split(int len) {
    sentenceClass newone = new sentenceClass("", attr);  // \u30c6\u30ad\u30b9\u30c8\u5c5e\u6027\u30af\u30ed\u30fc\u30f3\u3067\u65b0\u898f\u306b\u4f5c\u6210
    // \u6587\u5b57\u5217\u306e\u5206\u5272\u30b3\u30d4\u30fc
    newone.sentence = sentence.substring(len);
    sentence        = sentence.substring(0, len);
    // \u30ea\u30b9\u30c8\u3092\u633f\u5165
    newone.next = next;
    next        = newone;
    return newone;
  }
  // \u6587\u5b57\u5217\u306e\u9577\u3055\uff08\u3053\u306e\u30ea\u30b9\u30c8\u304b\u3089\u5148\u306e\u6587\u5b57\u5217\u306e\u9577\u3055\u3092\u5408\u7b97\uff09
  public int length() {
    if (next == null) return sentence.length();                  // \u7d42\u4e86\u6761\u4ef6
      else            return next.length() + sentence.length();  // \u518d\u5e30\u547c\u3073\u51fa\u3057
  }
   // \u5c5e\u6027\u306a\u3057\u306e\u6587\u5b57\u5217\u3068\u3057\u3066\u8fd4\u3059\uff08\u3053\u306e\u30ea\u30b9\u30c8\u304b\u3089\u5148\u306e\u5168\u3066\uff09
   public String getPlainText() {
   if (next == null) return sentence;
     else            return sentence + next.getPlainText();
   }
}

// \u4e00\u884c\u5206\u306e\u30af\u30e9\u30b9
class lineClass {
  protected int     no;      // \u884c\u756a\u53f7\uff0e\uff10\u304b\u3089\u59cb\u307e\u308b\uff08\u30c7\u30d0\u30c3\u30b0\u7528\uff09
  sentenceClass     line;    // \u30bb\u30f3\u30c6\u30f3\u30b9\u306e\u30ea\u30b9\u30c8\u69cb\u9020\u306e\u5148\u982d\uff08\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u306e\u30c7\u30fc\u30bf\u306f\u3053\u3053\u306b\uff09
  protected boolean flag;    // \u5165\u529b\u6e08\u307f\u304b\uff1f\uff08\u7a7a\u884c\u3092\u8003\u616e\uff0eline\u306e\u6587\u5b57\u6570\u3067\u306f\u5224\u65ad\u3067\u304d\u306a\u3044\u305f\u3081\uff0e\u3055\u3089\u306bGC\u3092\u4f7f\u308f\u305a\u30ea\u30b9\u30c8\u3092\u518d\u5229\u7528\u3059\u308b\u305f\u3081\u306b\u3082\uff09
  protected boolean overlap; // \u524d\u306e\u884c\u306e\u6298\u308a\u8fd4\u3057\u304b\uff08\u5f8c\u65e5\uff0c\u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\u306e\u30b5\u30a4\u30ba\u5909\u66f4\u306b\u5bfe\u5fdc\u3059\u308b\u305f\u3081\u306b\uff09
  lineClass         next;    // \u6b21\u306e\u884c\u306e\u4f4d\u7f6e
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  lineClass() { clear(); }
  // \u30af\u30ea\u30a2
  public void clear() {
    no         = 0;
    line       = null;
    flag       = false;
    overlap    = false;
    next       = null;
  }
  // \u884c\u5358\u4f4d\u306e\u30c7\u30fc\u30bf\u306e\u30bb\u30c3\u30c8\uff08\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u51e6\u7406\u306f\u4e0a\u6d41\u3067\u884c\u3046\uff0e\u3053\u306e\u884c\u304c\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u3059\u308b\u884c\u306a\u3089\u3070over\u3092true\u306b\u30bb\u30c3\u30c8\u3057\u3066\u30b3\u30fc\u30eb\uff09
  public void set(sentenceClass data, boolean over) {
    // \u73fe\u30ea\u30b9\u30c8\u306b\u30c7\u30fc\u30bf\u3092\u30bb\u30c3\u30c8
    // no \u306f\u521d\u671f\u5316\u6642\u3042\u308b\u3044\u306f\u4e00\u3064\u524d\u306e\u30ea\u30b9\u30c8\u306b\u30c7\u30fc\u30bf\u3092\u30bb\u30c3\u30c8\u3055\u308c\u305f\u6642\u306b\u8a2d\u5b9a\u6e08\u307f
    line    = data;    // buff\u3092\u305d\u306e\u307e\u307e\u4f7f\u3046\uff0e\u3057\u305f\u304c\u3063\u3066buff\u306fset()\u3057\u305f\u5f8c\u306b\u518d\u78ba\u4fdd\u304c\u5fc5\u8981
    flag    = true;
    overlap = over;
    if (next == null) next = new lineClass();  // \u6b21\u306e\u884c\u30c7\u30fc\u30bf\u306e\u78ba\u4fdd\uff08\u305f\u3060\u3057\uff0c\u30ea\u30b9\u30c8\u69cb\u9020\u3092\u518d\u5229\u7528\u3059\u308b\u5834\u5408\u306f\u78ba\u4fdd\u3057\u306a\u3044\uff09
    next.no = no + 1;  // \u81ea\u52d5\u52a0\u7b97
  }
  // \u30c6\u30ad\u30b9\u30c8\u5c5e\u6027\u3092\u8003\u616e\u306b\u5165\u308c\u3066\u540c\u3058\u30c6\u30ad\u30b9\u30c8\u5c5e\u6027\u3092\u6301\u3064\u96a3\u63a5\u3057\u305f\u30ea\u30b9\u30c8\u3092\u30de\u30fc\u30b8\u3059\u308b\u51e6\u7406\u3092\u884c\u5358\u4f4d\u3067\u5b9f\u884c\u3059\u308b
  public void merge() { line.merge(); }
}

///////////////////////////////
// \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u672c\u4f53\u306e\u30af\u30e9\u30b9
class textbufferClass {
  private int           cwidth;            // \u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\u306e\u30c6\u30ad\u30b9\u30c8\u306e\u4e00\u884c\u306e\u6587\u5b57\u6570
  private screenClass   screenSetting;     // \u753b\u9762\u8a2d\u5b9a
  int                   fontSize;          // \u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\u306e\u30c6\u30ad\u30b9\u30c8\u306e\u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba
  private lineClass     topLine;           // \u4e00\u756a\u6700\u521d\u306e\u884c\u30c7\u30fc\u30bf
  lineClass             currentWriteLine;  // \u73fe\u5728\u306e\u66f8\u304d\u8fbc\u307f\u53ef\u80fd\u306a\u884c\u30c7\u30fc\u30bf
  textAttrClass         currentAttr;       // \u73fe\u5728\u306e\u6587\u5b57\u5c5e\u6027\uff08\u4e3b\u306b\u66f8\u304d\u8fbc\u307f\u7528\uff09
  protected int         totalLines;        // \u51fa\u529b\u6e08\u307f\u306e\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u306e\u884c\u6570\u3092\u5358\u7d14\u306b\u8fd4\u3059\uff08\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u306f\u8003\u616e\u3057\u306a\u3044\u2192\u8003\u616e\u3059\u308b\uff09
  protected int         readingLine;       // \u73fe\u5728\u306e\u8aad\u307f\u51fa\u3057\u3055\u308c\u3066\u3044\u308b\u884c\u756a\u53f7
  private sentenceClass buff;              // \u73fe\u5728\u306e\u672a\u6539\u884c\u306e\u30d0\u30c3\u30d5\u30a1

  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  textbufferClass(screenClass scr, textAttrClass attr) {
    screenSetting    = scr;
    cwidth           = screenSetting.cwidth;  // \u4e00\u884c\u306e\u6587\u5b57\u6570
    fontSize         = attr.fontSize;
    topLine          = new lineClass();
    currentWriteLine = topLine;
    currentAttr      = new textAttrClass();  // \u30c7\u30d5\u30a9\u30eb\u30c8\u5024\u304c\u8a2d\u5b9a\u3055\u308c\u308b
    totalLines       = 0;
    readingLine      = 0;
    buff             = new sentenceClass("", currentAttr);  // \u5e38\u306b\u6700\u521d\u306e\u30bb\u30f3\u30c6\u30f3\u30b9\u306f\u7a7a
  }
  // \u5168\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u306e\u30af\u30ea\u30a2
  // GC\u3067\u6d88\u3048\u308b\u306e\u3092\u671f\u5f85\u3059\u308b\u306e\u3067\u306f\u306a\u304f\u53e4\u3044\u30ea\u30b9\u30c8\u69cb\u9020\u3092\u518d\u5229\u7528\u3059\u308b
  public void clearTextBuffer() {
    lineClass  temp, next;
    temp = topLine;
    while (true) {
      if (temp.next == null)  break;
      //    if (temp.flag == false) break;  // \u5b89\u5168\u306e\u305f\u3081\u306b\u30b3\u30e1\u30f3\u30c8\u30a2\u30a6\u30c8
      next = temp.next;  // \u6b21\u306e\u30ea\u30b9\u30c8\u306e\u30dd\u30a4\u30f3\u30bf\u3092\u9000\u907f\u3055\u305b\u3066\u304b\u3089
      temp.clear();      // \u73fe\u30e9\u30a4\u30f3\u306e\u30c7\u30fc\u30bf\u3092\u521d\u671f\u5316\u3057\u3066
      temp = next;       // \u6b21\u306b\u79fb\u52d5\u3059\u308b
    }
    currentAttr.init();  // \u30b7\u30b9\u30c6\u30e0\u30c7\u30d5\u30a9\u30eb\u30c8\u5024\u306b\u521d\u671f\u5316
    currentWriteLine = topLine;
    totalLines       = 0;
    readingLine      = 0;
    if (buff != null) buff.clearSentence(currentAttr);  // \u30d0\u30c3\u30d5\u30a1\u306e\u521d\u671f\u5316\uff08\u30ea\u30b9\u30c8\u3092\u8fbf\u3089\u306a\u3044\uff1aGC\u306b\u671f\u5f85\uff09
  }
  ///////////////////////
  // \u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u95a2\u4fc2
  // \u4e0e\u3048\u3089\u308c\u305f\u6587\u5b57\u5217\u306e\u5e45\uff08\u6587\u5b57\u6570\u3067\u306f\u7121\u3044\uff09\u3092\u8fd4\u3059\uff08\u5168\u89d21.0\uff0c\u534a\u89d20.5\uff09
  public float getStringWidth(String str) {
    float len;
    if (crowbar.tomahawkMode == 2) len = screenSetting.pgText.textWidth(str) / fontSize;
      else                         len = textWidth(str) / fontSize;
    if ((crowbar.config.proportional == false) && (len < 0.5f)) len = 0.5f; // \u534a\u89d2\u6587\u5b57\u30920.5\u306b\u56fa\u5b9a
    return len;
  }
  // \u6307\u5b9a\u3055\u308c\u305f\u6587\u5b57\u5e45\u306f\u4e0e\u3048\u3089\u308c\u305f\u6587\u5b57\u5217\u306e\u4f55\u6587\u5b57\u76ee\u307e\u3067\u306a\u306e\u304b\u3092\u8abf\u3079\u308b
  public int convertStringWidth2Length(String str, int len) {
    int i;
    for (i = len - 1; i < str.length(); i++) {    // len - 1\u304b\u3089\u59cb\u3081\u308b\u306e\u306f\u9ad8\u901f\u5316\u306e\u305f\u3081
      if (getStringWidth(str.substring(0, i + 1)) > len) break;
    }
    return i;
  }
  // -----------\u30d0\u30c3\u30d5\u30a1\u95a2\u9023 --------------------
  // \u30d0\u30c3\u30d5\u30a1\u306b\u30bb\u30f3\u30c6\u30f3\u30b9\u3092\u8ffd\u52a0\u3059\u308b\uff08\u5358\u7d14\u306b\u30c1\u30a7\u30fc\u30f3\u3092\u7e4b\u3050\uff0e\u5f8c\u3067\u5c5e\u6027\u3092\u30c1\u30a7\u30c3\u30af\u3057\u3066\u30de\u30fc\u30b8\u3059\u308b\u5fc5\u8981\u304c\u3042\u308b\uff0e\u7a7a\u6587\u5b57\u5217\u3067\u3082\u7e4b\u3050\uff09
  public void appendSentence(String str, textAttrClass attr) {
    if (buff == null) buff = new sentenceClass(str, attr);  // \u30d0\u30c3\u30d5\u30a1\u304c\u7121\u3044\uff01\u3053\u3068\u306f\u7121\u3044\u306f\u305a\uff0e
      else            buff.addSentence(str, attr);
    // \u6587\u5b57\u8868\u793a\u5c5e\u6027\u306e\u66f4\u65b0
    currentAttr.clone(attr);
  }
  // \u30c7\u30fc\u30bf\u66f8\u304d\u8fbc\u307f\u306e\u672c\u4f53\uff08\u3082\u3057\u3053\u306e\u884c\u304c\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u3055\u308c\u305f\u884c\u306a\u3089\u3070overlap\u306btrue\u3092\u30bb\u30c3\u30c8\u3057\u3066\u30b3\u30fc\u30eb\u3059\u308b\uff09
  public void _setLine(boolean overlapped) {
    currentWriteLine.set(buff, overlapped);
    currentWriteLine = currentWriteLine.next;
    totalLines++;
  }
  // \u30d0\u30c3\u30d5\u30a1\u306e\u30c7\u30fc\u30bf\u3092\u884c\u30c7\u30fc\u30bf\u3068\u3057\u3066\u78ba\u5b9a\u3059\u308b
  // \u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u3092\u8003\u616e\u3059\u308b\u5fc5\u8981\u304c\u3042\u308b\u3068\u304d\u306foverlap\u3092true\u306b\u30bb\u30c3\u30c8\u3057\u3066\u30b3\u30fc\u30eb\u3059\u308b
  // \u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u6709\u52b9\u6642\u306b\u6298\u308a\u8fd4\u3057\u5206\u3092\u65b0\u305f\u306b\u884c\u30c7\u30fc\u30bf\u3092\u4f5c\u6210\u3057\u3066\u305d\u3061\u3089\u306b\u7d9a\u3051\u308b\uff0e
  public void setLine(boolean overlap) {
    if (!overlap) {
      buff.merge();  // \u30de\u30fc\u30b8\u3092\u5148\u306b\u884c\u3046
      _setLine(false);
    } else {
      normalizeBuffer();
      _setLine(false);
    }
    buff = new sentenceClass("", currentAttr);  // \u5e38\u306b\u6700\u521d\u306e\u30bb\u30f3\u30c6\u30f3\u30b9\u306f\u7a7a
  }
  // \u3044\u307e\u30d0\u30c3\u30d5\u30a1\u306b\u6e9c\u307e\u3063\u3066\u3044\u308b\u30bb\u30f3\u30c6\u30f3\u30b9\u304c\u4e00\u884c\u306e\u884c\u6570\u3092\u8d85\u3048\u3066\u3044\u308b\u306a\u3089\u3070\u8d85\u3048\u3066\u3044\u308b\u5206\u306f\u30e9\u30a4\u30f3\u30c7\u30fc\u30bf\u3068\u3057\u3066\u78ba\u5b9a\u3059\u308b
  // \u3053\u308c\u306f\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u8a31\u53ef\u6642\u4ee5\u5916\u306b\u547c\u3073\u51fa\u3057\u3066\u306f\u3044\u3051\u306a\u3044\uff0e
  public void normalizeBuffer() {
    if (getStringWidth(buff.getPlainText()) >= cwidth) {
      // \u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u6709\u52b9\u6642\u306e\u5206\u5272\u51e6\u7406
      // lineClass\u306eoverlap\u306f\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u306e\u201d\u767a\u751f\u3057\u305f\u201d\u884c\u306e\u307ftrue\u3068\u3059\u308b
      buff.merge();  // \u30de\u30fc\u30b8\u3092\u5148\u306b\u884c\u3046
      sentenceClass  bufBakPtr, buffPtr;
      textAttrClass  bakAttr;
      float total = 0.0f;

      buffPtr = buff;
      while (true) {
        if (buffPtr == null) break;
        // \u6298\u308a\u8fd4\u3057\u304c\u5fc5\u8981\u306a\u5834\u5408
        if (total + getStringWidth(buffPtr.sentence) >= cwidth) {
          // \u30bb\u30f3\u30c6\u30f3\u30b9\u3092\u5206\u5272\u3059\u308b
          bufBakPtr = buffPtr.split(convertStringWidth2Length(buffPtr.sentence, PApplet.parseInt(cwidth - total)));
          buffPtr.next = null;
          // \u3053\u308c\u306f\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u3057\u305f\u5206\u306a\u306e\u3067\u5f15\u6570true
          _setLine(true);
          // \u5206\u5272\u3057\u305f\u6b8b\u308a\u304c\u7a7a\u306e\u5834\u5408
          if (bufBakPtr.sentence.length() == 0) buff = bufBakPtr.next;  // \u5358\u306b\u7121\u8996
            else                                buff = bufBakPtr;
          buffPtr = buff;
          total   = 0;
        } else {
          total += getStringWidth(buffPtr.sentence);
          if (buffPtr.next == null) {
            // \u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u306e\u767a\u751f\u3057\u3066\u3044\u306a\u3044\u884c\uff08\u3042\u308b\u3044\u306f\u6b8b\u308a\u306e\u90e8\u5206\uff09
            break;
          } else buffPtr = buffPtr.next;
        }
      }
    }
    return;
  }
  // \u30d0\u30c3\u30d5\u30a1\u3092\u30d5\u30e9\u30c3\u30b7\u30e5\uff08\u66f8\u304d\u51fa\u3059\uff09
  public void flushBuffer(boolean overlap) { if (buff.length() > 0) setLine(overlap); }
  // \u6307\u5b9a\u3055\u308c\u305f\u884c\u756a\u53f7\u306e\u884c\u30c7\u30fc\u30bf\u3092\u8fd4\u3059\uff08\uff10\u884c\u304b\u3089\u59cb\u3081\u308b\uff09
  public lineClass getTargetLine(int line) {
    lineClass temp = topLine;
    for (int num = 0; num < line; num++) {
      if (temp.next == null) break;
      if (temp.flag != true) break;
      temp = temp.next;
    }
    return temp;
  }
  // \u8868\u793a\u958b\u59cb\u884c\u3092\u30c0\u30a4\u30ec\u30af\u30c8\u306b\u6307\u5b9a\u3059\u308b
  public void setReadingLine(int num) {
    if (num < 0) num = 0;
    if (crowbar.afterRunning && (num >= totalLines - 1)) num = totalLines - 1;
    readingLine = num;
  }
  // \u8868\u793a\u958b\u59cb\u884c\u6570\u3092\u6307\u5b9a\u884c\u6570\u5206\uff0c\u5897\u52a0\u3059\u308b
  public void incrementReadingLine(int num) { setReadingLine(readingLine + num); }

  // \u30c7\u30d0\u30c3\u30b0\u7528\uff1a\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u3092\u5168\u3066\u8868\u793a
  public void displayAllTextBuffer() {
    int  i;
    lineClass temp;
    temp = topLine;
    sentenceClass sen;
    i = 0;
    println();
    println("No.:(No.):flag:overlap:length[sentence1, sentence2, ...]");
    while (true) {
      if (temp == null) break;
      if (temp.line == null) break;
      print(str(i) + ":" + str(temp.no) + ":" + str(temp.flag) +":" + str(temp.overlap) + ":" + str(temp.line.length()));
      print("[");
      sen = temp.line;
      while (true) {
        print(hex(sen.attr.textColor));
        print("(" + str(sen.sentence.length()) + ")");
        print(",");
        if (sen.next == null) break;
        sen = sen.next;
      } 
      println("]");
      if (temp.next == null) break;
      temp = temp.next;
      i++;
    }
  }
}

// \u30ad\u30fc\u30dc\u30fc\u30c9\u5165\u529b\u898f\u5247\u306e\u30af\u30e9\u30b9
class keyInputConstraintClass {
  private boolean point;     // [.]\u30ad\u30fc\u304c\u62bc\u3055\u308c\u305f\u304b
  private boolean sign;      // [+],[-]\u30ad\u30fc\u304c\u62bc\u3055\u308c\u305f\u304b
  private boolean inputted;  // \u6570\u5b57\u304c\u65e2\u306b\u5165\u529b\u6e08\u307f\u304b
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  keyInputConstraintClass() { reset(); }
  // \u521d\u671f\u5316
  public void reset() { point = sign = inputted = false; }
  // 1) \u6d6e\u52d5\u5c0f\u6570\u70b9\u6642\u306e\u5165\u529b\u898f\u5247\u30c1\u30a7\u30c3\u30af
  public boolean checkFloat(char c) {
    boolean flag = true;
    switch (c) {
      // \u7b26\u53f7
    case '+' :
    case '-' :
      if ((sign) || (inputted)) flag = false;
        else                    sign = true;
      break;
      // \u5c0f\u6570\u70b9
    case '.' :
      if ((point) || (!inputted)) flag  = false;
        else                      point = true;
      break;
    default :
      if (isNumberChar(c)) inputted = true;
        else               flag     = false;
      break;
    }
    return flag;
  }
  // 2) \u6574\u6570\u5165\u529b\u6642\u306e\u5165\u529b\u898f\u5247\u30c1\u30a7\u30c3\u30af\uff08\u73fe\u72b6\u306f\u4f7f\u308f\u308c\u3066\u3044\u306a\u3044\uff09
  public boolean checkInteger(char c) {
    if (c == '.') return false;
    return checkFloat(c);
  }
  // 3) \u8ad6\u7406\u578b\u5165\u529b\u6642\u306e\u5165\u529b\u898f\u5247\u30c1\u30a7\u30c3\u30af
  public boolean checkBoolean(char c) {
    if (crowbar.keyBufferLength() >= 1) return false;
    return true;
  }
}

// \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u8a18\u9332\u7528\u30af\u30e9\u30b9
class loggingClass {
  private String       _defaultFileName = _DEFAULT_LOG_FILENAME;
  protected String     logFileName;    // \u30d5\u30a1\u30a4\u30eb\u540d\uff08\u30b9\u30b1\u30c3\u30c1\u30d5\u30a9\u30eb\u30c0\u306b\u4fdd\u5b58\uff09
  private boolean      loggingNow;     // true\u306e\u9593\u306f\u30ed\u30b0\u3092\u8a18\u9332\u3059\u308b
  private PrintWriter  output;         // \u30ed\u30b0\u51fa\u529b\u7528\u30d5\u30a1\u30a4\u30eb\u30dd\u30a4\u30f3\u30bf
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  loggingClass() {
    logFileName   = "";
    loggingNow    = false;
    output        = null;
  }
  public void setFileName(String filename) {
    if (filename.length() > 0) logFileName = filename;
      else                     logFileName = _defaultFileName;
  }
  public boolean isEnableLogging() { return output == null ? false : true; }
  // ---- \u30ed\u30b0\u95a2\u4fc2\u306e\u30b3\u30de\u30f3\u30c9 -----
  // \u30e6\u30fc\u30b6\u30fc\u306f\u4f7f\u7528\u3057\u306a\u3044
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u306e\u307fprint()
  public void print2Log(String str)   { if (loggingNow) output.print(str);   }
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u306e\u307fprintln()
  public void println2Log(String str) { if (loggingNow) output.println(str); }
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u306e\u307fnewline()
  public void newline2Log() { println2Log(""); }

  // ---- \u95a2\u6570 -------------------------------------------------
  // \u5b9f\u969b\u306b\u306f\u4e00\u3064\u4e0a\u306e\u30af\u30e9\u30b9\u304cI/F\u306b\u306a\u308b\u306e\u3067\u30e6\u30fc\u30b6\u306f\u4f7f\u7528\u3057\u306a\u3044\u3053\u3068
  // ---- \u95a2\u6570 -------------------------------------------------
  public String setDefaultFilename() { return _defaultFileName; }
  public String setDefaultFilename(String fname) {
    String oldname = _defaultFileName;
    _defaultFileName = fname;
    return oldname;
  }
  // \u30ed\u30b0\u8a18\u9332\u958b\u59cb
  public PrintWriter startLogging() {
    if (output != null) stopLogging();
    output     = createWriter(logFileName);
    loggingNow = true;
    println2Log("--- Logging start : " + nowDateTime() + "---");
    return output;
  }
  public PrintWriter getLogfile() { return output; }
  // \u30ed\u30b0\u8a18\u9332\u7d42\u4e86
  public void stopLogging() {
    if (output != null) {
      println2Log("--- Logging finished : " + nowDateTime() + "---");
      // \u30d5\u30a1\u30a4\u30eb\u3092\u9589\u3058\u308b
      output.flush();
      output.close();
    }
    // \u8a2d\u5b9a\u3092\u521d\u671f\u5316\u3059\u308b
    loggingNow  = false;
    output      = null;
  }
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u4fdd\u5b58\u3092\u4e00\u6642\u7684\u306b\u505c\u6b62\u3059\u308b
  public void pauseLogging()   { loggingNow = false;  }
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u4fdd\u5b58\u3092\u518d\u958b\u3059\u308b
  public void restartLogging() { if (output != null) loggingNow = true; }
}

// ------------------------------------
// \u30c6\u30ad\u30b9\u30c8\u753b\u9762\uff08\u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\uff09\u306e\u5c5e\u6027
// ------------------------------------
class screenClass {
  protected int   cwidth, cheight;           // \u30ad\u30e3\u30e9\u30af\u30bf\u306e\u6a2a\u6587\u5b57\u6570\uff0c\u884c\u6570
  protected int   gwx, gwy;                  // \u30b9\u30af\u30ea\u30fc\u30f3\u30b5\u30a4\u30ba
  protected int   colwidth, rowheight;       // \u4e00\u6587\u5b57\u306e\u6587\u5b57\u9001\u308a\uff0c\u884c\u9593\uff08pixel\uff09
  protected int   frameWidth;                // \u984d\u7e01\u306e\u5e45\uff08\u4e0a\u4e0b\u5de6\u53f3\u540c\u4e00\uff09
  protected float hStep, vStep;              // \u6587\u5b57\u9593\u9694\uff0c\u884c\u9593\u9694\u306e\u6bd4\u7387\uff081.0\u3067\u5bc6\u7740\uff09
  protected PGraphics pgText;                // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528
  screenClass(int max_x, int max_y, int fsize) {
    cwidth     = max_x;
    cheight    = max_y;
    frameWidth = 10;
    hStep      = _HSTEP;
    vStep      = _VSTEP;
    reCalc(fsize);
  }
  public void setPgText(PGraphics pg) { pgText = pg; }
  public void reCalc(int fsize) {
    colwidth   = PApplet.parseInt(fsize * hStep);
    rowheight  = PApplet.parseInt(fsize * vStep);
    gwx        = cwidth  * colwidth  + frameWidth * 2;
    gwy        = cheight * rowheight + frameWidth * 2;
  }
}

// \u6a5f\u80fd\u9078\u629e\u306e\u30d5\u30e9\u30b0
class configFlagClass {
  protected boolean noDisplay;     // \u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30b9\u8868\u793a\u306e\u6291\u5236
  protected boolean noTextArea;    // PDE\u306e\u30c6\u30ad\u30b9\u30c8\u30a8\u30ea\u30a2\u3078\u306e\u6587\u5b57\u5217\u306e\u8868\u793a\u306e\u6291\u5236
  protected boolean noOverlap;     // \u30a6\u30a3\u30f3\u30c9\u30a6\u304b\u3089\u306f\u307f\u51fa\u3059\u6587\u5b57\u5217\u3092\u6298\u308a\u8fd4\u3057\u3066\u6b21\u884c\u306b\u8868\u793a\u3057\u306a\u3044
  protected boolean proportional;  // \u534a\u89d2\u82f1\u6570\u5b57\u306e\u51fa\u529b\u5e45\u30920.5\u306b\u56fa\u5b9a\u3057\u306a\u3044
  protected boolean degreeBase;    // \uff08\u4e3b\u306bTomahawk\u306b\u304a\u3051\u308b\uff09\u89d2\u5ea6\u306e\u5358\u4f4d\u3092\u5ea6\u3068\u3059\u308b\u5834\u5408\u306ftrue
  configFlagClass() {
    noDisplay = noTextArea = noOverlap  = false;
    proportional = false;
    degreeBase   = true;
  }
  public void clone(configFlagClass src) {
    noDisplay    = src.noDisplay;
    noTextArea   = src.noTextArea;
    noOverlap    = src.noOverlap;
    proportional = src.proportional;
    degreeBase   = src.degreeBase;
  }
}

// Draw()\u306b\u304a\u3051\u308b\u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u6587\u5b57\u5217\u5165\u529b\u7528\u306e\u30af\u30e9\u30b9
// ENTER\u304c\u62bc\u3055\u308c\u305f\u306a\u3089\u3070\u305d\u3053\u307e\u3067\u306b\u5165\u529b\u3055\u308c\u305f\u4e00\u6587\u306fbuff2\u306b\u4fdd\u7ba1\u3055\u308c\uff0cgets()\u3055\u308c\u308b\u3068\u3053\u3061\u3089\u304c\u8fd4\u3055\u308c\u308b\uff0ebuff2\u306f\u30af\u30ea\u30a2\u3059\u308b\u304c\uff0cbuff\u306f\u30af\u30ea\u30a2\u3057\u306a\u3044\uff0e
// ENTER\u3057\u3066\u3044\u306a\u3044\u72b6\u614b\u3067gets()\u3055\u308c\u305f\u5834\u5408\u306fbuff\u3092\u8fd4\u3057\uff0cbuff\u3092\u30af\u30ea\u30a2\u3059\u308b\uff0e
// ENTER\u3055\u308c\u3066\u5165\u529b\u304c\u78ba\u5b9a\u3057\u305f\u304b\u3069\u3046\u304b\u3092\u78ba\u8a8d\u3057\u305f\u4e0a\u3067gets()\u3059\u308b\u306e\u304c\u57fa\u672c\u7684\u306a\u4f7f\u3044\u65b9\uff0e
// \u305f\u3060\u3057\u6587\u5b57\u5217\u30d0\u30c3\u30d5\u30a1\u306f\u4e00\u3064\u3060\u3051\uff0e\u306a\u304a\uff0c\u62e1\u5f35\u3059\u308b\u3053\u3068\u306f\u3067\u304d\u308b\u304c\u3057\u306a\u3044\u3060\u3051\uff0e
// \u30a8\u30b3\u30fc\u30d0\u30c3\u30af\u306f\u3069\u3046\u3057\u3088\u3046\uff0e\u30d0\u30c3\u30af\u30b9\u30da\u30fc\u30b9\u3068\u304b\u3082\uff0e
// \u30d5\u30e9\u30c3\u30b7\u30e5\u3055\u308c\u306a\u3044\u8aad\u307f\u51fa\u3057gets()\u3092\u7528\u610f\u3057\u3066\uff0c\u81ea\u5206\u3067\u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u306b\u8868\u793a\u3057\u3066\u8cb0\u3048\u3070\u826f\u3044\u304b\uff0e
// keyPressed()\u3067\u306f\u30ad\u30fc\u30b3\u30fc\u30c9\u3092\u30c1\u30a7\u30c3\u30af\u3057\u306a\u3044\uff0e\u7247\u3063\u7aef\u304b\u3089add()\u3059\u308b\uff0e\u5224\u5b9a\u306fadd()\u3067\u884c\u306a\u3046\uff0e
class realtimeInputClass {
  private boolean enable;  // \u6587\u5b57\u5217\u306e\u683c\u7d0d\u3092\u8a31\u53ef\u3055\u308c\u3066\u3044\u308b\u6642\u306ftrue\uff0c\u7981\u6b62\u3055\u308c\u3066\u3044\u308b\u6642\u306ffalse
  private String [] buff2; // ENTER\u5f8c\u306b\u78ba\u5b9a\u3057\u305f\u6587\u5b57\u5217\u3092\u683c\u7d0d\u3059\u308b
  private String buff;     // \u73fe\u5728\u5165\u529b\u4e2d\u306e\u6587\u5b57\u5217\uff08\u672a\u78ba\u5b9a\uff09\u3092\u4e00\u6642\u7684\u306b\u683c\u7d0d\u3059\u308b
  private int finished;    // \u78ba\u5b9a\u6e08\u307f\u306e\u6587\u5b57\u5217\u6570\uff0e\u672a\u78ba\u5b9a\u306a\u3089\u30700
  private int autoCount;   // \u30ab\u30a6\u30f3\u30c8\u30c0\u30a6\u30f3\u3057\u3066\u30bc\u30ed\u306b\u306a\u3063\u305f\u3089enable\u3092\u81ea\u52d5\u7684\u306bfalse\u306b\u5909\u66f4\u3059\u308b
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  realtimeInputClass() {
    disable();
    flush();
  }
  // enable/disable\u306b\u5207\u308a\u66ff\u3048\u308b\u969b\u306b\u30d0\u30c3\u30d5\u30a1\u3092\u30d5\u30e9\u30c3\u30b7\u30e5\u3059\u308b\u306e\u3082\u624b\u3060\u304c\uff0c\u305d\u3053\u307e\u3067\u304a\u7bc0\u4ecb\u306f\u3057\u306a\u3044
  // \u6587\u5b57\u5217\u306e\u683c\u7d0d\u3092\u8a31\u53ef
  public void enable(int lines) { enable = true; autoCount = lines > 0 ? lines : 0; }  // 0\u3082\u7121\u671f\u9650
  // \u6587\u5b57\u5217\u306e\u683c\u7d0d\u3092\u7981\u6b62
  public void disable()         { enable = false; }
  // \u6587\u5b57\u5217\u306e\u683c\u7d0d\u304c\u8a31\u53ef\u3055\u308c\u3066\u3044\u308b\u6642\u306ftrue
  public boolean isEnable() { return enable;  }
  // \u5168\u30d0\u30c3\u30d5\u30a1\u3092\u30af\u30ea\u30a2
  public void flush()    {
    buff      = "";
    buff2     = (String []) new String[1];
    finished  = 0;
    autoCount = 0;
  }
  // \u6587\u5b57\u5217\u5165\u529b\u30d0\u30c3\u30d5\u30a1\u304b\u3089\u6587\u5b57\u5217\u3092\u53d6\u5f97\u3059\u308b
  // FIFO\u306a\u306e\u3067\u78ba\u5b9a\u6e08\u307f\u306e\u6587\u5b57\u5217\u304c\u30d0\u30c3\u30d5\u30a1\uff08buff2\uff09\u306b\u5b58\u5728\u3059\u308b\u306a\u3089\u3070\u6700\u3082\u53e4\u3044\u6587\u5b57\u5217\u3092\u8fd4\u3059\uff0e
  // \u672a\u78ba\u5b9a\u72b6\u614b\u306a\u3089\u3070buff\u3092\u8fd4\u3059\uff0e
  // flush\u304ctrue\u306a\u3089\u3070\u6587\u5b57\u5217\u3092\u8fd4\u3059\u3068\u5171\u306b\u30d0\u30c3\u30d5\u30a1\u3092\u4e00\u3064\u524a\u9664\u3059\u308b
  public String gets(boolean flush)   {
    String ret;
    if (finished > 0) {
      // \u5165\u529b\u78ba\u5b9a\u6e08\u307f\u306e\u6587\u5b57\u5217\u304c\u3042\u308b\u5834\u5408
      ret      = buff2[0];
      if (flush) {
        buff2 = subset(buff2, 1, finished);
        finished--;
      }
    } else {
      // \u5165\u529b\u78ba\u5b9a\u6e08\u307f\u306e\u6587\u5b57\u5217\u304c\u7121\u3044\u5834\u5408
      ret  = buff;
      if (flush) buff = "";
    }
    return ret;
  }
  //\u5165\u529b\u6e08\u307f\u306e\u6587\u5b57\u5217\u306e\u9577\u3055\u3092\u8fd4\u3059\uff08\u5165\u529b\u78ba\u5b9a\u6e08\u307f\u306e\u30d0\u30c3\u30d5\u30a1\u6570\u306ffinished()\u3067\u5f97\u3089\u308c\u308b\uff09
  // \u5165\u529b\u78ba\u5b9a\u6e08\u307f\u3067\u306f\u7121\u3044\u306a\u3089\u672a\u78ba\u5b9a\uff08buff\uff09\u306e\u6587\u5b57\u5217\u3092\u8fd4\u3059
  public int length()    {
    if (finished > 0) return buff2[0].length();
    return buff.length();
  }
  // \u30ad\u30fc\u30dc\u30fc\u30c9\u304b\u3089\u5165\u529b\u3055\u308c\u305f\u6587\u5b57\u3092\u30d0\u30c3\u30d5\u30a1\u306b\u683c\u7d0d\u3059\u308b
  // ENTER\u304c\u62bc\u3055\u308c\u305f\u306a\u3089\u3070\u78ba\u5b9a\u51e6\u7406\u3092\u884c\u3046
  public void add() {
    if (enable == false) return;
    switch (keyCode) {
      case ENTER : 
        buff2[finished++] = buff;
        buff2 = append(buff2, "");
        buff  = "";
        if (autoCount > 0) {
          if (--autoCount <= 0) {
            enable    = false;
            autoCount = 0;
          }
        }
        break;
      case BACKSPACE :
        bs();
        break;
      case UP :
      case DOWN :
      case LEFT :
      case RIGHT :
      case SHIFT :
      case TAB :
      case ESC :
      case DELETE :
        break;
      default :
        buff += key;
    }
  }
  // \u30d0\u30c3\u30af\u30b9\u30da\u30fc\u30b9\u30ad\u30fc\u304c\u62bc\u3055\u308c\u305f\u5834\u5408\u306f\u30d0\u30c3\u30d5\u30a1(buff)\u304b\u3089\u4e00\u6587\u5b57\u524a\u9664
  public void bs() {
    int len;
    if ((len = buff.length()) > 0) {
      buff = buff.substring(0, len - 1); 
    }
  }
}

/////////////////////////////////////////
// \u30ad\u30fc\u30dc\u30fc\u30c9\u5165\u529b\u3068\u30b3\u30f3\u30bd\u30fc\u30eb\u51fa\u529b\u306e\u30af\u30e9\u30b9
/////////////////////////////////////////
class consoleClass extends tomahawkClass {
  // \u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\u95a2\u4fc2\u306e\u7ba1\u7406\u7528\u5909\u6570
  protected float cx = 0.0f, cy = 0.0f;        // \u30ad\u30e3\u30e9\u30af\u30bf\u306e\u8868\u793a\u4f4d\u7f6e\uff08\u30ab\u30ec\u30f3\u30c8\u30dd\u30b8\u30b7\u30e7\u30f3\uff09\uff0c\u534a\u89d2\u6587\u5b57\u306f0.5\u6587\u5b57
  protected float tabSize = _TABSIZE;        // \u30bf\u30d6\u6587\u5b57\u6570
  screenClass     screenSetting;
  // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u306e\u5c5e\u6027\u306e\u8a2d\u5b9a\uff08clrscr()\u3067\u8a2d\u5b9a\u3055\u308c\u308b\uff09
  protected textAttrClass  currentAttr;
  // \u6a5f\u80fd\u9078\u629e\u306e\u30d5\u30e9\u30b0
  configFlagClass config, _config;
  // \u30c6\u30ad\u30b9\u30c8\u753b\u9762\u306e\u30b9\u30af\u30ed\u30fc\u30eb\u8868\u793a\u95a2\u4fc2
  textbufferClass      textbuffer;         // \u30d0\u30c3\u30d5\u30a1\u95a2\u4fc2\u306e\u30af\u30e9\u30b9
  private boolean      recordTextBuffer;   // true\u306e\u9593\u306f\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u306b\u8a18\u9332\u3059\u308b
  protected int        autoScrollLines;    // \u81ea\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u3059\u308b\u884c\u6570\uff080\u304c\u6307\u5b9a\u3055\u308c\u3066\u3044\u308b\u6642\u306f\u5b8c\u5168\u306b\u6d88\u53bb\uff09
  // \u30ad\u30fc\u30dc\u30fc\u30c9\u5165\u529b\u898f\u5247\u306e\u30c1\u30a7\u30c3\u30af
  keyInputConstraintClass  keyCheck;
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u95a2\u4fc2
  loggingClass         logging;
  private boolean      enableLogging;  // \u30c6\u30ad\u30b9\u30c8\u30ed\u30b0\u3092\u8a18\u9332\u3059\u308b\uff08setup()\u3067\u306e\u307f\u6709\u52b9\uff09
  // Draw()\u4e2d\u306e\u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u6587\u5b57\u5217\u5165\u529b\u7528\u30d0\u30c3\u30d5\u30a1
  realtimeInputClass   input;

  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf\uff08\u5f15\u6570\u306f\u6a2a\u65b9\u5411\u306e\u6700\u5927\u6587\u5b57\u6570\u3068\u7e26\u65b9\u5411\u306e\u6700\u5927\u884c\u6570\uff09
  consoleClass(int max_x, int max_y, int mode) {
    super(mode);
    // \u30b9\u30af\u30ea\u30fc\u30f3\u306e\u8a2d\u5b9a
    currentAttr   = new textAttrClass();
    screenSetting = new screenClass(max_x, max_y, currentAttr.fontSize);
    // \u518d\u8a2d\u5b9a
    screenReset();
    // \u30c7\u30d5\u30a9\u30eb\u30c8\u6587\u5b57\u8272\u3068\u80cc\u666f\u8272\u306e\u8a2d\u5b9a
    textColor(currentAttr.textColor, currentAttr.bgColor);
    // \u30b9\u30af\u30ed\u30fc\u30eb\u8868\u793a\u7528\u306e\u30d0\u30c3\u30d5\u30a1\u95a2\u9023
    textbuffer       = new textbufferClass(screenSetting, currentAttr);
    recordTextBuffer = true;
    autoScrollLines  = 0;
    // \u30ad\u30fc\u30dc\u30fc\u30c9\u5165\u529b\u898f\u5247\u30c1\u30a7\u30c3\u30af
    keyCheck      = new keyInputConstraintClass();
    // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u95a2\u4fc2
    logging       = new loggingClass();
    enableLogging = false;
    // \u6a5f\u80fd\u30b9\u30a4\u30c3\u30c1\u306e\u30d0\u30c3\u30af\u30a2\u30c3\u30d7\u306e\u521d\u671f\u5316
    config  = new configFlagClass();
    _config = new configFlagClass();
    backupConfigFlag();
    // Draw()\u4e2d\u306e\u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u6587\u5b57\u5217\u5165\u529b\u7528\u30d0\u30c3\u30d5\u30a1
    input = new realtimeInputClass();
  }
  public void backupConfigFlag()  { _config.clone(config);  }
  public void restoreConfigFlag() {  config.clone(_config); }

  // \u30d5\u30a9\u30f3\u30c8\u306e\u8a2d\u5b9a
  public void prepareFont() {
    if (tomahawkMode == 2) {
      // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4f7f\u7528\u6642
      PFont font = createFont(_FONTNAME, currentAttr.fontSize, false);  // \u30d5\u30a9\u30f3\u30c8\u3092\u5909\u63db
      screenSetting.pgText.beginDraw();
      screenSetting.pgText.textFont(font);                     // \u30d5\u30a9\u30f3\u30c8\u3092\u8a2d\u5b9a
      if (!_JAVA2D) screenSetting.pgText.textMode(SCREEN);     // JAVA2D\u306a\u3089\u30b3\u30e1\u30f3\u30c8\u30a2\u30a6\u30c8\u3057\u306a\u304f\u3066\u306f\u3044\u3051\u306a\u3044\uff0eP2D\u3060\u3068\u5fc5\u8981\uff0e
      screenSetting.pgText.textSize(currentAttr.fontSize);     // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba\u3092\u8a2d\u5b9a\uff08\u4e0d\u8981\uff1f\uff09
      screenSetting.pgText.textAlign(LEFT, TOP);               // \u914d\u7f6e
//    screenSetting.pgText.smooth();
      screenSetting.pgText.endDraw();
    } else {
      // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4e0d\u4f7f\u7528\u6642
      PFont font = createFont(_FONTNAME, currentAttr.fontSize, true);  // \u30d5\u30a9\u30f3\u30c8\u3092\u5909\u63db
      textFont(font);                     // \u30d5\u30a9\u30f3\u30c8\u3092\u8a2d\u5b9a
//    textMode(SCREEN);                   // \u3053\u308c\u3092\u6709\u52b9\u306b\u3059\u308b\u3068\u6587\u5b57\u304c\u8868\u793a\u3055\u308c\u306a\u3044
      textSize(currentAttr.fontSize);     // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba\u3092\u8a2d\u5b9a\uff08\u4e0d\u8981\uff1f\uff09
      textAlign(LEFT, TOP);               // \u914d\u7f6e
    }
  }
  // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba\u306e\u521d\u671f\u8a2d\u5b9a\u306e\u5b9f\u4f53\uff08\u76f4\u63a5\uff0c\u30e6\u30fc\u30b6\u306f\u547c\u3073\u51fa\u3055\u306a\u3044\uff09
  public void _setFontSize(int size) {
    if (size <= 0) return;
    currentAttr.fontSize  = size;
    textbuffer.fontSize   = size;
    screenSetting.reCalc(size);
    // \u5b9f\u969b\u306b\u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba\u3092\u5909\u66f4\u3059\u308b
    if (tomahawkMode == 2) {
      screenSetting.pgText.beginDraw();
      screenSetting.pgText.textSize(size);
      screenSetting.pgText.endDraw();
    } else {
      textSize(size);
    }
    screenReset();
  }
  // \u753b\u9762\u30d1\u30e9\u30e1\u30fc\u30bf\u5909\u66f4\u5f8c\u306e\u30ea\u30bb\u30c3\u30c8\u52d5\u4f5c
  public void screenReset() {
    // \u30b9\u30af\u30ea\u30fc\u30f3\u306e\u8a2d\u5b9a
    //  Processing2 \u307e\u3067
    //  size(screenSetting.gwx, screenSetting.gwy);
    //  Processing3 \u4ee5\u964d
    //  http://ttff.hatenablog.com/entry/2015/08/31/211650
    surface.setSize(screenSetting.gwx, screenSetting.gwy);  // \u52d5\u7684\u306a\u30b9\u30af\u30ea\u30fc\u30f3\u30b5\u30a4\u30ba\u306e\u5909\u66f4
    if (tomahawkMode == 2) {
      if (_JAVA2D) screenSetting.pgText = createGraphics(screenSetting.gwx, screenSetting.gwy, JAVA2D);  // \u901f\u5ea6\u304c\u6975\u3081\u3066\u9045\u3044
        else       screenSetting.pgText = createGraphics(screenSetting.gwx, screenSetting.gwy, P2D);     // SCREEN\u3092\u8a2d\u5b9a\u3059\u308b\u5fc5\u8981\u304c\u3042\u308b
    } else         screenSetting.pgText = null;
    _clrscr();  
    // \u30d5\u30a9\u30f3\u30c8\u95a2\u4fc2
    prepareFont();
  }

  // ----------- \u753b\u9762\u51fa\u529b\u95a2\u4fc2-----------------
  // \u6587\u5b57\u4f4d\u7f6e\u3092\u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30b9\u5ea7\u6a19\u306b\u5909\u63db
  private int ptx(float x) { return PApplet.parseInt(x * screenSetting.colwidth  + screenSetting.frameWidth);  }
  private int pty(float y) { return PApplet.parseInt(y * screenSetting.rowheight + screenSetting.frameWidth);  }

  // \u51fa\u529b\u4f4d\u7f6e\u6307\u5b9a
  public crowbarClass locate(float x, float y) {
    locateX(x);
    locateY(y);
    return crowbar;
  }
  public float locateX() { return cx; }
  public float locateY() { return cy; }
  public float setLocateX(float x) { float oldx = locateX(); if (x < 0.0f) x = 0.0f; cx = x; return oldx; }
  public float setLocateY(float y) { float oldy = locateY(); if (y < 0.0f) y = 0.0f; cy = y; return oldy; }
  public crowbarClass locateX(float x) { setLocateX(x); return crowbar; }
  public crowbarClass locateY(float y) { setLocateY(y); return crowbar; }
  // \u884c\u6570\u304c\u6700\u5927\u5024\u306b\u9054\u3057\u305f\u304b
  private boolean rowCheck() {
    // \u9054\u3057\u305f\u306a\u3089\u3070\u753b\u9762\u6d88\u53bb
    if (cy >= screenSetting.cheight) {
      if (autoScrollLines == 0) {
        // \u30aa\u30fc\u30c8\u30b9\u30af\u30ed\u30fc\u30eb\u7121\u52b9\uff08\u5168\u753b\u9762\u6d88\u53bb\uff09
        _clrscr();
        textbuffer.readingLine += screenSetting.cheight;  // \u3053\u3053\u3060\u3051\u306f\u5f37\u5236\u7684\u306b\u30a4\u30f3\u30af\u30ea\u30e1\u30f3\u30c8\u3059\u308b\u5fc5\u8981\u304c\u3042\u308b\uff08\u307e\u3060\u51fa\u529b\u3057\u3066\u3044\u306a\u3044\uff09
      } else {
        // \u30aa\u30fc\u30c8\u30b9\u30af\u30ed\u30fc\u30eb\u5bfe\u5fdc
        stopRecordTextBuffer();
        pageLineScroll(autoScrollLines);
        startRecordTextBuffer();
      }
      return true;
    }
    return false;
  }
  // BS\u30ad\u30fc\u304c\u62bc\u3055\u308c\u305f\u5834\u5408\u306e\u51e6\u7406
  public void backSpace() {
    if (keyBufferLength() > 0) {
      keyBuffer = keyBuffer.substring(0, keyBuffer.length() - 1);
      writeBS();
    }
  }
  // \u30c6\u30ad\u30b9\u30c8\u6587\u5b570.5\u6587\u5b57\u5206\u3092\u524a\u9664\uff08\u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u6642\u306e\u307f\u6709\u52b9\u306a\u305f\u3081\uff09
  private void writeBS() {
    if (cx <= 0) return;
    if (!displaySwitch()) {
      cx -= 0.5f;
      if (tomahawkMode == 2) {
        // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u30ec\u30a4\u30e4\u30fc\u4f7f\u7528\u6642
        resetAlpha(ptx(cx), pty(cy), screenSetting.colwidth/2, screenSetting.rowheight, true);
      } else {
        // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u30ec\u30a4\u30e4\u30fc\u4e0d\u4f7f\u7528\u6642
        noStroke();
        fill(currentAttr.bgColor);    // \u80cc\u666f\u8272
        rect(ptx(cx), pty(cy), screenSetting.colwidth/2, screenSetting.rowheight);
        fill(currentAttr.textColor, 255);          // \u5857\u308a\u3064\u3076\u3057\u8272
      }
    }
  }
  // \u4e0e\u3048\u3089\u308c\u305f\u6587\u5b57\u306e\u5927\u304d\u3055\u3092\u8fd4\u3059\uff0e\u5168\u89d2\u306a\u3089\u3070\uff11\uff0c\u534a\u89d2\u306a\u3089\u30700.5
  private float charLength(char c) {
    float len;
    if (tomahawkMode == 2) len = screenSetting.pgText.textWidth(c) / currentAttr.fontSize;
      else                 len = textWidth(c) / currentAttr.fontSize;
    if ((config.proportional == false) && (len < 0.5f)) len = 0.5f; // \u534a\u89d2\u6587\u5b57\u30920.5\u306b\u56fa\u5b9a
    return len;
  }
  // \u03b1\u5024\u3092\u30ea\u30bb\u30c3\u30c8\u3059\u308b\uff0e\u7b2c\uff15\u5f15\u6570\u304ctrue\u306e\u5834\u5408\u306f\u7121\u6761\u4ef6\u306b#000000\u3067\u5857\u308a\u3064\u3076\u3059
  public void resetAlpha(int x, int y, int w, int h, boolean clr) {
    screenSetting.pgText.beginDraw();
    PImage pimg = screenSetting.pgText.get(x, y, w, h);
    int p;
    for (int i = 0; i < pimg.pixels.length; i++) {
      if (clr) pimg.pixels[i] = color(0xFF000000, 0);
      else {
        p = pimg.pixels[i] & 0x0ffffff;
        if (p > 0) {
  //        p |= 0x0ff000000;
  //        pimg.pixels[i] = color(p);
        } else pimg.pixels[i] = color(p, 0);
      }
    }
    screenSetting.pgText.set(x, y, pimg);
    screenSetting.pgText.endDraw();
  }
  // \u4e00\u6587\u5b57\u8868\u793a\uff08\u6587\u5b57\u5217\u306f\u5168\u3066\u3053\u306e\u95a2\u6570\u3092\u4ecb\u3057\u3066text()\u3067\u8868\u793a\u3059\u308b
  private void putchar(char c) {
    int px = ptx(cx);
    int py = pty(cy);
    if (c != ' ') {  // \u4f55\u6545\u304bPGraphics\u3092\u4f7f\u3063\u305f\u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u306b\u5bfe\u3057\u3066\u534a\u89d2\u7a7a\u767d\u3092text()\u3059\u308b\u3068\u30b4\u30df\u304c\u4e00\u884c\u4e0a\u306b\u30dd\u30c4\u30ea\u3068\u8868\u793a\u3055\u308c\u308b\u305f\u3081\u306e\u82e6\u8089\u306e\u7b56\uff08\u30d0\u30b0\uff1f\uff09
                     // https://forum.processing.org/topic/bug-illeagal-pixel-is-dotted-when-space-character-is-displayed-by-using-text-in-pgraphics
      if (tomahawkMode == 2) {
        // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4f7f\u7528\u6642
        screenSetting.pgText.beginDraw();
        screenSetting.pgText.text(c, px, py);
        screenSetting.pgText.endDraw();
        if (!_JAVA2D) resetAlpha(px, py - 2, currentAttr.fontSize * 2, currentAttr.fontSize + 4, false);   // \u306a\u305c\u304b-2\u3057\u306a\u3044\u3068\u7dda\u304c\u6b8b\u308b
      } else text(c, px, py); // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4e0d\u4f7f\u7528\u6642
    }
    cx += charLength(c);
  }

  ///////////////////////
  // \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u95a2\u9023
  ///////////////////////
  // \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u3078\u306e\u8a18\u9332\u3092\u4e00\u6642\u7684\u306b\u505c\u6b62\u3059\u308b
  public void stopRecordTextBuffer() {  recordTextBuffer = false; }
  // \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u3078\u306e\u8a18\u9332\u3092\u518d\u958b\u3059\u308b
  public void startRecordTextBuffer() { recordTextBuffer = true;  }
  // \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u306e\u6307\u5b9a\u3055\u308c\u305f\u884c\u304b\u3089\uff11\u30da\u30fc\u30b8\u5206\u3092\u518d\u63cf\u753b\u3059\u308b
  public void redrawPage() {
    // \u81ea\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\uff08Run\u4e2d\uff09\u306e\u305f\u3081\u306b\u30ab\u30ec\u30f3\u30c8\u5c5e\u6027\u3092\u30d0\u30c3\u30af\u30a2\u30c3\u30d7
    textAttrClass bakAttr = new textAttrClass();
    bakAttr.clone(currentAttr);
    // \u518d\u63cf\u753b
    redrawPage(textbuffer.readingLine);
    // \u30ab\u30ec\u30f3\u30c8\u5c5e\u6027\u306e\u30d0\u30c3\u30af\u30a2\u30c3\u30d7\u3092\u30ea\u30b9\u30c8\u30a2
    currentAttr.clone(bakAttr);
  }
  public void redrawPage(int line) {
    int       lineCount, dcy;
    lineClass thisline;

    // \u8868\u793a\u958b\u59cb\u884c\u6570\u306e\u30c1\u30a7\u30c3\u30af
    textbuffer.incrementReadingLine(0);
    // \u521d\u671f\u5316
    _clrscr();
    thisline = textbuffer.getTargetLine(line);
    // \u518d\u63cf\u753b
    // \u30b9\u30af\u30ed\u30fc\u30eb\u8868\u793a\u6642\u306f\u4e00\u6642\u7684\u306b\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u3092\u5f37\u5236\u7684\u306b\u30aa\u30d5\u306b\u3059\u308b
    boolean over_flag = config.noOverlap;
    disableOverlap();
    for (lineCount = 0; lineCount < screenSetting.cheight; lineCount += dcy) {
      if (!thisline.flag) break; // \u3053\u308c\u4ee5\u964d\uff0c\u30c6\u30ad\u30b9\u30c8\u304c\u51fa\u529b\u3055\u308c\u3066\u3044\u306a\u3044\u306e\u3067\u629c\u3051\u308b
      dcy      = writelnText(thisline.line);
      thisline = thisline.next;
    }
    // \u5143\u306e\u72b6\u614b\u306b\u623b\u3059
    config.noOverlap = over_flag;
  }
  // \u30da\u30fc\u30b8\u5358\u4f4d\u306e\u30b9\u30af\u30ed\u30fc\u30eb
  // page\u304c\u6b63\u3067\u4e0b\uff0c\u8ca0\u3067\u4e0a\u306b\u30b9\u30af\u30ed\u30fc\u30eb
  public void pageScroll(float page) {
    textbuffer.incrementReadingLine(PApplet.parseInt(screenSetting.cheight * page));
    redrawPage();
  }
  // \u6307\u5b9a\u3057\u305f\u884c\u6570\u3060\u3051\u4e0a/\u4e0b\u306b\u30b9\u30af\u30ed\u30fc\u30eb\u3059\u308b
  // num \u304c\u6b63\u3067\u4e0b\uff0c\u8ca0\u3067\u4e0a\u306b\u30b9\u30af\u30ed\u30fc\u30eb
  public void pageLineScroll(int num) {
    textbuffer.incrementReadingLine(num);
    redrawPage();
  }
  // \u6700\u65b0\u306e\u30da\u30fc\u30b8\u3092\u518d\u63cf\u753b\uff08\u30ab\u30fc\u30bd\u30eb\u4f4d\u7f6e\u304c\u5fa9\u5143\u3055\u308c\u306a\u3044\u306e\u306f\u4ed5\u65b9\u304c\u7121\u3044
  public void redrawNewestPage() {
    int  linenumber;
    if (textbuffer.totalLines < screenSetting.cheight) textbuffer.setReadingLine(0);
    else                                               textbuffer.setReadingLine(textbuffer.totalLines - PApplet.parseInt(screenSetting.cheight / 2.0f));
    redrawPage();
  }
  // \u65b0\u3057\u3044\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u5f62\u5f0f\u3067\u4e00\u884c\u5206\u306e\u51fa\u529b\uff08\u8272\u3064\u304d\uff09
  public int writelnText(sentenceClass sen) {
    int num = 1;
    int dy;
    while (true) {
      textColor(sen.attr.textColor);
      // \u30c6\u30ad\u30b9\u30c8\u30ab\u30e9\u30fc\u3092\u5909\u66f4
      if (tomahawkMode == 2) {
        // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4f7f\u7528\u6642
        screenSetting.pgText.beginDraw();
        screenSetting.pgText.fill(sen.attr.textColor, 255f);
        screenSetting.pgText.endDraw();
      } else {
        // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4e0d\u4f7f\u7528\u6642
        fill(sen.attr.textColor, 255);
      }
      if ((dy = setWrite(sen.sentence)) > 1) num += (dy - 1);
      if (sen.next == null) break;
      sen = sen.next;
    }
    writeln("");
    return num;
  }
  // ------------------------
  // \u6587\u5b57\u8272\u3068\u80cc\u666f\u8272\u306e\u521d\u671f\u8a2d\u5b9a
  // ------------------------
  // \u6587\u5b57\u306e\u8272\u306e\u307f\u3092\u5909\u66f4\u3059\u308b
  // (a) \u73fe\u5728\u306e\u8a2d\u5b9a\u5024\u3092\u8fd4\u3059
  public int textColor() { return currentAttr.textColor; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public int setTextColor(int textcolor) {
    int oldColor = currentAttr.textColor;
    if (brightness(textcolor) <= 2.0f) textcolor = 0xFF000002;  // PGraphics\u306e\u4ed5\u69d8\u4e0a\u306e\u554f\u984c\u70b9\u306e\u56de\u907f
    currentAttr.textColor = textcolor;
    if (tomahawkMode == 2) {
      // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4f7f\u7528\u6642
      screenSetting.pgText.beginDraw();
      screenSetting.pgText.fill(currentAttr.textColor, 255);
      screenSetting.pgText.endDraw();
    } else {
      // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4e0d\u4f7f\u7528\u6642
      fill(currentAttr.textColor);
    }
    return oldColor;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  // (c-1) \u6587\u5b57\u8272\u306e\u307f\u5909\u66f4
  public crowbarClass textColor(int textcolor) { setTextColor(textcolor); return crowbar; }
  // (c-2) \u6587\u5b57\u8272\u3068\u80cc\u666f\u3092\u540c\u6642\u306b\u5909\u66f4
  public crowbarClass textColor(int tcolor, int bcolor) {
    textColor(tcolor);
    bgColor(bcolor);
    return crowbar;
  }
  // \u80cc\u666f\u306e\u8272\u306e\u307f\u3092\u5909\u66f4\u3059\u308b\uff08\u3042\u307e\u308a\u304a\u52e7\u3081\u3057\u306a\u3044\uff09
  // (a) \u73fe\u5728\u306e\u8a2d\u5b9a\u5024\u3092\u8fd4\u3059
  public int bgColor() { return currentAttr.bgColor; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public int setBgColor(int bgcolor) {
    int oldColor        = currentAttr.bgColor;
    currentAttr.bgColor = bgcolor;
    return oldColor;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  public crowbarClass bgColor(int bgcolor) { setBgColor(bgcolor); return crowbar; }

  // \u30bf\u30d6\u6587\u5b57\u6570\u306e\u8a2d\u5b9a
  // (a) \u73fe\u5728\u306e\u8a2d\u5b9a\u5024\u3092\u8fd4\u3059
  public float tabSize() { return tabSize; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float setTabSize(float num) {
    float oldnum = tabSize();
    if ((num < 0.0f) || (num >= screenSetting.cwidth)) return oldnum;
    tabSize = num;
    return oldnum;
  }
  public crowbarClass tabSize(float num) { setTabSize(num); return crowbar; }
  // --------
  // \u30bf\u30d6\u51fa\u529b
  // --------
  public String getTabSpace() {
    String space = "";
    float num = PApplet.parseInt((cx + tabSize) % tabSize * 2);
//  if (num == 0) return "";
    if (num == 0) num = tabSize;
    num = PApplet.parseInt(tabSize * 2) - num;
    for (int i = 0; i < num; i++) space += " ";    
    return space;
  }
  // \u5f15\u6570\u6307\u5b9a\u306a\u3057\uff08\u8a2d\u5b9a\u5024\u3092\u4f7f\u7528\u3059\u308b\uff09
  public float setTab(boolean flag) {
    String space = getTabSpace();
    if (flag) write(space); else _write(space);
    return space.length() / 0.5f;
  }
  // \u5f15\u6570\u6307\u5b9a\u3042\u308a\uff08\u66ab\u5b9a\u7684\u306b\u6307\u5b9a\u3055\u308c\u305f\u5024\u3092\u4f7f\u7528\u3059\u308b\uff09
  public float setTab(float temp, boolean flag) {
    float bak = tabSize();
    tabSize   = temp;
    float num = setTab(flag);
    tabSize   = bak;
    return num;
  }
  // \u30e6\u30fc\u30b6\u306f\u4ee5\u4e0b\u306e\u95a2\u6570\u3092\u4f7f\u7528
  // \u5f15\u6570\u6307\u5b9a\u306a\u3057\uff08\u8a2d\u5b9a\u5024\u3092\u4f7f\u7528\u3059\u308b\uff09
  public float setTab()  { return setTab(true); }
  public float _setTab() { return setTab(false); }
  // \u5f15\u6570\u6307\u5b9a\u3042\u308a\uff08\u66ab\u5b9a\u7684\u306b\u6307\u5b9a\u3055\u308c\u305f\u5024\u3092\u4f7f\u7528\u3059\u308b\uff09
  public float setTab(float temp)  { return setTab(temp, true); }
  public float _setTab(float temp) { return setTab(temp, false); }
  public crowbarClass  tab() {  setTab(); return crowbar; }
  public crowbarClass _tab() { _setTab(); return crowbar; }
  public crowbarClass  tab(float temp) {  setTab(temp); return crowbar; }
  public crowbarClass _tab(float temp) { _setTab(temp); return crowbar; }

  // \u753b\u9762\u6d88\u53bb\uff08\u753b\u9762\u306e\u307f\u30af\u30ea\u30a2\uff09
  public crowbarClass _clrscr() {
    if (tomahawkMode == 2) {
      // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4f7f\u7528\u6642
      background(currentAttr.bgColor);  // \u80cc\u666f\u8272
      screenSetting.pgText.beginDraw();
      screenSetting.pgText.background(0xFF000000, 0);
      screenSetting.pgText.fill(currentAttr.textColor, 255);      // \u5857\u308a\u3064\u3076\u3057\u8272
      screenSetting.pgText.endDraw();
    } else {
      // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4e0d\u4f7f\u7528\u6642
//    background(_BGCOLOR);
      background(currentAttr.bgColor);
      fill(currentAttr.textColor);      // \u5857\u308a\u3064\u3076\u3057\u8272
    }
    cx = cy = 0;
    return crowbar;
  }
  // \u753b\u9762\u6d88\u53bb\uff08\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u3082\u30af\u30ea\u30a2\uff09
  public crowbarClass clrscr()        { _clrscr(); clrTextBuffer(); return crowbar;  }
  // \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u306e\u307f\u30af\u30ea\u30a2\uff09
  public crowbarClass clrTextBuffer() { textbuffer.clearTextBuffer(); return crowbar; }

  // \u30c6\u30ad\u30b9\u30c8\u51fa\u529b\uff08\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\uff0c\u30ed\u30b0\u8a18\u9332\uff0c\u30d0\u30c3\u30af\u30b9\u30da\u30fc\u30b9\u306b\u3088\u308b\u6d88\u53bb\u306b\u5bfe\u5fdc\uff09
  // \u623b\u308a\u5024\u306f\u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\u306b\u51fa\u529b\u3057\u305f\u5b9f\u969b\u306e\u884c\u6570\uff08\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u3092\u8003\u616e\uff09
  public int writeMain(String message) {
    int num = 0;
    if (!displaySwitch()) {
      rowCheck();
      num = _setWrite(message);
      if (recordTextBuffer) {
        textbuffer.appendSentence(message, currentAttr);
        // \u3082\u3057\u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u6307\u5b9a\u304c\u6709\u52b9\u304b\u3064\u4e00\u884c\u3092\u8d85\u3048\u3066\u3044\u308b\u306a\u3089\u3070\uff0c\u8d85\u3048\u3066\u3044\u308b\u5206\u3092\u5148\u306b\u78ba\u5b9a\u3059\u308b\uff0e
        if (!config.noOverlap) textbuffer.normalizeBuffer();
      }
    }
    // \u30b3\u30f3\u30bd\u30fc\u30eb\u306b\u51fa\u529b
    if ((!config.noTextArea) && (recordTextBuffer)) print(message);
    // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u8a18\u9332
    if (enableLogging) print2Log(message);
    return num;
  }
  // \u30e6\u30fc\u30b6\u306f\u4ee5\u4e0b\u306e\u95a2\u6570\u3092\u4f7f\u7528
  // \u30c6\u30ad\u30b9\u30c8\u51fa\u529b\uff08\u5358\u7d14\u306b\u63cf\u753b\u3059\u308b\u3060\u3051\uff09: Draw()\u4e2d\u3067\u5229\u7528\u3059\u308b\u306e\u306b\u9069\u3057\u3066\u3044\u308b
  public int _setWrite(int value)     { return _setWrite(str(value)); }
  public int _setWrite(float value)   { return _setWrite(str(value)); }
  public int _setWrite(boolean value) { return _setWrite(str(value)); }
  public int _setWrite(String message) {
    int  i, num = 1;
    if (message == null) return 0;
    // \u30c6\u30ad\u30b9\u30c8\u306e\u8272\u3092\u5fa9\u5143\u3059\u308b
    if (tomahawkMode == 2) {
      // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4f7f\u7528\u6642
      screenSetting.pgText.beginDraw();
      screenSetting.pgText.fill(currentAttr.textColor, 255);
      screenSetting.pgText.endDraw();
    } else {
      // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4e0d\u4f7f\u7528\u6642
      fill(currentAttr.textColor);
    }
    rowCheck();
    for (i = 0; i < message.length(); i++) {
      if (message.charAt(i) == '\n') {  // \u6539\u884c\uff08write()\u306f\u4e0a\u4f4d\u3067\u5207\u308a\u5206\u3051\u308b\uff09
        cx = 0;
        cy++;
        num++;
        rowCheck();
      } else putchar(message.charAt(i));
      // \u6298\u308a\u8fd4\u3057\u8868\u793a\u306b\u95a2\u3059\u308b\u51e6\u7406
      if (config.noOverlap != true) {
        if (cx >= screenSetting.cwidth) {
          // \u3053\u3053\u3067normalizeBuffer()\u304c\u5fc5\u8981\u304b\uff1f
          cx = 0;
          cy++;
          num++;
          rowCheck();
        }
      }
    }
    return num;
  }
  // \u5ea7\u6a19\u6307\u5b9a\uff08\u30ed\u30b0\u51fa\u529b\u7b49\u306a\u3057\uff09
  public int _setWrite(float x, float y, int value)     { return _setWrite(x, y, str(value)); }
  public int _setWrite(float x, float y, float value)   { return _setWrite(x, y, str(value)); }
  public int _setWrite(float x, float y, boolean value) { return _setWrite(x, y, str(value)); }
  public int _setWrite(float x, float y, String message) {
    locate(x, y);
    return _setWrite(message);
  }
  public crowbarClass _write(int value)      { return _write(str(value)); }
  public crowbarClass _write(float value)    { return _write(str(value)); }
  public crowbarClass _write(boolean value)  { return _write(str(value)); }
  public crowbarClass _write(String message)                   { _setWrite(message);       return crowbar; }
  public crowbarClass _write(float x, float y, String message) { _setWrite(x, y, message); return crowbar; }
  // \u6539\u884c\u3042\u308a
  public int _setWriteln(int value)     { return _setWriteln(str(value)); }
  public int _setWriteln(float value)   { return _setWriteln(str(value)); }
  public int _setWriteln(boolean value) { return _setWriteln(str(value)); }
  public int _setWriteln(String message) {
    int  num;
    num = _setWrite(message);
    cy++;
    cx = 0;
    return num;
  }
  // \u5ea7\u6a19\u6307\u5b9a\uff08\u30ed\u30b0\u51fa\u529b\u7b49\u306a\u3057\uff09
  public int _setWriteln(float x, float y, int value)     { return _setWriteln(x, y, str(value)); }
  public int _setWriteln(float x, float y, float value)   { return _setWriteln(x, y, str(value)); }
  public int _setWriteln(float x, float y, boolean value) { return _setWriteln(x, y, str(value)); }
  public int _setWriteln(float x, float y, String message) {
    locate(x, y);
    return _setWriteln(message);
  }
  public crowbarClass _writeln(int value)     { return _writeln(str(value)); }
  public crowbarClass _writeln(float value)   { return _writeln(str(value)); }
  public crowbarClass _writeln(boolean value) { return _writeln(str(value)); }
  public crowbarClass _writeln(String message)                   { _setWriteln(message);       return crowbar; }
  public crowbarClass _writeln(float x, float y, int value)      { return _writeln(x, y, str(value)); }
  public crowbarClass _writeln(float x, float y, float value)    { return _writeln(x, y, str(value)); }
  public crowbarClass _writeln(float x, float y, boolean value)  { return _writeln(x, y, str(value)); }
  public crowbarClass _writeln(float x, float y, String message) { _setWriteln(x, y, message); return crowbar; }
  // \u6587\u5b57\u5217\u8868\u793a\uff08\u6539\u884c\u7121\u3057\uff09
  public int setWrite(int value)     { return setWrite(str(value)); }
  public int setWrite(float value)   { return setWrite(str(value)); }
  public int setWrite(boolean value) { return setWrite(str(value)); }
  public int setWrite(String message) {
    int num = 0;
    String [] msg = split(message, '\n');  // \u6539\u884c\u5bfe\u5fdc
    for (int i = 0; i < msg.length; i++) {
      if (i < msg.length - 1) num += setWriteln(msg[i]);
        else                  num += writeMain(msg[i]);
    }
    return num;
  }
  // \u5ea7\u6a19\u6307\u5b9a\uff08\u30ed\u30b0\u51fa\u529b\u7b49\u5bfe\u5fdc\uff09
  public int setWrite(float x, float y, int value)      { return setWrite(x, y, str(value)); }
  public int setWrite(float x, float y, float value)    { return setWrite(x, y, str(value)); }
  public int setWrite(float x, float y, boolean value)  { return setWrite(x, y, str(value)); }
  public int setWrite(float x, float y, String message) {
    int     num;
    boolean flag;
    flag = textAreaSwitch();
    disableTextArea();
    locate(x, y);
    num = setWrite(message);
    textAreaSwitch(flag);
    return num;
  }
  public crowbarClass write(int value)     { return write(str(value)); }
  public crowbarClass write(float value)   { return write(str(value)); }
  public crowbarClass write(boolean value) { return write(str(value)); }
  public crowbarClass write(String message)                   { setWrite(message);       return crowbar; }
  public crowbarClass write(float x, float y, int value)      { return write(x, y, str(value)); }
  public crowbarClass write(float x, float y, float value)    { return write(x, y, str(value)); }
  public crowbarClass write(float x, float y, boolean value)  { return write(x, y, str(value)); }
  public crowbarClass write(float x, float y, String message) { setWrite(x, y, message); return crowbar; }
  // \u30c6\u30ad\u30b9\u30c8\u51fa\u529b\uff08\u6539\u884c\uff09
  public int setWriteln(int value)     { return setWriteln(str(value)); }
  public int setWriteln(float value)   { return setWriteln(str(value)); }
  public int setWriteln(boolean value) { return setWriteln(str(value)); }
  public int setWriteln(String message) {
    int num = setWrite(message); // \u4ee5\u4e0b\u6539\u884c\u306e\u307f\u51fa\u529b
    if (!displaySwitch()) {
      if (recordTextBuffer) textbuffer.setLine(!config.noOverlap);
      cy++;
      cx = 0;
    }
    // \u30b3\u30f3\u30bd\u30fc\u30eb\u306b\u51fa\u529b
    if (!config.noTextArea) if (recordTextBuffer) println();
    // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u8a18\u9332
    if (enableLogging) println2Log("");
    return num;
  }
  // \u5ea7\u6a19\u6307\u5b9a\uff08\u30ed\u30b0\u51fa\u529b\u7b49\u5bfe\u5fdc\uff09
  public int setWriteln(float x, float y, int value)      { return setWriteln(x, y, str(value)); }
  public int setWriteln(float x, float y, float value)    { return setWriteln(x, y, str(value)); }
  public int setWriteln(float x, float y, boolean value)  { return setWriteln(x, y, str(value)); }
  public int setWriteln(float x, float y, String message) {
    int     num;
    boolean flag;
    flag = textAreaSwitch();
    disableTextArea();
    locate(x, y);
    num = setWriteln(message);
    textAreaSwitch(flag);
    return num;
  }
  public crowbarClass writeln(int value)     { return writeln(str(value)); }
  public crowbarClass writeln(float value)   { return writeln(str(value)); }
  public crowbarClass writeln(boolean value) { return writeln(str(value)); }
  public crowbarClass writeln(String message)                   { setWriteln(message);       return crowbar; }
  public crowbarClass writeln(float x, float y, int value)      { return writeln(str(value)); }
  public crowbarClass writeln(float x, float y, float value)    { return writeln(str(value)); }
  public crowbarClass writeln(float x, float y, boolean value)  { return writeln(str(value)); }
  public crowbarClass writeln(float x, float y, String message) { setWriteln(x, y, message); return crowbar; }
  // \u6539\u884c
  public crowbarClass newline() { writeln(""); return crowbar; }
  public crowbarClass newline(int n) { String str = ""; for (int i = 0; i < n; i++, str += "\n"); write(str); return crowbar; }
  // \u884c\u982d\u3078\u79fb\u52d5
  public crowbarClass cr()      { locate(0.0f, locateY()); return crowbar; }
  // ----------
  // \u8a2d\u5b9a\u306e\u5909\u66f4
  // ----------
  // \u30a6\u30a3\u30f3\u30c9\u30a6\u30b5\u30a4\u30ba\u306e\u5909\u66f4\uff1a\u3000\u5f37\u5236\u7684\u306b\u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\u306e\u30b5\u30a4\u30ba\u304c\u5909\u66f4\u3055\u308c\u308b\u3060\u3051\u3067\u30c6\u30ad\u30b9\u30c8\u753b\u9762\u306e\u51e6\u7406\u306b\u306f\u53cd\u6620\u3055\u308c\u306a\u3044\u305f\u3081\u975e\u63a8\u5968\uff0e
  public crowbarClass windowSize(int x, int y) {
    screenSetting.gwx = x;
    screenSetting.gwy = y;
    size(screenSetting.gwx, screenSetting.gwy);
    return crowbar;
  }
  // \u30c7\u30a3\u30b9\u30d7\u30ec\u30a4\u8868\u793a\u306e\u6291\u5236\u3068\u8a31\u53ef
  // (a) \u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059
  public boolean displaySwitch() { return config.noDisplay; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u8a2d\u5b9a\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public boolean setDisplaySwitch(boolean flag) {
    boolean oldflag = displaySwitch();
    config.noDisplay = flag;
    return oldflag;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  public crowbarClass disableDisplay()            { config.noDisplay = true;  return crowbar; }
  public crowbarClass enableDisplay()             { config.noDisplay = false; return crowbar; }
  public crowbarClass displaySwitch(boolean flag) { setDisplaySwitch(flag);   return crowbar; }
  // \u30c6\u30ad\u30b9\u30c8\u30a8\u30ea\u30a2\u8868\u793a\u306e\u6291\u5236\u3068\u8a31\u53ef
  // (a) \u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059
  public boolean textAreaSwitch() { return config.noTextArea; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u8a2d\u5b9a\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public boolean setTextAreaSwitch(boolean flag) { 
    boolean oldflag = textAreaSwitch();
    config.noTextArea = flag;
    return oldflag;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  public crowbarClass disableTextArea()            { config.noTextArea = true;  return crowbar; }
  public crowbarClass enableTextArea()             { config.noTextArea = false; return crowbar; }
  public crowbarClass textAreaSwitch(boolean flag) { setTextAreaSwitch(flag);   return crowbar; }
  // \u30aa\u30fc\u30d0\u30fc\u30e9\u30c3\u30d7\u8868\u793a\uff08\u6298\u308a\u8fd4\u3057\uff09\u306e\u6291\u5236\u3068\u8a31\u53ef
  // (a) \u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059
  public boolean overlapSwitch() { return config.noOverlap; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u8a2d\u5b9a\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public boolean setOverlapSwitch(boolean flag) { 
    boolean oldflag = overlapSwitch();
    config.noOverlap = flag;
    return oldflag;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  public crowbarClass disableOverlap()            { config.noOverlap = true;  return crowbar; }
  public crowbarClass enableOverlap()             { config.noOverlap = false; return crowbar; }
  public crowbarClass overlapSwitch(boolean flag) { setOverlapSwitch(flag);   return crowbar; }
  // \u534a\u89d2\u82f1\u6570\u5b57\u51fa\u529b\u6642\u306e\u6587\u5b57\u5e45\u30920.5\u306b\u56fa\u5b9a\u3059\u308b\u304b
  // (a) \u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059
  public boolean proportionalFontSwitch() { return config.proportional; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u8a2d\u5b9a\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public boolean setProportionalFontSwitch(boolean flag) {
    boolean oldflag = proportionalFontSwitch();
    if (!crowbar.checkOptionsSetupOnly("setProportionalFontSwitch()", null, false)) config.proportional = flag;
    return oldflag;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  public crowbarClass enableProportionalFont() {
    if (!crowbar.checkOptionsSetupOnly("enableProportionalFont()", null, false)) config.proportional = true;
    return crowbar;
  }
  public crowbarClass disableProportionalFont(){
    if (!crowbar.checkOptionsSetupOnly("disableProportionalFont()", null, false)) config.proportional = false;
    return crowbar;
  }
  public crowbarClass proportionalFontSwitch(boolean flag) {
    if (!crowbar.checkOptionsSetupOnly("setProportionalFont()", null, false)) proportionalFontSwitch(flag);
    return crowbar;
  }
  // \uff08\u4e3b\u306bTomahawk\u3067\uff09\u89d2\u5ea6\u306e\u5358\u4f4d\u3092\u5ea6\u3068\u3059\u308b\u304b
  // (a) \u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059
  public boolean angleModeSwitch()  { return config.degreeBase; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u8a2d\u5b9a\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public boolean setAngleModeSwitch(boolean flag) {
    boolean oldflag = angleModeSwitch();
    config.degreeBase = flag;
    return oldflag;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  public crowbarClass degreeAngleMode()             { config.degreeBase = true;  return crowbar; }
  public crowbarClass radianAngleMode()             { config.degreeBase = false; return crowbar; }
  public crowbarClass angleModeSwitch(boolean flag) { setAngleModeSwitch(flag);  return crowbar; }

  // \u3010\u30c6\u30ad\u30b9\u30c8\u51fa\u529b\u306e\u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u3078\u306e\u51fa\u529b\u3011
  // Main() \u3068 Draw()\u5b9f\u884c\u4e2d\u306ecrowbar.write()/writeln()\u3092\u30ed\u30b0\u306b\u8a18\u9332
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u8a18\u9332\u958b\u59cb\uff1aOptions()\u306e\u4e2d\u3067\u5ba3\u8a00\u3059\u308b\u306e\u304c\u7121\u96e3\u3060\u304c\uff0c
  // \u305d\u308cMain()\u3084Draw()\u306e\u4e2d\u3067\u5ba3\u8a00\u3057\u3066\u3082\u69cb\u308f\u306a\u3044\uff0e
  // \u30d5\u30a1\u30a4\u30eb\u3078\u306e\u8ffd\u8a18\u306f\u4ed5\u69d8\u4e0a\u4e0d\u53ef\u80fd\u306a\u3088\u3046\u306a\u306e\u3067\uff0c\u73fe\u72b6\u3067\u306f\u672a\u5bfe\u5fdc
  // \u65e2\u306b\u8a18\u9332\u958b\u59cb\u3057\u3066\u3044\u3066\u30af\u30ed\u30fc\u30ba\u3055\u308c\u3066\u3044\u306a\u3044\u5834\u5408\u306f\uff0c\u73fe\u5728\u8a18\u9332\u4e2d\u306e\u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u3092\u9589\u3058\u3066\u65b0\u3057\u304f\u8a18\u9332\u3092\u958b\u59cb\u3059\u308b
  // 1) \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u30c7\u30d5\u30a9\u30eb\u30c8\u30d5\u30a1\u30a4\u30eb\u540d\u3092\u5909\u66f4\u3059\u308b
  public String defaultFilename() { return logging.setDefaultFilename();  }
  public String setDefaultFilename(String fname) { 
    if (fname.length() == 0) return defaultFilename();
    return logging.setDefaultFilename(fname);
  }
  public crowbarClass defaultFilename(String fname) { defaultFilename(fname); return crowbar; }
  // 2-1) \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u30aa\u30fc\u30d7\u30f3\uff08\u5f15\u6570\u7121\u3057\uff1a\u30c7\u30d5\u30a9\u30eb\u30c8\u306e\u30d5\u30a1\u30a4\u30eb\u540d\u3067\u4fdd\u5b58\uff09
  public crowbarClass startLogging() { return startLogging(""); }
  // 2-2) \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u30aa\u30fc\u30d7\u30f3\uff08\u30d5\u30a1\u30a4\u30eb\u540d\u6307\u5b9a\u3042\u308a\uff09
  public crowbarClass startLogging(String fname) {
    logging.setFileName(fname);
    println("\u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u3092\u4f5c\u6210\u3057\u307e\u3059\uff1a" + logging.logFileName);
    if (logging.startLogging() == null) crowbar.errorMessage("\u30a8\u30e9\u30fc", "startLogging()\u306b\u3066\u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u4f5c\u6210\u306b\u5931\u6557\u3057\u307e\u3057\u305f\uff0e", logging.logFileName, false);
    return crowbar;
  }
  public PrintWriter getLogfile() { return logging.getLogfile(); }
  // 3) \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u30af\u30ed\u30fc\u30ba\uff08\u660e\u793a\u3057\u306a\u3044\u3067\u3082crowbar\u7d42\u4e86\u6642\u306b\u9589\u3058\u3066\u304f\u308c\u308b\uff09
  public crowbarClass stopLogging()    { logging.stopLogging();    return crowbar; }
  // 4-1) \u30ed\u30b0\u8a18\u9332\u306e\u4e00\u6642\u4e2d\u65ad
  public crowbarClass pauseLogging()   { logging.pauseLogging();   return crowbar; }
  // 4-2) \u30ed\u30b0\u8a18\u9332\u306e\u518d\u958b
  public crowbarClass restartLogging() { logging.restartLogging(); return crowbar; }
  // 5) \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u306e\u307fprint()
  public crowbarClass print2Log(String str)   { logging.print2Log(str); return crowbar; }
  // 6) \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u306e\u307fprintln()
  public crowbarClass println2Log(String str) { logging.println2Log(str); return crowbar; }
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u306e\u307fnewline()
  public crowbarClass newline2Log()      { logging.newline2Log(); return crowbar; }
  public crowbarClass newline2Log(int n) { for (int i = 0; i < n; i++) logging.newline2Log(); return crowbar; }

  // \u4ee5\u4e0b\u306f\u30e6\u30fc\u30b6\u304c\u7528\u3044\u3066\u306f\u3044\u3051\u306a\u3044\uff08\u30b7\u30b9\u30c6\u30e0\u7528\uff09
  public void enableLogOutput()     { enableLogging = true; return; }
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u51fa\u529b\u3092\u8a31\u53ef
  public void disableLogOutput()    { enableLogging = false; return; }
  // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306e\u51fa\u529b\u3092\u4e0d\u8a31\u53ef
  public boolean isEnableLogging()  { return logging.isEnableLogging(); }

  // --------------- \u30ad\u30fc\u30dc\u30fc\u30c9\u5165\u529b\u95a2\u9023 -------------------
  // \u4ee5\u4e0b\u306e\u95a2\u6570\u3084\u5909\u6570\u3092\u30e6\u30fc\u30b6\u306f\u5229\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044
  //
  private String keyBuffer = "";
  boolean inputNow = false;    // \u30a8\u30b3\u30fc\u30d0\u30c3\u30af\u3042\u308a
  boolean inputFixed = false;  // ENTER\u304c\u5165\u529b\u3055\u308c\u305f\u3089true
  // \u30d0\u30c3\u30d5\u30a1\u30af\u30ea\u30a2  
  public void flushKeyBuffer() {
    keyBuffer = "";
    inputFixed = false;
  }
  // \u6587\u5b57\u5217\u9577\u3092\u8fd4\u3059
  public int keyBufferLength() { return keyBuffer.length(); }
  // \u30b3\u30f3\u30bd\u30fc\u30eb\u304b\u3089\u306e\u5165\u529b\u3092\u958b\u59cb
  public void startInput() {
    inputFixed = false;
    inputNow   = true;
  }
  // \u30ad\u30fc\u30dc\u30fc\u30c9\u5165\u529b\u5b8c\u4e86
  public void inputFinish() {
    inputFixed = true;
    inputNow   = false;
  }
  // \u6587\u5b57\u5217\u306e\u8ffd\u52a0
  public void strcat(String str) { keyBuffer += str; }
  // \u30ad\u30fc\u30d0\u30c3\u30d5\u30a1\u30fc\u3092\u8aad\u307f\u51fa\u3059
  public String getKeyBuffer() {
    String buf;
    buf = keyBuffer;  // \u30a4\u30f3\u30b9\u30bf\u30f3\u30b9\u306e\u30af\u30ed\u30fc\u30f3\u304c\u4f5c\u6210\u3055\u308c\u308b\u306e\u306a\u3089\u826f\u3044\u3051\u308c\u3069\uff0e
    keyBuffer = "";
    inputNow   = false;
    inputFixed = false;
    return buf;  // \u6587\u5b57\u5217\u30c7\u30fc\u30bf\u306e\u307f\u3092\u8fd4\u3055\u306a\u304f\u3066\u826f\u3044\u306e\u304b\uff1f
  }

  // ------------------------------------
  // Draw()\u4e2d\u306e\u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u6587\u5b57\u5217\u5165\u529b
  // ------------------------------------
  // (1) \u6709\u52b9/\u7121\u52b9\u306e\u5207\u308a\u66ff\u3048
  // (1-1) \u6709\u52b9\u5316
  public crowbarClass inputEnable(int lines)  {
    if (!crowbar.checkOptionsSetupNot("inputEnable()", null, false)) input.enable(lines);
    return crowbar;
  }
  public crowbarClass inputEnable() { return inputEnable(1); }
  // (1-2) \u7121\u52b9\u5316
  public crowbarClass inputDisable() {
    if (!crowbar.checkOptionsSetupNot("inputEnable()", null, false)) input.disable();
    return crowbar;
  }
  // (2) \u30d0\u30c3\u30d5\u30a1\u306e\u30af\u30ea\u30a2
  public crowbarClass inputFlush() { input.flush(); return crowbar; }
  // (3) \u6587\u5b57\u5217\u306e\u53d6\u5f97
  // (3-1) \u53d6\u5f97\uff06\u30d0\u30c3\u30d5\u30a1\u30af\u30ea\u30a2
  public String gets() { return input.gets(true); }
  // (3-2) \u53d6\u5f97\u306e\u307f
  public String echo() { return input.gets(false); }
  // (4) \u5165\u529b\u78ba\u5b9a\uff08ENTER\uff09\uff1f
  public int inputFinished() { return input.finished; }
}

//////////////////////////////
// \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u6700\u5c0f\u5358\u4f4d\u306e\u30af\u30e9\u30b9
//////////////////////////////
class arguments {
  boolean ready;    // \u5165\u529b\u6e08\u307f\u304b
  String  label;    // \u30d1\u30e9\u30e1\u30fc\u30bf\u540d\u79f0\uff0e\u7701\u7565\u6642\u306fnull
  String  message;  // \u30c6\u30ad\u30b9\u30c8\u753b\u9762\u306b\u8868\u793a\u3059\u308b\u30e1\u30c3\u30bb\u30fc\u30b8
  String  value;    // \u30ad\u30fc\u30dc\u30fc\u30c9\u304b\u3089\u5165\u529b\u3055\u308c\u305f\u30c7\u30fc\u30bf\uff08\u6587\u5b57\u5217\uff09
  String  initialValue;   // ""\u306e\u5834\u5408\u306f\u521d\u671f\u5024\u306e\u6307\u5b9a\u306a\u3057\u3068\u5224\u65ad
  String [] selectValues; // null\u306e\u5834\u5408\u306f\u9078\u629e\u80a2\u30bf\u30a4\u30d7\u3067\u306f\u306a\u3044\u3068\u5224\u65ad\uff08\u8a2d\u5b9a\u6642\u306f\u7a7a\u767d\u3067\u533a\u5207\u3089\u308c\u305f\u6587\u5b57\u5217\uff09
  char    parameterType;  // 'A': Normal, 'N': \u6570\u5024\u306e\u307f, 'I':\u6574\u6570\u306e\u307f, 'B':\u6d6e\u52d5\u5c0f\u6570\u70b9\u306e\u307f, 'S': \u9078\u629e\u80a2
  // \u914d\u5217\u578b\u7528
  int         arrayType; // 0: false, 1:\u4e00\u6b21\u5143\u30a8\u30f3\u30c9\u30ec\u30b9, 2:\u4e00\u6b21\u5143\u5373\u5024, 3:\u4e00\u6b21\u5143\u30e9\u30d9\u30eb, 4:\u4e8c\u6b21\u5143\uff08\u5373\u5024\uff0c\u5373\u5024\uff09, 5:\u4e8c\u6b21\u5143\uff08\u5373\u5024, \u30e9\u30d9\u30eb), 6:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u5373\u5024\uff09, 7:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u30e9\u30d9\u30eb\uff09
  int         index1;  // \u30a8\u30f3\u30c9\u30ec\u30b9\u5165\u529b\u6642\u306f\u521d\u671f\u50240\u304b\u3089\u30b9\u30bf\u30fc\u30c8\u3057\u3066\u5165\u529b\u78ba\u5b9a\u3068\u3068\u3082\u306b\u30a4\u30f3\u30af\u30ea\u30e1\u30f3\u30c8\uff0e\u78ba\u5b9a\u3057\u3066ready\u3092true\u3078
  int         index2;  // \u4e00\u6b21\u5143\u6642\u306f-1\u306e\u307e\u307e
  String [][] arrayValue;
  boolean     endless;
  int         labelIndex1;  // \u30e9\u30d9\u30eb\u306b\u3088\u308b\u9593\u63a5\u6307\u5b9a\u304c\u3055\u308c\u3066\u3044\u306a\u3044\u5834\u5408\u306f -1
  int         labelIndex2;
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  arguments() {
    label   = null;
    message = value = initialValue = "";
    selectValues  = null;
    parameterType = 'A';
    arrayType = 0;
    index1 = index2 = -1;
    endless = false;
    labelIndex1 = labelIndex2 = -1;
    resetArgument();
  }
  public void resetArgument() {
    ready   = false;
    if (arrayType == 1) index2 = 0;
    arrayValue = null;
  }
  // \u5024\u3092\u8a2d\u5b9a\uff08\u6a19\u6e96\uff09
  public void set(String str) {
    value = str;
    ready = true;
  }
  // \u5024\u3092\u8a2d\u5b9a\uff08\u914d\u5217\uff09
  public boolean setArray(int idx, String str) {
    if ((arrayValue == null) || (arrayType == 0)) return false;
    if (idx > index1) return false;
    arrayValue[0][idx] = str;
    if ((index2 == 0) && (index1 == idx)) ready = true;
    return true;
  }
  public boolean setArray(int idx1, int idx2, String str) {
    if ((arrayValue == null) || (arrayType == 0)) return false;
    if ((idx1 == index1) && (idx2 == index2)) ready = true;
    arrayValue[idx1][idx2] = str;
    return true;
  }
  // \u30e9\u30d9\u30eb\u540d\u306e\u8a2d\u5b9a
  public void setLabel(String str) { label = str.toUpperCase(); }
}

class frontendClass extends consoleClass { 
  arguments [] argv;                    // \u30d1\u30e9\u30e1\u30fc\u30bf\u7fa4\uff08\u30e6\u30fc\u30b6\u306b\u3088\u308a\u5bfe\u8a71\u7684\u306b\u5165\u529b\u3055\u308c\u308b\uff09
  int          argc;                    // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u6570
  protected int obtainArgIndex = 0;     // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u30b3\u30e1\u30f3\u30c8\u5ba3\u8a00\u6642\u306e\u81ea\u52d5\u767b\u9332\u7528\u30ab\u30a6\u30f3\u30bf
  protected int readArgIndex = 0;       // \u30d1\u30e9\u30e1\u30fc\u30bf\u81ea\u52d5\u8aad\u307f\u51fa\u3057\u7528\u30ab\u30a6\u30f3\u30bf
  protected boolean autoInput = false;  // TAB\u30ad\u30fc\u3092\u62bc\u3059\u3068\u305d\u308c\u4ee5\u964d\u306e\u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u3067\u306f\u521d\u671f\u5024\u3092\u63a1\u7528
  protected int obtainArrayIndex1, obtainArrayIndex2;  // \u914d\u5217\u5165\u529b\u6642\u306e\u30a4\u30f3\u30c7\u30c3\u30af\u30b9

  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  frontendClass(int x, int y, int mode) {
    // consoleClass\u306e\u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf\u3092\u547c\u3076
    super(x, y, mode);
    // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u521d\u671f\u5316
    argc = 0;
    argv = (arguments [])new arguments[1]; // \u5e38\u306b\u4e00\u3064\u4f59\u5206\u306b\u4f5c\u6210
    argv[0] = new arguments();
    resetArrayIndex();
  }
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5024\u306e\u30bb\u30c3\u30c8
  public void setValue(String str) { argv[obtainArgIndex].set(str); }
  // \u30ad\u30fc\u5165\u529b\u30eb\u30fc\u30eb\uff08\u6570\u5024\u306e\u307f\uff09
  public boolean is_numbersOnly() {
    if (argv[obtainArgIndex].parameterType == 'N') return true;
    return false;
  }
  public boolean is_integerOnly() {
    if (argv[obtainArgIndex].parameterType == 'I') return true;
    return false;
  }
  public boolean is_booleanOnly() {
    if (argv[obtainArgIndex].parameterType == 'B') return true;
    return false;
  }
  // \u30ad\u30fc\u5165\u529b\u30eb\u30fc\u30eb\uff08\u9078\u629e\u80a2\uff09
  // \u9078\u629e\u80a2\u578b\u306a\u3089\u3070\u9078\u629e\u80a2\u6570\uff08\u6700\u5927\uff11\uff10\uff09\u3092\u8fd4\u3059
  // \u9078\u629e\u80a2\u578b\u3067\u306f\u306a\u3044\u306a\u3089\u3070\uff10\u3092\u8fd4\u3059
  // \u7570\u5e38\u6642\u306f99\u3092\u8fd4\u3059
  public int is_selectOnly() {
    arguments arg;
    arg = argv[obtainArgIndex];
    if (arg.parameterType == 'S') {
      // \u30c1\u30a7\u30c3\u30af\uff11
      if (arg.selectValues == null) {
        crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u9078\u629e\u80a2\u578b\u306a\u306e\u306b\u9078\u629e\u80a2\u304c\u30bb\u30c3\u30c8\u3055\u308c\u3066\u3044\u307e\u305b\u3093", arg.message, true);
        return 99;
      }
      // \u30c1\u30a7\u30c3\u30af\uff12
      if (arg.selectValues.length > 10) {
        crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u9078\u629e\u80a2\u578b\u306e\u9078\u629e\u80a2\u306e\u6570\u304c\uff11\uff10\u500b\u3088\u308a\u591a\u3044", arg.message, true);
        return 99;
      }
      return arg.selectValues.length;
    }
    return 0;
  }
  // \u9078\u629e\u80a2\u578b\u306e\u9078\u629e\u3055\u308c\u305f\u30d1\u30e9\u30e1\u30fc\u30bf\u5024\u3092\u8fd4\u3059
  public String get_selectValue(int index) { return argv[obtainArgIndex].selectValues[index]; }
  // \u521d\u671f\u5024\u3092\u53d6\u5f97
  public String get_initialValue()         { return argv[obtainArgIndex].initialValue;        }
  ///////////////
  // \u30ad\u30fc\u5165\u529b\u5224\u5b9a
  // \u6570\u5b57\u5165\u529b\u7528\u30ad\u30fc\u304b\uff1f
  public boolean isKeyIntegers(char c) {
    if (isNumberChar(c)) return true;
    switch (c) {
    case '+' :
    case '-' :
      return true;
    }
    return false;
  }
  public boolean isKeyNumbers(char c) {
    if (isKeyIntegers(c)) return true;
    if (c == '.')         return true;
    return false;
  }
  public boolean isKeyBoolean(char c) {
    switch (c) {
      case '0':
      case '1':
      case 'Y':
      case 'y':
      case 'N':
      case 'n':
      case 'T':
      case 't':
      case 'F':
      case 'f': return true;
    }
    return false;
  }
  // \u5168\u3066\u306e\u30d1\u30e9\u30e1\u30fc\u30bf\u304c\u5165\u529b\u5b8c\u4e86\u3057\u3066\uff0cMain()\u3092\u5b9f\u884c\u53ef\u80fd\u304b\uff1f
  public boolean allReady() {
    int i;
    // \u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u304c\u6307\u5b9a\u3055\u308c\u3066\u3044\u306a\u3044
    if (argv == null) return true;
    // \u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u304c\u6307\u5b9a\u3055\u308c\u3066\u3044\u308b
    for (i = 0; i < argc; i++) {
      if (argv[i].ready != true) return false;
    }
    return true;
  }
  // \u5168\u3066\u306e\u5165\u529b\u5b8c\u4e86\u30d5\u30e9\u30b0\u3092\u30ea\u30bb\u30c3\u30c8\uff08\u518d\u5165\u529b\u6642\u7528\uff09
  public void allResetArguments() {
    int i;
    for (i = 0; i < argv.length; i++) argv[i].resetArgument(); // argv[i].ready = false;
    readArgIndex   = 0;
    obtainArgIndex = 0;
    resetArrayIndex();
  }
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u304c\u4e00\u3064\u3082\u6307\u5b9a\u3055\u308c\u3066\u3044\u306a\u3044\u5834\u5408\u306btrue\uff1a\u4f59\u8a08\u306a\u30b7\u30b9\u30c6\u30e0\u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u51fa\u529b\u3092\u6291\u5236\u3059\u308b\u305f\u3081
  public boolean isNoParameter() {
    if (argc == 0) return true;
    return false;
  }
  // \u914d\u5217\u5165\u529b\u95a2\u4fc2
  // arrayType; // 0: false, 1:\u4e00\u6b21\u5143\u30a8\u30f3\u30c9\u30ec\u30b9, 2:\u4e00\u6b21\u5143\u5373\u5024, 3:\u4e00\u6b21\u5143\u30e9\u30d9\u30eb, 4:\u4e8c\u6b21\u5143\uff08\u5373\u5024\uff0c\u5373\u5024\uff09, 5:\u4e8c\u6b21\u5143\uff08\u5373\u5024, \u30e9\u30d9\u30eb), 6:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u5373\u5024\uff09, 7:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u30e9\u30d9\u30eb\uff09
  public void resetArrayIndex() { obtainArrayIndex1 = obtainArrayIndex2 = 0; }
  public boolean setArrayValue(String data) {
    arguments param = argv[obtainArgIndex];
    if (param.arrayType == 1) {
      // \u7a7a\u306e\u5834\u5408\u306f\u5165\u529b\u5b8c\u4e86
      if (data.length() == 0){
        param.ready = true;
        return true;
      }
      // \u30a8\u30f3\u30c9\u30ec\u30b9\u6642\u306f\u5148\u306b\u62e1\u5f35\uff08expand()\u306f\u4e8c\u6b21\u5143\u306b\u5bfe\u5fdc\u3057\u3066\u3044\u308b\u306e\u304b\u4e0d\u660e\u306a\u306e\u3067\u2190\u8abf\u3079\u308d\u3088\uff09
      String [][] newArray = new String [1][++param.index2];
      for (int i = 0; i < param.index2 - 1; i++) newArray[0][i] = param.arrayValue[0][i];
      param.arrayValue = newArray;
    }
    param.arrayValue[obtainArrayIndex1][obtainArrayIndex2] = data;
    if (param.arrayType == 1) {
      obtainArrayIndex2++;  // \u30a8\u30f3\u30c9\u30ec\u30b9\u6642
    } else {
      if (++obtainArrayIndex2 >= param.index2) {
        obtainArrayIndex2 = 0;
        if (++obtainArrayIndex1 >= param.index1) {
          obtainArrayIndex1 = 0;
          param.ready = true;
        }
      }
    }
    return true;
  }
  public void initArrayInput() {
    arguments param = argv[obtainArgIndex];
    if ((param.index1 >= 0) && (param.index2 >= 0)) return;
    // \u30e9\u30d9\u30eb\u6307\u5b9a\u6642\u306e\u5024\u306e\u8aad\u307f\u51fa\u3057
    switch (param.arrayType) {
      case 0: return; // \u914d\u5217\u3067\u306f\u7121\u3044
      case 1: return; // \u30a8\u30f3\u30c9\u30ec\u30b9\u6642\u306f\u81ea\u52d5\u3067\u62e1\u5f35
      case 2:
      case 4: break;  // \u30e9\u30d9\u30eb\u306a\u3057
      case 3:
      case 6:
      case 7:
        if ((param.index1 = getInt(param.labelIndex1)) < 0) {
          crowbar.errorMessage("\u5b9f\u884c\u6642\u30a8\u30e9\u30fc", "\u914d\u5217\u306e\u5927\u304d\u3055\u3068\u3057\u3066\u5165\u529b\u3055\u308c\u305f\u5024\u304c0\u4ee5\u4e0b\u3067\u3059", "array()", true);
          return;
        }
        if ((param.arrayType == 3) || (param.arrayType == 6)) break;
      case 5:
        if ((param.index2 = getInt(param.labelIndex2)) < 0) {
          crowbar.errorMessage("\u5b9f\u884c\u6642\u30a8\u30e9\u30fc", "\u914d\u5217\u306e\u5927\u304d\u3055\u3068\u3057\u3066\u5165\u529b\u3055\u308c\u305f\u5024\u304c0\u4ee5\u4e0b\u3067\u3059", "array()", true);
          return;
        }
    }
    param.arrayValue = new String [param.index1][param.index2];
  }

  // ------------------------------
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u8aac\u660e\u306e\u53d6\u5f97
  // detail : \u8a73\u7d30\u306a\u60c5\u5831\uff08\u578b\u6307\u5b9a\uff09\u3092\u8868\u793a\u3059\u308b\u5834\u5408\u306ftrue
  public String get_paramMessage(int index, boolean detail) {
    String    message;
    arguments arg;

    // \u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u306e\u7bc4\u56f2\u306e\u30c1\u30a7\u30c3\u30af
    if ((index >= argc) || (index < 0)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "get\u7cfb\u547d\u4ee4\u3067\u30d1\u30e9\u30e1\u30fc\u30bf\u8aad\u307f\u51fa\u3057\u306eIndex\u304c\u7bc4\u56f2\u3092\u8d85\u3048\u3066\u3044\u307e\u3059", "Index=" + str(index), true);
      return "";
    }
    // \u8aac\u660e\u306e\u53d6\u5f97
    arg     = argv[index];
    // \u5168\u3066\u306e\u30bf\u30a4\u30d7\u306b\u5171\u901a
    message = arg.message;
    // \u914d\u5217\u306e\u5834\u5408
    // arrayType; // 0: false, 1:\u4e00\u6b21\u5143\u30a8\u30f3\u30c9\u30ec\u30b9, 2:\u4e00\u6b21\u5143\u5373\u5024, 3:\u4e00\u6b21\u5143\u30e9\u30d9\u30eb, 4:\u4e8c\u6b21\u5143\uff08\u5373\u5024\uff0c\u5373\u5024\uff09, 5:\u4e8c\u6b21\u5143\uff08\u5373\u5024, \u30e9\u30d9\u30eb), 6:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u5373\u5024\uff09, 7:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u30e9\u30d9\u30eb\uff09
    switch (arg.arrayType) {
      case 1: case 2: case 3:
        message += "(" + str(crowbar.obtainArrayIndex2) + ")"; break;
      case 4: case 5: case 6: case 7:
        message += "(" + str(crowbar.obtainArrayIndex1) + "," + str(crowbar.obtainArrayIndex2) + ")"; break;
    }
    if (!detail) return message;
    // \u4ee5\u4e0b\uff0c\u30aa\u30d7\u30b7\u30e7\u30f3\u306b\u3088\u3063\u3066\u30e1\u30c3\u30bb\u30fc\u30b8\u3092\u8ffd\u52a0
    // \u521d\u671f\u5024\u304c\u4e0e\u3048\u3089\u308c\u3066\u3044\u308b\u5834\u5408
    if (arg.initialValue.length() > 0) {
      if (!crowbar.run.silentMode) message += "\uff08" + arg.initialValue + "\uff09";
        else                       message += "\uff08\u521d\u671f\u5024\uff1a" + arg.initialValue + "\uff09";
    }
    // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u7a2e\u985e\u306b\u3088\u3063\u3066
    if (arg.parameterType == 'N') {
      // \u6570\u5b57\u306e\u307f
      if (!crowbar.run.silentMode) message += "\uff0f\u6570\u5b57\u306e\u307f";
    } else if (arg.parameterType == 'S') {
      // \u9078\u629e\u80a2\u578b
      int i;
      message += "\uff0f\uff08";
      for (i = 0; i < arg.selectValues.length; i++) {
        if (i > 0) message += ",";
        message += str(i) + ":" + arg.selectValues[i];
      }
      message += "\uff09";
    }
    return message;
  }
  // \u521d\u671f\u5024\u306e\u81ea\u52d5\u5165\u529b\u30e2\u30fc\u30c9\uff08true\u3067\u81ea\u52d5\u5165\u529b\uff09
  public void automaticInputByDefalutValue(boolean flag) { autoInput = flag; }
  // --------------------------------------------
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08\u753b\u9762\u306b\u8868\u793a\u3059\u308b\u30e1\u30c3\u30bb\u30fc\u30b8\uff09
  // --------------------------------------------
  // Ver.4 \u304b\u3089
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00
  public crowbarClass param(String str) {
    if (!crowbar.checkOptionsSetupOnly("defineStr()", str, true)) {
      argc = argv.length;
      argv = (arguments [])expand(argv, argc + 1);
      argv[argc] = new arguments();
      // \u73fe\u5728\u306e\u5024\u3092\u30bb\u30c3\u30c8
      argv[argc - 1].message = str;
    }
    return crowbar;
  }
  // (1) \u578b\u6307\u5b9a
  // (1a) \u6d6e\u52d5\u5c0f\u6570\u70b9\u578b
  public crowbarClass setFloat() {
    if (crowbar.checkOptionsSetupOnly("setFloat()", null, true)) return crowbar;
    if (argc <= 0) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08param()\uff09\u304c\u884c\u306a\u308f\u308c\u308b\u524d\u306b\u578b\u6307\u5b9a\u3092\u4f7f\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044", "setFloat()", true);
    else argv[argc - 1].parameterType = 'N';
    return crowbar;
  }
  public crowbarClass setFloat(float init) {
    setFloat();
    if (argc <= 0) return crowbar;
    argv[argc - 1].initialValue = str(init);
    return crowbar;
  }
  public crowbarClass setFloat(int init) { return setFloat(PApplet.parseFloat(init)); }
  // (1b) \u6574\u6570\u578b
  public crowbarClass setInt() {
    if (crowbar.checkOptionsSetupOnly("setInt()", null, true)) return crowbar;
    if (argc <= 0) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08param()\uff09\u304c\u884c\u306a\u308f\u308c\u308b\u524d\u306b\u578b\u6307\u5b9a\u3092\u4f7f\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044", "setInt()", true);
    else argv[argc - 1].parameterType = 'I';
    return crowbar;
  }
  public crowbarClass setInt(int init) {
    setInt();
    if (argc <= 0) return crowbar;
    argv[argc - 1].initialValue = str(init);
    return crowbar;
  }
  public crowbarClass setInt(float init) { return setInt(PApplet.parseInt(init)); }
  // (1c) \u8ad6\u7406\u578b
  public crowbarClass setBoolean() {
    if (crowbar.checkOptionsSetupOnly("setBoolean()", null, true)) return crowbar;
    if (argc <= 0) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08param()\uff09\u304c\u884c\u306a\u308f\u308c\u308b\u524d\u306b\u578b\u6307\u5b9a\u3092\u4f7f\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044", "setBoolean()", true);
    else argv[argc - 1].parameterType = 'B';
    return crowbar;
  }
  public crowbarClass setBoolean(boolean init) {
    setBoolean();
    if (argc <= 0) return crowbar;
    argv[argc - 1].initialValue = str(init);
    return crowbar;
  }
  public crowbarClass setBoolean(int init)    { return setBoolean(PApplet.parseBoolean(init)); }
  public crowbarClass setBoolean(float init)  { return setBoolean(PApplet.parseInt(init)); }
  public crowbarClass setBoolean(String init) {
    int val = -1;
    init = init.toUpperCase();
    if (init.equals("TRUE"))       val = 1;
    else if (init.equals("FALSE")) val = 0;
    else if (init.length() == 1) {
      switch (init.charAt(0)) {
        case '1':
        case 'T':
        case 'Y': val = 1; break;
        case '0':
        case 'F':
        case 'N': val = 0; break;
      }
    }
    if (val < 0) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u8ad6\u7406\u578b(setBoolean()\uff09\u306e\u521d\u671f\u5024\u306e\u6307\u5b9a\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093", init, true);
    else {
      if (val == 1) setBoolean(true);
      else          setBoolean(false);
    }
    return crowbar;
  }
  // (1d) \u591a\u80a2\u9078\u629e\u578b
  public crowbarClass setSelect(String str) {
    if (crowbar.checkOptionsSetupOnly("setSelect()", null, true)) return crowbar;
    if (argc <= 0) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08param()\uff09\u304c\u884c\u306a\u308f\u308c\u308b\u524d\u306b\u578b\u6307\u5b9a\u3092\u4f7f\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044", "setSelect()", true);
    String list[];
    if (str.length() <= 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "setSelect()\u3067\u9078\u629e\u80a2\u578b\u306e\u30d1\u30e9\u30e1\u30fc\u30bf\u5ba3\u8a00\u306e\u7b2c\uff12\u30d1\u30e9\u30e1\u30fc\u30bf\u304c\u7a7a\u6587\u5b57\u5217\u3067\u3059", str, true);
      return crowbar;
    }
    list = split(str, ' ');
    if (list.length > 10) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "setSelect()\u3067\u9078\u629e\u80a2\u578b\u306e\u30d1\u30e9\u30e1\u30fc\u30bf\u5ba3\u8a00\u306e\u9078\u629e\u80a2\u306e\u6570\u304c\uff11\uff10\u500b\u3092\u8d85\u3048\u3066\u3044\u307e\u3059", str, true);
      return crowbar;
    }
    argv[argc - 1].parameterType = 'S';
    argv[argc - 1].selectValues = list;
    return crowbar;
  }
  public crowbarClass setSelect(String str, int num) {
    setSelect(str);
    if ((num < 0) || (num > 9)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "setSelect()\u3067\u9078\u629e\u80a2\u578b\u306e\u521d\u671f\u5024\u304c0\u304b\u30899\u306e\u6574\u6570\u3067\u306f\u3042\u308a\u307e\u305b\u3093", str, true);
      return crowbar;
    }
    if (num >= argv[argc - 1].selectValues.length) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "setSelect()\u3067\u9078\u629e\u80a2\u578b\u306e\u521d\u671f\u5024\u304c0\u304b\u3089\u9078\u629e\u80a2\u306e\u6570-1\u306e\u6574\u6570\u3067\u306f\u3042\u308a\u307e\u305b\u3093", str, true);
      return crowbar;
    }
    argv[argc - 1].initialValue = str(num);
    return crowbar;
  }
  // (1e) \u6587\u5b57\u5217\u578b
  public crowbarClass setStr() {
    if (crowbar.checkOptionsSetupOnly("setStr()", null, true)) return crowbar;
    if (argc <= 0) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08param()\uff09\u304c\u884c\u306a\u308f\u308c\u308b\u524d\u306b\u578b\u6307\u5b9a\u3092\u4f7f\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044", "setStr()", true);
    else argv[argc - 1].parameterType = 'A';
    return crowbar;
  }
  public crowbarClass setStr(String init) {
    setStr();
    if (argc <= 0) return crowbar;
    argv[argc - 1].initialValue = init;
    return crowbar;
  }
  public crowbarClass setStr(float init) { return setStr(str(init)); }
  public crowbarClass setStr(int init)   { return setStr(str(init)); }

  // (2) \u30e9\u30d9\u30eb\u540d\u306e\u8ffd\u52a0
  public crowbarClass label(String str) {
    if (crowbar.checkOptionsSetupOnly("label()", str, true)) return crowbar;
    if (argc - 1 < 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08param()\uff09\u304c\u884c\u306a\u308f\u308c\u308b\u524d\u306blabel()\u3092\u4f7f\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044", str, true);
      return crowbar;
    }
    if (checkLabel(str) >= 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "label()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u3068\u540c\u3058\u30d1\u30e9\u30e1\u30fc\u30bf\u304c\u65e2\u306b\u4f5c\u6210\u6e08\u307f\u3067\u3059\uff08\u91cd\u8907\uff09", str, true);
      return crowbar;
    }
    argv[argc - 1].setLabel(str);
    return crowbar;
  }
  // \u30e9\u30d9\u30eb\u540d\u3092\u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u6307\u5b9a\u3067\u8aad\u307f\u51fa\u3059(\u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u306e\u81ea\u52d5\u66f4\u65b0\u306f\u3057\u306a\u3044\uff09
  public String getLabel(int index) {
    if ((index >= argc) || (index < 0)) return null;
    return argv[index].label;
  }

  // (3) \u914d\u5217\u578b\u306e\u8ffd\u52a0
  //  int  arrayType; // 0: false, 1:\u4e00\u6b21\u5143\u30a8\u30f3\u30c9\u30ec\u30b9, 2:\u4e00\u6b21\u5143\u5373\u5024, 3:\u4e00\u6b21\u5143\u30e9\u30d9\u30eb
  // (3a) \u4e00\u6b21\u5143\u914d\u5217\uff08\u30a8\u30f3\u30c9\u30ec\u30b9\u5165\u529b\uff09
  public crowbarClass array() {
    arguments param = argv[argc - 1];
    if (crowbar.checkOptionsSetupOnly("array()", null, true)) return crowbar;
    if (argc <= 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08param()\uff09\u304c\u884c\u306a\u308f\u308c\u308b\u524d\u306b\u914d\u5217\u578b\u6307\u5b9a\u3092\u4f7f\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044", "array()", true);
      return crowbar;
    }
    param.arrayType = 1;
    param.endless = true;
    param.index2 = 0;
    param.arrayValue = new String[1][1];
    return crowbar;
  }
  // (3b) \u4e00\u6b21\u5143\u914d\u5217\uff08\u5373\u5024\u6307\u5b9a\uff09
  public crowbarClass array(int num) {
    arguments param = argv[argc - 1];
    array();
    if (num <= 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u914d\u5217\u6570\u306f0\u3088\u308a\u5927\u304d\u306a\u6570\u5b57\u3092\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044", "array()", true);
      return crowbar;
    }
    param.arrayType = 2;
    param.endless = false;
    param.index1 = 1;
    param.index2 = num;
    return crowbar;
  }
  // (3c) \u4e00\u6b21\u5143\u914d\u5217\uff08\u30e9\u30d9\u30eb\u6307\u5b9a\uff09
  public crowbarClass array(String label) {
    arguments param = argv[argc - 1];
    array();
    if ((param.labelIndex1 = checkLabel(label)) < 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "array()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u304c\u5ba3\u8a00\u3055\u308c\u3066\u3044\u307e\u305b\u3093", label, true);
      return crowbar;
    }
    param.arrayType = 3;
    param.index1 = 1;
    param.endless = false;
    return crowbar;
  }
  //  int  arrayType; // 4:\u4e8c\u6b21\u5143\uff08\u5373\u5024\uff0c\u5373\u5024\uff09, 5:\u4e8c\u6b21\u5143\uff08\u5373\u5024, \u30e9\u30d9\u30eb), 6:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u5373\u5024\uff09, 7:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u30e9\u30d9\u30eb\uff09
  // (3d) \u4e8c\u6b21\u5143\u914d\u5217\uff08\u5373\u5024, \u5373\u5024\uff09
  public crowbarClass array(int num1, int num2) {
    arguments param = argv[argc - 1];
    array();
    if ((num1 <= 0) || (num2 <= 0)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u914d\u5217\u6570\u306f0\u3088\u308a\u5927\u304d\u306a\u6570\u5b57\u3092\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044", "array()", true);
      return crowbar;
    }
    param.arrayType = 4;
    param.endless = false;
    param.index1 = num1;
    param.index2 = num2;
    return crowbar;
  }
  // (3e) \u4e8c\u6b21\u5143\u914d\u5217\uff08\u5373\u5024, \u30e9\u30d9\u30eb\uff09
  public crowbarClass array(int num, String label) {
    arguments param = argv[argc - 1];
    array();
    if (num <= 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u914d\u5217\u6570\u306f0\u3088\u308a\u5927\u304d\u306a\u6570\u5b57\u3092\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044", "array()", true);
      return crowbar;
    } else if ((param.labelIndex2 = checkLabel(label)) < 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "array()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u304c\u5ba3\u8a00\u3055\u308c\u3066\u3044\u307e\u305b\u3093", label, true);
      return crowbar;
    }
    param.arrayType = 5;
    param.endless = false;
    param.index1 = num;
    return crowbar;
  }
  // (3f) \u4e8c\u6b21\u5143\u914d\u5217\uff08\u30e9\u30d9\u30eb, \u5373\u5024\uff09
  public crowbarClass array(String label, int num) {
    arguments param = argv[argc - 1];
    array();
    if ((param.labelIndex1 = checkLabel(label)) < 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "array()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u304c\u5ba3\u8a00\u3055\u308c\u3066\u3044\u307e\u305b\u3093", label, true);
      return crowbar;
    } else if (num <= 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u914d\u5217\u6570\u306f0\u3088\u308a\u5927\u304d\u306a\u6570\u5b57\u3092\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044", "array()", true);
      return crowbar;
    }
    param.arrayType = 6;
    param.endless = false;
    param.index2 = num;
    return crowbar;
  }
  // (3e) \u4e8c\u6b21\u5143\u914d\u5217\uff08\u30e9\u30d9\u30eb, \u30e9\u30d9\u30eb\uff09
  public crowbarClass array(String label1, String label2) {
    arguments param = argv[argc - 1];
    array();
    if ((param.labelIndex1 = checkLabel(label1)) < 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "array()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u304c\u5ba3\u8a00\u3055\u308c\u3066\u3044\u307e\u305b\u3093", label1, true);
      return crowbar;
    } else if ((param.labelIndex2 = checkLabel(label2)) < 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "array()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u304c\u5ba3\u8a00\u3055\u308c\u3066\u3044\u307e\u305b\u3093", label2, true);
      return crowbar;
    }
    param.arrayType = 7;
    param.endless = false;
    return crowbar;
  }

  // Ver.3\u307e\u3067\u306e\u4e92\u63db\uff08\u524a\u9664\u4e88\u5b9a\uff09
  // (1) \u6570\u5b57\u306e\u307f\uff08\u6d6e\u52d5\u5c0f\u6570\u70b9\uff09
  // (1a) \u6a19\u6e96
  public crowbarClass define(String str) {
    if (!crowbar.checkOptionsSetupOnly("define()", str, true)) {
      defineStr(str);
      argv[argc - 1].parameterType = 'N';
    }
    return crowbar;
  }
  // (1b) \u521d\u671f\u5024\u3042\u308a
  // (1b-1) \u6587\u5b57\u5217
  public crowbarClass define(String str1, String str2) {
    if (!crowbar.checkOptionsSetupOnly("define()", str1, true)) {
      defineStr(str1, str2);
      argv[argc - 1].parameterType = 'N';
    }
    return crowbar;
  }
  // (1b-2) \u6d6e\u52d5\u5c0f\u6570\u70b9
  public crowbarClass define(String str, float f) { return define(str, str(f)); }
  // (1b-3) \u6574\u6570
  public crowbarClass define(String str, int i)   { return define(str, str(i)); }

  // (2) \u5165\u529b\u5236\u9650\u898f\u5247\u306a\u3057 \uff1a\u5168\u3066\u306edefine\u7cfb\u306f\u6700\u7d42\u7684\u306b\u3053\u306e\u95a2\u6570\u3092\u547c\u3076
  public crowbarClass defineStr(String str) {
    if (!crowbar.checkOptionsSetupOnly("defineStr()", str, true)) {
      argc = argv.length;
      argv = (arguments [])expand(argv, argc + 1);
      argv[argc] = new arguments();
      // \u73fe\u5728\u306e\u5024\u3092\u30bb\u30c3\u30c8
      argv[argc - 1].message = str;
    }
    return crowbar;
  }
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08\u5165\u529b\u5236\u9650\u898f\u5247\u306a\u3057\uff1a\u521d\u671f\u5024\u3042\u308a\uff09
  public crowbarClass defineStr(String str1, String str2) {
    defineStr(str1);
    argv[argc - 1].initialValue = str2;
    return crowbar;
  }
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08\u5165\u529b\u5236\u9650\u898f\u5247\u306a\u3057\uff1a\u521d\u671f\u5024\u3042\u308a\uff0cfloat\u6e21\u3057\uff09
  public crowbarClass defineStr(String str, float f) { return define(str, str(f)); }
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08\u5165\u529b\u5236\u9650\u898f\u5247\u306a\u3057\uff1a\u521d\u671f\u5024\u3042\u308a\uff0cint\u6e21\u3057\uff09
  public crowbarClass defineStr(String str, int i)   { return define(str, str(i)); }
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08\u9078\u629e\u80a2\u578b\uff1a\u5165\u529b\u5236\u9650\u898f\u5247\u306f0-9\u306e\u307f\uff09
  public crowbarClass defineSel(String str1, String str2) {
    if (crowbar.checkOptionsSetupOnly("defineSel()", str1, true)) return crowbar;
    String list[];
    if (str2.length() <= 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "defineSel()\u3067\u9078\u629e\u80a2\u578b\u306e\u30d1\u30e9\u30e1\u30fc\u30bf\u5ba3\u8a00\u306e\u7b2c\uff12\u30d1\u30e9\u30e1\u30fc\u30bf\u304c\u7a7a\u6587\u5b57\u5217\u3067\u3059", str1, true);
      return crowbar;
    }
    list = split(str2, ' ');
    if (list.length > 10) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "defineSel()\u3067\u9078\u629e\u80a2\u578b\u306e\u30d1\u30e9\u30e1\u30fc\u30bf\u5ba3\u8a00\u306e\u9078\u629e\u80a2\u306e\u6570\u304c\uff11\uff10\u500b\u3092\u8d85\u3048\u3066\u3044\u307e\u3059", str1, true);
      return crowbar;
    }
    defineStr(str1);
    argv[argc - 1].parameterType = 'S';
    argv[argc - 1].selectValues = list;
    return crowbar;
  }
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5ba3\u8a00\uff08\u9078\u629e\u578b\uff1a\u521d\u671f\u5024\u3042\u308a\uff09
  public crowbarClass defineSel(String str1, String str2, int num) {
    defineSel(str1, str2);
    if (num < 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "defineSel()\u3067\u9078\u629e\u80a2\u578b\u306e\u521d\u671f\u5024\u304c0\u304b\u30899\u306e\u6574\u6570\u3067\u306f\u3042\u308a\u307e\u305b\u3093", str1, true);
      return crowbar;
    }
    if (num >= argv[argc - 1].selectValues.length) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "defineSel()\u3067\u9078\u629e\u80a2\u578b\u306e\u521d\u671f\u5024\u304c0\u304b\u3089\u9078\u629e\u80a2\u306e\u6570-1\u306e\u6574\u6570\u3067\u306f\u3042\u308a\u307e\u305b\u3093", str1, true);
      return crowbar;
    }
    argv[argc - 1].initialValue = str(num);
    return crowbar;
  }

  //-------------------------
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5024\u3092\u53d7\u3051\u53d6\u308b
  //-------------------------
  // 1) index\u3092\u660e\u793a\u7684\u306b\u6307\u5b9a\u3059\u308b
  // 1-a) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u6587\u5b57\u5217\u3067\u8fd4\u3059
  public String getStr(int index) {
    if (argv[index].arrayType != 0) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u914d\u5217\u578b\u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u8aad\u307f\u51fa\u3059\u6642\u306fArray\u578b\u306eget\u547d\u4ee4\u3092\u4f7f\u7528\u3057\u3066\u4e0b\u3055\u3044", "", true);
      return "";
    }
    if ((index >= argc) || (index < 0)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "get\u7cfb\u547d\u4ee4\u306b\u304a\u3044\u3066\u30d1\u30e9\u30e1\u30fc\u30bf\u8aad\u307f\u51fa\u3057\u306eIndex\u304c\u7bc4\u56f2\u3092\u8d85\u3048\u3066\u3044\u307e\u3059", "Index=" + str(index), true);
      return "";
    }
    // \u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u306e\u81ea\u52d5\u66f4\u65b0
    readArgIndex = index + 1;
    return argv[index].value;
  }
  // arrayType; // 0: false, 1:\u4e00\u6b21\u5143\u30a8\u30f3\u30c9\u30ec\u30b9, 2:\u4e00\u6b21\u5143\u5373\u5024, 3:\u4e00\u6b21\u5143\u30e9\u30d9\u30eb, 4:\u4e8c\u6b21\u5143\uff08\u5373\u5024\uff0c\u5373\u5024\uff09, 5:\u4e8c\u6b21\u5143\uff08\u5373\u5024, \u30e9\u30d9\u30eb), 6:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u5373\u5024\uff09, 7:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u30e9\u30d9\u30eb\uff09
  // \u4e00\u6b21\u5143\u914d\u5217
  public String [] getStrArray(int index) {
    if ((index >= argc) || (index < 0)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "get\u7cfb\u547d\u4ee4\u306b\u304a\u3044\u3066\u30d1\u30e9\u30e1\u30fc\u30bf\u8aad\u307f\u51fa\u3057\u306eIndex\u304c\u7bc4\u56f2\u3092\u8d85\u3048\u3066\u3044\u307e\u3059", "Index=" + str(index), true);
      return null;
    }
    // \u914d\u5217\u578b\u306e\u30c1\u30a7\u30c3\u30af
    switch (argv[index].arrayType) {
      case 1: case 2: case 3: break;
      default :
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u6307\u5b9a\u3055\u308c\u305f\u914d\u5217\u306f\u4e00\u6b21\u5143\u914d\u5217\u3067\u306f\u3042\u308a\u307e\u305b\u3093", "Index=" + str(index), true);
      return null;
    }
    // \u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u306e\u81ea\u52d5\u66f4\u65b0
    readArgIndex = index + 1;
    return argv[index].arrayValue[0];
  }
  // \u4e8c\u6b21\u5143\u914d\u5217
  public String [][] getStrArray2(int index) {
    if ((index >= argc) || (index < 0)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "get\u7cfb\u547d\u4ee4\u306b\u304a\u3044\u3066\u30d1\u30e9\u30e1\u30fc\u30bf\u8aad\u307f\u51fa\u3057\u306eIndex\u304c\u7bc4\u56f2\u3092\u8d85\u3048\u3066\u3044\u307e\u3059", "Index=" + str(index), true);
      return null;
    }
    // \u914d\u5217\u578b\u306e\u30c1\u30a7\u30c3\u30af
    switch (argv[index].arrayType) {
      case 4: case 5: case 6: case 7: break;
      default :
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u6307\u5b9a\u3055\u308c\u305f\u914d\u5217\u306f\u4e8c\u6b21\u5143\u914d\u5217\u3067\u306f\u3042\u308a\u307e\u305b\u3093", "Index=" + str(index), true);
      return null;
    }
    // \u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u306e\u81ea\u52d5\u66f4\u65b0
    readArgIndex = index + 1;
    return argv[index].arrayValue;
  }
  // 1-b) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092float\u3067\u8fd4\u3059
  public float getFloat(int index)     { return PApplet.parseFloat(getStr(index));   }
  public float [] getFloatArray(int index) {
    String [] ptr = getStrArray(index);
    if (ptr == null) return null;
    float [] ret = new float [argv[index].index2];
    for (int i = 0; i < ptr.length; i++) {
      ret[i] = PApplet.parseFloat(ptr[i]);
    }
    return ret;
  }
  public float [][] getFloatArray2(int index) {
    String [][] ptr = getStrArray2(index);
    if (ptr == null) return null;
    float [][] ret = new float [argv[index].index1][argv[index].index2];
    for (int i = 0; i < ptr.length; i++) {
      for (int j = 0; j < ptr[0].length; j++) {
        ret[i][j] = PApplet.parseFloat(ptr[i][j]);
      }
    }
    return ret;
  }
  // 1-c) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092int\u3067\u8fd4\u3059
  public int getInt(int index)         { return PApplet.parseInt(getStr(index));     }
  public int [] getIntArray(int index) {
    String [] ptr = getStrArray(index);
    if (ptr == null) return null;
    int [] ret = new int [argv[index].index2];
    for (int i = 0; i < ptr.length; i++) {
      ret[i] = PApplet.parseInt(ptr[i]);
    }
    return ret;
  }
  public int [][] getIntArray2(int index) {
    String [][] ptr = getStrArray2(index);
    if (ptr == null) return null;
    int [][] ret = new int [argv[index].index1][argv[index].index2];
    for (int i = 0; i < ptr.length; i++) {
      for (int j = 0; j < ptr[0].length; j++) {
        ret[i][j] = PApplet.parseInt(ptr[i][j]);
      }
    }
    return ret;
  }
  // 1-d) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092boolean\u3067\u8fd4\u3059
  public boolean getBoolean(int index) { return PApplet.parseBoolean(getStr(index)); }
  public boolean [] getBooleanArray(int index) {
    String [] ptr = getStrArray(index);
    if (ptr == null) return null;
    boolean [] ret = new boolean [argv[index].index2];
    for (int i = 0; i < ptr.length; i++) {
      ret[i] = PApplet.parseBoolean(ptr[i]);
    }
    return ret;
  }
  public boolean [][] getBooleanArray2(int index) {
    String [][] ptr = getStrArray2(index);
    if (ptr == null) return null;
    boolean [][] ret = new boolean [argv[index].index1][argv[index].index2];
    for (int i = 0; i < ptr.length; i++) {
      for (int j = 0; j < ptr[0].length; j++) {
        ret[i][j] = PApplet.parseBoolean(ptr[i][j]);
      }
    }
    return ret;
  }

  // 2) index\u3092\u660e\u793a\u7684\u306b\u6307\u5b9a\u3057\u306a\u3044\u3067\u9806\u756a\u306b\u81ea\u52d5\u7684\u306b\u8aad\u307f\u51fa\u3059
  // 2-a) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u6587\u5b57\u5217\u3067\u6e21\u3059\uff08\u81ea\u52d5\uff09
  public String getStr()            { return getStr(readArgIndex); }
  public String [] getStrArray()    { return getStrArray(readArgIndex); }
  public String [][] getStrArray2() { return getStrArray2(readArgIndex); }
  // 2-b) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092float\u3067\u8fd4\u3059\uff08\u81ea\u52d5\uff09
  public float getFloat()            { return getFloat(readArgIndex); }
  public float [] getFloatArray()    { return getFloatArray(readArgIndex); }
  public float [][] getFloatArray2() { return getFloatArray2(readArgIndex); }
  // 2-c) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092int\u3067\u8fd4\u3059\uff08\u81ea\u52d5\uff09
  public int getInt()            { return getInt(readArgIndex); }
  public int [] getIntArray()    { return getIntArray(readArgIndex); }
  public int [][] getIntArray2() { return getIntArray2(readArgIndex); }
  // 2-d) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092boolean\u3067\u8fd4\u3059\uff08\u81ea\u52d5\uff09
  public boolean getBoolean()            { return getBoolean(readArgIndex); }
  public boolean [] getBooleanArray()    { return getBooleanArray(readArgIndex); }
  public boolean [][] getBooleanArray2() { return getBooleanArray2(readArgIndex); }
  
  // 3) \u30e9\u30d9\u30eb\u540d\u3092\u660e\u793a\u7684\u306b\u6307\u5b9a\u3059\u308b
  // \u30e9\u30d9\u30eb\u540d\u304b\u3089\u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u756a\u53f7\u3092\u5f97\u308b\uff08\u5b58\u5728\u3057\u306a\u3044\u5834\u5408\u306f -1\uff09
  public int checkLabel(String str) {
    String label = str.toUpperCase();
    for (int i = 0; i < argc; i++) {
      if (argv[i].label == null) continue;
      if (argv[i].label.equals(label) == true) return i;
    }
    return -1;
  }
  public int checkLabel4get(String label) {
    int index;
    if ((index = checkLabel(label)) < 0) crowbar.errorMessage("\u30a8\u30e9\u30fc", "get\u7cfb\u547d\u4ee4\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u3092\u6301\u3064\u30d1\u30e9\u30e1\u30fc\u30bf\u5ba3\u8a00\u304c\u5b58\u5728\u3057\u307e\u305b\u3093", label, true);
    return index;
  }
  // 3-a) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u6587\u5b57\u5217\u3067\u8fd4\u3059
  public String getStr(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return "";
    return getStr(index);
  }
  public String [] getStrArray(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return null;
    return getStrArray(index);
  }
  public String [][] getStrArray2(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return null;
    return getStrArray2(index);
  }
  // 3-b) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092float\u3067\u8fd4\u3059
  public float getFloat(String label)     { return PApplet.parseFloat(getStr(label));   }
  public float [] getFloatArray(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return null;
    return getFloatArray(index);
  }
  public float [][] getFloatArray2(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return null;
    return getFloatArray2(index);
  }
  // 3-c) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092int\u3067\u8fd4\u3059
  public int getInt(String label)         { return PApplet.parseInt(getStr(label));     }
  public int [] getIntArray(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return null;
    return getIntArray(index);
  }
  public int [][] getIntArray2(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return null;
    return getIntArray2(index);
  }
  // 3-d) \u30d1\u30e9\u30e1\u30fc\u30bf\u3092boolean\u3067\u8fd4\u3059
  public boolean getBoolean(String label) { return PApplet.parseBoolean(getStr(label)); }
  public boolean [] getBooleanArray(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return null;
    return getBooleanArray(index);
  }
  public boolean [][] getBooleanArray2(String label) {
    int index;
    if ((index = checkLabel4get(label)) < 0) return null;
    return getBooleanArray2(index);
  }
}

// Options()\u3067\u8a2d\u5b9a\u3057\u305f\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u30d0\u30c3\u30af\u30a2\u30c3\u30d7\u3068\u5fa9\u5143
// \u5225\u306bOptions()\u4ee5\u5916\u3067\u3082\u5909\u66f4\u53ef\u80fd\u306a\u306e\u3067\uff0c\u4e8c\u56de\u76ee\u4ee5\u964d\u306e\u5b9f\u884c\u6642\u306bOptions()\u3067\u8a2d\u5b9a\u3057\u305f\u5024\u3092\u623b\u3055\u306a\u3044\u3068\u6319\u52d5\u304c\u5909\u308f\u3063\u3066\u3057\u307e\u3046\u305f\u3081
class runningParameterClass {
  protected boolean noShowParams;    // \u5165\u529b\u6e08\u307f\u306e\u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u78ba\u8a8d\u306e\u305f\u3081\u306b\u8868\u793a\u3059\u308b\u304b\uff1f
  protected boolean nonStop;         // Main()\u7d42\u4e86\u5f8c\u306fdraw()\u306e\u7d42\u7aef\u306b\u8a18\u8ff0\u3057\u305f\u30b3\u30fc\u30c9\u3092\u7e70\u308a\u8fd4\u3057\u5b9f\u884c\u3059\u308b\uff0enonStop()\u3067true/stop()\u3067false
  private boolean   userDrawLoop;    // Draw()\u306e\u30eb\u30fc\u30d7\u5b9f\u884c\u3092\u505c\u6b62\u3057\u305f\u308a\u518d\u958b\u3057\u305f\u308a\u3059\u308b\u969b\u306b\u7528\u3044\u308b\uff0etrue\u3067\u7e70\u308a\u8fd4\u3057\u5b9f\u884c\uff0eloop(), noLoop()\u3067\u8a2d\u5b9a\uff0e
  private int       nonStopCounter;  // Draw\u306e\u5b9f\u884c\u56de\u6570\uff08-1\u3067\u7121\u5236\u9650\uff0c0\u3067\u5b9f\u884c\u3057\u306a\u3044\uff09
  protected boolean silentMode;      // \u30b7\u30b9\u30c6\u30e0\u30e1\u30c3\u30bb\u30fc\u30b8\u8868\u793a\u3092\u6700\u5c0f\u9650\u306b\u6291\u3048\u308b
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  runningParameterClass() {
    noShowParams   = nonStop = false;
    userDrawLoop   = true;
    nonStopCounter = -1;
    silentMode     = false;
  }
  public void clone(runningParameterClass src) {
    noShowParams   = src.noShowParams;
    nonStop        = src.nonStop;
    userDrawLoop   = src.userDrawLoop;
    nonStopCounter = src.nonStopCounter;
    silentMode     = src.silentMode;
  }
}

//////////////////////////////////////////////////////////////////////////////
// \u30d7\u30ed\u30bb\u30b9\u30b3\u30f3\u30c8\u30ed\u30fc\u30eb\u306e\u30af\u30e9\u30b9\uff08\u30ad\u30fc\u30dc\u30fc\u30c9\u5165\u529b\u3068\u30b3\u30f3\u30bd\u30fc\u30eb\u51fa\u529b\u306e\u30af\u30e9\u30b9\u3092\u7d99\u627f\uff09
//////////////////////////////////////////////////////////////////////////////
class crowbarClass extends frontendClass {
  int                   status = -1;              // \u30d7\u30ed\u30bb\u30b9\u306e\u72b6\u614b\u3092\u7ba1\u7406
  String []             comment;                  // \u30d7\u30ed\u30b0\u30e9\u30e0\u306e\u30b3\u30e1\u30f3\u30c8\uff0e\u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u524d\u306b\u8868\u793a\u3055\u308c\u308b\uff0e
  protected boolean     halt;                     // \u5f37\u5236\u7d42\u4e86\u30d5\u30e9\u30b0\uff08halt()\u3067\u30bb\u30c3\u30c8\u3055\u308c\u308b\uff09
  boolean               running       = false;    // Main()\u3042\u308b\u3044\u306fcrowbar.nonStop()\u6307\u5b9a\u6642\u306b\u30e6\u30fc\u30b6\u30d7\u30ed\u30b0\u30e9\u30e0\u5b9f\u884c\u4e2d\u306ftrue
  boolean               afterRunning  = false;    // Main()\u304c\u7d42\u308f\u3063\u305f\u5f8c\uff0c\u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u3092\u518d\u63cf\u753b\u53ef\u80fd\u306a\u9593\u306e\u307ftrue;\uff08Draw()\u304c\u52d5\u3044\u3066\u3044\u3066\u3082\u305d\u308c\u306f\u6c17\u306b\u3057\u306a\u3044\uff0e\u4eca\u306e\u3068\u3053\u308d\uff09
  runningParameterClass run, _run;
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  crowbarClass(int x, int y, int mode) {
    super(x, y, mode);
    // \u30d7\u30ed\u30b0\u30e9\u30e0\u30b3\u30e1\u30f3\u30c8\u306e\u521d\u671f\u5316
    comment = null;
    // \u5f37\u5236\u7d42\u4e86\u30d5\u30e9\u30b0
    halt    = false;
    // \u5b9f\u884c\u72b6\u614b\u5236\u5fa1\u7528\u30d5\u30e9\u30b0\u985e\u306e\u78ba\u4fdd\uff08\u30d0\u30c3\u30af\u30a2\u30c3\u30d7\u542b\u3080\uff09
    run  = new runningParameterClass();
    _run = new runningParameterClass();
    // \u52d5\u4f5c\u306b\u95a2\u308f\u308b\u30b9\u30a4\u30c3\u30c1\u306e\u30d0\u30c3\u30af\u30a2\u30c3\u30d7\u306e\u521d\u671f\u5316
    backupRunningFlag();
  }
  // Options()\u304bSetup()\u4ee5\u5916\u3067\u306f\u6307\u5b9a\u3057\u3066\u306f\u3044\u3051\u306a\u3044\u547d\u4ee4\u3092\u30c1\u30a7\u30c3\u30af\u3057\u30a8\u30e9\u30fc\u3092\u8868\u793a\u3059\u308b 
  // \u30a8\u30e9\u30fc\u6642\u306btrue
  public boolean checkOptionsSetupOnly(String command, String a, boolean halt) {
    if (crowbar.status > 0) {
      errorMessage("\u30a8\u30e9\u30fc", command + "\u306fOptions()\u304bSetup()\u3067\u4f7f\u7528\u3057\u3066\u4e0b\u3055\u3044", a, halt);
      return true;
    }
    return false;
  }
  // Options()\u3084Setup()\u3067\u6307\u5b9a\u3057\u3066\u306f\u3044\u3051\u306a\u3044\u547d\u4ee4\u3092\u30c1\u30a7\u30c3\u30af\u3057\u30a8\u30e9\u30fc\u3092\u8868\u793a\u3059\u308b 
  // \u30a8\u30e9\u30fc\u6642\u306btrue
  public boolean checkOptionsSetupNot(String command, String a, boolean halt) {
    if (crowbar.status <= 0) {
      errorMessage("\u30a8\u30e9\u30fc", command + "\u306fOptions()\u3084Setup()\u3067\u4f7f\u7528\u3057\u3066\u306f\u3044\u3051\u307e\u305b\u3093", a, halt);
      return true;
    }
    return false;
  }
  // \u30a8\u30e9\u30fc\u30e1\u30c3\u30bb\u30fc\u30b8\u3092\u51fa\u529b\u3057\uff0c\u5fc5\u8981\u306a\u3089\u3070halt\u306e\u30d5\u30e9\u30b0\u3092\u7acb\u3066\u308b
  public void errorMessage(String head, String body, String tail, boolean halt) {
    print("[" + head + "] " + body);
    if ((tail != null) && (tail.length() > 0)) print("\uff08" + tail + "\uff09");
    println("\uff0e");
    if (halt) crowbar.halt();
    return;
  }

  // \u52d5\u4f5c\u306b\u95a2\u308f\u308b\u30b9\u30a4\u30c3\u30c1\u306e\u30d0\u30c3\u30af\u30a2\u30c3\u30d7
  public void backupRunningFlag()  { _run.clone(run); }
  // \u52d5\u4f5c\u306b\u95a2\u308f\u308b\u30b9\u30a4\u30c3\u30c1\u306e\u30ea\u30b9\u30c8\u30a2
  public void restoreRunningFlag() { run.clone(_run); }

  // \u4ee5\u4e0b\u306e\u95a2\u6570\u3092\u30e6\u30fc\u30b6\u306f\u4f7f\u7528\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044
  // \u5165\u529b\u6e08\u307f\u306e\u5168\u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u8868\u793a\u3059\u308b
  public crowbarClass showAllParameters() {
    int i, _readArgIndex;
    // \u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u306e\u30d0\u30c3\u30af\u30a2\u30c3\u30d7
    _readArgIndex = readArgIndex;
    if (run.noShowParams) return this; // \u5ff5\u306e\u305f\u3081
    for (i = 0; i < argc; i++) {
      if (!argv[i].ready) break;  // \u5165\u529b\u6e08\u307f\u306e\u5206\u306e\u307f\u8868\u793a\u3059\u308b\u306e\u3067\uff0e
/*
      write(get_paramMessage(i, false) + "\uff1a");
      if (getLabel(i) != null) write("(" + getLabel(i) + ") = ");
      writeln("[" + getStr(i) + "]");
*/
      // \u914d\u5217\u306b\u914d\u616e
      // arrayType; // 0: false, 1:\u4e00\u6b21\u5143\u30a8\u30f3\u30c9\u30ec\u30b9, 2:\u4e00\u6b21\u5143\u5373\u5024, 3:\u4e00\u6b21\u5143\u30e9\u30d9\u30eb, 4:\u4e8c\u6b21\u5143\uff08\u5373\u5024\uff0c\u5373\u5024\uff09, 5:\u4e8c\u6b21\u5143\uff08\u5373\u5024, \u30e9\u30d9\u30eb), 6:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u5373\u5024\uff09, 7:\u4e8c\u6b21\u5143\uff08\u30e9\u30d9\u30eb, \u30e9\u30d9\u30eb\uff09
      switch (argv[i].arrayType) {
        case 0: writeln(get_paramMessage(i, false) + " = " + getStr(i));  break;
        case 1: case 2: case 3:
          String [] str1 = getStrArray(i);
          for (obtainArrayIndex2 = 0; obtainArrayIndex2 < str1.length; obtainArrayIndex2++) writeln(get_paramMessage(i, false) + " = " + str1[obtainArrayIndex2]);
          break; 
        case 4: case 5: case 6: case 7:
          String [][] str2 = getStrArray2(i);
          for (obtainArrayIndex1 = 0; obtainArrayIndex1 < str2.length; obtainArrayIndex1++) {
            for (obtainArrayIndex2 = 0; obtainArrayIndex2 < str2[0].length; obtainArrayIndex2++) writeln(get_paramMessage(i, false) + " = " + str2[obtainArrayIndex1][obtainArrayIndex2]);
          }
          break;
      }
    }
    // \u30a4\u30f3\u30c7\u30c3\u30af\u30b9\u306e\u30ea\u30b9\u30c8\u30a2
    readArgIndex = _readArgIndex;
    return this;
  }
  // \u5165\u529b\u6e08\u307f\u306e\u5168\u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u306e\u307f\u51fa\u529b
  public crowbarClass showAllParameters2Log() {
    boolean _display, _textarea;
    // \u30d5\u30e9\u30b0\u306e\u30d0\u30c3\u30af\u30a2\u30c3\u30d7
    _display  = displaySwitch();
    _textarea = textAreaSwitch();
    // \u30c6\u30ad\u30b9\u30c8\u51fa\u529b\u3092\u4e00\u6642\u7684\u306b\u7981\u6b62
    disableDisplay();
    disableTextArea();
    // \u7981\u6b62\u3057\u305f\u4e0a\u3067\u51fa\u529b\u3059\u308c\u3070\u30ed\u30b0\u306b\u306e\u307f\u51fa\u529b\u3055\u308c\u308b
    showAllParameters();
    // \u30d5\u30e9\u30b0\u3092\u623b\u3059
    if (!_display)  enableDisplay();
    if (!_textarea) enableTextArea();
    return this;
  }

  // -----------------------------------------------
  // \u30d1\u30e9\u30e1\u30fc\u30bf\u8868\u793a\u306e\u78ba\u8a8d\u8868\u793a\u306e\u6291\u5236\uff08Options()\u3067\u6307\u5b9a\uff09
  public crowbarClass noShowParameters() {
    if (!crowbar.checkOptionsSetupOnly("noShowParameters()", null, false)) run.noShowParams = true;
    return this;
  }
  public crowbarClass showParameters()   {  // \u5fc5\u8981\u6027\u306f\u7121\u3044
    if (!crowbar.checkOptionsSetupOnly("showParameters()", null, false))   run.noShowParams = false;
    return this;
  }
  // ----------------------------------------
  // \u30b7\u30b9\u30c6\u30e0\u30e1\u30c3\u30bb\u30fc\u30b8\u8868\u793a\u3092\u6700\u5c0f\u9650\u306b\u6291\u5236\u3059\u308b
  public crowbarClass silentMode()       {
    if (!checkOptionsSetupOnly("silentMode()", null, false)) run.silentMode = true;
    return this;
  }
  // \u30b7\u30b9\u30c6\u30e0\u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u6587\u5b57\u8272\u3092\u5909\u66f4\u3059\u308b
  public crowbarClass systemColor(int color1, int color2, int color3) {
    if (checkOptionsSetupOnly("systemColor()", null, false)) return this;
    systemColor1(color1);
    systemColor2(color2);
    systemColor3(color3);
    return this;
  }
  // \u30b7\u30b9\u30c6\u30e0\u6587\u5b57\u8272\u3092\u5909\u66f4\u3059\u308b
  public crowbarClass systemColor1(int textcolor) {
    if (!crowbar.checkOptionsSetupOnly("systemColor1()", null, false)) _SYSTEMCOLOR1 = textcolor;
    return crowbar;
  }
  public crowbarClass systemColor2(int textcolor) {
    if (!crowbar.checkOptionsSetupOnly("systemColor2()", null, false)) _SYSTEMCOLOR2 = textcolor;
    return crowbar;
  }
  public crowbarClass systemColor3(int textcolor) {
    if (!crowbar.checkOptionsSetupOnly("systemColor3()", null, false)) _SYSTEMCOLOR3 = textcolor;
    return crowbar;
  }

  // ----------------------------------------------------------------------------
  // Main()\u7d42\u4e86\u5f8c\u306bdraw()\u7d42\u7aef\u306b\u8a18\u8ff0\u3057\u305f\u30b3\u30fc\u30c9\u3092\u7e70\u308a\u8fd4\u3057\u5b9f\u884c\u3059\u308b\u305f\u3081\u306e\u30b3\u30f3\u30c8\u30ed\u30fc\u30eb
  // ----------------------------------------------------------------------------
  public crowbarClass nonStop() { run.nonStop = true; return this; }  // Draw()\u95a2\u6570\u304c\u6709\u52b9
  public crowbarClass stop()    {                         // Draw()\u95a2\u6570\u304c\u7d42\u4e86\u3057\u305f\u3089\u30d7\u30ed\u30b0\u30e9\u30e0\u7d42\u4e86
    run.nonStop        = false; 
    run.nonStopCounter = -1;
    return this;
  }  
  public crowbarClass nonStop(int count) {
    nonStop();
    run.nonStopCounter = count;
    return this;
  }
  // nonStopCounter\u3092-1\u3057\u3066\u30ab\u30a6\u30f3\u30c8\u30a2\u30c3\u30d7\u3057\u305f\u3089true
  public boolean checkNonStopCounter() {
    if (run.nonStopCounter == -1) return false;  // \u8a2d\u5b9a\u3055\u308c\u3066\u3044\u306a\u3044
    if (--run.nonStopCounter > 0) return false;  // \u307e\u3060\u307e\u3060
    run.nonStopCounter = -1;
    return true;
  }

  // ------------------------------------------------------
  // Draw()\u306e\u30eb\u30fc\u30d7\u5b9f\u884c\u306e\u505c\u6b62\u3068\u518d\u958b\u306e\u305f\u3081\u306e\u30b3\u30f3\u30c8\u30ed\u30fc\u30eb
  // ------------------------------------------------------
  public crowbarClass loop()   { run.userDrawLoop = true;  return this; }
  public crowbarClass noLoop() { run.userDrawLoop = false; return this; }
  
  // ----------------------------------------
  // Crowbar\u3092\u5b89\u5168\u306b\u5f37\u5236\u7d42\u4e86\u3059\u308b
  // \u305f\u3060\u3057\u7121\u9650\u30eb\u30fc\u30d7\u304b\u3089\u306e\u8131\u51fa\u306f\u539f\u7406\u7684\u306b\u7121\u7406
  // ----------------------------------------
  public crowbarClass halt() {
    halt   = true;
//  status = 90;
    return this;
  }

  // ----------------------------------------------
  // \u30d7\u30ed\u30b0\u30e9\u30e0\u306e\u8aac\u660e\uff08\u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u524d\u306b\u8868\u793a\u3055\u308c\u308b
  // ----------------------------------------------
  // \u30d7\u30ed\u30b0\u30e9\u30e0\u30b3\u30e1\u30f3\u30c8\u3092\u8868\u793a\u3059\u308b
  public void outputProgramComments() {
    int i, commNum;
    commNum = comment.length;
    for (i = 0; i < commNum; i++) writeln(comment[i]);
  }
  // \u30d7\u30ed\u30b0\u30e9\u30e0\u30b3\u30e1\u30f3\u30c8\u3092\u5ba3\u8a00\uff08\u8907\u6570\u5ba3\u8a00\u53ef\u80fd\uff09\uff0esetup()\u5185\u3067\u30e6\u30fc\u30b6\u304c\u5ba3\u8a00\u3059\u308b\uff0e
  public crowbarClass programComment(String str) {
    checkOptionsSetupOnly("programComment()", null, false);
    String addStr[];
    addStr    = new String[1];
    addStr[0] = str;
    if (comment == null) {
      // \u4e00\u500b\u76ee\u306e\u30b3\u30e1\u30f3\u30c8\u306e\u5834\u5408
      comment = (String [])new String[1];
      comment = addStr;
    } else {
      // \u4e8c\u500b\u76ee\u4ee5\u964d\u306e\u30b3\u30e1\u30f3\u30c8\u306e\u5834\u5408
      comment = concat(comment, addStr);
    }
    return this;
  }
  // ---------------------------------------------------------------
  // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba\u3092\u5909\u66f4\u3059\u308b\uff08Options(), Setup()\u306e\u4e2d\u3067\u4f7f\u7528\u3059\u308b\u3053\u3068\uff09
  // ---------------------------------------------------------------
  // (a) \u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059
  public int fontSize() { return currentAttr.fontSize; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public int setFontSize(int size) {
    if (checkOptionsSetupOnly("setFontSize()", str(size), false)) return this.fontSize();
    int oldSize;
    oldSize = currentAttr.fontSize;
    _setFontSize(size);
    return oldSize;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  public crowbarClass fontSize(int size) {
    if (!checkOptionsSetupOnly("fontSize()", str(size), false)) this.setFontSize(size);
    return this;
  }
  // -------------------------------------------------------------------
  // \u81ea\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u306e\u8a2d\u5b9a\u3092\u5909\u66f4\u3059\u308b\uff1aOptions(), Setup()\u306e\u4e2d\u3067\u4f7f\u7528\u3059\u308b\u3053\u3068
  // -------------------------------------------------------------------
  // \u81ea\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u306e\u884c\u6570\u6307\u5b9a
  public int autoScrollLines() { return autoScrollLines; }
  public int setAutoScrollLines(int lines) {
    int oldlines = autoScrollLines();
//  if (status > 0) return oldlines;  // Main()\u5b9f\u884c\u524d\u4ee5\u5916\u306f\u5909\u66f4\u3092\u8a8d\u3081\u306a\u3044\uff08\u8a8d\u3081\u3066\u3082\u826f\u3044\u304b\u306a\uff09
    // \u7bc4\u56f2\u30c1\u30a7\u30c3\u30af
    if (lines < 0)                     lines = 0;
    if (lines > screenSetting.cheight) lines = 0;
    autoScrollLines = lines;
    return oldlines;
  }
  public crowbarClass autoScrollLines(int lines) { setAutoScrollLines(lines); return this; }
  public float autoScrollPage() { return (autoScrollLines / screenSetting.cheight); }
  public float setAutoScrollPage(float rate) {
    float oldrate = autoScrollPage();
//  if (status > 0) return oldrate;  // Main()\u5b9f\u884c\u524d\u4ee5\u5916\u306f\u5909\u66f4\u3092\u8a8d\u3081\u306a\u3044\uff08\u8a8d\u3081\u3066\u3082\u826f\u3044\u304b\u306a\uff09
    // \u7bc4\u56f2\u30c1\u30a7\u30c3\u30af
    if (rate < 0.0f) rate = 0.0f;
    if (rate > 1.0f) rate = 1.0f;
    autoScrollLines(PApplet.parseInt(screenSetting.cheight * rate));
    return oldrate;
  }
  public crowbarClass autoScrollPage(float rate) { setAutoScrollPage(rate); return this; }
  // ------------------------------------------------------
  // \u6587\u5b57\u9001\u308a\uff0c\u884c\u9001\u308a\u3092\u5909\u66f4\u3059\u308b\uff08Options()\u306e\u4e2d\u3067\u4f7f\u7528\u3059\u308b\u3053\u3068\uff09
  // ------------------------------------------------------
  // (a) \u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059
  public float hStep() { return screenSetting.hStep; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float setHStep(float step) {
    float oldStep = hStep();
    if (checkOptionsSetupOnly("setHStep()", str(step), false)) return oldStep;
    if (step <= 0.0f) return oldStep;
    screenSetting.hStep = step;
    screenSetting.reCalc(fontSize());
    screenReset();
    return oldStep;
  }
  // (c) \u30de\u30eb\u30c1\u30b9\u30c6\u30fc\u30c8\u30e1\u30f3\u30c8
  public crowbarClass hStep(float step) {
    if (!checkOptionsSetupOnly("hStep()", str(step), false)) setHStep(step);
    return this; 
  }
  // (a) \u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059
  public float vStep() { return screenSetting.vStep; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float setVStep(float step) {
    float oldStep = vStep();
    if (checkOptionsSetupOnly("setVStep()", str(step), false)) return oldStep;
    if (step <= 0.0f) return oldStep;
    screenSetting.vStep = step;
    screenSetting.reCalc(fontSize());
    screenReset();
    return oldStep;
  }
  public crowbarClass vStep(float step) {
    if (!checkOptionsSetupOnly("vStep()", str(step), false)) setVStep(step);
    return this;
  }
  // \u30d7\u30ed\u30bb\u30b9\u30b3\u30f3\u30c8\u30ed\u30fc\u30e9\u5185\u3067\u306e\u624b\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u8a31\u53ef
  public void enableManualScroll() {
    stopRecordTextBuffer();
    textbuffer.flushBuffer(!crowbar.overlapSwitch());
    afterRunning = true;
  }
  // \u30d7\u30ed\u30bb\u30b9\u30b3\u30f3\u30c8\u30ed\u30fc\u30e9\u5185\u3067\u306e\u624b\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u306e\u7981\u6b62
  public void disableManualScroll() {
    stopRecordTextBuffer();
    redrawNewestPage();
    afterRunning = false;
    startRecordTextBuffer();
  }
}

public void keyPressed() {
  if (crowbar.running == false) {
    if (crowbar.inputNow) {
    // \u3053\u3053\u306b\u3042\u3063\u305f\u30d1\u30e9\u30e1\u30fc\u30bf\u30fc\u5165\u529b\u306e\u305f\u3081\u306e\u30ad\u30fc\u5224\u5b9a\u306fProcessing3\u4ee5\u964d\u306fdraw()\u5185\u3067\u547c\u3076\u5fc5\u8981\u304c\u751f\u3058\u305f\u305f\u3081\u306bparameterInputControl()\u306b\u79fb\u52d5\u3057\u307e\u3057\u305f\u3002
    } else {
      // \u5f37\u5236\u7684\u306b\u629c\u3051\u305f\u3044\u5834\u5408
      if (getKEY() == 'Q') crowbar.status = 99;
    }
    // \u3053\u3053\u306b\u3042\u3063\u305f\u4e00\u884c\uff0f\u534a\u30da\u30fc\u30b8\u5358\u4f4d\u3067\u306e\u624b\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u306e\u305f\u3081\u306e\u30ad\u30fc\u5224\u5b9a\u306fProcessing3\u4ee5\u964d\u306fdraw()\u5185\u3067\u547c\u3076\u5fc5\u8981\u304c\u751f\u3058\u305f\u305f\u3081\u306bmanualScrollControl()\u306b\u79fb\u52d5\u3057\u307e\u3057\u305f\u3002
    redraw();
  } else {
    // Draw()\u5b9f\u884c\u6642\u306e\u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u6587\u5b57\u5217\u5165\u529b
    if (crowbar.input.isEnable()) crowbar.input.add();
    // crowbar.nonStop()\u6307\u5b9a\u6642\u306e\u30e6\u30fc\u30b6\u30d7\u30ed\u30b0\u30e9\u30e0\u5b9f\u884c\u4e2d\u306e\u30ad\u30fc\u5165\u529b\u5224\u5b9a
    // \u30b3\u30fc\u30c9\u306fKeyPressed()\u306b\u8a18\u8ff0\u3059\u308b\u3068\u826f\u3044\uff0e
    KeyPressed();
  }
}

public void parameterInputControl() {
  if (crowbar.running == false) {
  // \u30e6\u30fc\u30b6\u30d7\u30ed\u30b0\u30e9\u30e0\u304c\u52d5\u4f5c\u3057\u3066\u3044\u306a\u3044\u6642\uff08\u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u4e2d\u306a\u3069\uff09
    if (crowbar.inputNow) {
      // \u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u4e2d
      if (key == ENTER) {
        if (crowbar.is_numbersOnly() || (crowbar.is_selectOnly() != 0) || crowbar.is_booleanOnly()) {
          // \u6570\u5024\u5165\u529b\u3068\u9078\u629e\u578b\uff08\u3064\u307e\u308a\u6587\u5b57\u5217\u5165\u529b\u6642\u4ee5\u5916\uff09\u306e\u5834\u5408\u306f\u7a7a\u5165\u529b\u306f\u62d2\u5426
          if ((crowbar.keyBufferLength() == 0) && (crowbar.get_initialValue().length() == 0)) {
            redraw();
            return;
          }
        }
        crowbar.inputFinish();
        crowbar.newline();
      } else if (key == BACKSPACE) {
        if (crowbar.keyBufferLength() > 0) crowbar.backSpace();
      } else if (key == TAB) {
        if (crowbar.get_initialValue().length() > 0) {
          crowbar.automaticInputByDefalutValue(true);
          crowbar.inputFinish();
          crowbar.newline();
        }
      } else {
        // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5165\u529b
        boolean flag = true;
        int     num;
        // \u30ad\u30fc\u5165\u529b\u30eb\u30fc\u30eb
        // \u6570\u5024\u306e\u307f\u306e\u5834\u5408
        if (crowbar.is_numbersOnly()) {
          if (!crowbar.isKeyNumbers(key)) flag = false;
            else                          flag = crowbar.keyCheck.checkFloat(key);
        }
        // \u6574\u6570\u306e\u307f\u306e\u5834\u5408
        if (crowbar.is_integerOnly()) {
          if (!crowbar.isKeyIntegers(key)) flag = false;
            else                           flag = crowbar.keyCheck.checkInteger(key);
        }
        // \u8ad6\u7406\u578b\u306e\u307f\u306e\u5834\u5408
        if (crowbar.is_booleanOnly()) {
          if (!crowbar.isKeyBoolean(key)) flag = false;
            else                          flag = crowbar.keyCheck.checkBoolean(key);
        }
        // \u9078\u629e\u80a2\u306e\u5834\u5408
        if ((num = crowbar.is_selectOnly()) > 0) {
          if (num == 99) {  // \u7570\u5e38\u691c\u51fa
            crowbar.halt();
            return;
          }
          if (crowbar.keyBufferLength() >= 1) flag = false; // \u65e2\u306b\uff11\u6587\u5b57\u5165\u529b\u6e08\u307f\uff08\u534a\u89d2\u7a7a\u767d\u3082\u542b\u3080\uff09
          if (!isNumberChar(key))             flag = false; // \u6570\u5b57\u30ad\u30fc\uff080-9\uff09\u3067\u306f\u306a\u3044
          if (PApplet.parseInt(str(key)) >= num)           flag = false; // \u9078\u629e\u80a2\u306e\u6570\u3088\u308a\u3082\u5927\u304d\u306a\u6570\u5b57
        }
        if (flag) {
          crowbar.strcat(str(key));
          crowbar.write(str(key));
        }
      }
    }
  }
}

public void manualScrollControl() {
  if (crowbar.running == false) {
    // \u30b9\u30af\u30ed\u30fc\u30eb\u53ef\u80fd\u306a\u72b6\u614b\uff08\u30d7\u30ed\u30b0\u30e9\u30e0\u304c\u4e00\u65e6\u7d42\u4e86\u3057\u3066\u30ad\u30fc\u5165\u529b\u3092\u5f85\u3063\u3066\u3044\u308b\u9593\u306e\u307f\uff09
    if (crowbar.afterRunning) {
      if (key == '-')      crowbar.pageScroll(-0.5f);
      else if (key == '+') crowbar.pageScroll(0.5f);
      else if (key == CODED) {
        if (keyCode == UP)         crowbar.pageLineScroll(-1);
        else if (keyCode == DOWN)  crowbar.pageLineScroll(1);
        else if (keyCode == LEFT)  crowbar.pageScroll(-0.5f);
        else if (keyCode == RIGHT) crowbar.pageScroll(0.5f);
      }
    }
  }
}

///////////////
// \u30d7\u30ed\u30bb\u30b9\u7ba1\u7406
///////////////
public void draw() {
  // halt()\u767a\u751f\u6642\u306e\u51e6\u7406\uff08Ver.4\u3088\u308a\u6539\u5584\uff09
  if (crowbar.halt) {
    crowbar.status = 90;
    crowbar.halt = false;
  }
  // \u72b6\u614b\u9077\u79fb\u306e\u7ba1\u7406
  switch (crowbar.status) {
  case -1: return;    // crowbar\u672a\u5b9a\u7fa9
  case 0: // \u521d\u671f\u72b6\u614b
    // Setup()\u4e2d\u3067crowbar.nonStop()/noShowParams()\u304c\u5b9f\u884c\u3055\u308c\u305f\u5834\u5408\u306e\u5bfe\u7b56(Main()\u306a\u3069\u3067\u5909\u66f4\u3055\u308c\u3066\u3044\u308b\u6050\u308c\u304c\u3042\u308b\u305f\u3081\uff09
//  crowbar.setColor(_SYSTEMCOLOR1, _BGCOLOR);
    crowbar.textColor(_SYSTEMCOLOR1);
    crowbar.backupRunningFlag();
    crowbar.backupConfigFlag();
    crowbar.resetView(false);    // \u5168\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8996\u70b9\uff08\u5909\u63db\u30de\u30c8\u30ea\u30c3\u30af\u30b9\uff09\u306e\u30d0\u30c3\u30af\u30a2\u30c3\u30d7
    // \u30d7\u30ed\u30b0\u30e9\u30e0\u30b3\u30e1\u30f3\u30c8\u306e\u8868\u793a
    if (crowbar.comment != null) {
      if (!crowbar.run.silentMode) crowbar.textColor(_SYSTEMCOLOR2).writeln("\u3010\u30d7\u30ed\u30b0\u30e9\u30e0\u8aac\u660e\u3011").textColor(_SYSTEMCOLOR1);
      crowbar.outputProgramComments();
      crowbar.newline();
    }
    // Tomahawk\u95a2\u4fc2
    if (crowbar.tomahawkMode != 0) crowbar.backupViewports();
    crowbar.status++;
    break;
  case 1: // \u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u958b\u59cb\uff08\u518d\u5b9f\u884c\u6642\u306f\u3053\u3053\u306b\u30b8\u30e3\u30f3\u30d7\u3057\u3066\u304f\u308b\uff09
    // \u521d\u671f\u5316
    crowbar.allResetArguments();
    crowbar.automaticInputByDefalutValue(false);
    // setup()\u4e2d\u3067crowbar.nonStop()/noShowParams()\u3092\u8a2d\u5b9a\u3057\u305f\u5024\u304cMain()\u3084Draw()\u306e\u5b9f\u884c\u3067\u5909\u66f4\u3055\u308c\u308b\u6050\u308c\u304c\u3042\u308b\u306e\u3067\u5fa9\u5143\u3059\u308b
    crowbar.restoreRunningFlag();
    crowbar.restoreConfigFlag();
    // \u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5165\u529b\u8981\u6c42\u304c\u4e00\u3064\u3082\u7121\u304b\u3063\u305f\u5834\u5408\u306f\u30e1\u30c3\u30bb\u30fc\u30b8\u3092\u8868\u793a\u3057\u306a\u3044
    if (!crowbar.isNoParameter()) {
      if (!crowbar.run.silentMode) crowbar.newline().textColor(_SYSTEMCOLOR2).writeln("\u3010\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5165\u529b\u3011").textColor(_SYSTEMCOLOR1);
    }
    // Tomahawk\u95a2\u4fc2
    if (crowbar.tomahawkMode != 0) crowbar.restoreViewports();
    // \u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u6587\u5b57\u5217\u5165\u529b\u306e\u7121\u52b9\u5316
    crowbar.inputDisable();
    crowbar.status++;
    break;
  case 2: // \u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u958b\u59cb
    if (!crowbar.isNoParameter()) {
      crowbar.keyCheck.reset();  // \u30ad\u30fc\u5165\u529b\u898f\u5247\u306e\u30ea\u30bb\u30c3\u30c8
      crowbar.initArrayInput();  // \u914d\u5217\u578b\u306e\u5165\u529b\u524d\u51e6\u7406
      crowbar.write(crowbar.get_paramMessage(crowbar.obtainArgIndex, true) + ":");
      crowbar.flushKeyBuffer();
      crowbar.startInput();
      // \u521d\u671f\u8a2d\u5b9a\u5024\u306e\u81ea\u52d5\u5165\u529b\u30e2\u30fc\u30c9\u6709\u52b9\u306e\u5834\u5408\u306f\u30d1\u30b9\u3059\u308b
      if ((crowbar.autoInput == true) && (crowbar.get_initialValue().length() > 0)) {
        crowbar.inputFinish();
        crowbar.newline();
      } else {
        noLoop();  // \u30eb\u30fc\u30d7\u505c\u6b62
      }
    }
    crowbar.status++;
    break;
  case 3: // \u5165\u529b\u4e2d
    if (!crowbar.isNoParameter()) {
    if (keyPressed) parameterInputControl();
      String inputs;
      if (crowbar.inputFixed) {
        // \u5165\u529b\u78ba\u5b9a
        boolean flag = true;
        inputs = crowbar.getKeyBuffer();
        // \u7a7a\u304b\u3064\u521d\u671f\u5024\u304c\u6307\u5b9a\u3055\u308c\u3066\u3044\u308b\u5834\u5408
        if (inputs.length() == 0) inputs = crowbar.get_initialValue();
        // \u6574\u6570\u578b\u306e\u5834\u5408
        if (crowbar.is_integerOnly()) {
          if (inputs.length() != 0) inputs = str(PApplet.parseInt(inputs));
        }
        // \u9078\u629e\u80a2\u578b\u306e\u5834\u5408
        int  num;
        if ((num = crowbar.is_selectOnly()) > 0) {
          if (num == 99) { // \u7570\u5e38\u691c\u51fa
            crowbar.halt();
            break;
          }
          // \u5ff5\u306e\u305f\u3081\u306b\u30c1\u30a7\u30c3\u30af
          if (((num = PApplet.parseInt(inputs)) < 0) || (num > 9)) flag = false;
          else if (num > crowbar.is_selectOnly())     flag = false;
          if (!flag) {
            // \u3042\u308a\u5f97\u306a\u3044\u306f\u305a\uff08\u5165\u529b\u6642\u306b\u30c1\u30a7\u30c3\u30af\u3057\u3066\u3044\u308b\u306e\u3067\uff09
            crowbar.errorMessage("\u5b9f\u884c\u6642\u30a8\u30e9\u30fc", "\u9078\u629e\u80a2\u578b\u306e\u5165\u529b\u5024\u304c\u7570\u5e38\u3067\u3059", str(num), true);
            break;
          }
          inputs = crowbar.get_selectValue(num);
        }
        // \u8ad6\u7406\u578b\u306e\u5834\u5408
        if (crowbar.is_booleanOnly()) {
          switch(inputs.charAt(0)) {
            case '1':
            case 'T':
            case 't':
            case 'Y':
            case 'y': inputs = str(true); break;
            case '0':
            case 'F':
            case 'f':
            case 'N':
            case 'n': inputs = str(false); break;
            default:
              crowbar.errorMessage("\u5b9f\u884c\u6642\u30a8\u30e9\u30fc", "\u8ad6\u7406\u578b\u306e\u5165\u529b\u5024\u304c\u7570\u5e38\u3067\u3059", inputs, true);
              break;
          }
        }
        // \u914d\u5217\u306b\u914d\u616e
        if (crowbar.argv[crowbar.obtainArgIndex].arrayType == 0) {
          crowbar.setValue(inputs);
          crowbar.obtainArgIndex++;
        } else {
          crowbar.setArrayValue(inputs);
          if (crowbar.argv[crowbar.obtainArgIndex].ready) {
            crowbar.obtainArgIndex++;
            crowbar.resetArrayIndex();
          }
        }
        // \u30eb\u30fc\u30d7\u518d\u958b
        loop();
        crowbar.status++;
      }
    } else crowbar.status++;
    break;
  case 4: // \u30d1\u30e9\u30e1\u30fc\u30bf\u5165\u529b\u5b8c\u4e86\u304b\u306e\u5224\u5b9a
    if (!crowbar.isNoParameter()) {
      if (crowbar.allReady()) crowbar.status++;
      else                    crowbar.status -= 2;
    } else crowbar.status++;
    break;
  case 5: // \u5b9f\u884c\u304b\uff1f \u518d\u5165\u529b\u304b\uff1f
    if (!crowbar.isNoParameter()) crowbar.newline();
    if (!crowbar.isNoParameter() && !crowbar.run.silentMode) {
      crowbar.textColor(_SYSTEMCOLOR2).writeln("\u3010\u5168\u3066\u306e\u30d1\u30e9\u30e1\u30fc\u30bf\u306e\u5165\u529b\u304c\u5b8c\u4e86\u3011").textColor(_SYSTEMCOLOR1);
      if (!crowbar.run.noShowParams) crowbar.showAllParameters();
      crowbar.textColor(_SYSTEMCOLOR3).write("\u30d7\u30ed\u30b0\u30e9\u30e0\u3092\u5b9f\u884c\u3059\u308b(Yes) /\u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u5165\u529b\u3057\u76f4\u3059(Retry) : ").textColor(_SYSTEMCOLOR1);
      // \u624b\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u306e\u8a31\u53ef
      crowbar.enableManualScroll();
      noLoop();
    }
    crowbar.status++;
    break;
  case 6: // \u30ad\u30fc\u5224\u5b9a\u7d50\u679c
    if (!crowbar.isNoParameter() && !crowbar.run.silentMode) {
      if (keyPressed) {
        if (getKEY() == 'Y') {
          crowbar.disableManualScroll(); // \u624b\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u306e\u7981\u6b62
          crowbar.writeln(str(key)).newline();
          crowbar.status++;
          loop();
        } else if (getKEY() == 'R') {
          crowbar.disableManualScroll(); // \u624b\u52d5\u30b9\u30af\u30ed\u30fc\u30eb\u306e\u7981\u6b62
          crowbar.writeln(str(key)).newline();
          crowbar.status -= 5;
          loop();
        }
        manualScrollControl();  // Processing3\u3088\u308a
      }
    } else crowbar.status++;
    break;
  case 7: // \u30e1\u30a4\u30f3\u30d7\u30ed\u30b0\u30e9\u30e0\u5b9f\u884c\u524d\u51e6\u7406\uff08\u3042\u308b\u306a\u3089\u3070\uff09
    preMain(); // optionCode\u30bf\u30d6\u53c2\u7167
    if (crowbar.halt) break;
    crowbar.running = true;
    crowbar.status++;
    break;
  case 8: // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u3078\u306e\u51fa\u529b\u3092\u8a31\u53ef\u3059\u308b:\u3053\u308c\u306f\u3082\u3057\u304b\u3057\u305f\u3089status==0\u304b\u3089\u8a31\u53ef\u3059\u308b\u304b\u3082\u77e5\u308c\u306a\u3044\uff0e\u4f59\u8a08\u306a\u6587\u5b57\u60c5\u5831\u306f\u8a18\u9332\u3057\u306a\u3044\u3068\u3044\u3046\u4ed5\u69d8\u306f\u304a\u7bc0\u4ecb\u3060\u3063\u305f\u304b\u3082\u3068\u3044\u3046\u53cd\u7701\uff0e
    crowbar.enableLogOutput();
    if (crowbar.isEnableLogging()) {
      // \u5168\u30d1\u30e9\u30e1\u30fc\u30bf\u3092\u51fa\u529b\u3059\u308b
      crowbar.restartLogging().newline2Log().showAllParameters2Log().newline2Log();
    }
    crowbar.status++;
    break;
  case 9: // \u30e1\u30a4\u30f3\u30d7\u30ed\u30b0\u30e9\u30e0\u5b9f\u884c
    Main();
    loop();  // \u30eb\u30fc\u30d7\u518d\u958b
    if (crowbar.halt) break;
    // \u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u6587\u5b57\u5217\u5165\u529b\u306e\u521d\u671f\u5316
    crowbar.inputFlush();
    crowbar.status++;
    break;
  case 10: // \u7e70\u308a\u8fd4\u3057\u5b9f\u884c\u30b3\u30fc\u30c9\uff08\u30aa\u30d7\u30b7\u30e7\u30f3\uff09
    if (crowbar.run.nonStop) {
      // crowbar.nonStop()\u6307\u5b9a\u6642\u306e\u7e70\u308a\u8fd4\u3057\u51e6\u7406\u306fDraw()\u306b\u8a18\u8ff0
      if (crowbar.run.userDrawLoop) {
        crowbar.resetView(true);  // \u5168\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306erotate(), scale(), translate()\u306e\u518d\u8a2d\u5b9a
        Draw();
        if (crowbar.checkNonStopCounter()) {  // \u3082\u3057nonStopCounter\u304c-1\u3067\u306f\u306a\u304f\uff0c-1\u3057\u3066\u30ab\u30a6\u30f3\u30c8\u30a2\u30c3\u30d7\u3057\u305f\u306a\u3089\u3070\u7d42\u4e86
          crowbar.stop();
          crowbar.status++;
        } 
      }
      break;
    }
    // \u30ea\u30a2\u30eb\u30bf\u30a4\u30e0\u6587\u5b57\u5217\u5165\u529b\u306e\u505c\u6b62\u3068\u521d\u671f\u5316
    crowbar.inputFlush();
    crowbar.inputDisable();
    crowbar.status++;
    break;
  case 11: // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u51fa\u529b\u3092\u4e00\u6642\u7684\u306b\u6b62\u3081\u308b
    crowbar.running = false;
    if (crowbar.isEnableLogging()) crowbar.pauseLogging();
    crowbar.status++;
    break;
  case 12: // \u30e1\u30a4\u30f3\u30d7\u30ed\u30b0\u30e9\u30e0\u5b9f\u884c\u5f8c\u51e6\u7406\uff08\u3042\u308b\u306a\u3089\u3070\uff09
    postMain(); // optionCode\u30bf\u30d6\u53c2\u7167
    crowbar.status++;
    break;
  case 13: // \u30ea\u30c8\u30e9\u30a4\u78ba\u8a8d\u30e1\u30c3\u30bb\u30fc\u30b8
    // \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u95a2\u9023
//  crowbar.textbuffer.flushBuffer(!crowbar.overlapSwitch());
//  crowbar.stopRecordTextBuffer();
    crowbar.textbuffer.flushBuffer(!crowbar.overlapSwitch());
//  crowbar.setColor(_SYSTEMCOLOR2, _BGCOLOR).newline();
    crowbar.textColor(_SYSTEMCOLOR2).newline();
    if (!crowbar.run.silentMode) crowbar.writeln("\u3010\u30d7\u30ed\u30b0\u30e9\u30e0\u7d42\u4e86\u3011").textColor(_SYSTEMCOLOR3).write("\u3082\u3046\u4e00\u5ea6\uff0c\u5b9f\u884c\u3057\u307e\u3059\u304b\uff1f(Yes/No)\uff1a");
    else                         crowbar.textColor(_SYSTEMCOLOR3).write("\u518d\u5b9f\u884c(Y/N)\uff1a");
    crowbar.textColor(_SYSTEMCOLOR1);
    crowbar.enableManualScroll();
    crowbar.status++;
    noLoop();
    break;
  case 14: // \u30ad\u30fc\u5224\u5b9a\u7d50\u679c
    if (keyPressed) {
      int K = getKEY();
      if ((K == 'Y') || (K == 'N')) {
        crowbar.writeln(str(key)).newline();
        // \u30c6\u30ad\u30b9\u30c8\u30d0\u30c3\u30d5\u30a1\u2015\u95a2\u9023
        crowbar.disableManualScroll();
        if (K == 'Y') crowbar.status = 1;
        else          crowbar.status++;
        loop();
      }
      manualScrollControl();  // Processing3\u3088\u308a
    }
    break;
  case 15: // \u7d42\u4e86
    crowbar.status = 99;
    break;
  case 90 : // crowbar.halt()\u3067\u98db\u3093\u3067\u304d\u305f
    crowbar.running = false;
    crowbar.afterRunning = true;
    crowbar.newline().textColor(_SYSTEMCOLOR2).writeln("\u3010\u91cd\u5927\u306a\u30a8\u30e9\u30fc\u304c\u767a\u751f\u3057\u307e\u3057\u305f\u3011\uff1a\u30b3\u30f3\u30bd\u30fc\u30eb\u9818\u57df\u306e\u30a8\u30e9\u30fc\u30e1\u30c3\u30bb\u30fc\u30b8\u3092\u3088\u304f\u78ba\u8a8d\u3057\u3066\u4e0b\u3055\u3044\uff0e");
    crowbar.textColor(_SYSTEMCOLOR3).writeln("[Q]\u30ad\u30fc\u3092\u62bc\u3059\u3068Crowbar\u3092\u7d42\u4e86\u3057\u307e\u3059\uff1a");
    crowbar.stopRecordTextBuffer();
    crowbar.status++;
    noLoop();
    break;
  case 91 : // \u30ad\u30fc\u5165\u529b\u5f85\u3061
    if (keyPressed) {
      if (getKEY() == 'Q') {
        crowbar.status = 99;
        loop();
      }
    }
    break;
  case 99: // \u7d42\u4e86\u51e6\u7406
    println();
    // \u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u3092\u958b\u3044\u305f\u307e\u307e\u306a\u3089\u9589\u3058\u308b
    if (crowbar.isEnableLogging()) {
      println("\u30d5\u30a1\u30a4\u30eb\u3092\u9589\u3058\u307e\u3059\uff0e");
      crowbar.restartLogging().newline2Log().stopLogging();
      crowbar.disableLogOutput();
    }
    println("Crowbar\u3092\u7d42\u4e86\u3057\u307e\u3059\uff0e");
    exit();
    break;
  default:
    if ((crowbar.status > 90) && (crowbar.halt)) crowbar.status = 99;  // crowbar.halt()\u3067\u623b\u3063\u3066\u6765\u305f\u306e\u306b crowbar.status\u304c++\u3055\u308c\u305f\u5834\u5408\u306a\u3069\u306b\u30ad\u30e3\u30c3\u30c1\uff0e90\u3058\u3083\u306a\u304f\u306615\u3067\u3082\u826f\u3044\u306e\u3060\u304c\uff0e
  }
  crowbar.refreshView();  // Tomahawk\u306e\u30d3\u30e5\u30fc\u5408\u6210
}

public void mouseDragged() {
  if (crowbar.running) {
    crowbar.resetView(true);
    MouseDragged();
  }
}
public void mouseMoved() {
  if (crowbar.running) {
    crowbar.resetView(true);
    MouseMoved();
  }
}
public void mousePressed() {
  if (crowbar.running) {
    crowbar.resetView(true);
    MousePressed();
  }
}
public void mouseReleased() {
  if (crowbar.running) {
    crowbar.resetView(true);
    MouseReleased();
  }
}
public void mouseClicked() {
  if (crowbar.running) {
    crowbar.resetView(true);
    MouseClicked();
  }
}
public void keyReleased() {
  if (crowbar.running) {
    crowbar.resetView(true);
    KeyReleased();
  }
}
public void keyTyped() {
  if (crowbar.running) {
    crowbar.resetView(true);
    KeyTyped();
  }
}

// \u30b7\u30b9\u30c6\u30e0\u521d\u671f\u8a2d\u5b9a
public void setup()
{
  initCrowbar();
  Options();
  Setup();
  crowbar.clrscr();
  crowbar.status = 0;  // \u6e96\u5099\u5b8c\u4e86 \uff08\u3053\u306e\u624b\u7d9a\u304d\u306f\u4e0d\u8981\u306a\u306e\u3060\u304c\u6c17\u6301\u3061\u306e\u554f\u984c\uff09
}

////////////////////////////////////////////////////////////////////////////////
// \u3042\u308b\u3068\u4fbf\u5229\u306a\u6c4e\u7528\u95a2\u6570\uff08Crowbar/Tomahawk\u3067\u3082\u4f7f\u7528\u3057\u3066\u3044\u308b\u306e\u3067\u524a\u9664\u3057\u306a\u3044\u3067\u4e0b\u3055\u3044\uff09
////////////////////////////////////////////////////////////////////////////////

//  1. int sgn(float), int sgn(int)                 : \u8ca0\u306a\u3089\u3070-1\uff0c\u6b63\u306a\u3089\u3070 1\uff0c\u30bc\u30ed\u306a\u3089\u3070 0 \u3092\u8fd4\u3059
//  2. String nowDateTime(void)                     : \u65e5\u6642\u3092\u6587\u5b57\u5217\u3067\u8fd4\u3059\uff08yyyy/mm/dd hh:mm:ss\uff09
//  3. char getKEY(void)                            : \u30ad\u30fc\u30dc\u30fc\u30c9\u304b\u3089\u5165\u529b\u3055\u308c\u305f\u6587\u5b57\u3092\u5927\u6587\u5b57\u306b\u5909\u63db\u3057\u3066\u8fd4\u3059(a-z\u306e\u5834\u5408\u306e\u307f)
//  4. boolean isNumberChar(char)                   : char\u304c'0'\u304b\u3089'9'\u306a\u3089\u3070\u771f
//  5. String strRight(String, int)                 : \u6587\u5b57\u5217\u306e\u53f3\u304b\u3089\u6307\u5b9a\u3055\u308c\u305f\u9577\u3055\u306e\u6587\u5b57\u5217\u3092\u8fd4\u3059
//  6. String strLeft(String, int)                  : \u6587\u5b57\u5217\u306e\u5de6\u304b\u3089\u6307\u5b9a\u3055\u308c\u305f\u9577\u3055\u306e\u6587\u5b57\u5217\u3092\u8fd4\u3059
//  7. float rotate2Dx(float x, float y, float rad)  : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u56de\u8ee2\u884c\u5217\uff08\uff58\u8ef8\u6210\u5206\uff09
//     float rotate2Dy(float x, float y, float rad)  : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u56de\u8ee2\u884c\u5217\uff08\uff59\u8ef8\u6210\u5206\uff09
//     float rotate2Dsx(float x, float y, float rad) : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u56de\u8ee2\u884c\u5217\uff08\uff58\u8ef8\u6210\u5206\uff09\uff1a\u30d4\u30af\u30bb\u30eb\u5ea7\u6a19\u7cfb\u7528
//     float rotate2Dxy(float x, float y, float rad) : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u56de\u8ee2\u884c\u5217\uff08\uff59\u8ef8\u6210\u5206\uff09\uff1a\u30d4\u30af\u30bb\u30eb\u5ea7\u6a19\u7cfb\u7528
//  8. float norm(float x0, float y0, float x1, float y1) : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u4e8c\u70b9\u9593\u306e\u8ddd\u96e2\uff08\u30e6\u30fc\u30af\u30ea\u30c3\u30c9\u30ce\u30eb\u30e0\uff09\u3092\u6c42\u3081\u308b
//  9. float [2] polygonGx(float [][] pt)           : \u591a\u89d2\u5f62\u306e\u56f3\u5fc3\u3092\u6c42\u3081\u308b
// 10. float triangleSurface(float x1, float y1, float x2, float y2, float x3, float y3) : \u4e09\u89d2\u5f62\u306e\u9762\u7a4d\u3092\u6c42\u3081\u308b
// 11. float [2] triangleG(float x1, float y1, float x2, float y2, float x3, float y3)   : \u4e09\u89d2\u5f62\u306e\u56f3\u5fc3\u3092\u6c42\u3081\u308b
// 12. void _debugPrint(String str)                         : \u30c7\u30d0\u30c3\u30b0\u7528\u306e\u30c6\u30ad\u30b9\u30c8\u51fa\u529b
//     void _debugPrintln(String str), void _debugPrintln()

// 1. int sgn(float), int sgn(int) : \u8ca0\u306a\u3089\u3070-1\uff0c\u6b63\u306a\u3089\u3070 1\uff0c\u30bc\u30ed\u306a\u3089\u3070 0 \u3092\u8fd4\u3059
public int sgn(int i) {
  return sgn(PApplet.parseFloat(i));
}
public int sgn(float f) {
  if (f < 0.0f) return -1;
  if (f > 0.0f) return  1;
  return 0;
}

// 2. String nowDateTime() : \u65e5\u6642\u3092\u6587\u5b57\u5217\u3067\u8fd4\u3059\uff08yyyy/mm/dd hh:mm:ss\uff09
public String nowDateTime() {
  return str(year()) + '/' + strRight('0' + str(month()), 2) + '/' + strRight('0' + str(day()), 2) + ' ' + strRight('0' + str(hour()), 2) + ':' + strRight('0' + str(minute()), 2) + ':' + strRight('0' + str(second()), 2);
}

// 3. char getKEY() : \u30ad\u30fc\u30dc\u30fc\u30c9\u304b\u3089\u5165\u529b\u3055\u308c\u305f\u6587\u5b57\u3092\u5927\u6587\u5b57\u306b\u5909\u63db\u3057\u3066\u8fd4\u3059(a-z\u306e\u5834\u5408\u306e\u307f)
public char getKEY() {
  if ((key < 'a') || (key > 'z')) return key;
  return str(key).toUpperCase().charAt(0);
}

// 4. boolean isNumberChar(char)    : char\u304c'0'\u304b\u3089'9'\u306a\u3089\u3070\u771f
public boolean isNumberChar(char c) {
  if ((c >= '0') && (c <= '9')) return true;
  return false;
}

// 5. String strRight(String, int) : \u6587\u5b57\u5217\u306e\u53f3\u304b\u3089\u6307\u5b9a\u3055\u308c\u305f\u9577\u3055\u306e\u6587\u5b57\u5217\u3092\u8fd4\u3059
public String strRight(String str, int len) {
  int  index;
  index = str.length() - len;
  if (index < 0) return str;
//return str.substring(index, len);
  return str.substring(index);
}

// 6. String strLeft(String, int)  : \u6587\u5b57\u5217\u306e\u5de6\u304b\u3089\u6307\u5b9a\u3055\u308c\u305f\u9577\u3055\u306e\u6587\u5b57\u5217\u3092\u8fd4\u3059
public String strLeft(String str, int len) {
  return str.substring(0, len);
}

// 7. float rotate2Dx(float x, float y, float rad)  : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u56de\u8ee2\u884c\u5217\uff08\uff58\u8ef8\u6210\u5206\uff09
//    float rotate2Dy(float x, float y, float rad)  : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u56de\u8ee2\u884c\u5217\uff08\uff59\u8ef8\u6210\u5206\uff09
//    float rotate2Dsx(float x, float y, float rad) : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u56de\u8ee2\u884c\u5217\uff08\uff58\u8ef8\u6210\u5206\uff09\uff1a\u30d4\u30af\u30bb\u30eb\u5ea7\u6a19\u7cfb\u7528
//    float rotate2Dxy(float x, float y, float rad) : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u56de\u8ee2\u884c\u5217\uff08\uff59\u8ef8\u6210\u5206\uff09\uff1a\u30d4\u30af\u30bb\u30eb\u5ea7\u6a19\u7cfb\u7528
//    rad\u306f\u3044\u305a\u308c\u3082\u53cd\u6642\u8a08\u65b9\u5411\u3092\u6b63\u3068\u3059\u308b
public float rotate2Dx(float x, float y, float rad) {
  return x * cos(rad) - y * sin(rad);
}
public float rotate2Dy(float x, float y, float rad) {
  return x * sin(rad) + y * cos(rad);
}
public float rotate2Dsx(float x, float y, float rad) {
  return x * cos(rad) + y * sin(rad);
}
public float rotate2Dsy(float x, float y, float rad) {
  return - x * sin(rad) + y * cos(rad);
}

// 8. float norm(float x0, float y0, float x1, float y1) : \u4e8c\u6b21\u5143\u5e73\u9762\u306b\u304a\u3051\u308b\u4e8c\u70b9\u9593\u306e\u8ddd\u96e2\uff08\u30e6\u30fc\u30af\u30ea\u30c3\u30c9\u30ce\u30eb\u30e0\uff09\u3092\u6c42\u3081\u308b
public float norm(float x0, float y0, float x1, float y1) {
  float dx, dy;
  dx = x1 - x0;
  dy = y1 - y0;
  return sqrt(dx * dx + dy * dy);
}

// 9. float [2] polygonG(float [][] pt) : \u591a\u89d2\u5f62\u306e\u56f3\u5fc3\u3092\u6c42\u3081\u308b
// http://homepage1.nifty.com/gfk/polygon-G.htm
public float [] polygonG(float [][] pt) {
  // \u56de\u7b54\u306e\u9818\u57df\u78ba\u4fdd
  float [] xyG = new float[2];
  xyG[0] = pt[0][0];
  xyG[1] = pt[0][1];
  // \uff11\u70b9\u306e\u5834\u5408\u306f\u4f55\u3082\u3057\u306a\u3044
  if (pt.length == 2) {
    // \u4e8c\u70b9\u306e\u5834\u5408\u306f\u4e2d\u70b9
    xyG[0] += pt[1][0];
    xyG[1] += pt[1][1];
    xyG[0] /= 2.0f;
    xyG[1] /= 2.0f;
  } else if (pt.length == 3) {
    // \u4e09\u70b9\u306e\u5834\u5408\u306f\u5e73\u5747
    xyG = triangleG(pt[0][0], pt[0][1], pt[1][0], pt[1][1], pt[2][0], pt[2][1]);
  } else {
    float St;    // \u5168\u9762\u7a4d
    float Si;    // \u5404\u4e09\u89d2\u5f62\u306e\u9762\u7a4d
    float [] xyGi = new float[2];  // \u5404\u4e09\u89d2\u5f62\u306e\u91cd\u5fc3
    int    i;
    // \u9802\u70b9\u306e\u8907\u88fd\uff08\uff0b\uff11\u500b\uff09\u3092\u4f5c\u6210\u3059\u308b\uff1a\u52b9\u7387\u306f\u60aa\u3044\u304c\u53c2\u7167\u5143\u306b\u60aa\u5f71\u97ff\u3092\u4e0e\u3048\u306a\u3044\u305f\u3081\u306b
    float p[][] = new float[pt.length + 1][2];
    for (i = 0; i < pt.length; i++) {
      p[i][0] = pt[i][0];
      p[i][1] = pt[i][1];
    }
    p[i][0] = pt[0][0];
    p[i][1] = pt[0][1];
    // \u91cd\u5fc3\u3092\u6c42\u3081\u308b
    St = 0.0f;
    xyG[0] = xyG[1] = 0.0f;
    for (i = 0; i < pt.length; i++) {
//    Si = triangleSurface(0.0, 0.0, p[i][0], p[i][1], p[i+1][0], p[i+1][1]);  // \u8ca0\u306e\u9762\u7a4d\u304c\u91cd\u8981\u3089\u3057\u3044
      Si = (p[i][0] * p[i+1][1] - p[i][1] * p[i+1][0]) / 2.0f;
      St += Si;
      xyGi = triangleG(0.0f, 0.0f, p[i][0], p[i][1], p[i+1][0], p[i+1][1]);
      xyG[0] += xyGi[0] * Si;
      xyG[1] += xyGi[1] * Si;
    }
    xyG[0] /= St;
    xyG[1] /= St;
  }
  return xyG;
}

// 10. float triangleSurface(float x1, float y1, float x2, float y2, float x3, float y3) : \u4e09\u89d2\u5f62\u306e\u9762\u7a4d\u3092\u6c42\u3081\u308b
public float triangleSurface(float x1, float y1, float x2, float y2, float x3, float y3) {
  float s;
  x1 -= x3;
  y1 -= y3;
  x2 -= x3;
  y2 -= y3;
  s = (x1 * y2 - y1 * x2) / 2.0f;
  return s < 0.0f ? -s : s;
}

// 11. float [2] triangleG(float x1, float y1, float x2, float y2, float x3, float y3)   : \u4e09\u89d2\u5f62\u306e\u56f3\u5fc3\u3092\u6c42\u3081\u308b
public float [] triangleG(float x1, float y1, float x2, float y2, float x3, float y3) {
  float [] xyG = new float[2];
  xyG[0] = (x1 + x2 + x3) / 3.0f;
  xyG[1] = (y1 + y2 + y3) / 3.0f;
  return xyG;
}

// 12. void _debugPrint(String str) : \u30c7\u30d0\u30c3\u30b0\u7528\u306e\u30c6\u30ad\u30b9\u30c8\u51fa\u529b
//     void _debugPrintln(String str), void _debugPrintln()
public void _debugPrint(String str) {
  if (_DEBUGFLAG) print(str);
}
public void _debugPrintln(String str) {
  if (_DEBUGFLAG) println(str);
}
public void _debugPrintln() {
  if (_DEBUGFLAG) println();
}

//--------------- End of crowbarClass.pde ----------------------
// ----------------------
// \u30b0\u30ed\u30fc\u30d0\u30eb\u95a2\u6570\u547c\u3073\u51fa\u3057
// 2012/12/02 Ver.4.1 -
// ----------------------
// \u3082\u3057\u30aa\u30d6\u30b8\u30a7\u30af\u30c8\u6307\u5411\u30bf\u30a4\u30d7\u306e\u547c\u3073\u51fa\u3057\u304c\u5b66\u751f\u306b\u3068\u3063\u3066\u96e3\u6613\u5ea6\u304c\u9ad8\u3044\u3068\u5224\u65ad\u3057\u305f\u5834\u5408\u306f
// \u3053\u306e\u30bd\u30fc\u30b9\u3092\u5229\u7528\u3059\u308b\uff0e\u3082\u3057\u4e0d\u8981\u306a\u3089\u3070\u3053\u306e\u30bd\u30fc\u30b9\u30d5\u30a1\u30a4\u30eb\u306f\u524a\u9664\u3057\u3066\u3082\u69cb\u3044\u307e\u305b\u3093\uff0e

// write()
public crowbarClass write(int value)      { return crowbar.write(value); }
public crowbarClass write(float value)    { return crowbar.write(value); }
public crowbarClass write(boolean value)  { return crowbar.write(value); }
public crowbarClass write(String str)     { return crowbar.write(str);   }

public crowbarClass write(float x, float y, int value)      { return crowbar.write(x, y, value); }
public crowbarClass write(float x, float y, float value)    { return crowbar.write(x, y, value); }
public crowbarClass write(float x, float y, boolean value)  { return crowbar.write(x, y, value); }
public crowbarClass write(float x, float y, String str)     { return crowbar.write(x, y, str);   }

// writeln()
public crowbarClass writeln(int value)      { return crowbar.writeln(value); }
public crowbarClass writeln(float value)    { return crowbar.writeln(value); }
public crowbarClass writeln(boolean value)  { return crowbar.writeln(value); }
public crowbarClass writeln(String str)     { return crowbar.writeln(str);   }

public crowbarClass writeln(float x, float y, int value)      { return crowbar.writeln(x, y, value); }
public crowbarClass writeln(float x, float y, float value)    { return crowbar.writeln(x, y, value); }
public crowbarClass writeln(float x, float y, boolean value)  { return crowbar.writeln(x, y, value); }
public crowbarClass writeln(float x, float y, String str)     { return crowbar.writeln(x, y, str);   }

// newline()
public crowbarClass newline()          { return crowbar.newline();     }
public crowbarClass newline(int line)  { return crowbar.newline(line); }

// textColor()
public crowbarClass textColor(int c)          { return crowbar.textColor(c);      }
public crowbarClass textColor(int tc, int bc) { return crowbar.textColor(tc, bc); }
public int textColor()                        { return crowbar.textColor();       }

// programComment()
public crowbarClass programComment(String str)  { return crowbar.programComment(str); }

// param()
public crowbarClass parameter(String str)  { return crowbar.param(str); }  // \u6ce8\u610f\uff01

// setFloat()
public crowbarClass setFloat()            { return crowbar.setFloat();     }
public crowbarClass setFloat(float init)  { return crowbar.setFloat(init); }
public crowbarClass setFloat(int init)    { return crowbar.setFloat(init); }

// setInt()
public crowbarClass setInt()            { return crowbar.setInt();     }
public crowbarClass setInt(float init)  { return crowbar.setInt(init); }
public crowbarClass setInt(int init)    { return crowbar.setInt(init); }

// setBoolean()
public crowbarClass setBoolean()              { return crowbar.setBoolean();     }
public crowbarClass setBoolean(boolean init)  { return crowbar.setBoolean(init); }
public crowbarClass setBoolean(float init)    { return crowbar.setBoolean(init); }
public crowbarClass setBoolean(int init)      { return crowbar.setBoolean(init); }
public crowbarClass setBoolean(String init)   { return crowbar.setBoolean(init); }

// setSelect()
public crowbarClass setSelect(String str)            { return crowbar.setSelect(str);       }
public crowbarClass setSelect(String str, int init)  { return crowbar.setSelect(str, init); }

// setStr()
public crowbarClass setStr()            { return crowbar.setStr();     }
public crowbarClass setStr(String init) { return crowbar.setStr(init); }
public crowbarClass setStr(float init)  { return crowbar.setStr(init); }
public crowbarClass setStr(int init)    { return crowbar.setStr(init); }

// label()
public crowbarClass label(String str)   { return crowbar.label(str); }
// \u30d0\u30fc\u30b8\u30e7\u30f3\u756a\u53f7
final String Version          = "3.0.0";

// \u5909\u63db\u306b\u95a2\u3059\u308b\u5b9a\u6570
float   SH_H     = 4.5f;    // \u30b7\u30e5\u30df\u30c3\u30c8\u30c8\u30ea\u30ac\u30fc\u306e\u95be\u5024\uff08H\u5074\uff09
float   SH_L     = 0.5f;    // \u30b7\u30e5\u30df\u30c3\u30c8\u30c8\u30ea\u30ac\u30fc\u306e\u95be\u5024\uff08L\u5074)
boolean REVERSE  = true;   // \u56de\u8ee2\u65b9\u5411\u306e\u53cd\u8ee2\uff08CW/CCW\u304c\u5e0c\u671b\u3068\u7570\u306a\u308b\u5834\u5408\u306b true \u306b\u5909\u66f4\u3057\u3066\u4e0b\u3055\u3044
int     CDS      = 3;      // \u89d2\u901f\u5ea6\u8a08\u7b97\uff08\u6570\u5024\u7a4d\u5206\uff09\u306b\u304a\u3051\u308b\u4e2d\u5fc3\u5dee\u5206\u8fd1\u4f3c\u306e\u524d\u5f8c\u30c7\u30fc\u30bf\u8ddd\u96e2\uff1a\u5fae\u5206\u5024 = {x(i - CDS) + x(i + CDS)} / 2\u0394t
float   DeltaT   = 0.05f;   // \u30b5\u30f3\u30d7\u30ea\u30f3\u30b0\u9593\u9694\uff08[ms]\uff09\uff1a\u89d2\u901f\u5ea6\u8a08\u7b97\u6642\u306b\u4f7f\u7528
int     EncCount = 600;    // https://www.mtl.co.jp/product/index.php/item?cell003=%E3%82%A4%E3%83%B3%E3%82%AF%E3%83%AA%E3%83%A1%E3%83%B3%E3%82%BF%E3%83%AB%E5%BC%8F&cell004=ME%E3%82%B7%E3%83%AA%E3%83%BC%E3%82%BA&name=ME-17-P%E3%82%B7%E3%83%AA%E3%83%BC%E3%82%BA&id=7&label=1
int     MApulse  = 0;      // \u30d1\u30eb\u30b9\u7d2f\u7a4d\u306e\u79fb\u52d5\u5e73\u5747\u306e\u524d\u5f8c\u306e\u9805\u6570\uff08\u5206\u6bcd\u306f n * 2 + 1\uff09
int     MAav     = 0;      // \u89d2\u901f\u5ea6\u306e\u79fb\u52d5\u5e73\u5747\u306e\u524d\u5f8c\u306e\u9805\u6570\uff08\u5206\u6bcd\u306f n * 2 + 1)\uff0c\u306a\u304a\uff0cpps\u306b\u79fb\u52d5\u5e73\u5747\u3092\u639b\u3051\u308b\u306e\u306f\uff0crpm\u306f\u79fb\u52d5\u5e73\u5747\u3057\u306a\u3044
int     Extract  = 0;      // \u30b5\u30f3\u30d7\u30ea\u30f3\u30b0\u30c7\u30fc\u30bf\u306e\u629c\u304d\u53d6\u308a\u9593\u9694\uff08= \u3067\u629c\u304d\u53d6\u308a\u306f\u884c\u308f\u306a\u3044\uff09

// \u5b9a\u6570\uff08\u521d\u671f\u5024\uff09
final int Init_PosX = 50;                 // \u30a6\u30a3\u30f3\u30c9\u30a6\u306e\u521d\u671f\u4f4d\u7f6e\uff08x\u5ea7\u6a19\uff09
final int Init_PosY = 50;                 // \u30a6\u30a3\u30f3\u30c9\u30a6\u306e\u521d\u671f\u4f4d\u7f6e\uff08y\u5ea7\u6a19\uff09

final int Wx = 60;
final int Wy = 20;
// Enc_Decoder\u56fa\u6709\u306e\u30e9\u30a4\u30d6\u30e9\u30ea\u30fc
// \u30e1\u30c3\u30bb\u30fc\u30b8\u8868\u793a\u95a2\u4fc2\u306e\u30af\u30e9\u30b9
class Message {
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf\u30fc
  Message() {
  }
  public void set(String msg) {
    set(msg, true, 0xFF000000);
  }
  // \u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u8868\u793a
  public void set(String msg, boolean flag, int col) {
    if (flag) write("\u3007");
    crowbar.textColor(col);
    writeln(msg);
    println(msg);
  }
  // \u30a8\u30e9\u30fc\u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u8868\u793a
  public void setError(String msg) {
    String label = "\u3007Error: "; 
    crowbar.textColor(0xFFFF0000);
    write(label);
    set(msg, false, 0xFF000000);
    print(label);
  }
  // \u8b66\u544a\u30e1\u30c3\u30bb\u30fc\u30b8\u306e\u8868\u793a
  public void setWarnning(String msg) {
    String label = "\u3007Warnning: "; 
    crowbar.textColor(0xFF800080);
    write(label);
    set(msg, false, 0xFF000000);
    print(label);
  }
}

// Gokuraku\u30b7\u30ea\u30fc\u30ba\u5171\u901a\u306e\u95a2\u6570\u30e9\u30a4\u30d6\u30e9\u30ea\u30fc\u306e\u6d41\u7528

//// \u5b9a\u6570
final String JapaneseFont     = "Meiryo";

// \u30b7\u30b9\u30c6\u30e0\u4f9d\u5b58\u306e\u30d1\u30b9\u533a\u5207\u308a\u5b50 (UNIX: /, Windwos: \\)
File _fp = new File("");
final String Separator = _fp.separator; 

//// \u5909\u63db\u95a2\u4fc2
// \u6d6e\u52d5\u5c0f\u6570\u70b9\u3092\u5c0f\u6570\u70b9\u4ee5\u4e0bn\u6841\u3067\u5207\u308a\u6368\u3066\u308b\u95a2\u6570
public float floorN(float f, int n) {
  return PApplet.parseFloat(floor(f * pow(10, n))) / pow(10, n);
}

//// \u30d5\u30a1\u30a4\u30eb\u95a2\u4fc2\u306e\u30af\u30e9\u30b9
// CSV\uff08\u30ab\u30f3\u30de\u533a\u5207\u308a\u306e\u6d6e\u52d5\u5c0f\u6570\u70b9\u6570\uff09\u306e\u30c6\u30ad\u30b9\u30c8\u3092\u5207\u308a\u5206\u3051\u308b\u30af\u30e9\u30b9
class CsvStrings {
  String text;
  String str;
  float  value;
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf\u30fc
  CsvStrings(String text) {
    this.set(text);
  }
  public void set(String str) {
    text = str + ",";
    value     =  PApplet.parseFloat("NaN");  // float\u306e\u5f62\u5f0f\u3067\u306f\u306a\u3044\u306e\u3067NaN\u306b\u306a\u308b
  }
  // \u6b21\u306e\u5024\u3092\u53d6\u5f97\u3059\u308b\uff1a\u6b63\u5e38\u306b\u7d42\u4e86\u3057\u305f\u3089true\u3092\u8fd4\u3057\uff0cvalue\u306b\u5024\u304c\u8a2d\u5b9a\u3055\u308c\u308b
  public boolean next() {
    if (text.indexOf(",") == -1) return false;
    if (text.length() == 0)      return false;
    if (text.equals(","))        return false;
    str   = text.substring(0, text.indexOf(","));
    value = PApplet.parseFloat(str);
    text  = text.substring(text.indexOf(",") + 1);
    return true;
  }
  public boolean is_float() {
    if (value != value) return false;  // NaN, \u3061\u3087\u3063\u3068\u30c8\u30ea\u30c3\u30ad\u30fc\u306a\u65b9\u6cd5
    return true;
  }
}
 //<>//
//// D&D\u95a2\u4fc2
// \u53c2\u8003URL\uff08\u30c9\u30e9\u30c3\u30b0\uff06\u30c9\u30ed\u30c3\u30d7\u306b\u95a2\u3057\u3066
// https://qiita.com/rain-lotus/items/258fa3defd41846bfd50
// https://sites.google.com/site/gutugutu30/other/processingdedoragguandodoroppu

  
  
  
  



DropTarget dropTarget;
Component  component;

public void drop_init() {  
  component = (Component)this.surface.getNative();
  dropTarget = new DropTarget(component, new DropTargetListener() {
    public void dragEnter(DropTargetDragEvent dtde) {
    }  
    public void dragOver(DropTargetDragEvent dtde) {
    }  
    public void dropActionChanged(DropTargetDragEvent dtde) {
    }  
    public void dragExit(DropTargetEvent dte) {
    }  
    public void drop(DropTargetDropEvent dtde) {  
      dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);  
      Transferable trans = dtde.getTransferable();  
      List<File> fileNameList = null;  
      if (trans.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {  
        try {  
          fileNameList = (List<File>)  
            trans.getTransferData(DataFlavor.javaFileListFlavor);
        } 
        catch (UnsupportedFlavorException ex) {
        } 
        catch (IOException ex) {
        }
      }  
      if (fileNameList == null) return;  
      fileSelected(fileNameList);
    }
  }
  );
}

//// \u30c9\u30e9\u30c3\u30b0\uff06\u30c9\u30ed\u30c3\u30d7\u95a2\u4fc2
// \u4e0a\u8a18URL\u53c2\u7167
// \u30c9\u30ed\u30c3\u30d7\u3055\u308c\u305f\u30d5\u30a1\u30a4\u30eb\u306e\u51e6\u7406
public void fileSelected(List<File> fs) {
  File [] fileList = {};
  File oneDirectory = null;  // \u7279\u4f8b\u306e\u305f\u3081\u306e\u5909\u6570
  for (File f:fs) {
    // \u30c9\u30e9\u30c3\u30b0\uff06\u30c9\u30ed\u30c3\u30d7\u3055\u308c\u305f\u30ea\u30b9\u30c8\u306e\u4e2d\u306b\u30d5\u30a9\u30eb\u30c0\u30fc\u304c\u542b\u307e\u308c\u3066\u3044\u305f\u5834\u5408\u306f\u7121\u8996\u3059\u308b
    if (f.isDirectory()) {
      oneDirectory = f;
      continue;
    }
    fileList = (File [])append(fileList, f);  // List\u304b\u3089Array\u3078\u5909\u66f4
  }
  if (fileList.length == 0) {
    // \u7279\u4f8b\u3068\u3057\u3066\uff0cD&D\u3067\u5358\u4e00\u306e\u30d5\u30a9\u30eb\u30c0\u30fc\u306e\u307f\u304cDrop\u3055\u308c\u305f\u6642\u306f\u30d5\u30a9\u30eb\u30c0\u30fc\u30e2\u30fc\u30c9\u3068\u3057\u3066\u52d5\u4f5c\u3059\u308b
    if (oneDirectory != null) {
//    im_file.folderSelected(oneDirectory);
      return;
    }
    return;  // \u30d5\u30a1\u30a4\u30eb\u304c\u4e00\u3064\u3082\u5b58\u5728\u3057\u306a\u304b\u3063\u305f\u5834\u5408
  }
//im_file.open_files(fileList);
}

// \u30af\u30ea\u30c3\u30d7\u30dc\u30fc\u30c9\u95a2\u4fc2
// \u5f15\u7528\u5143\uff1a https://romly.com/blog/processing_copy_to_clipboard/




public void CopyToClipboard(String s)
{
    Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
    StringSelection data = new StringSelection(s);
    clipboard.setContents(data, data);
}

public void Options() {
  crowbar.nonStop();
  crowbar.setFontSize(20);
  crow.autoScrollLines(1);
  crowbar.fontSize(14);
}

public void initCrowbar() {
  crow = startCrowbar.generate(Wx, Wy, 0);
}
crowbarClass crow;

public void Draw() {
  // \u4f55\u6545\u304bfileselected()\u304b\u3089\u547c\u3070\u308c\u305f\u95a2\u6570\u7fa4\u3067\u51fa\u529b\u3057\u305f\u6587\u5b57\u5217\u304c\u753b\u9762\u4e0a\u306b\u8868\u793a\u3055\u308c\u306a\u3044\u306e\u3067\uff0c\u51e6\u7406\u306e\u5927\u534a\u3092Draw()\u306b\u79fb\u52d5\u3057\u305f
  if (selected != null) {
    // \u8aad\u307f\u8fbc\u3093\u3060\u30c7\u30fc\u30bf\u306b\u30a8\u30e9\u30fc\u304c\u5b58\u5728\u3057\u306a\u3044\u306a\u3089\u3070\u30c7\u30fc\u30bf\u51e6\u7406\u3092\u884c\u3046
    if (im_data.readData(selected)) {
      data.decode(im_data.Af, im_data.Bf);
      if (ex_file.export_data(false)) {              // \u51fa\u529b\u6210\u529f\u6642
        if (Extract > 0) ex_file.export_data(true);  // \u66f4\u306b\u629c\u304d\u51fa\u3057\u30d5\u30a1\u30a4\u30eb\u306e\u51fa\u529b\u304c\u5fc5\u8981\u306a\u6642
      }
    }
    msg.set("\u7d42\u4e86\u3057\u307e\u3059\uff0e\u7d9a\u3051\u308b\u306a\u3089\u3070[R]\u30ad\u30fc\u3092\u62bc\u3057\u3066\u4e0b\u3055\u3044");
    writeln("");
    selected = null;
  }
  
  // \u51fa\u529b\u30d5\u30a1\u30a4\u30eb\u304c\u5225\u30a2\u30d7\u30ea\u30b1\u30fc\u30b7\u30e7\u30f3\u306b\u3088\u308a\u958b\u304b\u308c\u3066\u3044\u3066\uff0ccreateWriter()\u304c\u4f8b\u5916\u3092\u767a\u751f\u3057\u305f\u5834\u5408\u306e\u51e6\u7406
  if (ex_file.exporting &&  ex_file.output == null) {
    msg.setError("\u51fa\u529b\u30d5\u30a1\u30a4\u30eb(" + ex_file.dest_filename + ")\u304c\u5225\u306e\u30a2\u30d7\u30ea\u30b1\u30fc\u30b7\u30e7\u30f3\u306b\u3088\u308a\u958b\u304b\u308c\u3066\u3044\u307e\u3059");
    ex_file.exporting = false;
  }
  // \u540c\u4e00\u30d1\u30e9\u30e1\u30fc\u30bf\u30fc\u3067\u8907\u6570\u306e\u30d5\u30a1\u30a4\u30eb\u3092\u51e6\u7406\u3059\u308b\u305f\u3081\u306b\u7121\u9650\u30eb\u30fc\u30d7\u3092\u69cb\u6210
  if (! waitingProcess) {
    open_fileselector();  // \u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u3092\u8868\u793a
    waitingProcess = true;
  }
}

// \u30e6\u30fc\u30b6\u72ec\u81ea\u306ekeyPressed()
public void KeyPressed() {
  if (getKEY() == 'Q') crow.stop();
  if ((waitingProcess) && (getKEY() == 'R')) waitingProcess = false;
}
// \u30e6\u30fc\u30b6\u72ec\u81ea\u306emousePressed()
public void MousePressed() {
}
// \u30e6\u30fc\u30b6\u72ec\u81ea\u306emouseRelased()
public void MouseReleased() {
}
// \u30e6\u30fc\u30b6\u72ec\u81ea\u306emouseDragged()
public void MouseDragged() {
}
// \u30e6\u30fc\u30b6\u72ec\u81ea\u306emouseMoved()
public void MouseMoved() {
}
// \u30e6\u30fc\u30b6\u72ec\u81ea\u306emouseClicked()
public void MouseClicked() {
}
// \u30e6\u30fc\u30b6\u72ec\u81ea\u306ekeyRleased()
public void KeyReleased() {
}
// \u30e6\u30fc\u30b6\u72ec\u81ea\u306ekeyTyped()
public void KeyTyped() {
}

// \u3082\u3057Main()\u306e\u958b\u59cb\u524d\u306b\u5b9f\u884c\u3057\u3066\u304a\u304d\u305f\u3044\u30b3\u30fc\u30c9\u304c\u5225\u306b\u3042\u308b\u5834\u5408\u306f\u4ee5\u4e0b\u306b\u8a18\u8ff0\uff0e
// \u3053\u306e\u30eb\u30fc\u30c1\u30f3\u306e\u51fa\u529b\u306f\u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u8a18\u9332\u3055\u308c\u307e\u305b\u3093\uff0e
public void preMain() {
  display_notice();
  variableInitialize();
}

// \u3082\u3057Main()\u7d42\u4e86\u5f8c\u306b\u5b9f\u884c\u3057\u3066\u304a\u304d\u305f\u3044\u30b3\u30fc\u30c9\u304c\u5225\u306b\u3042\u308b\u5834\u5408\u306f\u4ee5\u4e0b\u306b\u8a18\u8ff0\uff0e
// \u3053\u306e\u30eb\u30fc\u30c1\u30f3\u306e\u51fa\u529b\u306f\u30ed\u30b0\u30d5\u30a1\u30a4\u30eb\u306b\u8a18\u9332\u3055\u308c\u307e\u305b\u3093\uff0e
public void postMain() {
}
// \u30c7\u30fc\u30bf\u51e6\u7406\u90e8\u3092\u72ec\u7acb\u5316 (Ver.2.1\u4ee5\u964d\uff09

class ProcessingData {
  String fullpathname;  // \u8aad\u307f\u8fbc\u3080CSV\u30d5\u30a1\u30a4\u30eb
  String filename;      // \u30d5\u30a1\u30a4\u30eb\u540d\u306e\u90e8\u5206\uff08\u62e1\u5f35\u5b50\u542b\u3080\uff09
  
  float   [] Af;        // A\u76f8\u306e\u96fb\u5727\uff08\u52ff\u8ad6\uff0c0/1\u3067\u3082\u69cb\u308f\u306a\u3044\uff09
  float   [] Bf;        // B\u76f8\u306e\u96fb\u5727\uff08\u52ff\u8ad6\uff0c0/1\u3067\u3082\u69cb\u308f\u306a\u3044\uff09
  boolean [] A;         // A\u76f8\u306e\u771f\u507d
  boolean [] B;         // B\u76f8\u306e\u771f\u507d
  int     [] enc;       // \u00b1\uff11
  float   [] acc;       // \u7d2f\u7a4d\u5024
  float   [] pps;       // \u89d2\u901f\u5ea6\uff08Pulse / sec)
  float   [] rpm;       // \u89d2\u901f\u5ea6\uff08rpm)
  float   [] radps;     // \u89d2\u901f\u5ea6\uff08rad/s\uff09
  int        max_num;   // \u30c7\u30fc\u30bf\u6570

  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf\u30fc
  ProcessingData() {
    max_num = 0;
  }
  // \u30e1\u30e2\u30ea\u30fc\u306b\u8aad\u307f\u8fbc\u3093\u3060\u96fb\u5727\u5024\u3092\u771f\u507d\u306b\u5909\u63db\u3057\u3066\u89e3\u8aad\uff08\u65b9\u5411\u5224\u5225\uff09
  public void convert2boolean()  {
    // \u771f\u507d\u5024\u306b\u5909\u63db
    A = new boolean[max_num];
    B = new boolean[max_num];
    A[0] = (Af[0] >= (SH_H + SH_L) / 2.0f) ? true : false;
    B[0] = (Bf[0] >= (SH_H + SH_L) / 2.0f) ? true : false;
    for (int i = 1; i < max_num; i++) {
      // A\u76f8\u306e\u5224\u5b9a
      if      ((A[i-1] == false) && (Af[i] > SH_H)) A[i] = true;
      else if ((A[i-1] == true)  && (Af[i] < SH_L)) A[i] = false;
      else                                          A[i] = A[i - 1];
      // B\u76f8\u306e\u5224\u5b9a
      if      ((B[i-1] == false) && (Bf[i] > SH_H)) B[i] = true;
      else if ((B[i-1] == true)  && (Bf[i] < SH_L)) B[i] = false;
      else                                          B[i] = B[i - 1];
    }
  }
  public boolean detectDirection() {
    // \u65b9\u5411\u5224\u5225
    int [] Ac = new int[max_num];  // A\u76f8\u306e\u5909\u5316\uff08\u2191:1, \u2193:-1\uff0c\u7121\u5909\u5316\uff1a0\uff0c[0]\u306f\u4f7f\u7528\u3057\u306a\u3044\uff09
    int [] Bc = new int[max_num];  // B\u76f8\u306e\u5909\u5316\uff08\u2191:1, \u2193:-1\uff0c\u7121\u5909\u5316\uff1a0\uff0c[0]\u306f\u4f7f\u7528\u3057\u306a\u3044\uff09
    // \u5909\u5316\u306e\u691c\u51fa
    for (int i = 1; i < max_num; i++) {
      if (A[i] != A[i - 1]) {
        if (A[i] == true) Ac[i] =  1; 
        else              Ac[i] = -1;
      } else              Ac[i] = 0;
      if (B[i] != B[i - 1]) {
        if (B[i] == true) Bc[i] =  1; 
        else              Bc[i] = -1;
      } else              Bc[i] = 0;
    }
    enc = new int[max_num];
    enc[0] = 0;
    for (int i = 1; i < max_num; i++) {
      // \u30c1\u30a7\u30c3\u30af
      if ((Ac[i] != 0) && (Bc[i] != 0)) {
        msg.setError("\u5224\u5b9a\u672c\u4f53\u3067\u7570\u5e38\u3092\u691c\u77e5\u3057\u307e\u3057\u305f\uff0e" + i + "\u884c\u76ee\u306e\u30c7\u30fc\u30bf\u3067A\u76f8\u3068B\u76f8\u304c\u540c\u6642\u306b\u5909\u5316\u3057\u3066\u3044\u307e\u3059");
        return false;
      }
      if (Ac[i] != 0) {                    // A\u76f8\u306b\u5909\u5316\u304c\u3042\u3063\u305f\u5834\u5408
        if (Ac[i] == 1) {                  // A\u76f8\u2191
          if (B[i] == false) enc[i] =  1;  // CW
          else               enc[i] = -1;  // CCW
        } else {                           // A\u76f8\u2193
          if (B[i] == false) enc[i] = -1;  // CCW
          else               enc[i] =  1;  // CW
        }
      } else if (Bc[i] != 0) {             // B\u76f8\u306b\u5909\u5316\u304c\u3042\u3063\u305f\u5834\u5408
        if (Bc[i] == 1) {                  // B\u76f8\u2191
          if (A[i] == false) enc[i] = -1;  // CCW
          else               enc[i] =  1;  // CW
        } else {                           // B\u76f8\u2193
          if (A[i] == false) enc[i] =  1;  // CW
          else               enc[i] = -1;  // CCW
        }
      } else enc[i] = 0;
    }
    return true;
  }
  // \u9006\u8ee2\u3059\u308b\u5834\u5408
  public void reverseDirection() {
    for (int i = 0; i < max_num; i++) if (enc[i] != 0) enc[i] = -enc[i];
  }
  // \u30ab\u30a6\u30f3\u30bf\u30fc\u306e\u7d2f\u7a4d
  public void accumlation() {
    acc = new float[max_num];
    acc[0] = 0;
    for (int i = 1; i < max_num; i++) acc[i] = acc[i - 1] + (float)enc[i];
  }
  // \u89d2\u901f\u5ea6\uff08pulse per sec.)
  // \u53c2\u8003\uff1a 2\u968e\u5fae\u5206\u30d5\u30a3\u30eb\u30bf\u30fc\u306b\u3088\u308b\u52a0\u901f\u5ea6\u306e\u7b97\u51fa\u6cd5\uff0chttps://tsukuba.repo.nii.ac.jp/record/6723/files/6.pdf
  //        \u4e2d\u5fc3\u5dee\u5206\u8fd1\u4f3c, https://koki0702.github.io/dezero-book/ja/step04.html
  //                      https://qiita.com/Negelon/items/fafec9b0d33ab96d1446
  // \u4e2d\u5fc3\u5dee\u5206\u8fd1\u4f3c\uff1acentral difference scheme ( CDS )
  public void calcurateAngularVelocity() {
    pps = new float[max_num];
    int i;
    // \u524d\u65b9\u30c7\u30fc\u30bf\u306f\u7121\u52b9
    for (i = 0; i < CDS; i++) pps[i] = 0.0f;
    // \u4e2d\u5fc3\u5dee\u5206\u8fd1\u4f3c\u51e6\u7406
    for (; i < max_num - CDS; i++) {
      pps[i] = (float)((double)(acc[i + CDS] - acc[i - CDS]) / (double)(2.0f * CDS * DeltaT/1000.0f));
    }
    // \u5f8c\u65b9\u30c7\u30fc\u30bf\u306f\u7121\u52b9
    for (; i < max_num; i++)  pps[i] = 0.0f;
  }
  // \u89d2\u901f\u5ea6 [rpm]
  public void convert2rpm() {
    rpm = new float[max_num];
    int i;
    // \u524d\u65b9\u30c7\u30fc\u30bf\u306f\u7121\u52b9
    for (i = 0; i < CDS; i++) rpm[i] = 0.0f;
    // \u4e2d\u5fc3\u5dee\u5206\u8fd1\u4f3c\u51e6\u7406
    for (; i < max_num - CDS; i++) {
      rpm[i] = (float)((double)pps[i] * (double)60.0f / ((double)EncCount * (double)4.0f));  // \u56db\u9013\u500d\u306a\u306e\u3067\u30ed\u30fc\u30bf\u30ea\u30fc\u30a8\u30f3\u30b3\u30fc\u30c0\u30fc\u306e\u5206\u89e3\u80fd\u306e\uff14\u500d\u306e\u5206\u89e3\u80fd
    }
    // \u5f8c\u65b9\u30c7\u30fc\u30bf\u306f\u7121\u52b9
    for (; i < max_num; i++)  rpm[i] = 0.0f;
  }
  // \u89d2\u901f\u5ea6 [rad/s]
  public void convert2radps() {
    radps = new float[max_num];
    int i;
    // \u524d\u65b9\u30c7\u30fc\u30bf\u306f\u7121\u52b9
    for (i = 0; i < CDS; i++) radps[i] = 0.0f;
    // \u4e2d\u5fc3\u5dee\u5206\u8fd1\u4f3c\u51e6\u7406
    for (; i < max_num - CDS; i++) {
      radps[i] = (float)((double)pps[i] / ((double)EncCount * (double)4.0f) * (double)TWO_PI);  // \u56db\u9013\u500d\u306a\u306e\u3067\u30ed\u30fc\u30bf\u30ea\u30fc\u30a8\u30f3\u30b3\u30fc\u30c0\u30fc\u306e\u5206\u89e3\u80fd\u306e\uff14\u500d\u306e\u5206\u89e3\u80fd
    }
    // \u5f8c\u65b9\u30c7\u30fc\u30bf\u306f\u7121\u52b9
    for (; i < max_num; i++)  radps[i] = 0.0f;
  }
  // \u65b9\u5411\u8ee2\u63db\u306e\u30c1\u30a7\u30c3\u30af
  // \u30fb\u4f55\u56de\u53cd\u8ee2\u3057\u305f\u304b
  // \u30fb\u9023\u7d9a\u3057\u3066\u56de\u8ee2\u65b9\u5411\u306e\u5909\u5316\u3057\u7121\u304b\u3063\u305f\u30b5\u30f3\u30d7\u30eb\u6570\uff08\u6700\u9577\uff0c\u6700\u77ed\uff09
  public void checkDirectionChange() {
    int direction;
    boolean ignore = true;     // \u30c7\u30fc\u30bf\u5192\u982d\u306e\u7121\u5909\u5316\u72b6\u614b\u3092\u7121\u8996\u3059\u308b
    int rev = 0;               // \u72b6\u614b\u5909\u5316\u306e\u56de\u6570
    int revmin = 0, revminLine = 0;  // \u9023\u7d9a\u3057\u3066\u56de\u8ee2\u65b9\u5411\u306e\u5909\u5316\u3057\u306a\u304b\u3063\u305f\u30b5\u30f3\u30d7\u30eb\u6570\uff08\u6700\u5c0f\uff09
    int revmax = 0, revmaxLine = 0;  // \u9023\u7d9a\u3057\u3066\u56de\u8ee2\u65b9\u5411\u306e\u5909\u5316\u3057\u306a\u304b\u3063\u305f\u30b5\u30f3\u30d7\u30eb\u6570\uff08\u6700\u5927\uff09
    int plsmin = 0, plsminLine = 0;  // \u9023\u7d9a\u3057\u3066A/B\u76f8\u5171\u306b\u30d1\u30eb\u30b9\u304c\u5909\u5316\u3057\u306a\u304b\u3063\u305f\u30b5\u30f3\u30d7\u30eb\u6570\uff08\u6700\u5c0f\uff09
    int plsmax = 0, plsmaxLine = 0;  // \u9023\u7d9a\u3057\u3066A/B\u76f8\u5171\u306b\u30d1\u30eb\u30b9\u304c\u5909\u5316\u3057\u306a\u304b\u3063\u305f\u30b5\u30f3\u30d7\u30eb\u6570\uff08\u6700\u5927\uff09

    direction = enc[0];  // \u521d\u671f\u72b6\u614b
    revmin = revmax = 0; revminLine = revmaxLine = 1;
    plsmin = plsmax = 0; plsminLine = plsmaxLine = 1;
    int  revcnt = 0, plscnt = 0;
    for (int i = 1; i < max_num; i++) {
      // \u30c7\u30fc\u30bf\u5192\u982d\u306e\u7121\u5909\u5316\u72b6\u614b\u3092\u7121\u8996\u3059\u308b
      if (ignore) {
        if ((A[i-1] != A[i]) || (B[i-1] != B[i])) {
          ignore = false;
          direction = enc[i];
          i++;
        }
        continue;
      }
      ++revcnt;
      ++plscnt;
      // \u53cd\u8ee2\u56de\u6570\u306e\u5909\u5316\u3092\u96c6\u8a08
      if (enc[i] != 0) {
        if (direction != enc[i]) {  // \u56de\u8ee2\u65b9\u5411\u306e\u5909\u5316\u3092\u691c\u51fa
          // \u53cd\u8ee2\u56de\u6570\u306e\u30ab\u30a6\u30f3\u30c8
          rev++;
          direction = enc[i];
          // \u7121\u5909\u5316\u671f\u9593\u306e\u96c6\u8a08
          if ((revmin == 0) || (revcnt < revmin)) { revmin = revcnt; revminLine = i; }
          if ((revmax == 0) || (revcnt > revmax)) { revmax = revcnt; revmaxLine = i; }
          revcnt = 0;
        }
      }
      // \u30d1\u30eb\u30b9\u7121\u5909\u5316\u306e\u96c6\u8a08
      if ((A[i-1] != A[i]) || (B[i-1] != B[i])) {  // \u30d1\u30eb\u30b9\u306e\u5909\u5316\u3092\u691c\u51fa
        // \u7121\u5909\u5316\u671f\u9593\u306e\u96c6\u8a08
        if ((plsmin == 0) || (plscnt < plsmin)) { plsmin = plscnt; plsminLine = i; }
        if ((plsmax == 0) || (plscnt > plsmax)) { plsmax = plscnt; plsmaxLine = i; }
        plscnt = 0;
      }
    }
    // \u7d50\u679c\u306e\u51fa\u529b
    if (rev == 0) msg.setWarnning("\u56de\u8ee2\u65b9\u5411\u306f\u4e00\u5b9a\u65b9\u5411\u3067\u3059");
    else          msg.setWarnning("\u56de\u8ee2\u65b9\u5411\u304c" + rev + "\u56de\u53cd\u8ee2\u3057\u307e\u3057\u305f");
    msg.setWarnning("\u56de\u8ee2\u65b9\u5411\u7121\u5909\u5316\u306e\u30b5\u30f3\u30d7\u30eb\u6570\u306e\u6700\u5927\uff0c\u6700\u5c0f\u306f\uff0c\u305d\u308c\u305e\u308c" + revmax + "\u56de(" + revmaxLine + "\u884c\u76ee\u8fba\u308a)\u3068" + revmin + "\u56de(" + revminLine + "\u884c\u76ee\u8fba\u308a)\u3067\u3059");
    msg.setWarnning("A/B\u76f8\u30d1\u30eb\u30b9\u7121\u5909\u5316\u306e\u30b5\u30f3\u30d7\u30eb\u6570\u306e\u6700\u5927\uff0c\u6700\u5c0f\u306f\uff0c\u305d\u308c\u305e\u308c" + plsmax + "\u56de(" + plsmaxLine + "\u884c\u76ee\u8fba\u308a)\u3068" + plsmin + "\u56de(" + plsminLine + "\u884c\u76ee\u8fba\u308a)\u3067\u3059");
  }
  // \u79fb\u52d5\u5e73\u5747
  // (a) \u30d1\u30eb\u30b9\u7d2f\u7a4d\u306e\u79fb\u52d5\u5e73\u5747\uff08int)
  public void movingAverageAcc() {
    // \u30a8\u30e9\u30fc\u30c1\u30a7\u30c3\u30af
    if (MApulse < 0) {
      msg.setError("\u79fb\u52d5\u5e73\u5747\uff08\u30d1\u30eb\u30b9\u7d2f\u7a4d\uff09\u306e\u9805\u6570\u304c\u8ca0\u306a\u306e\u3067\u79fb\u52d5\u5e73\u5747\u306f\u884c\u3044\u307e\u305b\u3093");
      return;
    }
    if (MApulse * 2 + 1 >=  max_num) {
      msg.setError("\u79fb\u52d5\u5e73\u5747\uff08\u30d1\u30eb\u30b9\u7d2f\u7a4d\uff09\u306e\u9805\u6570\u304c\u30c7\u30fc\u30bf\u6570\u306b\u5bfe\u3057\u3066\u5927\u304d\u904e\u304e\u308b\u306e\u3067\u79fb\u52d5\u5e73\u5747\u306f\u884c\u3044\u307e\u305b\u3093");
      return;
    }
    // \u30c7\u30fc\u30bf\u8907\u88fd
    float [] acc0 = new float[max_num];
    for (int i = 0; i < max_num; i++) acc0[i] = acc[i];
    // \u672c\u4f53
    for (int i = MApulse; i < max_num - MApulse - 1;i++) {
      double sum = 0.0f;
      for (int j = -MApulse; j <= MApulse; j++) sum += (double)acc0[i + j];
      acc[i] = (float)(sum / (double)(MApulse * 2 + 1));
    }
    msg.set("\u30d1\u30eb\u30b9\u7d2f\u7a4d\u3092" + MApulse + "\u9805\u3067\u79fb\u52d5\u5e73\u5747\u3057\u307e\u3057\u305f");
  }
  // (b) \u89d2\u901f\u5ea6(pps)\u306e\u79fb\u52d5\u5e73\u5747\uff08float)
  public void movingAverageAV() {
    // \u30a8\u30e9\u30fc\u30c1\u30a7\u30c3\u30af
    if (MAav < 0) {
      msg.setError("\u79fb\u52d5\u5e73\u5747\uff08\u89d2\u901f\u5ea6\uff09\u306e\u9805\u6570\u304c\u8ca0\u306a\u306e\u3067\u79fb\u52d5\u5e73\u5747\u306f\u884c\u3044\u307e\u305b\u3093");
      return;
    }
    if (MAav * 2 + 1 >=  max_num) {
      msg.setError("\u79fb\u52d5\u5e73\u5747\uff08\u89d2\u901f\u5ea6\uff09\u306e\u9805\u6570\u304c\u30c7\u30fc\u30bf\u6570\u306b\u5bfe\u3057\u3066\u5927\u304d\u904e\u304e\u308b\u306e\u3067\u79fb\u52d5\u5e73\u5747\u306f\u884c\u3044\u307e\u305b\u3093");
      return;
    }
    // \u30c7\u30fc\u30bf\u8907\u88fd
    float [] pps0 = new float[max_num];
    for (int i = 0; i < max_num; i++) pps0[i] = pps[i];
    // \u672c\u4f53
    for (int i = MAav + CDS; i < max_num - MAav - CDS - 1;i++) {  // CDS\u306e\u5206\u3060\u3051\u524d\u5f8c\u306f0\u306e\u30c7\u30fc\u30bf\u304c\u5165\u3063\u3066\u3044\u308b\u305f\u3081\uff08\u53b3\u5bc6\u306b\u306f\u305d\u306e\u5206\u306f\u305d\u306e\u533a\u9593\u3067\u5e73\u5747\u3092\u53d6\u308b\u3079\u304d\uff09
      double sum = 0.0f;
      for (int j = -MAav; j <= MAav; j++) sum += (double)pps0[i + j];
      pps[i] = (float)(sum / (double)(MAav * 2 + 1));
    }
    msg.set("\u89d2\u901f\u5ea6(pps)\u3092" + MAav + "\u9805\u3067\u79fb\u52d5\u5e73\u5747\u3057\u307e\u3057\u305f");
  }
  // \u6700\u5c0f\u5024\u3092\u6c42\u3081\u308b
  public float minimum(float [] data) {
    float ret = data[CDS];
    for (int i = CDS + 1; i < max_num - CDS; i++) if (ret > data[i]) ret = data[i]; 
    return ret;
  }
  // \u6700\u5927\u5024\u3092\u6c42\u3081\u308b
  public float maximum(float [] data) {
    float ret = data[CDS];
    for (int i = CDS + 1; i < max_num - CDS; i++) if (ret < data[i]) ret = data[i]; 
    return ret;
  }
  // \u5e73\u5747\u5024\u3092\u6c42\u3081\u308b
  public float mean(float [] data) {
    double ret = 0.0f;
    int    n = 0;
    for (int i = CDS; i < max_num - CDS; i++, n++) ret += (double)data[i];
    ret /= (double)n;
    return (float)ret;
  }
  // \u6a19\u6e96\u504f\u5dee\u3092\u6c42\u3081\u308b
  public float sd(float [] data, float xbar) {
    double ret = 0.0f;
    int    n = 0;
    for (int i = CDS; i < max_num - CDS; i++, n++) ret += (double)pow(data[i] - xbar, 2);
    ret /= (double)n;
    ret = sqrt((float)ret);
    return (float)ret;
  }
  // \u89d2\u901f\u5ea6\u306e\u5143\u306b\u306a\u308bPulse per sec\u3092\u6c42\u3081\u308bCDS\u304c\u9069\u5207\u304b\u3069\u3046\u304b\u3092\u78ba\u8a8d\u3059\u308b\u3068\u5171\u306b\u3001\u6307\u5b9a\u3055\u308c\u305fCDS\u3067\u8a08\u7b97\u3092\u884c\u3046
  public void comparePPSbyCDS() {
    int CDS0;    // \u30aa\u30ea\u30b8\u30ca\u30eb\u306eCDS\u306e\u5024\u3092\u4e00\u6642\u4fdd\u5b58
    float  max1,  max2,  max10,  max0;
    float  min1,  min2,  min10,  min0;
    float  sd1,   sd2,   sd10,   sd0;
    float  mean1, mean2, mean10, mean0;
    String str;

    CDS0 = CDS;
    // CDS = 1\u306e\u5834\u5408
    CDS = 1;
    calcurateAngularVelocity();
    max1  = maximum(pps);
    min1  = minimum(pps);
    mean1 = mean(pps);
    sd1   = sd(pps, mean1);
    str   = "(\u53c2\u8003)CDS=" + nf(CDS) + "\u306e\u6642\u306ePPS\uff08\u6700\u5927/\u6700\u5c0f/\u5e73\u5747/\u6a19\u6e96\u504f\u5dee\uff09\uff1a" + nf(max1) + "/" + nf(min1) + "/" + nf(mean1) + "/" + nf(sd1);
    msg.setWarnning(str);
    // CDS = CDS0 * 2\u306e\u5834\u5408
    CDS = CDS0 * 2;
    if (CDS * 2 < max_num) {
      calcurateAngularVelocity();
      max2  = maximum(pps);
      min2  = minimum(pps);
      mean2 = mean(pps);
      sd2  = sd(pps, mean2);
      str   = "(\u53c2\u8003)CDS=" + nf(CDS) + "\u306e\u6642\u306ePPS\uff08\u6700\u5927/\u6700\u5c0f/\u5e73\u5747/\u6a19\u6e96\u504f\u5dee\uff09\uff1a" + nf(max2) + "/" + nf(min2) + "/" + nf(mean2) + "/" + nf(sd2);
      msg.setWarnning(str);
    }
    // CDS = CDS0 * 10\u306e\u5834\u5408
    CDS = CDS0 * 10;
    if (CDS * 2 < max_num) {
      calcurateAngularVelocity();
      max10  = maximum(pps);
      min10  = minimum(pps);
      mean10 = mean(pps);
      sd10   = sd(pps, mean10);
      str   = "(\u53c2\u8003)CDS=" + nf(CDS) + "\u306e\u6642\u306ePPS\uff08\u6700\u5927/\u6700\u5c0f/\u5e73\u5747/\u6a19\u6e96\u504f\u5dee\uff09\uff1a" + nf(max10) + "/" + nf(min10) + "/" + nf(mean10) + "/" + nf(sd10);
      msg.setWarnning(str);
    }
    // CDS = CDS0\u306e\u5834\u5408
    CDS = CDS0;
    calcurateAngularVelocity();
    max0  = maximum(pps);
    min0  = minimum(pps);
    mean0 = mean(pps);
    sd0  = sd(pps, mean0);
    str   = "CDS=" + nf(CDS) + "\u306e\u6642\u306ePPS\uff08\u6700\u5927/\u6700\u5c0f/\u5e73\u5747/\u6a19\u6e96\u504f\u5dee\uff09\uff1a" + nf(max0) + "/" + nf(min0) + "/" + nf(mean0) + "/" + nf(sd0);
    msg.setWarnning(str);
  }
  // \u89e3\u6790\u672c\u4f53
  public boolean decode(float [] Afloat, float [] Bfloat) {  
    // \u8aad\u307f\u8fbc\u3093\u3060\u30c7\u30fc\u30bf\u306e\u6b63\u5f53\u6027\u306e\u518d\u30c1\u30a7\u30c3\u30af
    Af = Afloat;
    Bf = Bfloat;
    if (Af.length != Bf.length) {
      msg.setError("A\u76f8\u306e\u30c7\u30fc\u30bf\u6570\u3068B\u76f8\u306e\u30c7\u30fc\u30bf\u6570\u304c\u7570\u306a\u308a\u307e\u3059\uff08\u6df1\u523b\u306a\u30a8\u30e9\u30fc\uff09");
      return false;
    }
    if (Af.length == 0) {
      msg.setError("\u8aad\u307f\u8fbc\u3093\u3060\u30c7\u30fc\u30bf\u6570\u304c\u30bc\u30ed\u3067\u3059");
      return false;
    }
    if (Af.length <= CDS * 2) {
      msg.setWarnning("\u8aad\u307f\u8fbc\u3093\u3060\u30c7\u30fc\u30bf\u6570(" + max_num + ")\u304cCDS(" + CDS + "*2\u3088\u308a\u3082\u5c11\u306a\u3044\u306e\u3067\u89d2\u901f\u5ea6\u3092\u8a08\u7b97\u3067\u304d\u307e\u305b\u3093");
      // \u8b66\u544a\u3067\u3042\u3063\u3066\u52d5\u4f5c\u306f\u7d42\u4e86\u3057\u306a\u3044
    }
    max_num = Af.length;

    // \u771f\u507d\u5024\u306b\u5909\u63db
    convert2boolean();
    // \u65b9\u5411\u5224\u5225
    if (!detectDirection()) return false;
    // \u9006\u8ee2\u3059\u308b\u5834\u5408
    if (REVERSE) reverseDirection();
    // \u30ab\u30a6\u30f3\u30bf\u30fc\u306e\u7d2f\u7a4d
    accumlation();
    // \u7d2f\u7a4d\u306e\u79fb\u52d5\u5e73\u5747
    if (MApulse > 0) movingAverageAcc();
    // \u89d2\u901f\u5ea6 [pulse per sec.]
    // calcurateAngularVelocity();
    comparePPSbyCDS();
    // \u89d2\u901f\u5ea6\u306e\u79fb\u52d5\u5e73\u5747
    if (MAav > 0) movingAverageAV();
    // \u89d2\u901f\u5ea6 [rpm]
    convert2rpm();
    // \u89d2\u901f\u5ea6 [rad/s]
    convert2radps();
    // \u65b9\u5411\u8ee2\u63db\u306e\u30c1\u30a7\u30c3\u30af
    checkDirectionChange();
    
    return true;
  }
}

ProcessingData data = new ProcessingData(); 
// ---------------------------------------------------------
// Crowbar\u7d44\u8fbc\u9ad8\u6a5f\u80fd\u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30e9\u30a4\u30d6\u30e9\u30eaTomahawk
// by T.Shirai
// \u958b\u767a\u958b\u59cb 2012/06/07  -> Crowbar Ver.3.00.00 (2012/06/21)
// \u03b1\u7248     2012/06/21  ->         Ver.3.01.00 (2012/07/02)
// \u03b1\u7248     2012/07/02  ->         Ver.3.02.00 (2012/07/05)
// \u03b1\u7248     2012/07/05  ->         Ver.3.03.00 (2012/07/11)
// \u03b1\u7248     2012/07/11  ->         Ver.3.04.00 (2012/07/16)
// \u03b2\u7248     2012/07/16  ->         Ver.3.05.00 (2012/08/02)
// \u03b2\u7248     2012/08/02  ->         Ver.4.00.00 (2012/10/10)
// \u03b2\u7248     2012/10/10  ->
// ---------------------------------------------------------
// tomahawkMode : 0, 1, 2 \u306fTomahawk\u306e\u30e2\u30fc\u30c9\u3092\u5207\u308a\u66ff\u3048\u308b\u975e\u5e38\u306b\u91cd\u8981\u306a\u30d1\u30e9\u30e1\u30fc\u30bf\u3067\uff0c\u5b9f\u884c\u4e2d\u306b\u5909\u66f4\u3059\u308b\u3082\u306e\u3067\u306f\u306a\u3044\uff0e
// 0 : \u3053\u306eCrowbar\u306b\u306fTomahawk\u304c\u5b58\u5728\u3057\u306a\u3044\u5834\u5408\uff08tomahawkClass.pde\u3092\u524a\u9664\u3057\uff0ccrowbarClass.pde\u5192\u982d\u306e\u30b3\u30e1\u30f3\u30c8\u3092\u5916\u3059\uff09
//     Tomahawk\u306f\u975e\u5e38\u306b\u8ca0\u8377\u304c\u5927\u304d\u3044\u306e\u3067\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u5229\u7528\u3059\u308b\u5fc5\u8981\u304c\u306a\u3044\u5834\u5408\u306f\u3053\u306e\u30e2\u30fc\u30c9\u306e\u4f7f\u7528\u3092\u52e7\u3081\u307e\u3059\uff0e
// 1 : Tomahawk\u3092\u5229\u7528\u3059\u308b\u304cCrowbar\u306e\u30c6\u30ad\u30b9\u30c8\u8868\u793a\u3092\u80cc\u666f\u306b\u63cf\u753b\u3059\u308b\uff0e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306f\u305d\u306e\u4e0a\u306e\u30ec\u30a4\u30e4\u30fc\u3068\u3057\u3066\u4e0a\u66f8\u304d\u3055\u308c\u308b\uff0e
//     \u5b9f\u884c\u30a6\u30a3\u30f3\u30c9\u30a6\u306e\u4e00\u90e8\u3092\u753b\u50cf\u63cf\u753b\u7528\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3068\u3057\u3066\u6d3b\u7528\u3059\u308b\u5834\u5408\u306a\u3069\u306b\u9069\u3057\u3066\u3044\u308b\uff0e
//     \u30c6\u30ad\u30b9\u30c8\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u3092\u30d6\u30ec\u30f3\u30c9\u3057\u306a\u3044\u305f\u3081\u6bd4\u8f03\u7684\u8ca0\u8377\u304c\u5c11\u306a\u3044\uff0e
// 2 : Tomahawk\u3092\u5229\u7528\u3059\u308b\uff0e\u3055\u3089\u306bCrowbar\u306e\u30c6\u30ad\u30b9\u30c8\u51fa\u529b\u3092\u5c02\u7528\u306e\u30ec\u30a4\u30e4\u30fc\u306b\u63cf\u753b\u3059\u308b\uff0e
//     \u30ec\u30a4\u30e4\u30fc\u306f\u80cc\u666f\uff0c\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\uff0c\u30c6\u30ad\u30b9\u30c8\u8868\u793a\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u306e\u9806\u3067\u30d6\u30ec\u30f3\u30c9\u3055\u308c\u308b\u305f\u3081\u30c6\u30ad\u30b9\u30c8\u8868\u793a\u304c\u96a0\u308c\u308b\u3053\u3068\u304c\u7121\u3044\uff0e
//     \u30aa\u30fc\u30d0\u30fc\u30d8\u30c3\u30c9\u304c\u6700\u3082\u91cd\u3044\u30e2\u30fc\u30c9\uff0e
// \uff08\u30c6\u30ad\u30b9\u30c8\u5c02\u7528\u30ec\u30a4\u30e4\u30fc\u4f7f\u7528\u6642\uff1a2\u306e\u5236\u7d04\uff09\uff1aProcessing\u306e\u4ed5\u69d8\u306b\u57fa\u3065\u304f
//   \u307e\u305a\uff0c\u30d5\u30a9\u30f3\u30c8\u306e\u898b\u6804\u3048\u304c\u60aa\u3044\uff0e\u30c6\u30ad\u30b9\u30c8\u306e\u8272\u3082\u4f55\u6545\u304b\u6307\u5b9a\u3057\u305f\u5024\u3088\u308a\u3082\u5c11\u3057\u6697\u304f\u306a\u308b\uff0e
//   \u30ec\u30a4\u30e4\u30fc\u3092\u91cd\u306d\u308b\u306e\u306bblend()\u3092\u4f7f\u7528\u3057\u3066\u3044\u308b\uff0e\u30c6\u30af\u30cb\u30c3\u30af\u3068\u3057\u3066\u306f\u4e0d\u900f\u660e\u5ea6\uff10\uff08\u3064\u307e\u308a\u900f\u660e\uff09\u304b\u3064\u9ed2\u3044\u80cc\u666f\u306b\u4e0d\u900f\u660e\u5ea6255\u3067
//   \u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30b9\u63cf\u753b\u3092\u884c\u306a\u3044\uff0cblend(BLEND)\u3059\u308b\u3068\u4e0d\u900f\u660e\u5ea6255\u306ePixel\u306e\u307f\u304c\u5408\u6210\u3055\u308c\u308b\u3068\u3044\u3046\u624b\u6cd5\u3092\u53d6\u3063\u3066\u3044\u307e\u3059\uff0e
//   \u3068\u3053\u308d\u304ctext()\u306fbackground(#000000, 0)\u306e\u80cc\u666f\u8272#000000\u3092\u5229\u7528\u3057\u3066\u304f\u308c\u308b\u306e\u3067\u3059\u304c\uff0c\u4e0d\u900f\u660e\u5ea6255\u3067\u63cf\u753b\u3057\u3066\u3057\u307e\u3044\u307e\u3059\uff0e
//   \u305d\u3053\u3067\u6587\u5b57\u3092text()\u3067\u63cf\u753b\u3059\u308b\u5ea6\u306b\u305d\u306e\u30a8\u30ea\u30a2\u3092pixel\u5358\u4f4d\u3067\u30c1\u30a7\u30c3\u30af\u3057\u3066\u80cc\u666f\u8272#000000\u306e\u5834\u5408\u306f\u5f37\u5236\u7684\u306bcolor(#00000, 0)
//   \u306b\u5909\u66f4\u3057\u307e\u3059\uff0e\u3057\u305f\u304c\u3063\u3066\u6587\u5b57\u8272\u3068\u3057\u3066#000000\u3092\u6307\u5b9a\u3059\u308b\u3068\u533a\u5225\u304c\u4ed8\u304d\u307e\u305b\u3093\u306e\u3067\u5185\u90e8\u3067\u52dd\u624b\u306b#000002\u306b\u6587\u5b57\u8272\u3092\u5909\u66f4\u3057\u3066
//   \u3044\u307e\u3059\uff0e\u3053\u306e\u4e0d\u900f\u660e\u5ea6\u306e\u5909\u66f4\u306e\u51e6\u7406\u306b\u3082\u4f59\u8a08\u306a\u30aa\u30fc\u30d0\u30fc\u30d8\u30c3\u30c9\u304c\u751f\u3058\u3066\u3044\u307e\u3059\uff0e\u3042\u307e\u308a\u5927\u304d\u306a\u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba\u3092\u6307\u5b9a\u3059\u308b\u3068\uff0c
//   blend()\u306b\u3082\u6642\u9593\u304c\u639b\u304b\u308a\u307e\u3059\uff0e

// \u89d2\u5ea6\u3092\u6271\u3046\u30af\u30e9\u30b9\uff08\u30cd\u30a4\u30c6\u30a3\u30d6\u306f\u5ea6\u3067\uff0c\u30c7\u30d5\u30a9\u30eb\u30c8\u3082\u5ea6\uff09
class angleClass {
  private float degree;
  private float radian;
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  angleClass(float angle) {
    set(angle);
  }
  // \u8907\u88fd
  public void clone(angleClass src) {
    degree = src.degree;
    radian = src.radian;
  }
  // deg/rad\u3067\u8a2d\u5b9a
//void set(float angle) { setDegree(angle); }
  public void set(float a) {
    if (!crowbar.angleModeSwitch()) setRadian(a);
      else                          setDegree(a);
  }
  public angleClass set(float angle, boolean deg) {
    if (deg) setDegree(angle);
      else   setRadian(angle);
    return this;
  }
  public angleClass setDegree(float degV) {
    degree = degV;
    radian = radians(degV);
    return this;
  }
  public angleClass setRadian(float radV) {
    radian = radV;
    degree = degrees(radV);
    return this;
  }
  // deg/rad\u3067\u8fd4\u3059
//float get()            { return degree; }
  public float get() {
    if (!crowbar.angleModeSwitch()) return getRadian();
    return getDegree();
  }
  public float get(boolean deg) { return (deg ? degree : radian); }
  public float getDegree()      { return degree; }
  public float getRadian()      { return radian; }
  // \u00b1\u03c0\uff0c\u00b1180\u5ea6\u306b\u6b63\u898f\u5316\uff0c\u3058\u3083\u306a\u304f\u3066
  // -2\u03c0 \u2266\u03b8\uff1c\uff5e2\u03c0\uff0c-360\u2266\u03b8\uff1c360\u306b\u6b63\u898f\u5316
  public angleClass normalize() {
    radian = radians(degree);
    while (radian >=  TWO_PI) radian -= TWO_PI;
    while (radian <  -TWO_PI) radian += TWO_PI;
    while (degree >=  360.0f) degree -= 360.0f;
    while (degree <  -360.0f) degree += 360.0f;
    return this;
  }
  // \u8db3\u3057\u7b97
  public angleClass add(angleClass src) {
    degree += src.degree;
    return this.normalize();
  }
  public angleClass add(float deg) {
    degree += deg;
    return this.normalize();
  }
  // \u5f15\u304d\u7b97
  public angleClass sub(angleClass src) {
    degree -= src.degree;
    return this.normalize();
  }
  public angleClass sub(float deg) {
    degree -= deg;
    return this.normalize();
  }
  // \u30b9\u30ab\u30e9\u3092\u639b\u3051\u308b
  public angleClass mult(float a) {
    degree *= a;
    return this.normalize();
  }
  // \u30b9\u30ab\u30e9\u3067\u5272\u308b
  public angleClass divide(float a) {
    degree /= a;
    return this.normalize();
  }
}

// \u73fe\u5728\u306e\u7dda\u8272\u3084\u5ea7\u6a19\u306a\u3069\u306e\u60c5\u5831\u3092\u4fdd\u6301
class currentDrawingClass {
  // \u63cf\u753b\u95a2\u4fc2
  boolean  isFill;       // \u5857\u308a\u6f70\u3059\uff1f
  int      fillColor;    // \u5857\u308a\u6f70\u3057\u8272
  int      fillTrans;    // \u5857\u308a\u6f70\u3057\u306e\u4e0d\u900f\u660e\u5ea6
  boolean  isStroke;     // \u5916\u5f62\u7dda\u63cf\u304f\uff1f
  int      strokeColor;  // \u5916\u5f62\u7dda\u8272
  int      strokeTrans;  // \u5916\u5f62\u7dda\u306e\u4e0d\u900f\u660e\u5ea6
  float    strokeWeight; // \u7dda\u5e45
  int      rectMode;     // \u56db\u89d2\u5f62\u306e\u5ea7\u6a19\u6307\u5b9a\u306e\u30e2\u30fc\u30c9\uff08CORNER, CORNERS, CENTER, RADUIS\uff09
  int      ellipseMode;  // \u6955\u5186\u3068\u5186\u5f27\u306e\u5ea7\u6a19\u6307\u5b9a\u306e\u30e2\u30fc\u30c9\uff08CENTER, RADIUS, CORNER)
  int      textureMode;  // \u30c6\u30af\u30b9\u30c1\u30e3\u30de\u30c3\u30d4\u30f3\u30b0\u306e\u30e2\u30fc\u30c9\uff08vertex()\uff14\u5f15\u6570 (IMAGE, NORMALIZED)
  int      imageMode;    // image(), copy()\u306e\u5ea7\u6a19\u306e\u53d6\u308a\u65b9 (CENTER, CORNER)
  float    curveTightness; // \u66f2\u7dda\uff08curve\uff09\u306e\u5f62\u72b6\u3092\u4fee\u6b63\u3059\u308b\u30d1\u30e9\u30e1\u30fc\u30bf
  int      curveDetail;    // \u66f2\u7dda\u306e\u66f2\u7dda\u89e3\u50cf\u5ea6
  // \u6587\u5b57\u95a2\u4fc2
  int      textColor;    // \u30c6\u30ad\u30b9\u30c8\u6587\u5b57\u306e\u8272
  int      textSize;     // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba
  int      textAlignH;   // \u6c34\u5e73\u65b9\u5411\u5272\u308a\u5f53\u3066
  int      textAlignV;   // \u5782\u76f4\u65b9\u5411\u5272\u308a\u5f53\u3066
  int      textLeading;  // \u6539\u884c\u5e45
  // LP
  int      vpx, vpy;     // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5185\u306e\u6700\u5f8c\u306b\u63cf\u753b\u3057\u305f\u5ea7\u6a19
  float    wpx, wpy;     // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u306b\u304a\u3051\u308b\u6700\u5f8c\u306b\u63cf\u753b\u3057\u305f\u5ea7\u6a19
  currentDrawingClass() {
    setDefault();
  }
  // \u8907\u88fd
  public void clone(currentDrawingClass src) {
    // \u63cf\u753b\u95a2\u4fc2
    isFill         = src.isFill;
    fillColor      = src.fillColor;
    fillTrans      = src.fillTrans;
    isStroke       = src.isStroke;
    strokeColor    = src.strokeColor;
    strokeTrans    = src.strokeTrans;
    strokeWeight   = src.strokeWeight;
    rectMode       = src.rectMode;
    ellipseMode    = src.ellipseMode;
    textureMode    = src.textureMode;
    imageMode      = src.imageMode;
    curveTightness = src.curveTightness;
    curveDetail    = src.curveDetail;
    // \u6587\u5b57\u95a2\u4fc2
    textColor    = src.textColor;
    textSize     = src.textSize;
    textAlignH   = src.textAlignH;
    textAlignV   = src.textAlignV;
    textLeading  = src.textLeading;
    // LP\uff08\u30ab\u30ec\u30f3\u30c8\u30dd\u30a4\u30f3\u30c8\uff09
    vpx          = src.vpx;
    vpy          = src.vpy;
    wpx          = src.wpx;
    wpy          = src.wpy;
  }
  // \u521d\u671f\u5024\u306b\u8a2d\u5b9a
  public void setDefault() {
    // \u63cf\u753b\u95a2\u4fc2
    isFill         = true;
    fillColor      = 0xFFFFFFFF;
    fillTrans      = 255;
    isStroke       = true;
    strokeColor    = 0xFF000000;
    strokeTrans    = 255;
    strokeWeight   = 1;
    rectMode       = CORNER;
    ellipseMode    = CENTER;
    textureMode    = IMAGE;
    imageMode      = CORNER;
    curveTightness = 0.0f;
    curveDetail    = 20;
    // \u6587\u5b57\u95a2\u4fc2
    textColor    = _TEXTCOLOR;
    textSize     = _FONTSIZE;
    textAlignH   = LEFT;
    textAlignV   = TOP;
    textLeading  = PApplet.parseInt(textSize * 1.5f);
    // LP
    vpx = vpy    = 0;
    wpx = wpy    = 0.0f;
  }
}

class curveClass {
  float  x1a,  y1a,  x2a,  y2a,  x3a,  y3a,  x4a,  y4a;
  int   _x1a, _y1a, _x2a, _y2a, _x3a, _y3a, _x4a, _y4a;
  int   status, _status;
  curveClass () {
    status  = 0;
    _status = 0;
  }
  // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb
  public void start(float x, float y) { x1a = x; y1a = y; x2a = x; y2a = y; status = 1; }
  public void addSub(float x, float y, boolean relative) {
    if (relative) {
      switch (status) {
        case 0  : x += x1a; y += y1a; break;
        case 1  : x += x2a; y += y2a; break;
        case 2  : x += x3a; y += y3a; break;
        default : x += x4a; y += y4a; break;
      }
    }
    switch (status) {
      case 0 : crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u66f2\u7dda\u306e\u59cb\u70b9\u304c\u6307\u5b9a\u3055\u308c\u3066\u3044\u307e\u305b\u3093", null, false);
               x1a = x; y1a = y;x2a = x; y2a = y; status++; break;  // \u505c\u6b62\u3059\u3079\u304d\uff1f
      case 1 : x3a = x; y3a = y; status++; break;
      case 2 : x4a = x; y4a = y; status++; break;
      case 3 : status++;
      default :
        x1a = x2a; x2a = x3a; x3a = x4a; x4a = x;
        y1a = y2a; y2a = y3a; y3a = y4a; y4a = y;
    }
  }
  public void addRel(float dx, float dy) { addSub(dx, dy, true); }
  public void add(float x, float y)      { addSub( x,  y, false); }
  public void end() {
    if (status == 3) {
      x1a = x2a; x2a = x3a; x3a = x4a;
      y1a = y2a; y2a = y3a; y3a = y4a;
      x4a = x3a;
      y4a = y3a;
      status++;
    } else {
      x1a = x2a; x2a = x3a; x3a = x4a;
      y1a = y2a; y2a = y3a; y3a = y4a;
    }
    if (status <= 3) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u66f2\u7dda\u306b\u6307\u5b9a\u3055\u308c\u305f\u70b9\u6570\u304c\u8db3\u308a\u307e\u305b\u3093", null, false);
    status = 0;
  }
  // \u30d4\u30af\u30bb\u30eb\u5ea7\u6a19\u7cfb
  public void _start(int x, int y) { _x1a = x; _y1a = y; _x2a = x; _y2a = y; _status = 1; }
  public void _addSub(int x, int y, boolean relative) {
    if (relative) {
      switch (_status) {
        case 0  : x += _x1a; y += _y1a; break;
        case 1  : x += _x2a; y += _y2a; break;
        case 2  : x += _x3a; y += _y3a; break;
        default : x += _x4a; y += _y4a; break;
      }
    }
    switch (_status) {
      case 0 : crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u66f2\u7dda\u306e\u59cb\u70b9\u304c\u6307\u5b9a\u3055\u308c\u3066\u3044\u307e\u305b\u3093", null, false);
               _x1a = x; _y1a = y; _x2a = x; _y2a = y; _status++; break;  // \u505c\u6b62\u3059\u3079\u304d\uff1f
      case 1 : _x3a = x; _y3a = y; _status++; break;
      case 2 : _x4a = x; _y4a = y; _status++; break;
      case 3 : _status++;
      default :
        _x1a = _x2a; _x2a = _x3a; _x3a = _x4a; _x4a = x;
        _y1a = _y2a; _y2a = _y3a; _y3a = _y4a; _y4a = y;
    }
  }
  public void _addRel(int dx, int dy) { _addSub(dx, dy, true); }
  public void _add(int x, int y)      { _addSub( x,  y, false); }
  public void _end() {
    if (_status == 3) {
      _x1a = _x2a; _x2a = _x3a; _x3a = _x4a;
      _y1a = _y2a; _y2a = _y3a; _y3a = _y4a;
      _x4a = _x3a;
      _y4a = _y3a;
      _status++;
    } else {
      _x1a = _x2a; _x2a = _x3a; _x3a = _x4a;
      _y1a = _y2a; _y2a = _y3a; _y3a = _y4a;
    }
    if (_status <= 3) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u66f2\u7dda\u306b\u6307\u5b9a\u3055\u308c\u305f\u70b9\u6570\u304c\u8db3\u308a\u307e\u305b\u3093", null, false);
    _status = 0;
  }
}

// \u5404\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30af\u30e9\u30b9
class viewportClass {
  protected PGraphics pg;                              // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30b9\u306e\u30cf\u30f3\u30c9\u30eb
  protected float     wx_min, wx_max, wy_min, wy_max;  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19
  protected int       vx, vy;                          // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u5b9f\u884c\u30b9\u30af\u30ea\u30fc\u30f3\u306b\u5bfe\u3059\u308b\u5de6\u4e0a\u306e\u5ea7\u6a19
  protected int       width, height;                   // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u6a2a\u5e45\uff0f\u7e26\u5e45
  boolean             monoRatio;                       // \u30d4\u30af\u30bb\u30eb\u6bd4\u306f\u7e26\u3082\u6a2a\u3082\u540c\u4e00\u306b\u3059\u308b\u304b
  float               pixelRatioX, pixelRatioY;        // \u30d4\u30af\u30bb\u30eb\u6bd4\uff08\u7e26\u3068\u6a2a\uff09\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u2192\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5185\u306ePixel\u5ea7\u6a19\u5909\u63db\u7528
  protected int       bgColor;                         // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u80cc\u666f\u8272
  protected String    label;                           // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8aac\u660e
  currentDrawingClass cdSet;                           // \u6700\u65b0\u306e\u63cf\u753b\u95a2\u4fc2\u306e\u60c5\u5831
  protected int       serialNumber;                    // \u4f5c\u6210\u9806\u306e\u901a\u3057\u756a\u53f7\uff08viewStack[[]\u306e\u5f15\u6570\uff09
  // \u898b\u3048\u65b9\uff08\u898b\u305b\u65b9\uff09
  protected boolean   transparentView;                 // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u80cc\u666f\u304c\u900f\u660e\u306a\u30d3\u30e5\u30fc
  protected int       transparency;                    // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u900f\u660e\u5ea6\uff08\u67a0\u306f\u9664\u304f\uff09\uff1a 0\uff5e255\uff08\u30c7\u30d5\u30a9\u30eb\u30c8\u306f255\uff09
  boolean             drawFrame;                       // \u67a0\u306e\u8868\u793a\u3092\u884c\u306a\u3046\u304b\uff1f
  int                 frameColor;                      // \u67a0\u306e\u8272
  int                 frameWidth;                      // \u67a0\u306e\u5e45\uff08\u30d4\u30af\u30bb\u30eb\uff09
  protected int       layerLevel;                      // \u8868\u793a\u9806\uff08\u512a\u5148\u5ea6\uff09\uff1a\u6570\u5b57\u304c\u5927\u304d\u3044\u307b\u3069\u5f8c\uff08\u4e0a\uff09\u306b\u8868\u793a\u3055\u308c\u308b
  float               magnification;                   // \u753b\u9762\u306e\u62e1\u5927\u7387\uff08\u30d4\u30af\u30bb\u30eb\u6bd4\u306b\u3053\u306e\u5024\u3092\u639b\u3051\u308b\uff09
  float               offsetX, offsetY;                // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u306b\u304a\u3051\u308b\u30aa\u30d5\u30bb\u30c3\u30c8\u91cf
  angleClass          rotateAngle;                     // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8996\u70b9\u306e\u56de\u8ee2\u89d2\u5ea6\uff08[rad]\uff09
  float               pivotX, pivotY;                  // \u30d4\u30dc\u30c3\u30c8\u5ea7\u6a19\uff08\u62e1\u5927\u7e2e\u5c0f\uff0c\u56de\u8ee2\uff09
  protected boolean   visible;                         // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8868\u793a\u3092\u30c0\u30a4\u30ca\u30df\u30c3\u30af\u306bOn/Off\u3067\u304d\u308b
  // \u66f2\u7dda\u3092\u7c21\u4fbf\u306b\u63cf\u304f\u305f\u3081\u306e\u30af\u30e9\u30b9
  curveClass          cc;
  // \u30d4\u30af\u30bb\u30eb\u95a2\u4fc2
  int []              pixels;                          // loadPixels()\u3067\u30bb\u30c3\u30c8\u3055\u308c\u308b
  // \u30c6\u30ad\u30b9\u30c8\u95a2\u4fc2
  private PFont       font;
  // \u30b3\u30f3\u30b9\u30c8\u30e9\u30af\u30bf
  viewportClass(String name, int x, int y, int w, int h) {
    // \u30c7\u30d0\u30c3\u30b0\u60c5\u5831
    label     = name.toUpperCase();
    // \u5ea7\u6a19\u95a2\u4fc2\u306e\u521d\u671f\u5316
    vx          = x;
    vy          = y;
    this.width  = w;
    this.height = h;
    monoRatio   = true;
//  world(0.0, 0.0, this.width, this.height);  // \u521d\u671f\u5024\u3067\u8a2d\u5b9a
    worldOrigin(1.0f);   // \u521d\u671f\u5024\u3067\u8a2d\u5b9a
    // \u80cc\u666f\u8272\uff0c\u30d5\u30ec\u30fc\u30e0
    bgColor      = _BGCOLOR;
    transparentView = false;
    drawFrame    = true;
    transparency = 255;
    frameColor   = 0xFF000000;
    frameWidth   = 1;
    // \u6700\u65b0\u306e\u63cf\u753b\u95a2\u4fc2\u306e\u60c5\u5831
    cdSet      = new currentDrawingClass();
    // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u898b\u305b\u65b9
    viewPivotCenter();          // \u62e1\u5927\u7e2e\u5c0f\uff0c\u56de\u8ee2\u306e\u4e2d\u5fc3\u5ea7\u6a19\uff08\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u5fc3\u306b\u521d\u671f\u8a2d\u5b9a\uff09
    magnification     = 1.0f;    // \u62e1\u5927\u7e2e\u5c0f
    offsetX = offsetY = 0.0f;    // \u5e73\u884c\u79fb\u52d5\u91cf
    rotateAngle       = new angleClass(0.0f);   // \u56de\u8ee2\u89d2\u5ea6\uff08[rad]\uff09
    serialNumber      = -1;     // \u4f5c\u6210\u9806\u306e\u901a\u3057\u756a\u53f7
    layerLevel        = -1;     // \u30ec\u30a4\u30e4\u30fc\u306e\u9806\u756a

    // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u7528\u306e\u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30b9\u3092\u78ba\u4fdd
    pg = createGraphics(this.width, this.height, JAVA2D);    // P3D\u3067\u63cf\u753b\u3059\u308b\u3068\u5186\u306b\u5909\u306a\u7dda\u304c\u6ca2\u5c71\u5165\u308b\u306e\u3067\uff0e
    pg.beginDraw();
//  pg.smooth();  // \u4e00\u5fdc\uff0c\u5ff5\u306e\u305f\u3081\u306b
    pg.endDraw();
    visible   = true;
    // \u66f2\u7dda\u3092\u63cf\u304f\u30af\u30e9\u30b9
    cc = new curveClass();
  }
  // \u30d7\u30ed\u30d1\u30c6\u30a3\u306e\u8907\u88fd\uff08\u5c5e\u6027\u95a2\u4fc2\u306e\u307f\uff09\uff1a\u305d\u3063\u304f\u308a\u3055\u3093\uff0esplitViewH/V()\u3067\u4f5c\u6210\u3057\u305f\u969b\u306b\u7528\u3044\u308b
  public void cloneAttr(viewportClass src) {
    bgColor         = src.bgColor;
    transparentView = src.transparentView;
    drawFrame       = src.drawFrame;
    transparency    = src.transparency;
    frameColor      = src.frameColor;
    frameWidth      = src.frameWidth;
    cdSet.clone(src.cdSet);
    pivotX          = src.pivotX;
    pivotY          = src.pivotY;
    magnification   = src.magnification;
    offsetX         = src.offsetX;
    offsetY         = src.offsetY;
    rotateAngle.clone(src.rotateAngle);
    visible         = src.visible;
  }
  // \u30d7\u30ed\u30d1\u30c6\u30a3\u306e\u8907\u88fd\uff08\u5168\u90e8\uff09
  public void clone(viewportClass src) {
    vx              = src.vx;
    vy              = src.vy;
    this.width      = src.width;
    this.height     = src.height;
    monoRatio       = src.monoRatio;
    cloneAttr(src);
    // \u30e6\u30cb\u30fc\u30af\u306a\u60c5\u5831\uff08\u8907\u88fd\u6ce8\u610f\uff09
    label           = src.label;
    serialNumber    = src.serialNumber;
    layerLevel      = src.layerLevel;
  }
  // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u306e\u30b3\u30d4\u30fc\uff08cloneView()\u3067\u4f7f\u7528\uff09
  public void cloneWorld(viewportClass src) {
    wx_min      = src.wx_min;
    wx_max      = src.wx_max;
    wy_min      = src.wy_min;
    wy_max      = src.wy_max;
    monoRatio   = src.monoRatio;
    pixelRatioX = src.pixelRatioX;
    pixelRatioY = src.pixelRatioY;
  }

  // \u73fe\u5728\u306e\u8a2d\u5b9a\u5024\u3067\u30b0\u30e9\u30d5\u30a3\u30c3\u30af\u30b9\u3092\u521d\u671f\u5316\u3059\u308b
  public void restore() {
    pg.beginDraw();
    if (cdSet.isFill) pg.fill(cdSet.fillColor, cdSet.fillTrans);
      else            pg.noFill();
    if (cdSet.isStroke) pg.stroke(cdSet.strokeColor, cdSet.strokeTrans);
      else              pg.noStroke();
    pg.strokeWeight(cdSet.strokeWeight);
    pg.rectMode(cdSet.rectMode);
    pg.ellipseMode(cdSet.ellipseMode);
    pg.textureMode(cdSet.textureMode);
    pg.imageMode(cdSet.imageMode);
    pg.curveTightness(cdSet.curveTightness);
    pg.curveDetail(cdSet.curveDetail);
    pg.endDraw();
  }

  // \u30d4\u30af\u30bb\u30eb\u6bd4\u3092\u8a2d\u5b9a\u3059\u308b
  public void setPixelRatio(float x, float y) {
    setPixelRatioX(x);
    setPixelRatioY(y);
  }
  public void setPixelRatioX(float x) {
    if (x == 0.0f) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u6307\u5b9a\u3055\u308c\u305f\u30d4\u30af\u30bb\u30eb\u6bd4\u304c\u30bc\u30ed\u3067\u3059", str(x), true);
      return;
    }
    pixelRatioX = x;
  }
  public void setPixelRatioY(float y) {
    if (y == 0.0f) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u6307\u5b9a\u3055\u308c\u305f\u30d4\u30af\u30bb\u30eb\u6bd4\u304c\u30bc\u30ed\u3067\u3059", str(y), true);
      return;
    }
    pixelRatioY = y;
  }
  
  // \u30d4\u30af\u30bb\u30eb\u6bd4\u306e\u8a08\u7b97
  public void calcPixelRatio() {
    float px, py;
    px = this.width  / (wx_max - wx_min);
    py = this.height / (wy_max - wy_min);
    if (monoRatio) {
      // \u7e26\u3068\u6a2a\u306e\u30d4\u30af\u30bb\u30eb\u6bd4\u3092\u540c\u4e00\u306b
      if (px > py) setPixelRatio(py, py); // \u7e26\u512a\u5148
      else         setPixelRatio(px, px); // \u6a2a\u512a\u5148
    } else         setPixelRatio(px, py); // \u5225\u3005
  }
  // --------------------
  // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u306e\u8a2d\u5b9a
  // --------------------
  // \u3010\u53c2\u7167\u3011
  public float world_minX() { return wx_min; }
  public float world_maxX() { return wx_max; }
  public float world_minY() { return wy_min; }
  public float world_maxY() { return wy_max; }
  // \u3010\u5909\u66f4\u3011
  // (a) \u5168\u6307\u5b9a
  public viewportClass world(float minx, float miny, float maxx, float maxy) {
    if ((minx >= maxx) || (miny >= maxy)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u306e\u8a2d\u5b9a\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093\uff08\u6700\u5c0f\u5024\u3068\u6700\u5927\u5024\u304c\u9006\u3067\u3059\uff09", null, true);
      return this;
    }
    wx_min = minx;
    wy_min = miny;
    wx_max = maxx;
    wy_max = maxy;
    calcPixelRatio();
    return this;
  }
  public viewportClass worldX(float minx, float maxx) { return world(minx, wy_min, maxx, wy_max); }
  public viewportClass worldY(float miny, float maxy) { return world(wx_min, miny, wx_max, maxy); }
  // (b) \uff58\uff0c\uff59\u305d\u308c\u305e\u308c\u306e\u6700\u5c0f\u5024\uff0f\u6700\u5927\u5024\u3092\u500b\u5225\u306b\u5909\u66f4
  public float world_minX(float x) {
    float oldvalue = wx_min;
    world(x, wy_min, wx_max, wy_max);
    return oldvalue;
  }
  public float world_minY(float y) {
    float oldvalue = wy_min;
    world(wx_min, y, wx_max, wy_max);
    return oldvalue;
  }
  public float world_maxX(float x) {
    float oldvalue = wx_max;
    world(wx_min, wy_min, x, wy_max);
    return oldvalue;
  }
  public float world_maxY(float y) {
    float oldvalue = wy_max;
    world(wx_min, wy_min, wx_max, y);
    return oldvalue;
  }
  // (c) \u30d4\u30af\u30bb\u30eb\u6bd4\u306e\u307f\u3092\u6307\u5b9a
  // \u4ee5\u4e0b\u516b\u65b9\u4f4d\uff080:\u4e2d\u592e, 1:\u5de6\u4e0a, 2:\u5de6\u4e0b, 3:\u53f3\u4e0a, 4: \u53f3\u4e0b, 5:\u4e2d\u592e\u4e0a, 6:\u4e2d\u592e\u4e0b, 7:\u5de6\u4e2d\u592e, 8:\u53f3\u4e2d\u592e
  public viewportClass _world(int pos, float ratio) {
    float dwx, dwy, dwx2, dwy2;
    setPixelRatio(ratio, ratio);
    dwx = this.width  / ratio;
    dwy = this.height / ratio;
    dwx2 = dwx / 2.0f;
    dwy2 = dwy / 2.0f;
    switch (pos) {
      case 0 : world(-dwx2, -dwy2, dwx2, dwy2); break;
      case 1 : world( 0.0f,  -dwy,  dwx,  0.0f);  break;
      case 2 : world( 0.0f,   0.0f,  dwx,  dwy);  break;
      case 3 : world(-dwx,  -dwy,  0.0f,  0.0f);  break;
      case 4 : world(-dwx,   0.0f,  0.0f,  dwy);  break;
      case 5 : world(-dwx2, -dwy,  dwx2, 0.0f);  break;
      case 6 : world(-dwx2,  0.0f,  dwx2, dwy);  break;
      case 7 : world( 0.0f,  -dwy2, dwx,  dwy2); break;
      case 8 : world(-dwx,  -dwy2, 0.0f,  dwy2); break;
    }
    return this; 
  }
  // (c-1) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u592e\u3092\u539f\u70b9
  public viewportClass worldOrigin() { return worldOrigin(pixelRatioX); }
  public viewportClass worldOrigin(float ratio) { return _world(0, ratio); }
  // (c-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5de6\u4e0a\u3092\u539f\u70b9
  public viewportClass worldLT() { return worldLT(pixelRatioX); }
  public viewportClass worldLT(float ratio) { return _world(1, ratio); }
  // (c-3) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5de6\u4e0b\u3092\u539f\u70b9
  public viewportClass worldLB() { return worldLB(pixelRatioX); }
  public viewportClass worldLB(float ratio) { return _world(2, ratio); }
  // (c-4) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u53f3\u4e0a\u3092\u539f\u70b9
  public viewportClass worldRT() { return worldRT(pixelRatioX); }
  public viewportClass worldRT(float ratio) { return _world(3, ratio); }
  // (c-5) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u53f3\u4e0b\u3092\u539f\u70b9
  public viewportClass worldRB() { return worldRB(pixelRatioX); }
  public viewportClass worldRB(float ratio) { return _world(4, ratio); }
  // (c-6) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u592e\u4e0a\u3092\u539f\u70b9
  public viewportClass worldCT() { return worldCT(pixelRatioX); }
  public viewportClass worldCT(float ratio) { return _world(5, ratio); }
  // (c-7) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u592e\u4e0b\u3092\u539f\u70b9
  public viewportClass worldCB() { return worldCB(pixelRatioX); }
  public viewportClass worldCB(float ratio) { return _world(6, ratio); }
  // (c-8) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5de6\u4e2d\u592e\u3092\u539f\u70b9
  public viewportClass worldLC() { return worldLC(pixelRatioX); }
  public viewportClass worldLC(float ratio) { return _world(7, ratio); }
  // (c-9) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u53f3\u4e2d\u592e\u3092\u539f\u70b9
  public viewportClass worldRC() { return worldRC(pixelRatioX); }
  public viewportClass worldRC(float ratio) { return _world(8, ratio); }
  
  // (d) \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u306e\u4e2d\u5fc3\u5ea7\u6a19\u3068\u30d4\u30af\u30bb\u30eb\u6bd4\u3092\u6307\u5b9a
  // \u3064\u307e\u308a\u3053\u306e\u6307\u5b9a\u3057\u305f\u5ea7\u6a19\u304c\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e2d\u592e\u306b\u8868\u793a\u3055\u308c\u308b\u3088\u3046\u306b\u30de\u30c3\u30d4\u30f3\u30b0\u3055\u308c\u308b
  public viewportClass worldCenter(float x, float y) { return worldCenter(x, y, pixelRatioX); }
  public viewportClass worldCenter(float x, float y, float ratio) {
    setPixelRatio(ratio, ratio);
    worldOrigin();
    world(wx_min + x, wy_min + y, wx_max + x, wy_max + y);
    return this;
  }
  
  // (e) \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u3092\uff58\uff59\u8ef8\u65b9\u5411\u306b\u79fb\u52d5\u3059\u308b
  public viewportClass worldMove(float dx, float dy) { return world(wx_min + dx, wy_min + dy, wx_max + dx, wy_max + dy); }
  public viewportClass worldMoveX(float dx) { return worldMove(dx, 0.0f); }
  public viewportClass worldMoveY(float dy) { return worldMove(0.0f, dy); }

  // ---------------------------------------------------
  // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u304b\u3089\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306ePixel\u5ea7\u6a19\u7cfb\u3078\u306e\u5909\u63db
  // ---------------------------------------------------
  // a) \u5358\u306b\u30d4\u30af\u30bb\u30eb\u6bd4\u3092\u639b\u3051\u305f\u3082\u306e\uff08\u534a\u5f84\u3084\u9ad8\u3055\uff0f\u5e45\u7528\uff09
  public int _px(float x) { return PApplet.parseInt(x * magnification * pixelRatioX); }
  public int _py(float y) { return PApplet.parseInt(y * magnification * pixelRatioY); }
  // b) \u5ea7\u6a19\u5909\u63db\uff08\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u2192\u30d4\u30af\u30bb\u30eb\u5ea7\u6a19\uff09
  public int px(float x) {
    float center = (wx_max + wx_min) / 2.0f;
    return PApplet.parseInt((x - center) * pixelRatioX) + (this.width / 2);
  }
  public int py(float y) {
    float center = (wy_max + wy_min) / 2.0f;
    return this.height - (PApplet.parseInt((y - center) * pixelRatioY) + (this.height / 2));
  }
  // c) \u9006\u5ea7\u6a19\u5909\u63db\uff08\u30d4\u30af\u30bb\u30eb\u5ea7\u6a19\u2192\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\uff09
  public float _rpx(int x) { return x / magnification / pixelRatioX; }
  public float _rpy(int y) { return y / magnification / pixelRatioY; }

  public float rpx(int x) {
    float center = (wx_max + wx_min) / 2.0f;
//  return  ((x - offsetX) - (this.width / 2)) / pixelRatioX + center;
    return  (x - (this.width / 2)) / pixelRatioX + center;
  }
  public float rpy(int y) {
    float center = (wy_max + wy_min) / 2.0f;
//  return ((this.height - (y + offsetY)) - (this.height / 2)) / pixelRatioY + center;
    return ((this.height - y) - (this.height / 2)) / pixelRatioY + center;
  }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306b\u63cf\u753b\u3059\u308b\u6700\u7d42\u51e6\u7406\uff08\u62e1\u5927\u7e2e\u5c0f\u30fb\u4e26\u9032\u30fb\u56de\u8ee2\uff09
  public int [] baseConv(int [] p, float x, float y) {
/*
    // \u4ee5\u4e0b\u306e\u51e6\u7406\u306frotate(), translate(), scale()\u3092\u4f7f\u308f\u305a\u306b\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u62e1\u5927\u7e2e\u5c0f\u56de\u8ee2\u306b\u5bfe\u5fdc\u3057\u305f\u969b\u306e\u3082\u306e\uff0e
    // \u4e00\u65e6\u3001\u30d4\u30dc\u30c3\u30c8\u5ea7\u6a19\u3092\u539f\u70b9\u3068\u3057\u3001Y\u8ef8\u6b63\u304c\u4e0a\u65b9\u5411\u306e\u5ea7\u6a19\u7cfb\u306b\u5909\u63db\u3059\u308b
    float cx, cy;
    cx = pivotX;
    cy = pivotY;
    x -= cx;
    y -= cy;
    y  = -y;
    // \u62e1\u5927\u7e2e\u5c0f
    x *= magnification;
    y *= magnification;
    // \u56de\u8ee2
    float rx, ry;
    float angle = rotateAngle.getRadian();
    rx = x * cos(angle) - y * sin(angle);
    ry = x * sin(angle) + y * cos(angle);
    // \u5143\u306e\u5ea7\u6a19\u306b\u623b\u3059
    rx += cx;
    ry  = -ry;
    ry += cy;
    // \u30aa\u30d5\u30bb\u30c3\u30c8
    rx +=  offsetX;
    ry += -offsetY;
    p[0] = int(rx);
    p[1] = int(ry);
*/
    // \u5f8c\u65e5\uff0c\u3053\u306e\u95a2\u6570\u81ea\u4f53\u304c\u4f55\u304b\u4fbf\u5229\u306a\u5f79\u306b\u7acb\u3064\u304b\u3082\u77e5\u308c\u306a\u3044\u306e\u3067\u4e00\u5fdc\uff0c\u6b8b\u3057\u3066\u304a\u304f\u304c\u3044\u3064\u307e\u3067\u305f\u3063\u3066\u3082\u4f7f\u3044\u9053\u304c\u7121\u3044\u306a\u3089\u3070\u6d88\u3059\uff0e
    p[0] = PApplet.parseInt(x);
    p[1] = PApplet.parseInt(y);
    return p;
  }
 
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306b\u63cf\u753b\u3059\u308b\u6700\u7d42\u51e6\u7406\uff08\u62e1\u5927\u7e2e\u5c0f\u30fb\u4e26\u9032\u30fb\u56de\u8ee2\uff09\u306e\u53cd\u8ee2
  public int [] reverseBaseConv(int [] p, float x, float y) {
    // \u30aa\u30d5\u30bb\u30c3\u30c8\u3092\u5f15\u304f
    x -=  offsetX;
    y -= -offsetY;
    // \u4e00\u65e6\u3001\u30d4\u30dc\u30c3\u30c8\u5ea7\u6a19\u3092\u539f\u70b9\u3068\u3057\u3001Y\u8ef8\u6b63\u304c\u4e0a\u65b9\u5411\u306e\u5ea7\u6a19\u7cfb\u306b\u5909\u63db\u3059\u308b
    float cx, cy;
    cx = pivotX;
    cy = pivotY;
    x -= cx;
    y -= cy;
    y  = -y;
    // \u62e1\u5927\u7e2e\u5c0f\u3092\u5143\u306b\u623b\u3059
    x /= magnification;
    y /= magnification;
    // \u9006\u56de\u8ee2
    float rx, ry;
    float angle = rotateAngle.getRadian();
    rx = x * cos(-angle) - y * sin(-angle);
    ry = x * sin(-angle) + y * cos(-angle);
    // \u5143\u306e\u5ea7\u6a19\u306b\u623b\u3059
    ry  = -ry;
    rx += cx;
    ry += cy;
    p[0] = PApplet.parseInt(rx);
    p[1] = PApplet.parseInt(ry);
    return p;
  }

  // --------------------------------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8868\u793a\uff0f\u975e\u8868\u793a\u306e\u30c0\u30a4\u30ca\u30df\u30c3\u30af\u306a\u5207\u308a\u66ff\u3048
  // --------------------------------------------------
  // \u72b6\u614b
  public boolean isViewVisible()       { return visible; }
  // (a) \u8868\u793a
  public viewportClass viewVisible()   { visible = true; return this; }
  // (b) \u975e\u8868\u793a
  public viewportClass viewUnvisible() { visible = false; return this; }
  // (c) \u5f15\u6570\u306b\u3088\u308b\u6307\u5b9a
  public viewportClass viewVisible(boolean flag) { if (flag) viewVisible(); else viewUnvisible(); return this; }
  // (d) \u30c8\u30b0\u30eb\u52d5\u4f5c\uff08\u5909\u66f4\u5f8c\u306e\u72b6\u614b\u3092\u8fd4\u3059\uff09
  public boolean toggleViewVisible() {
    if (isViewVisible()) {
      viewUnvisible();
      return false;
    } else {
      viewVisible();
      return true;
    }
  }
/*
  viewportClass setViewVisible(boolean flag) {
    viewVisible(flag);
    return this;
  }
*/
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u79fb\u52d5
  public viewportClass moveView(int x, int y)      { vx  = x;  vy  = y;  return this; }
  public viewportClass moveViewRel(int dx, int dy) { vx += dx; vy += dy; return this; }

  // ----------------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u67a0\u7dda\u3084\u4e0d\u900f\u660e\u5ea6\u306e\u8a2d\u5b9a
  // ----------------------------------
  // \u30d5\u30ec\u30fc\u30e0\u30ab\u30e9\u30fc
  // (a-1) \u30d5\u30ec\u30fc\u30e0\u30ab\u30e9\u30fc\u3092\u53d6\u5f97\uff08\u73fe\u5728\u306e\u30d5\u30ec\u30fc\u30e0\u306e\u307f\uff09
  public int frameColor() { return frameColor; }
  // (a-2) \u30d5\u30ec\u30fc\u30e0\u30ab\u30e9\u30fc\u306e\u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public int setFrameColor(int c) {
    int oldcolor = frameColor();
    frameColor = c & 0xFFFFFFFF;
    return oldcolor;
  }
  public viewportClass frameColor(int c) {
    setFrameColor(c);
    return this;
  }
  // \u30d5\u30ec\u30fc\u30e0\u306e\u8868\u793a\uff0f\u975e\u8868\u793a
  // (b) \u30d5\u30ec\u30fc\u30e0\u306e\u8868\u793a\uff0f\u975e\u8868\u793a
  public boolean drawFrame() { return drawFrame; }
  public boolean setDrawFrame(boolean flag) {
    boolean oldstatus = drawFrame;
    drawFrame = flag;
    return oldstatus;
  }
  public viewportClass drawFrame(boolean flag) {
    setDrawFrame(flag);
    return this;
  }
  // \u30d5\u30ec\u30fc\u30e0\u5e45
  // (c-1) \u30d5\u30ec\u30fc\u30e0\u5e45\u3092\u53d6\u5f97
  public int frameWidth() { return frameWidth; }
  // (c-2) \u30d5\u30ec\u30fc\u30e0\u5e45\u306e\u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public int setFrameWidth(int w) {
    int oldwidth = frameWidth();
    frameWidth = w;
    return oldwidth;
  }
  public viewportClass frameWidth(int w) {
    setFrameWidth(w);
    return this;
  }

  // (a) \u4e0d\u900f\u660e\u5ea6\u306e\u53d6\u5f97
  public int transparency() { return transparency; }
  // (b) \u4e0d\u900f\u660e\u5ea6\u306e\u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public int setTransparency(int trans) {
    int oldtrans = transparency();
    if (trans < 0)   trans = 0;
    if (trans > 255) trans = 255;
    transparency = cdSet.fillTrans = cdSet.strokeTrans = trans;  // \u5857\u308a\u6f70\u3057\u3084\u7dda\u306e\u4e0d\u900f\u660e\u5ea6\u3082\u5909\u66f4\u3059\u308b
    return oldtrans;
  }
  public viewportClass transparency(int trans) {
    setTransparency(trans);
    return this;
  }

  // \u80cc\u666f\u8272\u306e\u8a2d\u5b9a
  // (a) \u8272\u3092\u53d6\u5f97\uff08\u4e0d\u900f\u660e\u5ea6\u306f\u7121\u8996\uff09
  public int viewBgColor() { return bgColor; }
  // (b) \u8272\u3092\u8a2d\u5b9a\uff08\u4e0d\u900f\u660e\u5ea6\u306f255\uff09
  public int setViewBgColor(int c) {
    int oldcolor = viewBgColor();
    bgColor = c & 0xFFFFFFFF;
    return oldcolor;
  }
  public viewportClass viewBgColor(int c) {
    setViewBgColor(c);
    return this;
  }

  // \u80cc\u666f\u3092\u900f\u660e\u306a\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306b\u3059\u308b\uff0f\u3057\u306a\u3044
  // (a) \u72b6\u614b\u3092\u8fd4\u3059
  public boolean transparentView() { return transparentView; }
  public boolean setTransparentView(boolean flag) {
    if (flag) drawFrame = false;  // \u900f\u660e\u306a\u30d3\u30e5\u30fc\u3092\u6307\u5b9a\u3055\u308c\u305f\u3089\u4e00\u7dd2\u306b\u67a0\u3082\u6d88\u3057\u3066\u3057\u307e\u3046\uff08\u304a\u7bc0\u4ecb\uff1f\uff09
    boolean oldstatus = transparentView();
    transparentView = flag;
    return oldstatus;
  }
  public viewportClass transparentView(boolean flag) {
    setTransparentView(flag);
    return this;
  }

  // ----------------------------------------------
  // \u30d4\u30dc\u30c3\u30c8\uff08\u62e1\u5927\u7e2e\u5c0f\u304a\u3088\u3073\u56de\u8ee2\u306e\u4e2d\u5fc3\u5ea7\u6a19\uff09\u306e\u8a2d\u5b9a
  // ----------------------------------------------
  // (a) \u73fe\u5728\u306e\u30d4\u30dc\u30c3\u30c8\u5ea7\u6a19\u3092\u8fd4\u3059
  public PVector viewPivot() {
    PVector vp = new PVector(pivotX, pivotY);
    return vp;
  }
  // (b) \u30d4\u30dc\u30c3\u30c8\u5ea7\u6a19\u306e\u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  // (b-1) \u81ea\u7531\u306b\u6307\u5b9a
  public PVector setViewPivot(float x, float y) {
    PVector vp = viewPivot();
    pivotX = x; 
    pivotY = y;
    return vp;
  }
  public viewportClass viewPivot(float x, float y) {
    pivotX = x;  pivotY = y;
    return this;
  }
  // (b-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u5fc3
  public PVector setViewPivotCenter() { return setViewPivot(this.width / 2, this.height / 2);  }
  public viewportClass viewPivotCenter() { setViewPivotCenter(); return this; }
  // (b-3) \u5de6\u4e0a\uff0c\u5de6\u4e0b\uff0c\u53f3\u4e0a\uff0c\u53f3\u4e0b
  public PVector setViewPivotLT()  { return setViewPivot(0.0f,              0.0f);               }
  public PVector setViewPivotLB()  { return setViewPivot(0.0f,              this.height - 1);   }
  public PVector setViewPivotRT()  { return setViewPivot(this.width - 1,   0.0f);               }
  public PVector setViewPivotRB()  { return setViewPivot(this.width - 1,   this.height - 1);   }
  public PVector setViewPivotCT()  { return setViewPivot(this.width / 2.0f, 0.0f);               }
  public PVector setViewPivotCB()  { return setViewPivot(this.width / 2.0f, this.height - 1);   }
  public PVector setViewPivotLC()  { return setViewPivot(0.0f,              this.height / 2.0f); }
  public PVector setViewPivotRC()  { return setViewPivot(this.width - 1,   this.height / 2.0f); }

  public viewportClass viewPivotLT()  { setViewPivotLT(); return this; }
  public viewportClass viewPivotLB()  { setViewPivotLB(); return this; }
  public viewportClass viewPivotRT()  { setViewPivotRT(); return this; }
  public viewportClass viewPivotRB()  { setViewPivotRB(); return this; }
  public viewportClass viewPivotCT()  { setViewPivotCT(); return this; }
  public viewportClass viewPivotCB()  { setViewPivotCB(); return this; }
  public viewportClass viewPivotLC()  { setViewPivotLC(); return this; }
  public viewportClass viewPivotRC()  { setViewPivotRC(); return this; }

  // --------
  // \u500d\u7387\u95a2\u4fc2
  // --------
  // (a) \u73fe\u5728\u306e\u500d\u7387\u3092\u8fd4\u3059
  public float viewScale() { return magnification; }
  // (b) \u500d\u7387\u306e\u5024\u3092\u5909\u66f4\u3059\u308b\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float setViewScale(float s) {
    float oldscale;
    if (s <= 0.0f) s = 1.0f;  // \u4e0d\u6b63\u306a\u5024
    oldscale = viewScale();
    magnification = s;
    return oldscale;
  }
  public viewportClass viewScale(float s) { setViewScale(s); return this; }
  // ----------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8996\u70b9\u306e\u56de\u8ee2\u89d2\u5ea6
  // ----------------------------
  // (a) \u73fe\u5728\u306e\u89d2\u5ea6\u3092\u8fd4\u3059
  public float viewRotate() { return rotateAngle.get(); }
  // (b) \u8996\u70b9\u306e\u89d2\u5ea6\u3092\u8a2d\u5b9a\u3059\u308b\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float setViewRotate(float a) {
    float oldangle = viewRotate();
//    if (a > TWO_PI) a -= TWO_PI; else if (a < -TWO_PI) a += TWO_PI;  // % \u3092\u4f7f\u3046\u3068\u8aa4\u5dee\u304c\u751f\u3058\u308b\uff1f\u3068\u3044\u3046\u6839\u62e0\u306e\u306a\u3044\u5c0f\u5fc3\u306a\u63a8\u6e2c
    rotateAngle.set(a);
    return oldangle;
  }
  public viewportClass viewRotate(float a)    { setViewRotate(a); return this; }
  // (c) \u8996\u70b9\u306e\u89d2\u5ea6\u3092\u5897\u6e1b\u3059\u308b\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float         setViewRotateRel(float a) { return setViewRotate(viewRotate() + a); }
  public viewportClass viewRotateRel(float a)    { setViewRotateRel(a); return this;       }
  // ----------------
  // \u30aa\u30d5\u30bb\u30c3\u30c8\u91cf\u95a2\u4fc2
  // ----------------
  // (a) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30aa\u30d5\u30bb\u30c3\u30c8\u91cf\u3092\u8fd4\u3059
  // (a-1) \uff58\u65b9\u5411
  public float viewOffsetX() { return offsetX; }
  // (a-2) \uff59\u65b9\u5411\uff08\u4e0a\u3092\u6b63\u3068\u3057\u3066\u3044\u308b\u70b9\u306b\u6ce8\u610f\uff09
  public float viewOffsetY() { return offsetY; }
  // (b) \u30aa\u30d5\u30bb\u30c3\u30c8\u91cf\u3092\u5909\u66f4\u3059\u308b\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09\uff1a\u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8
  // (b-1) \uff58\u65b9\u5411
  public float setViewOffsetX(float offset) {
    float oldoffset = viewOffsetX();
    offsetX = offset;
    return oldoffset;
  }
  public viewportClass viewOffsetX(float offset) { setViewOffsetX(offset); return this; }
  // (b-2) \uff59\u65b9\u5411\uff08\u4e0a\u3092\u6b63\u3068\u3057\u3066\u3044\u308b\u70b9\u306b\u6ce8\u610f\uff09
  public float setViewOffsetY(float offset) {
    float oldoffset = viewOffsetY();
    offsetY = offset;
    return oldoffset;
  }
  public viewportClass viewOffsetY(float offset) { setViewOffsetY(offset); return this; }
  // (b-3) \uff58\u65b9\u5411\uff0f\uff59\u65b9\u5411\u540c\u6642\uff1a\u5e38\u306btrue\u3092\u8fd4\u3059
  public boolean setViewOffset(float offx, float offy) {
    viewOffsetX(offx);
    viewOffsetY(offy);
    return true;
  }
  public viewportClass viewOffset(float offx, float offy) { setViewOffset(offx, offy); return this; }

  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306b\u65b0\u5ea7\u6a19\u7cfb\u3092\u8a2d\u5b9a\u3059\u308b
  public void resetView() {
    float pax, pay, pbx, pby, pcx, pcy;
    pg.endDraw();
    pg.beginDraw();
    pg.rotate( - rotateAngle.getRadian());
    pg.scale(magnification);
    pax = pivotX + offsetX;
    pay = pivotY - offsetY;
    pbx = rotate2Dsx(pax, pay, -rotateAngle.getRadian());
    pby = rotate2Dsy(pax, pay, -rotateAngle.getRadian());
    pcx = pbx - magnification * pivotX;
    pcy = pby - magnification * pivotY;
    pg.translate(pcx / magnification, pcy / magnification);
  }

  // ------
  // \u8272\u95a2\u4fc2
  // ------
  // (a) fill()
  // (a-1) \u73fe\u5728\u306e\u5857\u308a\u6f70\u3057\u8272\u3092\u53d6\u5f97
  public int fill()      { return cdSet.fillColor; }
  // (a-2) \u5857\u308a\u6f70\u3057\u8272\u3092\u5909\u66f4\uff08\uff0b\u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059\uff09
//int fill(int c) { return this.fill(c, cdSet.fillTrans); }
  public int setFill(int c) { cdSet.fillTrans = 255; return this.setFill(c, cdSet.fillTrans); }
  // (a-3) \u5857\u308a\u6f70\u3057\u8272\u3092\u5909\u66f4\uff08\u4e0d\u900f\u660e\u5ea6\u5bfe\u5fdc\uff0b\u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059\uff09
  public int setFill(int c, int trans) {
    if (trans < 0)   trans = 0;
    if (trans > 255) trans = 255;
    int oldcolor;
    oldcolor = this.fill();
    cdSet.fillColor = c & 0xFFFFFFFF;
    cdSet.fillTrans = trans;
    pg.fill(cdSet.fillColor, cdSet.fillTrans);
    cdSet.isFill = false;
    return oldcolor;
  }
  public viewportClass fill(int c, int trans) { this.setFill(c, trans); return this; }
  public viewportClass fill(int c)            { this.setFill(c);        return this; }
  // (a-4) \u5857\u308a\u6f70\u3057\u7121\u3057
  public viewportClass noFill() {
    cdSet.isFill = false;
    pg.noFill();
    return this;
  }
  // (a-5) \u518d\u3073\u5857\u308a\u6f70\u3057
  public viewportClass reFill() {
    this.fill(cdSet.fillColor, cdSet.fillTrans);
    return this;
  }
  // (b) stroke()
  // (b-1) \u73fe\u5728\u306e\u7dda\u8272\u3092\u53d6\u5f97
  public int stroke()      { return cdSet.strokeColor; }
  // (b-2) \u7dda\u8272\u3092\u5909\u66f4\uff08\uff0b\u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059\uff09
  public int setStroke(int c) { return this.setStroke(c, cdSet.fillTrans); }
  // (b-3) \u7dda\u8272\u3092\u5909\u66f4\uff08\u4e0d\u900f\u660e\u5ea6\u5bfe\u5fdc\uff0b\u73fe\u5728\u306e\u5024\u3092\u8fd4\u3059\uff09
  public int setStroke(int c, int trans) {
    if (trans < 0)   trans = 0;
    if (trans > 255) trans = 255;
    int oldcolor;
    oldcolor = this.stroke();
    cdSet.strokeColor = c & 0xFFFFFFFF;
    cdSet.strokeTrans = trans;
    pg.stroke(cdSet.strokeColor, cdSet.strokeTrans);
    return oldcolor;
  }
  public viewportClass stroke(int c, int trans) { this.setStroke(c, trans); return this; }
  public viewportClass stroke(int c)            { this.setStroke(c);        return this; }
  // (b-4) \u7dda\u7121\u3057
  public viewportClass noStroke() {
    cdSet.isStroke = false;
    pg.noStroke();
    return this;
  }
  // (b-5) \u518d\u3073\u7dda\u6709\u308a
  public viewportClass reStroke() {
    this.stroke(cdSet.strokeColor, cdSet.strokeTrans);
    return this;
  }
  // \u7dda\u5e45
  // (a) \u73fe\u5728\u5024\u8aad\u307f\u51fa\u3057
  public float strokeWeight() { return cdSet.strokeWeight; }
  // (b) \u8a2d\u5b9a\uff08\uff0b\u73fe\u5728\u306e\u5024\uff09
  public float setStrokeWeight(float w) {
    float oldwidth = strokeWeight();
    pg.strokeWeight(w);
    cdSet.strokeWeight = w;
    return oldwidth;
  }
  public viewportClass strokeWeight(float w) { this.setStrokeWeight(w); return this; }

  // \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u753b\u9762\u6d88\u53bb\u3059\u308b
  // flag\u304ctrue\u306e\u5834\u5408\u306f\u80cc\u666f\u8272\u304c\u900f\u660e\u306b\u8a2d\u5b9a\u3055\u308c\u3066\u3044\u308b\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u6d88\u53bb\u306f\u884c\u306a\u308f\u306a\u3044
  public viewportClass clrView(boolean flag) {
    if (transparentView) {
      if (!flag) pg.background(bgColor, 0);
    } else       pg.background(bgColor, transparency);
    return this;
  }
  public viewportClass clrView() { return clrView(false); }

  // ------------------------------------------
  // \u6700\u7d42\u63cf\u753b\u70b9\uff08\u30ab\u30ec\u30f3\u30c8\u30dd\u30b8\u30b7\u30e7\u30f3\uff09\u3092\u79fb\u52d5\u3059\u308b
  // ------------------------------------------
  public viewportClass _moveTo(int x, int y) {
    cdSet.vpx = x;
    cdSet.vpy = y;
    return this;
  }
  public viewportClass moveTo(float x, float y) {
    cdSet.wpx = x;
    cdSet.wpy = y;
    return this;
  }
  public viewportClass _moveToRel(int dx, int dy) {
    cdSet.vpx += dx;
    cdSet.vpy += dy;
    return this;
  }
  public viewportClass moveToRel(float dx, float dy) {
    cdSet.wpx += dx;
    cdSet.wpy += dy;
    return this;
  }
  public int  _getCpX() { return cdSet.vpx; }
  public int  _getCpY() { return cdSet.vpy; }
  public float getCpX() { return cdSet.wpx; }
  public float getCpY() { return cdSet.wpy; }

  // \u5b9f\u969b\u306b\u63cf\u753b\u3059\u308b\u95a2\u6570
  // \u5171\u6709\u3059\u308b\u4f5c\u696d\u7528\u5909\u6570
  int [] tmp1 = new int[2];
  int [] tmp2 = new int[2];
  int [] tmp3 = new int[2];
  int [] tmp4 = new int[2];
//  int [] tmp1, tmp2, tmp3, tmp4;
  // ------------
  // \u76f4\u7dda\u63cf\u753b\u95a2\u4fc2
  // ------------
  // \u76f4\u7dda\u3092\u63cf\u304f\uff08\u30d4\u30af\u30bb\u30eb\u5ea7\u6a19\uff09
  public viewportClass _line(int x1, int y1, int x2, int y2) {
    tmp1 = baseConv(tmp1, x1, y1);
    tmp2 = baseConv(tmp2, x2, y2);
    pg.line(tmp1[0], tmp1[1], tmp2[0], tmp2[1]);
    _moveTo(x2, y2);
    return this;
  }
  // \u76f4\u7dda\u3092\u63cf\u304f\uff08\u30ef\u30fc\u30eb\u30c9\uff09
  public viewportClass line(float x1, float y1, float x2, float y2) {
    _line(px(x1), py(y1), px(x2), py(y2));
    moveTo(x2, y2);
    return this;
  }
  // \u59cb\u70b9\u7701\u7565\uff08\u7d76\u5bfe\u5ea7\u6a19\uff09
  public viewportClass _lineTo(int x, int y)    { return _line(cdSet.vpx, cdSet.vpy, x, y); }
  public viewportClass lineTo(float x, float y) { return this.line(cdSet.wpx, cdSet.wpy, x, y); }
  // \u59cb\u70b9\u7701\u7565\uff08\u76f8\u5bfe\u5ea7\u6a19\uff09
  public viewportClass _lineRel(int dx, int dy)    { return _line(cdSet.vpx, cdSet.vpy, cdSet.vpx + dx, cdSet.vpy + dy); }
  public viewportClass lineRel(float dx, float dy) { return this.line(cdSet.wpx, cdSet.wpy, cdSet.wpx + dx, cdSet.wpy + dy); }
  // ----------
  // \u70b9\u7dda\u3092\u63cf\u304f
  // ----------
  // (a) \u7d76\u5bfe\u5ea7\u6a19\u6307\u5b9a
  // (a-1) \u30d4\u30af\u30bb\u30eb\u5ea7\u6a19
  public viewportClass _dashedLine(int x0, int y0, int x1, int y1, int step) {
    float  px0, py0, px1, py1, normv;
    float  unitx, unity;
    float  dx, dy;
    int    countmax, count;
    boolean stroke = true;

    countmax = PApplet.parseInt(norm(x0, y0, x1, y1) / step);
    if (countmax <= 0) {
      _line(x0, y0, x1, y1);
      return this;
    }
    px0 = x0;
    py0 = y0;
    for (count = 0; count < countmax; count++) {
      dx = x1 - px0;
      dy = y1 - py0;
      normv = sqrt(dx * dx + dy * dy);
      if (normv < step) {
        _line(PApplet.parseInt(px0), PApplet.parseInt(py0), x1, y1);
        return this;
      }
      unitx = dx / normv;
      unity = dy / normv;
      px1 = px0 + unitx * step;
      py1 = py0 + unity * step;
      if (stroke) _line(PApplet.parseInt(px0), PApplet.parseInt(py0), PApplet.parseInt(px1), PApplet.parseInt(py1));
      stroke = !stroke;
      px0 = px1;
      py0 = py1;
    }
    _moveTo(x1, y1);
    return this;
  }
  // (a-2) \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb
  public viewportClass dashedLine(float x1, float y1, float x2, float y2, int step) {
    _dashedLine(px(x1), py(y1), px(x2), py(y2), step);
    moveTo(x2, y2);
    return this;
  }
  // (b) \u59cb\u70b9\u7701\u7565\uff08\u7d76\u5bfe\u5ea7\u6a19\uff09
  public viewportClass _dashedLineTo(int x, int y, int step)         { return _dashedLine(cdSet.vpx, cdSet.vpy, x, y, step); }
  public viewportClass dashedLineTo(float x, float y, int step)      { return  dashedLine(cdSet.wpx, cdSet.wpy, x, y, step); }
  // (c) \u59cb\u70b9\u7701\u7565\uff08\u76f8\u5bfe\u5ea7\u6a19\uff09
  public viewportClass _dashedLineRel(int dx, int dy, int step)      { return _dashedLine(cdSet.vpx, cdSet.vpy, cdSet.vpx + dx, cdSet.vpy + dy, step); }
  public viewportClass dashedLineRel(float dx, float dy, int step)   { return  dashedLine(cdSet.wpx, cdSet.wpy, cdSet.wpx + dx, cdSet.wpy + dy, step); }

  // --------
  // \u5186\u3092\u63cf\u304f
  // --------
  // \u4e00\u90e8\u306e\u6a5f\u80fd\u306fplot()\u3067\u5b9f\u73fe\u3059\u308b\u3053\u3068\u306b\u3057\u305f\u306e\u3067\uff0c\u305d\u3061\u3089\u3092\u53c2\u7167
  // (a) \u6955\u5186\u3092\u63cf\u304f
  public viewportClass _ellipse(int x, int y, int w, int h) {
    tmp1 = baseConv(tmp1, x, y);
    pg.ellipse(tmp1[0], tmp1[1], w, h);
    _moveTo(x, y);
    return this;
  }
  public viewportClass ellipse(float x, float y, float w, float h) {
    if (cdSet.ellipseMode == CORNERS) _ellipse(px(x), py(y), px(w), py(h));
      else                            _ellipse(px(x), py(y), _px(w), _py(h));
    moveTo(x, y);
    return this;
  }
  // (b) \u771f\u5186\u3092\u63cf\u304f
  public viewportClass _ellipse(int x, int y, int r)      { return _ellipse(x, y, r, r); }
  public viewportClass ellipse(float x, float y, float r) { return this.ellipse(x, y, r, r); }
  public viewportClass plot(float x, float y, int r) {
    int mode = this.setEllipseMode(RADIUS);
    ellipse(x, y, _rpx(r));
    this.setEllipseMode(mode);
    return this;
  }
  // (c) \u771f\u5186\u3092\u63cf\u304f\uff08\u534a\u5f84\u306e\u307f\u6307\u5b9a\uff09
  public viewportClass _ellipse(int  r) { return _ellipse(cdSet.vpx, cdSet.vpy, r); }
  public viewportClass ellipse(float r) { return ellipse(cdSet.wpx, cdSet.wpy,  r); }
  public viewportClass plot(int r)      { return plot(cdSet.wpx, cdSet.wpy, r); }

  // \u6955\u5186\uff08ellipse\uff09\u3068\u5186\u5f27\uff08arc\uff09\u306e\u5ea7\u6a19\u6307\u5b9a\u306e\u30e2\u30fc\u30c9
  // CENTER\uff08\u30c7\u30d5\u30a9\u30eb\u30c8\uff09, RADIUS, CORNER, CORNERS\u304c\u4f7f\u3048\u308b
  public int ellipseMode() { return cdSet.ellipseMode; }
  public int setEllipseMode(int mode) {
    int oldmode = ellipseMode();
    pg.ellipseMode(mode);
    cdSet.ellipseMode = mode;
    return oldmode;
  }
  public viewportClass ellipseMode(int mode) { this.setEllipseMode(mode); return this; }

  // -----------
  // \u4e09\u89d2\u5f62\u3092\u63cf\u304f
  // -----------
  // (a) \u4e09\u70b9\u6307\u5b9a
  public viewportClass _triangle(int x1, int y1, int x2, int y2, int x3, int y3) {
    tmp1 = baseConv(tmp1, x1, y1);
    tmp2 = baseConv(tmp2, x2, y2);
    tmp3 = baseConv(tmp3, x3, y3);
    pg.triangle(tmp1[0], tmp1[1], tmp2[0], tmp2[1], tmp3[0], tmp3[1]);
    _moveTo(PApplet.parseInt((x1 + x2 + x3) / 3.0f), PApplet.parseInt((y1 + y2 + y3) / 3.0f));  // \u4e2d\u592e\uff0c\u3060\u3068\u601d\u3046
    return this;
  }
  public viewportClass triangle(float x1, float y1, float x2, float y2, float x3, float y3) {
    _triangle(px(x1), py(y1), px(x2), py(y2), px(x3), py(y3));
    moveTo((x1 + x2 + x3) / 3.0f, (y1 + y2 + y3) / 3.0f);
    return this;
  }
  // \u4e2d\u5fc3\u5ea7\u6a19\u3092\u6307\u5b9a\uff08\u56de\u8ee2\u5bfe\u5fdc\uff09
  public viewportClass _triangle(int x, int y, int s, float angle) {
    int   dx1, dy1, dx2, dy2, dx3, dy3;
    float da;
    angleClass ang = new angleClass(angle);
    angle = ang.getRadian();
    da  = TWO_PI / 3.0f;
    dx1 = 0;
    dy1 = s;
    dx2 = PApplet.parseInt(rotate2Dx(dx1, dy1, angle + da));
    dy2 = PApplet.parseInt(rotate2Dy(dx1, dy1, angle + da));
    dx3 = PApplet.parseInt(rotate2Dx(dx1, dy1, angle - da));
    dy3 = PApplet.parseInt(rotate2Dy(dx1, dy1, angle - da));
    dx1 = PApplet.parseInt(rotate2Dx(dx1, dy1, angle));
    dy1 = PApplet.parseInt(rotate2Dy(dx1, dy1, angle));
    _triangle(x + dx1, y + dy1, x + dx2, y + dy2, x + dx3, y + dy3);
    _moveTo(x, y);
    return this;
  }
  public viewportClass triangle(float x, float y, float s, float angle) {
    float dx1, dy1, dx2, dy2, dx3, dy3, da;
    angleClass ang = new angleClass(angle);
    angle = ang.get();
    da  = TWO_PI / 3.0f;
    dx1 = 0;
    dy1 = s;
    dx2 = rotate2Dx(dx1, dy1, angle + da);
    dy2 = rotate2Dy(dx1, dy1, angle + da);
    dx3 = rotate2Dx(dx1, dy1, angle - da);
    dy3 = rotate2Dy(dx1, dy1, angle - da);
    dx1 = rotate2Dx(dx1, dy1, angle);
    dy1 = rotate2Dy(dx1, dy1, angle);
    this.triangle(x + dx1, y + dy1, x + dx2, y + dy2, x + dx3, y + dy3);
    moveTo(x, y);
    return this;
  }
  // \u4e2d\u5fc3\u5ea7\u6a19\u3092\u6307\u5b9a\uff08\u56de\u8ee2\u306a\u3057\uff09
  public viewportClass _triangle(int x, int y, int s)         { return _triangle(x, y, s, 0.0f); }
  public viewportClass  triangle(float x, float y, float s)   { return  triangle(x, y, s, 0.0f); }
  // \u30b5\u30a4\u30ba\u306e\u307f\u6307\u5b9a\uff08\u56de\u8ee2\u5bfe\u5fdc\uff09
  public viewportClass _triangle(int   s, float angle)        { return _triangle(cdSet.vpx, cdSet.vpy, s, angle); }
  public viewportClass  triangle(float s, float angle)        { return  triangle(cdSet.wpx, cdSet.wpy, s, angle); } 
  // \u30b5\u30a4\u30ba\u306e\u307f\u6307\u5b9a\uff08\u56de\u8ee2\u306a\u3057\uff09
  public viewportClass _triangle(int   s) { return _triangle(s, 0.0f); }
  public viewportClass  triangle(float s) { return  triangle(s, 0.0f); }
  
  // ------------
  // \u56db\u8fba\u5f62\u3092\u63cf\u304f
  // ------------
  public viewportClass _quad(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4) {
    tmp1 = baseConv(tmp1, x1, y1);
    tmp2 = baseConv(tmp2, x2, y2);
    tmp3 = baseConv(tmp3, x3, y3);
    tmp4 = baseConv(tmp4, x4, y4);
    pg.quad(tmp1[0], tmp1[1], tmp2[0], tmp2[1], tmp3[0], tmp3[1], tmp4[0], tmp4[1]);
    float [][] pt = new float[4][2];
    pt[0][0] = x1;
    pt[0][1] = y1;
    pt[1][0] = x2;
    pt[1][1] = y1;
    pt[2][0] = x3;
    pt[2][1] = y3;
    pt[3][0] = x4;
    pt[3][1] = y4;
    float [] xyG = new float[2];
    xyG = polygonG(pt);
    _moveTo(PApplet.parseInt(xyG[0]), PApplet.parseInt(xyG[1]));
    return this;
  }
  public viewportClass quad(float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4) {
    _quad(px(x1), py(y1), px(x2), py(y2), px(x3), py(y3), px(x4), py(y4));
    float [][] pt = new float[4][2];
    pt[0][0] = x1;
    pt[0][1] = y1;
    pt[1][0] = x2;
    pt[1][1] = y1;
    pt[2][0] = x3;
    pt[2][1] = y3;
    pt[3][0] = x4;
    pt[3][1] = y4;
    float [] xyG = new float[2];
    xyG = polygonG(pt);
    moveTo(xyG[0], xyG[1]);
    return this;
  }
  public viewportClass _quad(int dx1, int dy1, int dx2, int dy2, int dx3, int dy3)             { return _quad(cdSet.vpx, cdSet.vpy, dx1, dy1, dx2, dy2, dx3, dy3); }
  public viewportClass  quad(float dx1, float dy1, float dx2, float dy2, float dx3, float dy3) { return  quad(cdSet.wpx, cdSet.wpy, dx1, dy1, dx2, dy2, dx3, dy3); }
  public viewportClass _quadRel(int x, int y, int dx1, int dy1, int dx2, int dy2, int dx3, int dy3, int dx4, int dy4) {
   return _quad(x + dx1, y + dy1, x + dx2, y + dy2, x + dx3, y + dy3, x + dx4, y + dy4);
  }
  public viewportClass quadRel(float x, float y, float dx1, float dy1, float dx2, float dy2, float dx3, float dy3, float dx4, float dy4) {
   return quad(x + dx1, y + dy1, x + dx2, y + dy2, x + dx3, y + dy3, x + dx4, y + dy4);
  }
  public viewportClass _quadRel(int dx1, int dy1, int dx2, int dy2, int dx3, int dy3, int dx4, int dy4) {
    return _quad(cdSet.vpx + dx1, cdSet.vpy + dy1, cdSet.vpx + dx2, cdSet.vpy + dy2, cdSet.vpx + dx3, cdSet.vpy + dy3, cdSet.vpx + dx4, cdSet.vpy + dy4);
  }
  public viewportClass quadRel(float dx1, float dy1, float dx2, float dy2, float dx3, float dy3, float dx4, float dy4) {
    return quad(cdSet.wpx + dx1, cdSet.wpy + dy1, cdSet.wpx + dx2, cdSet.wpy + dy2, cdSet.wpx + dx3, cdSet.wpy + dy3, cdSet.wpx + dx4, cdSet.wpy + dy4);
  }
  // --------------------------------------------------------
  // \u9577\u65b9\u5f62\u3092\u63cf\u304f
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8996\u70b9\u306e\u56de\u8ee2\u306b\u5bfe\u5fdc\u3059\u308b\u305f\u3081\u306bquad()\u3067\u63cf\u753b\u3059\u308b
  // --------------------------------------------------------
  // (a) \u5de6\u4e0a\u59cb\u70b9
  public viewportClass _rect(int x, int y, int w, int h) {
    switch (cdSet.rectMode) {
      case CORNERS :
        _quad(x, y, x, h, w, h, w, y);
        break;
      case CENTER :
        int dx = w / 2;
        int dy = h / 2;
        _quad(x - dx, y - dy, x - dx, y + dy, x + dx, y + dy, x + dx, y - dy);
        break;
      case RADIUS :
        _quad(x - w,  y - h,  x - w,  y + h,  x + w,  y + h,  x + w,  y - h );
        break;
      default :  // CORNER\uff08\u30c7\u30d5\u30a9\u30eb\u30c8\uff09
        _quad(x, y, x, y + h, x + w, y + h, x + w, y);
        break;
    }
    _moveTo(x, y);
    return this;
  }
  public viewportClass rect(float x, float y, float w, float h) {
    if (cdSet.rectMode == CORNERS) _rect(px(x), py(y),  px(w),  py(h));
      else                         _rect(px(x), py(y), _px(w), _py(h));
    moveTo(x, y);
    return this;
  }
  public viewportClass _rect(int w, int h)     { return _rect(cdSet.vpx, cdSet.vpy, w, h); }
  public viewportClass  rect(float w, float h) { return  rect(cdSet.wpx, cdSet.wpy, w, h); }
  // (b) \u305d\u308c\u4ee5\u5916\u306e\u6307\u5b9a\u65b9\u6cd5\u306frectMode()\u3067\u6307\u5b9a\u3059\u308c\u3070\u826f\u3044\u306e\u3067\u7701\u7565
  // CORNER\uff08\u30c7\u30d5\u30a9\u30eb\u30c8\uff09, CORNERS, CENTER, RADIUS\u304c\u4f7f\u3048\u308b
  public int rectMode() { return cdSet.rectMode; }
  public int setRectMode(int mode) {
    int oldmode = rectMode();
    pg.rectMode(mode);
    cdSet.rectMode = mode;
    return oldmode;
  }
  public viewportClass rectMode(int mode) { this.setRectMode(mode); return this; }
  // ---------
  // \u5186\u5f27\u3092\u63cf\u304f
  // ---------
  public viewportClass _arc(int x, int y, int w, int h, float start, float stop) {
    tmp1 = baseConv(tmp1, x, y);
    angleClass startAngle, stopAngle;
    startAngle = new angleClass(start);
    stopAngle  = new angleClass(stop);
    pg.arc(tmp1[0], tmp1[1], w, h, startAngle.getRadian(), stopAngle.getRadian());
    _moveTo(x, y);
    return this;
  }
  public viewportClass _arc(int x, int y, int r, float start, float stop) { return _arc(x, y, r, r, start, stop); }
  public viewportClass _arc(int w, int h, float start, float stop)        { return _arc(cdSet.vpx, cdSet.vpy, w, h, start, stop); }
  public viewportClass _arc(int r, float start, float stop)               { return _arc(r, r, start, stop); }
  public viewportClass arc(float x, float y, float w, float h, float start, float stop) {
    float temp;
    temp  =  start;
    start = -stop;
    stop  = -temp;
    _arc(px(x), py(y), _px(w), _py(h), start, stop);
    moveTo(x, y);
    return this;
  }
  public viewportClass arc(float x, float y, float r, float start, float stop) { return arc(x, y, r, r, start, stop); }
  public viewportClass arc(float w, float h, float start, float stop)          { return arc(cdSet.wpx, cdSet.wpy, w, h, start, stop); }
  public viewportClass arc(float r, float start, float stop)                   { return arc(r, r, start, stop); } 
  // ------------
  // \u70b9\u3092\u63cf\u753b\u3059\u308b
  // ------------
  public viewportClass _point(int x, int y) {
    tmp1 = baseConv(tmp1, x, y);
    pg.point(tmp1[0], tmp1[1]);
    _moveTo(x, y);
    return this;
  }
  public viewportClass _point() { return _point(cdSet.vpx, cdSet.vpy); }
  public viewportClass point(float x, float y) {
    _point(px(x), py(y));
    moveTo(x, y);
    return this;
  }
  public viewportClass point() { return point(cdSet.wpx, cdSet.wpy); }
  // --------
  // \u9802\u70b9\u95a2\u4fc2
  // --------
  // mode\u306e\u9078\u629e\u80a2\u306f
  // LINES\uff0cLINE_STRIP\uff0cLINE_LOOP\uff0cTRIANGLES\uff0cTRIANGLE_FAN\uff0cTRIANGLE_STRIP\uff0cQUADS\uff0cQUAD_STRIP\uff0cPOLYGON
  public viewportClass beginShape(int mode) {
    pg.beginShape(mode);
    return this;
  }
  // mode\u7701\u7565\u6642\u306fPOLYGON
  public viewportClass beginShape() {
    pg.beginShape();
    return this;
  }
  public viewportClass endShape() {
    pg.endShape();
    return this;
  }
  // \u9802\u70b9
  public viewportClass _vertex(int x, int y) {
    tmp1 = baseConv(tmp1, x, y);  // \u56de\u8ee2\u306b\u6b63\u3057\u304f\u5bfe\u5fdc\u3067\u304d\u3066\u3044\u306a\u3044
    pg.vertex(tmp1[0], tmp1[1]);
    _moveTo(x, y);
    return this;
  }
  public viewportClass _vertex() { return _vertexRel(0, 0); }
  public viewportClass  vertex(float x, float y) {
    _vertex(px(x), py(y));
    moveTo(x, y);
    return this;
  }
  // \u9802\u70b9\uff08\u30c6\u30af\u30b9\u30c1\u30e3\u7528\uff09\uff1a\u8996\u70b9\u306e\u56de\u8ee2\u306b\u306f\u5bfe\u5fdc\u3067\u304d\u306a\u3044\u3068\u601d\u3046
  public viewportClass _vertex(float x, float y, float u, float v) { // \u5c11\u3005\u7406\u89e3\u4e0d\u8db3\u304b\u3082\uff0ex,y\u3092\u7701\u7565\u3059\u308b\u3068\u9802\u70b9\u3068\u533a\u5225\u304c\u4ed8\u304b\u306a\u304f\u306a\u308b
    tmp1 = baseConv(tmp1, x, y);
    if (textureMode() == NORMAL) pg.vertex(x, y, u, v);
      else                       pg.vertex(tmp1[0], tmp1[1], u, v);
    return this;
  }
  // \u9802\u70b9
  public viewportClass vertex()                       { return vertexRel(0.0f, 0.0f); }
  public viewportClass _vertexRel(int   dx, int   dy) { return _vertex(cdSet.vpx + dx, cdSet.vpy + dy); }
  public viewportClass  vertexRel(float dx, float dy) { return  vertex(cdSet.wpx + dx, cdSet.wpy + dy); }
  // \u9802\u70b9\uff08\u30c6\u30af\u30b9\u30c1\u30e3\u7528\uff09\uff1a\u8996\u70b9\u306e\u56de\u8ee2\u306b\u306f\u5bfe\u5fdc\u3067\u304d\u306a\u3044\u3068\u601d\u3046
  public viewportClass vertex(float x, float y, float u, float v) { // \u5c11\u3005\u7406\u89e3\u4e0d\u8db3\u304b\u3082\uff0ex,y\u3092\u7701\u7565\u3059\u308b\u3068\u9802\u70b9\u3068\u533a\u5225\u304c\u4ed8\u304b\u306a\u304f\u306a\u308b
    if (textureMode() == NORMAL) _vertex(x, y, u, v);
      else                       _vertex(px(x), py(y), u, v);
    pg.endDraw();
    return this;
  }
  // \u9802\u70b9\uff08\u66f2\u7dda\uff09
  public viewportClass _curveVertex(int x, int y) {
    tmp1 = baseConv(tmp1, x, y);
    pg.curveVertex(tmp1[0], tmp1[1]);
    _moveTo(x, y);
    return this;
  }
  public viewportClass _curveVertex() { return _curveVertex(cdSet.vpx, cdSet.vpy); }
  public viewportClass curveVertex(float x, float y) {
    _curveVertex(px(x), py(y));
    moveTo(x, y);
    return this;
  }
  public viewportClass curveVertex()                       { return curveVertex(cdSet.wpx, cdSet.wpy); }
  public viewportClass _curveVertexRel(int   dx, int   dy) { return _curveVertex(cdSet.vpx + dx, cdSet.vpy + dy); }
  public viewportClass  curveVertexRel(float dx, float dy) { return  curveVertex(cdSet.wpx + dx, cdSet.wpy + dy); }
  public viewportClass _bezierVertex(int cx1, int cy1, int cx2, int cy2, int x, int y) {
    tmp1 = baseConv(tmp1, cx1, cy1);
    tmp2 = baseConv(tmp2, cx2, cy2);
    tmp3 = baseConv(tmp3, x,   y  );
    pg.bezierVertex(tmp1[0], tmp1[1], tmp2[0], tmp2[1], tmp3[0], tmp3[1]);
    _moveTo(x, y);
    return this;
  }
  public viewportClass _bezierVertex(int cx1, int cy1, int cx2, int cy2) {
    _bezierVertex(cx1, cy1, cx2, cy2, cdSet.vpx, cdSet.vpy);
    return this;
  }
  public viewportClass bezierVertex(float cx1, float cy1, float cx2, float cy2, float x, float y) {
    _bezierVertex(px(cx1), py(cy1), px(cx2), py(cy2), px(x), py(y));
    moveTo(x, y);
    return this;
  }
  public viewportClass bezierVertex(float cx1, float cy1, float cx2, float cy2) {
    bezierVertex(cx1, cy1, cx2, cy2, cdSet.wpx, cdSet.wpy);
    return this;
  }
  public viewportClass _bezierVertexRel(int dcx1, int dcy1, int dcx2, int dcy2, int dx, int dy) {
    _bezierVertexRel(cdSet.vpx + dcx1, cdSet.vpy + dcy1, cdSet.vpx + dcx2, cdSet.vpy + dcy2, cdSet.vpx + dx, cdSet.vpy + dy);
    return this;
  }
  public viewportClass bezierVertexRel(float dcx1, float dcy1, float dcx2, float dcy2, float dx, float dy) {
    bezierVertexRel(cdSet.wpx + dcx1, cdSet.wpy + dcy1, cdSet.wpx + dcx2, cdSet.wpy + dcy2, cdSet.wpx + dx, cdSet.wpy + dy);
    return this;
  }
  public viewportClass texture(PImage img) {
    pg.texture(img);
    return this;
  }
  // \u30c6\u30af\u30b9\u30c1\u30e3\u30fc\u30e2\u30fc\u30c9(IMAGE, NORMALIZED)
  public int textureMode() { return cdSet.textureMode; }
  public int setTextureMode(int mode) {
    int oldmode = textureMode();
    pg.textureMode(mode);
    cdSet.textureMode = mode;
    return oldmode;
  }
  public viewportClass textureMode(int mode) { this.setTextureMode(mode); return this; }
  // --------
  // \u66f2\u7dda\u95a2\u4fc2
  // --------
  // (1) curve
  public viewportClass _curve(int a1x, int a1y, int x1, int y1, int x2, int y2, int a2x, int a2y) {
    tmp1 = baseConv(tmp1, a1x, a1y);
    tmp2 = baseConv(tmp2, x1,  y1 );
    tmp3 = baseConv(tmp3, x2,  y2 );
    tmp4 = baseConv(tmp4, a2x, a2y);
    pg.curve(tmp1[0], tmp1[1], tmp2[0], tmp2[1], tmp3[0], tmp3[1], tmp4[0], tmp4[1]);
    _moveTo(x2, y2);
    return this;
  }
  public viewportClass curve(float a1x, float a1y, float x1, float y1, float x2, float y2, float a2x, float a2y) {
    _curve(px(a1x), py(a1y), px(x1), py(y1), px(x2), py(y2), px(a2x), py(a2y));
    moveTo(x2, y2);
    return this;
  }
  public viewportClass _curveTo(int a1x, int a1y, int x2, int y2, int a2x, int a2y)            { return _curve(a1x, a1y, cdSet.vpx, cdSet.vpy, x2, y2, a2x, a2y); }
  public viewportClass curveTo(float a1x, float a1y, float x2, float y2, float a2x, float a2y) { return  curve(a1x, a1y, cdSet.wpx, cdSet.wpy, x2, y2, a2x, a2y); }
  // (2) \u30d1\u30e9\u30e1\u30fc\u30bf
  public float curveTightness() { return cdSet.curveTightness; }
  public float curveTightness(float squishy) {
    float oldparam = curveTightness();
    pg.curveTightness(squishy);
    cdSet.curveTightness = squishy;
    return oldparam;
  }
  public int curveDetail() { return cdSet.curveDetail; }
  public int curveDetail(int detail) {
    int oldparam = curveDetail();
    pg.curveDetail(detail);
    cdSet.curveDetail = detail;
    return oldparam;
  }
  // (3) \u7c21\u7565\u306b\u66f2\u7dda\u3092\u63cf\u304f\u305f\u3081\u306e\u62e1\u5f35
  // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb
  public void  drawCurve() {  curve(cc.x1a,  cc.y1a,  cc.x2a,  cc.y2a,  cc.x3a,  cc.y3a,  cc.x4a,  cc.y4a);  }
  public void _drawCurve() { _curve(cc._x1a, cc._y1a, cc._x2a, cc._y2a, cc._x3a, cc._y3a, cc._x4a, cc._y4a); }
  public viewportClass curveStart(float x, float y) { cc.start(x, y);                 return this; }
  public viewportClass curveStart()                 { cc.start(cdSet.wpx, cdSet.wpy); return this; }
  public viewportClass curveAdd(float x,  float y)  { cc.add(x, y);      if (cc.status >= 3) drawCurve(); return this; }
  public viewportClass curveRel(float dx, float dy) { cc.addRel(dx, dy); if (cc.status >= 3) drawCurve(); return this; }
  public viewportClass curveEnd()                   { cc.end();          if (cc.status == 0) drawCurve(); return this; }
  // \u30d4\u30af\u30bb\u30eb\u5ea7\u6a19
  public viewportClass _curveStart(int x, int y)    { cc._start(x, y);                 return this; }
  public viewportClass _curveStart()                { cc._start(cdSet.vpx, cdSet.vpy); return this; }
  public viewportClass _curveAdd(int x,   int y)    { cc._add(x, y);      if (cc._status >= 3) _drawCurve(); return this; }
  public viewportClass _curveRel(int dx,  int dy)   { cc._addRel(dx, dy); if (cc._status >= 3) _drawCurve(); return this; }
  public viewportClass _curveEnd()                  { cc._end();          if (cc._status == 0) _drawCurve(); return this; }

  // ----------------
  // \u30c6\u30ad\u30b9\u30c8\u8868\u793a\u95a2\u4fc2
  // ----------------
  public viewportClass prepareFont()             { return prepareFont(cdSet.textSize);  }
  public viewportClass prepareFont(int fontsize) { return prepareFont(_FONTNAME, fontsize); }
  public viewportClass prepareFont(String fontname, int fontsize) {
    if (crowbar.checkOptionsSetupOnly("prepareFont()", fontname + "/" + str(fontsize), false)) return this;
    font = createFont(fontname, fontsize, false);  // \u30d5\u30a9\u30f3\u30c8\u3092\u5909\u63db
    pg.textFont(font);         // \u30d5\u30a9\u30f3\u30c8\u3092\u8a2d\u5b9a
//  pg.textMode(SCREEN);       // SCREEN\u306b\u8a2d\u5b9a\u3059\u308b\u3068\u8868\u793a\u3055\u308c\u306a\u3044
    pg.textSize(fontsize);     // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba\u3092\u8a2d\u5b9a\uff08\u4e0d\u8981\uff1f\uff09
    pg.textAlign(cdSet.textAlignH, cdSet.textAlignV);   // \u914d\u7f6e
//  pg.textLeading(cdSet.textLeading);
    this.textLeading(PApplet.parseInt((this.textAscent() + this.textDescent()) * 1.2f));
    cdSet.textSize = fontsize;
    return this;
  }
  // \u30d5\u30a9\u30f3\u30c8\u30b5\u30a4\u30ba
  public int textSize() { return cdSet.textSize; }
  public int setTextSize(int size) {
    int oldsize = cdSet.textSize;
    pg.textSize(size);
    cdSet.textSize = size;
    return oldsize;
  }
  public viewportClass textSize(int size) { this.setTextSize(size); return this; }
  // \u5272\u308a\u5f53\u3066
  // LEFT, CENTER, RIGHT : \u6c34\u5e73\u65b9\u5411\uff08\u30c7\u30d5\u30a9\u30eb\u30c8\u306fLEFT\uff09
  // TOP, BOTTOM, CENTER, BASELINE : \u5782\u76f4\u65b9\u5411\uff08\u30c7\u30d5\u30a9\u30eb\u30c8\u306fBASELINE\uff09
  public int textAlign()  { return cdSet.textAlignH; }
  public int textAlignH() { return cdSet.textAlignH; }
  public int textAlignV() { return cdSet.textAlignV; }
  public viewportClass textAlign(int align, int yalign) {
    pg.textAlign(align, yalign);
    cdSet.textAlignH = align;
    cdSet.textAlignV = yalign;
    return this;
  }
  public int setTextAlign(int align) {
    int oldalign = cdSet.textAlignH;
    pg.textAlign(align);
    cdSet.textAlignH = align;
    return oldalign;
  }
  public int setTextAlignH(int align) { return this.setTextAlign(align); }
  public int setTextAlignV(int align) {
    int oldalign = textAlignV();
    this.textAlign(textAlignH(), align);
    return oldalign;
  }
  public viewportClass textAlign(int align)  { this.setTextAlign(align);  return this; }
  public viewportClass textAlignH(int align) { this.setTextAlignH(align); return this; }
  public viewportClass textAlignV(int align) { this.setTextAlignV(align); return this; }
  // \u884c\u9593
  public int textLeading() { return cdSet.textLeading; }
  public int setTextLeading(int dist) {
    int oldleading = cdSet.textLeading;
    pg.textLeading(dist);
    cdSet.textLeading = dist;
    return oldleading;
  }
  public viewportClass textLeading(int dist) { this.setTextLeading(dist); return this; }
  // \u30d9\u30fc\u30b9\u30e9\u30a4\u30f3\u304b\u3089\u306e\u8ddd\u96e2
  public float textAscent()          { return pg.textAscent();   }
  public float textDescent()         { return pg.textDescent();  }
  public float textWidth(String str) { return pg.textWidth(str); }
  // \u5b9f\u969b\u306b\u63cf\u753b\u3059\u308b
  public float _setText(int value, int x, int y)     { return _setText(str(value), x, y); }
  public float _setText(float value, int x, int y)   { return _setText(str(value), x, y); }
  public float _setText(boolean value, int x, int y) { return _setText(str(value), x, y); }
  public float _setText(String str, int x, int y) {
    tmp1 = baseConv(tmp1, x, y);
    pg.fill(cdSet.textColor);
    pg.text(str, tmp1[0], tmp1[1]);
    pg.fill(cdSet.fillColor);
    _moveTo(x + PApplet.parseInt(pg.textWidth(str)), y);
    return this.textWidth(str);
  }
  public float _setText(int value)     { return _setText(str(value)); }
  public float _setText(float value)   { return _setText(str(value)); }
  public float _setText(boolean value) { return _setText(str(value)); }
  public float _setText(String str) { return _setText(str, cdSet.vpx, cdSet.vpy); }
  public float setText(int value, float x, float y)     { return setText(str(value), x, y); }
  public float setText(float value, float x, float y)   { return setText(str(value), x, y); }
  public float setText(boolean value, float x, float y) { return setText(str(value), x, y); }
  public float setText(String str, float x, float y) {
    float w;
    w = _setText(str, px(x), py(y)) / pixelRatioX;
    moveTo(x + w, y);
    return w;
  }
  public float setText(int value)     { return setText(str(value)); }
  public float setText(float value)   { return setText(str(value)); }
  public float setText(boolean value) { return setText(str(value)); }
  public float setText(String str) { return _setText(str); }
  public viewportClass _text(int value, int x, int y)      { return _text(str(value), x, y); }
  public viewportClass _text(float value, int x, int y)    { return _text(str(value), x, y); }
  public viewportClass _text(boolean value, int x, int y)  { return _text(str(value), x, y); }
  public viewportClass _text(String str, int x, int y)     { _setText(str, x, y); return this; }
  public viewportClass _text(int value)     { return _text(str(value)); }
  public viewportClass _text(float value)   { return _text(str(value)); }
  public viewportClass _text(boolean value) { return _text(str(value)); }
  public viewportClass _text(String str)                   { _setText(str);       return this; }
  public viewportClass  text(int value, float x, float y)     { return text(str(value), x, y); }
  public viewportClass  text(float value, float x, float y)   { return text(str(value), x, y); }
  public viewportClass  text(boolean value, float x, float y) { return text(str(value), x, y); }
  public viewportClass  text(String str, float x, float y)    { setText(str, x, y); return this; }
  public viewportClass  text(int value)                       { return text(str(value)); }
  public viewportClass  text(float value)                     { return text(str(value)); }
  public viewportClass  text(boolean value)                   { return text(str(value)); }
  public viewportClass  text(String str)                      {  setText(str);      return this; }
  // \u4e92\u63db\u6027\u306e\u305f\u3081\u306e\u95a2\u6570\u5b9a\u7fa9
  public float _setWrite(int x, int y, int value)      { return _setWrite(x, y, str(value)); }
  public float _setWrite(int x, int y, float value)    { return _setWrite(x, y, str(value)); }
  public float _setWrite(int x, int y, boolean value)  { return _setWrite(x, y, str(value)); }
  public float _setWrite(int x, int y, String str)     { return _setText(str, x, y); }
  public float _setWrite(int value)                    { return _setWrite(str(value)); }
  public float _setWrite(float value)                  { return _setWrite(str(value)); }
  public float _setWrite(boolean value)                { return _setWrite(str(value)); }
  public float _setWrite(String str)                   { return _setText(str);       }
  public float  setWrite(float x, float y, int value)     { return  setWrite(x, y, str(value)); }
  public float  setWrite(float x, float y, float value)   { return  setWrite(x, y, str(value)); }
  public float  setWrite(float x, float y, boolean value) { return  setWrite(x, y, str(value)); }
  public float  setWrite(float x, float y, String str)    { return  setText(str, x, y); }
  public float  setWrite(int value)                    { return setWrite(str(value)); }
  public float  setWrite(float value)                  { return setWrite(str(value)); }
  public float  setWrite(boolean value)                { return setWrite(str(value)); }
  public float  setWrite(String str)                   { return  setText(str);       }
  public viewportClass _write(int x, int y, int value)      { return _write(x, y, str(value)); }
  public viewportClass _write(int x, int y, float value)    { return _write(x, y, str(value)); }
  public viewportClass _write(int x, int y, boolean value)  { return _write(x, y, str(value)); }
  public viewportClass _write(int x, int y, String str)     { return _text(str, x, y); }
  public viewportClass _write(int value)                    { return _write(str(value)); }
  public viewportClass _write(float value)                  { return _write(str(value)); }
  public viewportClass _write(boolean value)                { return _write(str(value)); }
  public viewportClass _write(String str)                   { return _text(str);       }
  public viewportClass  write(float x, float y, int value)      { return write(x, y, str(value)); }
  public viewportClass  write(float x, float y, float value)    { return write(x, y, str(value)); }
  public viewportClass  write(float x, float y, boolean value)  { return write(x, y, str(value)); }
  public viewportClass  write(float x, float y, String str)     { return  text(str, x, y); }
  public viewportClass  write(int value)                    { return write(str(value)); }
  public viewportClass  write(float value)                  { return write(str(value)); }
  public viewportClass  write(boolean value)                { return write(str(value)); }
  public viewportClass  write(String str)                   { return  text(str);        }

  // \u6587\u5b57\u8272\u95a2\u4fc2
  // (a) \u6587\u5b57\u8272\u306e\u53d6\u5f97
  public int viewTextColor() { return cdSet.textColor; }
  // (b) \u6587\u5b57\u8272\u306e\u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public int setViewTextColor(int c) {
    int oldcolor = viewTextColor();
    cdSet.textColor = c & 0xFFFFFFFF;
    return oldcolor;
  }
  public viewportClass viewTextColor(int c) { setViewTextColor(c); return this; }

  // --------
  // \u753b\u50cf\u95a2\u4fc2
  // --------
  // \u8aad\u307f\u8fbc\u307f\uff08loadImage()\u306fPGraphics\u3092\u4f7f\u3046\u5fc5\u8981\u306f\u7121\u3044\uff0e\u306a\u304a\uff0c\u30b0\u30ed\u30fc\u30d0\u30eb\u3067\u5b9f\u884c\u3057\u3066\u3082\u30c0\u30e1\uff09
  // \u30e2\u30fc\u30c9 (CORNER, CORNERS)
  // image(), copy()\u306b\u5f71\u97ff\u3092\u4e0e\u3048\u308b
  public int imageMode() { return cdSet.imageMode; }
  public int setImageMode(int mode) {
    int oldmode = this.imageMode();
    pg.imageMode(mode);
    cdSet.imageMode = mode;
    return oldmode;
  }
  public viewportClass imageMode(int mode) { this.setImageMode(mode); return this; }
  // \u51fa\u529b
  // (a) \u30d4\u30af\u30bb\u30eb\u5ea7\u6a19
  public viewportClass _image(PImage img, int x, int y, int w, int h) {
    pg.image(img, x, y, w, h);
    return this;
  }
  public viewportClass _image(PImage img, int x, int y) { pg.image(img, x, y);  return this; }
  public viewportClass _image(PImage img) { _image(img, cdSet.vpx, cdSet.vpy);  return this; }
  // (b) \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19
  public viewportClass image(PImage img, float x, float y, float w, float h) {
    _image(img, px(x), py(y), _px(w), _py(h));
    return this;
  }
  public viewportClass image(PImage img, float x, float y) { _image(img, px(x), py(y)); return this; }
  public viewportClass image(PImage img) { _image(img, px(cdSet.wpx), py(cdSet.wpy));   return this; }
  // \u8272\u3084\u4e0d\u900f\u660e\u5ea6
  public viewportClass tint(float gray)                               { pg.tint(gray);                   return this; }
  public viewportClass tint(float gray, float alpha)                  { pg.tint(gray, alpha);            return this; }
  public viewportClass tint(float value1, float value2, float value3) { pg.tint(value1, value2, value3); return this; }
  public viewportClass tint(int c)                                  { pg.tint(c);                      return this; }
  public viewportClass tint(int c, float alpha)                     { pg.tint(c, alpha);               return this; }
  // \u53d6\u308a\u6d88\u3057
  public viewportClass noTint() { pg.noTint(); return this; }

  // \u30d4\u30af\u30bb\u30eb\u95a2\u9023
  // \u30d0\u30c3\u30d5\u30a1\u306e\u78ba\u4fdd
  public PImage createImageRGB(float w, float h)   { return createImage(_px(w), _py(h), RGB); }
  public PImage createImageARGB(float w, float h)  { return createImage(_px(w), _py(h), ARGB); }
  public PImage createImageALPHA(float w, float h) { return createImage(_px(w), _py(h), ALPHA); }
  // \u8aad\u307f\u8fbc\u307f
  public viewportClass loadPixels() {
    pg.loadPixels();
    pixels = pg.pixels;
    return this;
  }
  // \u66f4\u65b0
  public viewportClass updatePixels() { pg.updatePixels(); return this; }

  public PImage _get()                                   { PImage img = pg.get();           return img;   }
  public int  _get(int x, int y)                       { int pixel = pg.get(x, y);      return pixel; }
  public PImage _get(int x, int y, int w, int h)         { PImage img = pg.get(x, y, w, h); return img;   }
  public PImage get()                                    { return _get(); }
  public int  get(float x, float y)                    { return _get(px(x), py(y)); }
  public PImage get(float x, float y, float w, float h)  { return _get(px(x), py(y), _px(w), _py(h)); }

  public viewportClass _set(int x, int y, int c)       { pg.set(x, y, c);   return this; }
  public viewportClass _set(int x, int y, PImage img)    { pg.set(x, y, img); return this; }
  public viewportClass _set(PImage img)                  { pg.set(0, 0, img); return this; }
  public viewportClass set(float x, float y, int c)    { return _set(px(x), py(y), c);   }
  public viewportClass set(float x, float y, PImage img) { return _set(px(x), py(y), img); }
  public viewportClass set(PImage img)                   { return _set(img);               }
  public viewportClass filter(int mode)                  { pg.filter(mode);        return this; }
  public viewportClass filter(int mode, float level)     { pg.filter(mode, level); return this; }
  // copy() : \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u9593\u3092\u307e\u305f\u3050\u30b3\u30d4\u30fc\u306f\u8003\u3048\u3066\u3044\u306a\u3044\uff0e\u81ea\u529b\u3067\u9811\u5f35\u308c\uff0e\u30b3\u30d4\u30fc\u5148\u306e\u30b5\u30a4\u30ba\u6307\u5b9a\u7701\u7565\u7248\u306f\u7528\u610f\u3057\u305f\uff0e
  public viewportClass _copy(int x, int y, int w, int h, int dx, int dy, int dw, int dh) {
    pg.copy(x, y, w, h, dx, dy, dw, dh);
    return this;
  }
  public viewportClass _copy(int x, int y, int w, int h, int dx, int dy) { return _copy(x, y, w, h, dx, dy, w, h); }
  public viewportClass _copy(PImage img, int x, int y, int w, int h, int dx, int dy, int dw, int dh) {
    pg.copy(img, x, y, w, h, dx, dy, dw, dh);
    return this;
  }
  public viewportClass _copy(PImage img, int x, int y, int w, int h, int dx, int dy) { return _copy(img, x, y, w, h, dx, dy, w, h); }
  public viewportClass copy(float x, float y, float w, float h, float dx, float dy, float dw, float dh) {
    pg.copy(px(x), py(y), _px(w), _py(h), px(dx), py(dy), _px(dw), _py(dh));
    return this;
  }
  public viewportClass copy(float x, float y, float w, float h, float dx, float dy) { return copy(x, y, w, h, dx, dy, w, h); }
  public viewportClass copy(PImage img, float x, float y, float w, float h, float dx, float dy, float dw, float dh) {
    pg.copy(img, px(x), py(y), _px(w), _py(h), px(dx), py(dy), _px(dw), _py(dh));
    return this;
  }
  public viewportClass copy(PImage img, float x, float y, float w, float h, float dx, float dy) { return copy(img, x, y, w, h, dx, dy, w, h); }

  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30ad\u30e3\u30d7\u30c1\u30e3\uff08\u52d5\u4f5c\u672a\u78ba\u8a8d\uff09\uff1a\u3082\u3057\u304b\u3057\u305f\u3089\u30d7\u30ed\u30bb\u30b9\u30b3\u30f3\u30c8\u30ed\u30fc\u30eb\u304c\u5fc5\u8981\u304b\u3082\u77e5\u308c\u306a\u3044
  public viewportClass save(String fname) {
    pg.save(fname);
    return this;
  }
/*
  void saveFrame() {    // saveFrame()\u306fPGraphics\u306b\u5b58\u5728\u3057\u306a\u3044\u3088\u3046\u3060
    pg.saveFrame();
  }
  void saveFrame(String format) {  // saveFrame()\u306fPGraphics\u306b\u5b58\u5728\u3057\u306a\u3044\u3088\u3046\u3060
    pg.saveFrame(format);
  }
*/

  // --------------------------------------------------------
  // \u30de\u30a6\u30b9\u306b\u3088\u308b\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5185\u30af\u30ea\u30c3\u30af\u306b\u5bfe\u3059\u308b\u30ec\u30b9\u30dd\u30f3\u30b9\u95a2\u4fc2
  // --------------------------------------------------------
  // (a) \u30de\u30a6\u30b9\u30dd\u30a4\u30f3\u30bf\u30fc\u304c\u3053\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e0a\u306b\u3042\u308b\u304b\uff1f\uff08\u4e0a\u306b\u5225\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u91cd\u306a\u3063\u3066\u3044\u308b\u304b\u3069\u3046\u304b\u306f\u6c17\u306b\u3057\u306a\u3044\uff0e\u30af\u30ea\u30c3\u30af\u3055\u308c\u305f\u304b\u3069\u3046\u304b\u3082\u95a2\u4fc2\u306a\u3044\uff09
  //     \u30af\u30ea\u30c3\u30af\u3055\u308c\u305f\u304b\u3069\u3046\u304b\u306fuserClicked()\u3067\u30a4\u30d9\u30f3\u30c8\u99c6\u52d5\u306b\u3059\u308b\uff0e
  public boolean mouseover() {
    if (visible != true) return false;
    if ((mouseX >= vx) && (mouseX <= vx + this.width) && (mouseY >= vy) && (mouseY <= vy + this.height)) return true;
    return false;
  }
  // (b) \u30de\u30a6\u30b9\u30dd\u30a4\u30f3\u30bf\u30fc\u306e\u5ea7\u6a19\u3092\u8fd4\u3057\u307e\u3059\uff0e\u9818\u57df\u5916\u3067\u3042\u3063\u3066\u3082\u8fd4\u3057\u307e\u3059\uff08\u8ca0\u306e\u5024\u3092\u8fd4\u3059\u5834\u5408\u3082\u3042\u308a\u307e\u3059\uff09\uff0e
  // (b-1) \u30d4\u30af\u30bb\u30eb\u5ea7\u6a19
  public int _viewMouseX() {
    int [] tmp = new int [2];
    tmp = reverseBaseConv(tmp, mouseX - vx, mouseY -vy);
    return tmp[0];
  }
  public int _viewMouseY() {
    int [] tmp = new int [2];
    tmp = reverseBaseConv(tmp, mouseX - vx, mouseY - vy);
    return tmp[1];
  }
  // (b-2) \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19
  public float viewMouseX() { return rpx(_viewMouseX()); }
  public float viewMouseY() { return rpy(_viewMouseY()); }
}

// Tomahawk\u672c\u4f53\u30af\u30e9\u30b9\uff08Crowbar\u306b\u7d99\u627f\u3055\u308c\u307e\u3059\uff09
class tomahawkClass {
  protected int               viewMax;       // \u5ba3\u8a00\u6e08\u307f\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u6570
  protected int               cvNumber;      // \u73fe\u5728\u6ce8\u76ee\u3057\u3066\u3044\u308b\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u756a\u53f7
  protected viewportClass     cv;            // \u73fe\u5728\u6ce8\u76ee\u3057\u3066\u3044\u308b\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30af\u30e9\u30b9
  protected viewportClass []  viewStack;     // \u5ba3\u8a00\u6e08\u307f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8
  protected viewportClass []  cloneStack;    // Options(), Setup()\u3067\u5ba3\u8a00\u3057\u305f\u72b6\u614b\u3092\u30d0\u30c3\u30af\u30a2\u30c3\u30d7\uff06\u30ea\u30b9\u30c8\u30a2\u3059\u308b\u305f\u3081\u306e\u9818\u57df
  protected int []            layerStack;    // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8868\u793a\u9806\u306e\u30b9\u30bf\u30c3\u30af(viewLayerPush(), viewLayerPop()\u5c02\u7528\uff09
  protected int               tomahawkMode;  // mode == 0: noTomahawk, 1: Basic, 2: Advanced
  tomahawkClass(int mode) {
//  background(_BGCOLOR);  // Crowbar\u3067\u6307\u5b9a\u3059\u308b\u80cc\u666f\u8272\u3067\u521d\u671f\u5316
    viewStack    = (viewportClass [])new viewportClass[1];  // \u914d\u5217\u3092\u4e00\u3064\u3060\u3051\u78ba\u4fdd\u3059\u308b\uff08\u3042\u3068\u3067\u5ba3\u8a00\u3055\u308c\u308b\u5ea6\u306b\u62e1\u5f35\u3059\u308b\uff09
    viewStack[0] = null;
    cloneStack    = (viewportClass [])new viewportClass[1];  // \u914d\u5217\u3092\u4e00\u3064\u3060\u3051\u78ba\u4fdd\u3059\u308b\uff08\u3042\u3068\u3067\u5ba3\u8a00\u3055\u308c\u308b\u5ea6\u306b\u62e1\u5f35\u3059\u308b\uff09
    cloneStack[0] = null;
    cvNumber     = 0;
    cv           = null;
    viewMax      = 0;
    layerStack   = null;
    tomahawkMode = mode;
  }
  // \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u72b6\u614b\u3092\u30d0\u30c3\u30af\u30a2\u30c3\u30d7
  public void backupViewports() {
    int i;
    if (cloneStack == null) return;
    for (i = 0; i < viewMax; i++) cloneStack[i].clone(viewStack[i]);
  }
  // \u30d0\u30c3\u30af\u30a2\u30c3\u30d7\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u72b6\u614b\u3092\u30ea\u30b9\u30c8\u30a2\u3059\u308b
  public void restoreViewports() {
    if (cloneStack == null) return;
    for (int i = 0; i < viewMax; i++) {
      viewStack[i].clone(cloneStack[i]);
      viewStack[i].restore();
    }
    layerStack = null;  // \u521d\u671f\u5316\uff08\u3064\u307e\u308aPush\u3055\u308c\u3066\u3044\u306a\u3044\u72b6\u614b\uff09
    crowbar.clrViewAll();
  }
  // \u30c7\u30d0\u30c3\u30b0\u7528\uff08\u5168\u30d3\u30e5\u30fc\u306e\u60c5\u5831\u3092\u8868\u793a\u3059\u308b\uff09
  public void displayAllViewData() {
    viewportClass vp;
    for (int i = 0; i < viewMax; i++) {
      vp = viewStack[i];
      print(str(i) + ":[" + str(vp.serialNumber) + "]" + vp.label + "/(" + str(vp.vx) + "," + str(vp.vy) + "," + str(vp.width) + "," + str(vp.height) + ")");
      print("-(" + str(vp.wx_min) + "," + str(vp.wy_min) + "," + str(vp.wx_max) + "," + str(vp.wy_max) + ")");
      print(" Color=#" + hex(vp.viewBgColor()) + ":Ratio =[" + str(vp.pixelRatioX) + "," + str(vp.pixelRatioY) + "]:Scale=" + str(vp.viewScale()));
      print(" Offset=" + str(vp.viewOffsetX()) + "," + str(vp.viewOffsetY()) + "Visible:" + str(vp.visible));
      println();
    }
  }
  
  // ----------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u95a2\u9023
  // ----------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8996\u70b9\uff08\u5909\u63db\u30de\u30c8\u30ea\u30c3\u30af\u30b9\uff09\u306e\u4fdd\u5b58\uff08\u30bc\u30ed\u306e\u72b6\u614b\uff09\u3068\u518d\u8a2d\u5b9a
  public void resetView(boolean reset) {
    int i;
    if (viewMax < 1) return;  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u5b58\u5728\u3057\u306a\u3044
    if (!reset) for (i = 0; i < viewMax; i++) getView(i).pg.pushMatrix();
      else      for (i = 0; i < viewMax; i++) getView(i).resetView();
  }

  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u65b0\u898f\u4f5c\u6210\uff08\u6210\u529f\u3057\u305f\u5834\u5408\u306f\u30d3\u30e5\u30fc\u756a\u53f7\u3092\u8fd4\u3059\uff0e\u5931\u6557\u3057\u305f\u5834\u5408\u306f -1 \u3092\u8fd4\u3059\uff09
  // (a) \u30d4\u30af\u30bb\u30eb\u5358\u4f4d\u3067\u6307\u5b9a
  public viewportClass createView(String label, int x, int y, int w, int h) {
    // \u30a8\u30e9\u30fc\u30c1\u30a7\u30c3\u30af
    if (crowbar.checkOptionsSetupOnly("createView()", label, true)) return null;
    if (checkView(label) != null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u3068\u540c\u3058\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u65e2\u306b\u4f5c\u6210\u6e08\u307f\u3067\u3059\uff08\u91cd\u8907\uff09", label, true);
      return null;
    }
    // \u9818\u57df\u78ba\u4fdd
    if (viewMax > 0) {
      viewStack  = (viewportClass [])expand(viewStack,  viewMax + 1);  // \u6700\u521d\u3060\u3051\u306f\u914d\u5217\u6570\uff11\u3067\u78ba\u4fdd\u3055\u308c\u3066\u3044\u308b\u305f\u3081
      cloneStack = (viewportClass [])expand(cloneStack, viewMax + 1);  // \u6700\u521d\u3060\u3051\u306f\u914d\u5217\u6570\uff11\u3067\u78ba\u4fdd\u3055\u308c\u3066\u3044\u308b\u305f\u3081
    }
    if (viewStack.length != viewMax + 1) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30e1\u30e2\u30ea\u306e\u78ba\u4fdd\u306b\u5931\u6557\u3057\u307e\u3057\u305f", null, true);
      return null;  // \u6b63\u3057\u304f\u914d\u5217\u306e\u62e1\u5927\u304c\u3067\u304d\u306a\u304b\u3063\u305f\u5834\u5408
    }
    // \u8ffd\u52a0\u51e6\u7406
    viewMax++;
    cvNumber = viewMax - 1;
    if ((cv = viewStack[cvNumber] = new viewportClass(label, x, y, w, h)) == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30e1\u30e2\u30ea\u306e\u78ba\u4fdd\u306b\u5931\u6557\u3057\u307e\u3057\u305f", null, true);
      return null;  // \u6b63\u3057\u304f\u914d\u5217\u306e\u62e1\u5927\u304c\u3067\u304d\u306a\u304b\u3063\u305f\u5834\u5408
    }
    cloneStack[cvNumber] = new viewportClass(label, x, y, w, h);                               // \u30d0\u30c3\u30af\u30a2\u30c3\u30d7\u9818\u57df\u3092\u78ba\u4fdd
    viewStack[cvNumber].serialNumber = cvNumber;  // \u4f5c\u6210\u9806\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7
    viewStack[cvNumber].layerLevel   = cvNumber;  // \u8868\u793a\u9806
    // \u8272\u60c5\u5831\u306a\u3069\u306e\u30c7\u30d5\u30a9\u30eb\u30c8\u8a2d\u5b9a
    cv.fill(0xFFFFFFFF,   cv.transparency); // \u900f\u660e\u5ea6\u306b\u5bfe\u5fdc\uff0e\u521d\u671f\u8272
    cv.stroke(0xFF000000, cv.transparency); // \u900f\u660e\u5ea6\u306b\u5bfe\u5fdc\uff0e\u521d\u671f\u8272
    cv.world(0, 0, w, h);
    return cv;
  }
  // (b) \u5272\u5408\u3067\u6307\u5b9a\u3059\u308b
  public viewportClass createView(String label, int x, int y, float w, float h) {
    if ((w <= 0.0f) || (h <= 0.0f)) return null;
    // if (w >= 1.0) w = 1.0;  // \u5225\u306b1.0\u3088\u308a\u3082\u5927\u304d\u304f\u3066\u3082\u3044\u3044\u304b
    // if (h >= 1.0) h = 1.0;
    return createView(label, x, y, PApplet.parseInt(crowbar.screenSetting.gwx * w), PApplet.parseInt(crowbar.screenSetting.gwy * h));
  }
  // (c) \u5168\u753b\u9762\u6307\u5b9a\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u4f5c\u6210\u3059\u308b
  public viewportClass createView(String label) { return createView(label, 0, 0, width, height); }

  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u5206\u5272\u3059\u308b\uff0e
  // (a) \u6c34\u5e73\u65b9\u5411
  // (a-1) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7
  public viewportClass splitViewH(int v, String label, float rate) {
    // \u30a8\u30e9\u30fc\u30c1\u30a7\u30c3\u30af
    if ((rate <= 0) || (rate >= 1.0f)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewH()\u306b\u304a\u3044\u3066\u5206\u5272\u5272\u5408\u306f 0 < rate < 1.0\u306e\u7bc4\u56f2\u3067\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044", str(rate), true);
      return null;
    }
    if (isValidViewNumber(v, false) == false) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewH()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63\u3067\u3059", str(v), true);
      return null;
    }
    return splitViewH(v, label, PApplet.parseInt(rate * getView(v).width));
  }
  public viewportClass splitViewH(int v, String label, int w) {
    // \u30a8\u30e9\u30fc\u30c1\u30a7\u30c3\u30af
    if (crowbar.checkOptionsSetupOnly("splitViewH()", label, true)) return null;
    if (isValidViewNumber(v, false) == false) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewH()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63\u3067\u3059", str(v), true);
      return null;
    }
    // \u5206\u5272
    viewportClass vp = getView(v);
    int xL, yL, wL, hL;  // \u5de6\uff08\u5143\uff09
    int xR, yR, wR, hR;  // \u53f3\uff08\u65b0\u898f\uff09
    // \u5909\u308f\u3089\u306a\u3044\u3082\u306e
    xL = vp.vx;
    yL = yR = vp.vy;
    hL = hR = vp.height;
    // width\u306b\u3088\u3063\u3066\u5909\u308f\u308b\u3082\u306e
    if (w > 0) { // \u5de6\u306e\u5e45\u6307\u5b9a
      wL = w;
      wR = vp.width - wL;      
    } else {     // \u53f3\u306e\u5e45\u6307\u5b9a
      wR = -w;
      wL = vp.width - wR;
    }
    xR = xL + wL;
    // \u30c1\u30a7\u30c3\u30af
    if ((wL <= 0) || (wR <= 0)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewH()\u306b\u304a\u3044\u3066\u5206\u5272\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e00\u65b9\u306e\u5e45\u304c\u30bc\u30ed\u4ee5\u4e0b\u3067\u3059", label, true);
      return null;
    }
    // \u5de6\u306e\u7e2e\u5c0f
    vp.width = wL;
    cv.world(0, 0, vp.width, vp.height);
    // \u7d42\u308f\u3063\u305f\u3089\u53f3\u3092\u65b0\u898f\u4f5c\u6210
    if (createView(label, xR, yR, wR, hR) == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewH()\u306b\u304a\u3044\u3066\u65b0\u3057\u3044\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4f5c\u6210\u306b\u5931\u6557\u3057\u307e\u3057\u305f", label, true);
      return null;
    }
    cv.cloneAttr(vp);  // \u5c5e\u6027\u306e\u30b3\u30d4\u30fc
    return cv;
  }
  // (a-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb
  public viewportClass splitViewH(String target, String label, float rate) {
    viewportClass vp = getView(target);
    if (vp == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewH()\u3067\u53c2\u7167\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u304c\u4e0d\u6b63\u3067\u3059", target, true);
      return null;
    }
    return splitViewH(vp.serialNumber, label, rate);
  }
  public viewportClass splitViewH(String target, String label, int w) {
    viewportClass vp = getView(target);
    if (vp == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewH()\u3067\u53c2\u7167\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u304c\u4e0d\u6b63\u3067\u3059", target, true);
      return null;
    }
    return splitViewH(vp.serialNumber, label, w);
  }
  // (a-3) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8
  public viewportClass splitViewH(String label, float rate) { return splitViewH(cvNumber, label, rate); }
  public viewportClass splitViewH(String label, int w)      { return splitViewH(cvNumber, label, w);    }

  // (b) \u5782\u76f4\u65b9\u5411
  // (b-1) \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7
  public viewportClass splitViewV(int v, String label, float rate) {
    // \u30a8\u30e9\u30fc\u30c1\u30a7\u30c3\u30af
    if ((rate <= 0) || (rate >= 1.0f)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewV()\u306b\u304a\u3044\u3066\u5206\u5272\u5272\u5408\uff08\u7b2c\u4e8c\u5f15\u6570\uff09\u306f 0 < rate < 1.0\u306e\u7bc4\u56f2\u3067\u6307\u5b9a\u3057\u3066\u4e0b\u3055\u3044", label, true);
      return null;
    }
    if (isValidViewNumber(v, false) == false) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewV()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63\u3067\u3059", str(v), true);
      return null;
    }
    return splitViewV(v, label, PApplet.parseInt(rate * getView(v).height));
  }
  public viewportClass splitViewV(int v, String label, int h) {
    // \u30a8\u30e9\u30fc\u30c1\u30a7\u30c3\u30af
    if (crowbar.checkOptionsSetupOnly("splitViewV()", label, true)) return null;
    if (isValidViewNumber(v, false) == false) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewV()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63\u3067\u3059", str(v), true);
      return null;
    }
    // \u5206\u5272
    viewportClass vp = getView(v);
    int xU, yU, wU, hU;  // \u4e0a\uff08\u5143\uff09
    int xL, yL, wL, hL;  // \u4e0b\uff08\u65b0\u898f\uff09
    // \u5909\u308f\u3089\u306a\u3044\u3082\u306e
    xU = xL = vp.vx;
    yU = vp.vy;
    wU = wL = vp.width;
    // h\u306b\u3088\u3063\u3066\u5909\u308f\u308b\u3082\u306e
    if (h > 0) { // \u4e0a\u306e\u9ad8\u3055\u6307\u5b9a
      hU = h;
      hL = vp.height - hU;      
    } else {     // \u4e0b\u306e\u9ad8\u3055\u6307\u5b9a
      hL = -h;
      hU = vp.height - hL;
    }
    yL = yU + hU;
    // \u30c1\u30a7\u30c3\u30af
    if ((hU <= 0) || (hL <= 0)) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewV()\u306b\u304a\u3044\u3066\u5206\u5272\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e00\u65b9\u306e\u9ad8\u3055\u304c\u30bc\u30ed\u4ee5\u4e0b\u3067\u3059", label, true);
      return null;
    }
    // \u4e0a\u306e\u7e2e\u5c0f
    vp.height = hU;
    cv.world(0, 0, vp.width, vp.height);
    // \u7d42\u308f\u3063\u305f\u3089\u4e0b\u3092\u65b0\u898f\u4f5c\u6210
    if (createView(label, xL, yL, wL, hL) == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewV()\u306b\u304a\u3044\u3066\u65b0\u3057\u3044\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4f5c\u6210\u306b\u5931\u6557\u3057\u307e\u3057\u305f", label, true);
      return null;
    }
    cv.cloneAttr(vp);  // \u5c5e\u6027\u306e\u30b3\u30d4\u30fc
    return cv;
  }
  // (b-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb
  public viewportClass splitViewV(String target, String label, float rate) {
    viewportClass vp = getView(target);
    if (vp == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewV()\u3067\u53c2\u7167\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u304c\u4e0d\u6b63\u3067\u3059", target, true);
      return null;
    }
    return splitViewV(vp.serialNumber, label, rate);
  }
  public viewportClass splitViewV(String target, String label, int h) {
    viewportClass vp = getView(target);
    if (vp == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewV()\u3067\u53c2\u7167\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u304c\u4e0d\u6b63\u3067\u3059", target, true);
      return null;
    }
    return splitViewV(vp.serialNumber, label, h);
  }
  // (b-3) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8
  public viewportClass splitViewV(String label, float rate) { return splitViewV(cvNumber, label, rate); }
  public viewportClass splitViewV(String label, int h)      { return splitViewV(cvNumber, label, h);    }

  // \u5168\u304f\u540c\u4e00\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u8907\u88fd\u3059\u308b
  // (1) \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7
  public viewportClass cloneView(int v, String label) {
    if (crowbar.checkOptionsSetupOnly("cloneView()", label, true)) return null;
    if (isValidViewNumber(v, false) == false) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "splitViewV()\u306b\u304a\u3044\u3066\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63\u3067\u3059", str(v), true);
      return null;
    }
    viewportClass vp = getView(v);
    cv = createView(label, vp.vx, vp.vy, vp.width, vp.height);
    cv.cloneAttr(vp);  // \u5c5e\u6027\u306e\u30b3\u30d4\u30fc
    cv.cloneWorld(vp); // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u306e\u30b3\u30d4\u30fc
    return cv;
  }
  // (2) \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb
  public viewportClass cloneView(String target, String label) {
    viewportClass vp = getView(target);
    if (vp == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "cloneView()\u3067\u53c2\u7167\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u304c\u4e0d\u6b63\u3067\u3059", target, true);
      return null;
    }
    return cloneView(vp.serialNumber, label);
  }
  // (3) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8
  public viewportClass cloneView(String label) { return cloneView(cvNumber, label); }

  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u756a\u306f\u6b63\u3057\u3044\u304b\uff1f
  public boolean isValidViewNumber(int v) { return isValidViewNumber(v, true); }
  public boolean isValidViewNumber(int v, boolean error) {
    if ((v >= viewMax) || (v < 0) || (v > viewStack.length)) {
      if (error) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u306f\u4e0d\u6b63\u3067\u3059", str(v), false);
      return false;
    }
    return true;
  }
  
  // ----------------------------------
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306b\u5207\u308a\u66ff\u3048\u308b
  // ----------------------------------
  // (a) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u8fd4\u3059
  public int view() { return cvNumber; }
  // (b) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u9078\u629e\uff08\u6210\u529f\u3057\u305f\u5834\u5408\u306ftrue\uff09
  // (b-1) \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8
  public viewportClass view(int n) {
    if (isValidViewNumber(n, false) == false) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "view()\u3067\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63\u3067\u3059", str(n), true);
      return null;
    }
    cvNumber = n;
    cv = viewStack[cvNumber];
    return cv;
  }
  // (b-2) \u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8
  public viewportClass view(String label) {
    viewportClass vp = getView(label);
    if (vp == null) return null;
    cvNumber = vp.serialNumber;
    cv = vp;
    return cv;
  }
  // (c) \u76f8\u5bfe\u7684/\u7d76\u5bfe\u7684\u306a\u79fb\u52d5
  // (c-1) \u4e00\u3064\u6b21\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3078\uff08\u884c\u304d\u904e\u304e\u305f\u5834\u5408\u306f-1\u3092\u8fd4\u3059\uff09
  public viewportClass nextView() {
    if (++cvNumber >= viewMax) return null;
    return view(cvNumber);
  }
  // (c-2) \u4e00\u3064\u524d\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3078\uff08\u623b\u308a\u904e\u304e\u305f\u5834\u5408\u306f-1\u3092\u8fd4\u3059\uff09
  public viewportClass prevView() {
    if (--cvNumber < 0) return null;
    return view(cvNumber);
  }
  // (c-3) \u6700\u521d\u306b\u78ba\u4fdd\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3078
  public viewportClass firstView() { return view(0); }
  // (c-4) \u6700\u5f8c\u306b\u78ba\u4fdd\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3078
  public viewportClass lastView()  { return view(viewMax - 1); }

  // ------------------------------------
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30af\u30e9\u30b9\u3092\u8fd4\u3059
  // ------------------------------------
  // (a) \u6307\u5b9a\u3055\u308c\u305f\u756a\u53f7\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30af\u30e9\u30b9\u3092\u8fd4\u3059
  public viewportClass _getView(int v, boolean error) {
    if (isValidViewNumber(v) == false) {
      if (error) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u306f\u4e0d\u6b63\u3067\u3059", str(v), true);
      return null;
    }
    return viewStack[v];
  }
  public viewportClass getView(int v)   { return _getView(v, true);  }  // \u30a8\u30e9\u30fc\u8868\u793a\u3059\u308b
  public viewportClass checkView(int v) { return _getView(v, false); }  // \u30a8\u30e9\u30fc\u8868\u793a\u3057\u306a\u3044\uff08\u7121\u3044\u3053\u3068\u3092\u78ba\u8a8d\u3059\u308b\u5834\u5408\u7528\uff09
  // (b) \u6307\u5b9a\u3055\u308c\u305f\u30e9\u30d9\u30eb\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30af\u30e9\u30b9\u3092\u8fd4\u3059\uff08\u5927\u6587\u5b57\u5c0f\u6587\u5b57\u306f\u533a\u5225\u3057\u306a\u3044\uff09
  public viewportClass _getView(String label, boolean error) {
//  for (int v = 0; v < viewMax; v++) if (viewStack[v].label.toUpperCase().equals(label.toUpperCase()) == true) return viewStack[v];
    for (int v = 0; v < viewMax; v++) if (viewStack[v].label.equals(label.toUpperCase()) == true) return viewStack[v];
    if (error) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u306f\u4e0d\u6b63\u3067\u3059", label, false);
    return null;
  }
  public viewportClass getView(String label)   { return _getView(label, true);  }  // \u30a8\u30e9\u30fc\u8868\u793a\u3059\u308b
  public viewportClass checkView(String label) { return _getView(label, false); }  // \u30a8\u30e9\u30fc\u8868\u793a\u3057\u306a\u3044\uff08\u7121\u3044\u3053\u3068\u3092\u78ba\u8a8d\u3059\u308b\u5834\u5408\u7528\uff09
  // (c) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30af\u30e9\u30b9\u3092\u8fd4\u3059\uff08\u4e0d\u8981\u3060\u3051\u308c\u3069\u4e00\u5fdc\uff09
  public viewportClass getView() {
    if (cv == null) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u307e\u3060\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306f\u4e00\u3064\u3082\u4f5c\u6210\u3055\u308c\u3066\u3044\u306a\u3044\u306e\u306b\u53c2\u7167\u3057\u3088\u3046\u3068\u3057\u307e\u3057\u305f", "getView()", false);
    return cv;
  }
  public viewportClass checkView() { return cv; }
  // ----------------------------------------------
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u8fd4\u3059
  // ----------------------------------------------
  // (a) \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u8fd4\u3059\uff08\u898b\u4ed8\u304b\u3089\u306a\u3044\u5834\u5408\u306f -1\uff09
  public int  _getViewNumber(String label, boolean error) {
    viewportClass vp = _getView(label, error);
    if (vp == null) return -1;
    return vp.serialNumber;
  }
  public int getViewNumber(String label)   { return _getViewNumber(label, true);  }  // \u30a8\u30e9\u30fc\u8868\u793a\u3059\u308b
  public int checkViewNumber(String label) { return _getViewNumber(label, false); }  // \u30a8\u30e9\u30fc\u8868\u793a\u3057\u306a\u3044\uff08\u7121\u3044\u3053\u3068\u3092\u78ba\u8a8d\u3059\u308b\u5834\u5408\u7528\uff09
  // (b) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u8fd4\u3059\uff08\u4e0d\u8981\u3060\u3051\u308c\u3069\u4e00\u5fdc\uff09
  public int getViewNumber(boolean error) {
    if (cv == null) crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u307e\u3060\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306f\u4e00\u3064\u3082\u4f5c\u6210\u3055\u308c\u3066\u3044\u306a\u3044\u306e\u306b\u53c2\u7167\u3057\u3088\u3046\u3068\u3057\u307e\u3057\u305f", "getView()", false);
    return cvNumber;
  }
  public int checkViewNumber() { return cvNumber; }
  // ------------------------------------------------
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u8fd4\u3059
  // ------------------------------------------------
  public String getViewLabel() {
    if (cv == null) return "";
    return cv.label;
  }
  public String getViewLabel(int v) {
    viewportClass vp = checkView(v);
    if (vp == null) return "";
    return vp.label;
  }
  // \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306f\u3053\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u304b\uff1f
  public boolean isView(String name) {
    if (cv == null) return false;
    name = name.toUpperCase();
    if (getViewLabel().equals(name)) return true;
    return false;
  }
 
  // ----------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e0a\u4e0b\u95a2\u4fc2\u306e\u79fb\u52d5
  // ----------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8868\u793a\u9806\u3092\u8868\u308f\u3059\u884c\u5217\u3092\u8fd4\u3059
  public int [] getViewOrderList() {
    int [] order = new int[viewMax];
    for (int i = 0; i < viewMax; i++) order[viewStack[i].layerLevel] = i;
    return order;
  }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8868\u793a\u9806\u30ea\u30b9\u30c8\u3092\u5b9f\u969b\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30c7\u30fc\u30bf\u306b\u66f8\u304d\u623b\u3059
  public void updateViewOrder(int [] order) {
    for (int i = 0; i < viewMax; i++) viewStack[order[i]].layerLevel = i;
  }
  // --------------
  // \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8868\u793a\u9806\u3092\u4e00\u756a\u4e0a\u306b\u79fb\u3059
  public viewportClass viewMoveToTop(int v) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    viewportClass vp = view(v);
    if (viewMax <= 1) return vp;  // \u4e0d\u8981\u306a\u306e\u3067
    int i;
    int [] order = getViewOrderList();
    for (i = viewStack[v].layerLevel; i < viewMax - 1; i++) order[i] = order[i + 1];
    order[i] = v;
    updateViewOrder(order);
    return vp;
  }
  public viewportClass viewMoveToTop(String label) { return viewMoveToTop(getViewNumber(label)); }
  public viewportClass viewMoveToTop()             { return viewMoveToTop(cvNumber); }
  // \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8868\u793a\u9806\u3092\u4e00\u756a\u4e0b\u306b\u79fb\u3059
  public viewportClass viewMoveToBottom(int v) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    viewportClass vp = view(v);
    if (viewMax <= 1) return vp;  // \u4e0d\u8981\u306a\u306e\u3067
    int i;
    int [] order = getViewOrderList();
    for (i = viewStack[v].layerLevel; i > 0; i--) order[i] = order[i - 1];
    order[0] = v;
    updateViewOrder(order);
    return vp;
  }
  public viewportClass viewMoveToBottom(String label) { return viewMoveToBottom(getViewNumber(label)); }
  public viewportClass viewMoveToBottom()             { return viewMoveToBottom(cvNumber);            }
  // \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e0a\u306b\u79fb\u3059\uff0e
  // \u4e8c\u3064\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public viewportClass viewMoveToAbove(int vt, int vr) {
    if ((isValidViewNumber(vt) == false) || (isValidViewNumber(vr) == false)) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    viewportClass vp = view(vt);
    if (viewMax <= 1) return vp;  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u4e00\u3064\u306e\u5834\u5408\u306f\u7121\u52b9
    int it, ir;
    it = viewStack[vt].layerLevel;
    ir = viewStack[vr].layerLevel;
    if (it == viewMax - 1) return vp; // \u65e2\u306b\u4e00\u756a\u4e0a
    return viewMoveToRel(vt, ir - it + 1);
  }
  public viewportClass viewMoveToAbove(String label1, String label2) { return viewMoveToAbove(getViewNumber(label1), getViewNumber(label2)); }
  // \u4e00\u3064\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a\uff08\u79fb\u52d5\u5148\u306e\u307f\uff09
  public viewportClass viewMoveToAbove(int vr)                       { return viewMoveToAbove(cvNumber, vr); }
  public viewportClass viewMoveToAbove(String label)                 { return viewMoveToAbove(cvNumber, getViewNumber(label)); }
  // \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e0b\u306b\u79fb\u3059\uff0e
  // \u4e8c\u3064\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public viewportClass viewMoveToBelow(int vt, int vr) {
    if ((isValidViewNumber(vt) == false) || (isValidViewNumber(vr) == false)) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    viewportClass vp = view(vt);
    if (viewMax <= 1) return vp; // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u4e00\u3064\u306e\u5834\u5408\u306f\u7121\u52b9
    int it, ir;
    it = viewStack[vt].layerLevel;
    ir = viewStack[vr].layerLevel;
    if (it == 0) return vp;   // \u65e2\u306b\u4e00\u756a\u4e0b
    return viewMoveToRel(vt, ir - it - 1);
  }
  public viewportClass viewMoveToBelow(String label1, String label2) { return viewMoveToBelow(getViewNumber(label1), getViewNumber(label2)); }
  // \u4e00\u3064\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a\uff08\u79fb\u52d5\u5148\u306e\u307f\uff09
  public viewportClass viewMoveToBelow(int vr)                       { return viewMoveToBelow(cvNumber, vr); }
  public viewportClass viewMoveToBelow(String label)                 { return viewMoveToBelow(cvNumber, getViewNumber(label)); }
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a\u3055\u308c\u305f\u6570\u3060\u3051\u4e0a\u4e0b\u306b\u79fb\u3059
  public viewportClass viewMoveToRel(int v, int num) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    viewportClass vp = view(v);
    if (viewMax <= 1) return vp;   // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u4e00\u3064\u306e\u5834\u5408\u306f\u7121\u52b9
    if (num == 0) return vp;  // \u79fb\u52d5\u3059\u308b\u5fc5\u8981\u306a\u3057
    if ((v + num) <= 0)                viewMoveToTop(v);      // \u4e00\u756a\u4e0a\u306b
    else if ((v + num) >= viewMax - 1) viewMoveToBottom(v);   // \u4e00\u756a\u4e0b\u306b
    else {
      int [] order = getViewOrderList();
      int it = viewStack[v].layerLevel;
      int i;
      if (num < 0) for (i = it; i > it + num; i--) order[i] = order[i - 1]; // \u4e0b\u306b
      else         for (i = it; i < it + num; i++) order[i] = order[i + 1]; // \u4e0a\u306b
      order[i] = v;
      updateViewOrder(order);
    }
    return vp;
  }
  public viewportClass viewMoveToRel(String label, int num)   { return viewMoveToRel(getViewNumber(label), num); }
  public viewportClass viewMoveToRel(int num)                 { return viewMoveToRel(cvNumber, num);  }
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a\u3055\u308c\u305f\u6570\u3060\u3051\u4e0a\u306b\u79fb\u3059
  public viewportClass viewMoveToUpper(int v, int num)        { return viewMoveToRel(v, num);     }
  public viewportClass viewMoveToUpper(String label, int num) { return viewMoveToRel(label, num); }
  public viewportClass viewMoveToUpper(int num)               { return viewMoveToRel(num);        }
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a\u3055\u308c\u305f\u6570\u3060\u3051\u4e0b\u306b\u79fb\u3059
  public viewportClass viewMoveToLower(int v, int num)        { return viewMoveToRel(v, -num);     }
  public viewportClass viewMoveToLower(String label, int num) { return viewMoveToRel(label, -num); }
  public viewportClass viewMoveToLower(int num)               { return viewMoveToRel(-num);        }
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u4e00\u3064\u4e0a\u306b\u79fb\u3059
  public viewportClass viewMoveToUp(int v)           { return viewMoveToUpper(v, 1);     }
  public viewportClass viewMoveToUp(String label)    { return viewMoveToUpper(label, 1); }
  public viewportClass viewMoveToUp()                { return viewMoveToUpper(1);        }
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u4e00\u3064\u4e0b\u306b\u79fb\u3059
  public viewportClass viewMoveToDown(int v)         { return viewMoveToLower(v, 1);     }
  public viewportClass viewMoveToDown(String label)  { return viewMoveToLower(label, 1); }
  public viewportClass viewMoveToDown()              { return viewMoveToLower(1);        }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e26\u3073\u9806\u3092\u521d\u671f\u72b6\u614b\uff08\u4f5c\u6210\u9806\uff09\u306b\u623b\u3059
  public void viewLayerReset() {
    if (viewMax <= 1) return;                   // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u4e00\u3064\u306e\u5834\u5408\u306f\u7121\u52b9
    int [] order = getViewOrderList();
    for (int i = 0; i < viewMax; i++) order[i] = i;
    updateViewOrder(order);
  }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e26\u3073\u9806\u3092\u8a18\u9332\u3059\u308b
  public void viewLayerPush() {
    if (viewMax <= 1) return;                   // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u4e00\u3064\u306e\u5834\u5408\u306f\u7121\u52b9
    layerStack = getViewOrderList();
  }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e26\u3073\u9806\u3092\u5fa9\u5143\u3059\u308b
  public boolean viewLayerPop() {
    if (viewMax <= 1) return true;              // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u4e00\u3064\u306e\u5834\u5408\u306f\u7121\u52b9
    if (layerStack == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e26\u3073\u9806\u306e\u8a18\u9332\u524d\u306bviewLayerPop()\u304c\u547c\u3070\u308c\u307e\u3057\u305f", null, true);
      return false;
    }
    int [] order = getViewOrderList();
    if (layerStack.length != viewMax) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e26\u3073\u9806\u3092\u5fa9\u5143\u3057\u3088\u3046\u3068\u3057\u307e\u3057\u305f\u304c\u30b9\u30bf\u30c3\u30af\u306e\u30b5\u30a4\u30ba\u304c\u7570\u306a\u308a\u307e\u3059", null, true);
      return false;
    }
    for (int i = 0; i < viewMax; i++) order[i] = layerStack[i];
    updateViewOrder(order);
    return true;
  }

  // ----------------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u67a0\u7dda\u3084\u4e0d\u900f\u660e\u5ea6\u306e\u8a2d\u5b9a
  // ----------------------------------
  // (a) \u30d5\u30ec\u30fc\u30e0\u30ab\u30e9\u30fc
  // (a-1) \u30d5\u30ec\u30fc\u30e0\u30ab\u30e9\u30fc\u306e\u53d6\u5f97
  public int getFrameColor(int v) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).frameColor();
  }
  public int getFrameColor(String label) { return getFrameColor(getViewNumber(label)); }
  public int getFrameColor()             { return getFrameColor(cvNumber);       }
  // (a-2) \u30d5\u30ec\u30fc\u30e0\u30ab\u30e9\u30fc\u306e\u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public int setFrameColor(int v, int c) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    int oldcolor = getFrameColor(v);
    getView(v).frameColor(c);
    return oldcolor;
  }
  public int setFrameColor(String label, int c) { return setFrameColor(getViewNumber(label), c); }
  public int setFrameColor(int c)               { return setFrameColor(cvNumber, c);             }
  public viewportClass frameColor(int v, int c) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).frameColor(c);
  }
  public viewportClass frameColor(String label, int c) { return frameColor(getViewNumber(label), c); }
  public viewportClass frameColor(int c)               { return frameColor(cvNumber, c);             }
  // (b) \u30d5\u30ec\u30fc\u30e0\u306e\u8868\u793a\uff0f\u975e\u8868\u793a
  // (b-1) \u72b6\u614b\u53d6\u5f97
  public boolean isDrawFrame(int v) {
    if (isValidViewNumber(v) == false) return false;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).drawFrame();
  }
  public boolean isDrawFrame(String label) { return isDrawFrame(getViewNumber(label)); }
  public boolean isDrawFrame()             { return isDrawFrame(cvNumber);             }
  // (b-2) \u8a2d\u5b9a\u5909\u66f4\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public boolean setDrawFrame(int v, boolean flag) {
    if (isValidViewNumber(v) == false) return false;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setDrawFrame(flag);
  }
  public boolean setDrawFrame(String label, boolean flag) { return setDrawFrame(getViewNumber(label), flag); }
  public boolean setDrawFrame(boolean flag)               { return setDrawFrame(cvNumber, flag);             }
  public viewportClass drawFrame(int v, boolean flag) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).drawFrame(flag);
  }
  public viewportClass drawFrame(String label, boolean flag) { return drawFrame(getViewNumber(label), flag); }
  public viewportClass drawFrame(boolean flag)               { return drawFrame(cvNumber, flag);             }
  // (c) \u30d5\u30ec\u30fc\u30e0\u5e45
  // (c-1) \u30d5\u30ec\u30fc\u30e0\u5e45\u306e\u53d6\u5f97
  public int getFrameWidth(int v) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).frameWidth();
  }
  public int getFrameWidth(String label) { return getFrameWidth(getViewNumber(label)); }
  public int getFrameWidth()             { return getFrameWidth(cvNumber);             }
  // (c-2) \u8a2d\u5b9a\u5909\u66f4\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public int setFrameWidth(int v, int w) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setFrameWidth(w);
  }
  public int setFrameWidth(String label, int w) { return setFrameWidth(getViewNumber(label), w); }
  public int setFrameWidth(int w)               { return setFrameWidth(cvNumber, w);             }
  public viewportClass frameWidth(int v, int w) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).frameWidth(w);
  }
  public viewportClass frameWidth(String label, int w) { return frameWidth(getViewNumber(label), w); }
  public viewportClass frameWidth(int w)               { return frameWidth(cvNumber, w);             }
  // (d) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u80cc\u666f\u8272\u95a2\u4fc2
  // (d-1) \u80cc\u666f\u8272\u306e\u53d6\u5f97
  public int getViewBgColor(int v) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewBgColor();
  }
  public int getViewBgColor(String label) { return getViewBgColor(getViewNumber(label)); }
  public int getViewBgColor()             { return getViewBgColor(cvNumber);             }
  // (d-2) \u80cc\u666f\u8272\u306e\u5909\u66f4\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public int setViewBgColor(int v, int c) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setViewBgColor(c);
  }
  public int setViewBgColor(String label, int c) { return setViewBgColor(getViewNumber(label), c); }
  public int setViewBgColor(int c)               { return setViewBgColor(cvNumber, c);             }
  public viewportClass viewBgColor(int v, int c) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewBgColor(c);
  }
  public viewportClass viewBgColor(String label, int c) { return viewBgColor(getViewNumber(label), c); }
  public viewportClass viewBgColor(int c)               { return viewBgColor(cvNumber, c);             }
  // (e) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u80cc\u666f\u3092\u900f\u660e\u306b\u3059\u308b\u304b\uff1f\uff08true\u3067\u900f\u660e\uff09
  // (e-1) \u72b6\u614b\u3092\u53d6\u5f97
  public boolean isTransparentView(int v) {
    if (isValidViewNumber(v) == false) return false;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).transparentView;
  }
  public boolean isTransparentView(String label) { return isTransparentView(getViewNumber(label)); }
  public boolean isTransparentView()             { return isTransparentView(cvNumber);            }
  // (e-2) \u8a2d\u5b9a\u5909\u66f4\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public boolean setTransparentView(int v, boolean flag) {
    if (isValidViewNumber(v) == false) return false;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setTransparentView(flag);    
  }
  public boolean setTransparentView(String label, boolean flag) { return setTransparentView(getViewNumber(label), flag); }
  public boolean setTransparentView(boolean flag)               { return setTransparentView(cvNumber, flag);             }
  public viewportClass transparentView(int v, boolean flag) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).transparentView(flag);    
  }
  public viewportClass transparentView(String label, boolean flag) { return transparentView(getViewNumber(label), flag); }
  public viewportClass transparentView(boolean flag)               { return transparentView(cvNumber, flag);             }
  // (f) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u81ea\u4f53\u306e\u4e0d\u900f\u660e\u5ea6\u306e\u5909\u66f4
  // (f-1) \u72b6\u614b\u3092\u53d6\u5f97
  public int getTransparency(int v) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).transparency();
  }
  public int getTransparency(String label) { return getTransparency(getViewNumber(label)); }
  public int getTransparency()             { return getTransparency(cvNumber);             }
  // (f-2) \u4e0d\u900f\u660e\u5ea6\u306e\u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public int setTransparency(int v, int trans) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setTransparency(trans);
  }
  public int setTransparency(String label, int trans) { return setTransparency(getViewNumber(label), trans); }
  public int setTransparency(int trans)               { return setTransparency(cvNumber, trans);             }
  public viewportClass transparency(int v, int trans) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).transparency(trans);
  }
  public viewportClass transparency(String label, int trans) { return transparency(getViewNumber(label), trans); }
  public viewportClass transparency(int trans)               { return transparency(cvNumber, trans);             }

  // ------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4f4d\u7f6e\u306e\u5909\u66f4
  // ------------------------
  // (a) \u6307\u5b9a\u3057\u305f\u4f4d\u7f6e\u306b\u79fb\u52d5
  public viewportClass moveView(int v, int x, int y) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).moveView(x, y);
  }
  public viewportClass moveView(String label, int x, int y) { return moveView(getViewNumber(label), x, y); }
  public viewportClass moveView(int x, int y)               { return moveView(cvNumber, x, y); }
  // (b) \u76f8\u5bfe\u4f4d\u7f6e\u6307\u4ee4
  public viewportClass moveViewRel(int v, int dx, int dy) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).moveViewRel(dx, dy);
  }
  public viewportClass moveViewRel(String label, int dx, int dy) { return moveViewRel(getViewNumber(label), dx, dy); }
  public viewportClass moveViewRel(int dx, int dy)               { return moveViewRel(cvNumber, dx, dy); }

  // \u5ea7\u6a19\u5909\u63db\uff08\u73fe\u5728\u306e\u30d3\u30e5\u30fc\uff09
  // \u5ea7\u6a19\u5909\u63db\uff08\u30ef\u30fc\u30eb\u30c9\u2192\u30d3\u30e5\u30fc\uff1a\u5927\u304d\u3055\u306e\u307f\uff09
  private int _px(float x) { return cv._px(x); }
  private int _py(float y) { return cv._py(y); }
  // \u5ea7\u6a19\u5909\u63db\uff08\u30ef\u30fc\u30eb\u30c9\u2192\u30d3\u30e5\u30fc\uff09
  private int px(float x)  { return cv.px(x); }
  private int py(float y)  { return cv.py(y); }

  // -----------------------------------
  // \u63cf\u753b\u30b3\u30de\u30f3\u30c9\u95a2\u4fc2\uff08\u30e6\u30fc\u30b6\u306b\u3088\u308b\u5229\u7528\uff09
  // -----------------------------------
  // \u5168\u3066\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u753b\u9762\u6d88\u53bb\u3059\u308b\uff08\u73fe\u5728\u306e\u30d3\u30e5\u30fc\u306f\u5909\u66f4\u3057\u306a\u3044\uff09
  // flag\u304ctrue\u306e\u5834\u5408\u306f\u80cc\u666f\u304c\u900f\u660e\uff08transparentView == true)\u306a\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306f\u6d88\u53bb\u3057\u306a\u3044
  public void clrViewAll(boolean flag) {
    int cv = cvNumber;
    int i;
    for (i = 0; i < viewMax; i++) clrView(i, flag);
    if (i > 0) view(cv);
  }
  public void clrViewAll() { clrViewAll(false); }
  // \u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u753b\u9762\u6d88\u53bb\u3059\u308b\uff08\u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u305d\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306b\u79fb\u3059\uff09
  public viewportClass clrView(int v, boolean flag) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    if (view(v) == null) return null;
    cv.clrView(flag);
    return cv;
  }
  public viewportClass clrView(String label, boolean flag) { return getView(label).clrView(flag); }
  public viewportClass clrView(boolean flag)               { return cv.clrView(flag); }
  public viewportClass clrView(int v)                      { return clrView(v, false); }
  public viewportClass clrView(String label)               { return clrView(label, false); }
  public viewportClass clrView()                           { return clrView(false); }

  // ----------------------------------------------
  // \u30d4\u30dc\u30c3\u30c8\uff08\u62e1\u5927\u7e2e\u5c0f\u304a\u3088\u3073\u56de\u8ee2\u306e\u4e2d\u5fc3\u5ea7\u6a19\uff09\u306e\u8a2d\u5b9a
  // ----------------------------------------------
  // (a) \u73fe\u5728\u306e\u30d4\u30dc\u30c3\u30c8\u5ea7\u6a19\u3092\u8fd4\u3059
  public PVector viewPivot(int v) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewPivot();
  }
  public PVector viewPivot(String label) { return viewPivot(getViewNumber(label)); }
  public PVector viewPivot()             { return viewPivot(cvNumber); }
  // (b) \u30d4\u30dc\u30c3\u30c8\u5ea7\u6a19\u306e\u8a2d\u5b9a\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\uff09
  public PVector setViewPivot(int v, float x, float y) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setViewPivot(x, y);
  }
  public PVector setViewPivot(String label, float x, float y) { return setViewPivot(getViewNumber(label), x, y); }
  public PVector setViewPivot(float x, float y)               { return setViewPivot(cvNumber, x, y); }
  public viewportClass viewPivot(int v, float x, float y) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewPivot(x, y);
  }
  public viewportClass viewPivot(String label, float x, float y) { return viewPivot(getViewNumber(label), x, y); }
  public viewportClass viewPivot(float x, float y)               { return viewPivot(cvNumber, x, y); }
  // \u4ee5\u4e0b\u516b\u65b9\u4f4d\uff080:\u4e2d\u592e, 1:\u5de6\u4e0a, 2:\u5de6\u4e0b, 3:\u53f3\u4e0a, 4: \u53f3\u4e0b, 5:\u4e2d\u592e\u4e0a, 6:\u4e2d\u592e\u4e0b, 7:\u5de6\u4e2d\u592e, 8:\u53f3\u4e2d\u592e
  public PVector _setViewPivot(int v, int pos) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    switch (pos) {
      case 0: return getView(v).setViewPivotCenter();
      case 1: return getView(v).setViewPivotLT();
      case 2: return getView(v).setViewPivotLB();
      case 3: return getView(v).setViewPivotRT();
      case 4: return getView(v).setViewPivotRB();
      case 5: return getView(v).setViewPivotCT();
      case 6: return getView(v).setViewPivotCB();
      case 7: return getView(v).setViewPivotLC();
      case 8: return getView(v).setViewPivotRC();
    }
    return null;  // \u4e0d\u6b63\u306a\u30dd\u30b8\u30b7\u30e7\u30f3
  }
  public viewportClass _viewPivot(int v, int pos) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    switch (pos) {
      case 0: return getView(v).viewPivotCenter();
      case 1: return getView(v).viewPivotLT();
      case 2: return getView(v).viewPivotLB();
      case 3: return getView(v).viewPivotRT();
      case 4: return getView(v).viewPivotRB();
      case 5: return getView(v).viewPivotCT();
      case 6: return getView(v).viewPivotCB();
      case 7: return getView(v).viewPivotLC();
      case 8: return getView(v).viewPivotRC();
    }
    return null;  // \u4e0d\u6b63\u306a\u30dd\u30b8\u30b7\u30e7\u30f3
  }
  // (b-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u5fc3
  public PVector setViewPivotCenter(int v)           { return _setViewPivot(v, 0); }
  public PVector setViewPivotCenter(String label)    { return setViewPivotCenter(getViewNumber(label)); }
  public PVector setViewPivotCenter()                { return setViewPivotCenter(cvNumber); }
  public viewportClass viewPivotCenter(int v)        { return _viewPivot(v, 0); }
  public viewportClass viewPivotCenter(String label) { return viewPivotCenter(getViewNumber(label)); }
  public viewportClass viewPivotCenter()             { return viewPivotCenter(cvNumber); }
   // (b-3) \u5de6\u4e0a\uff0c\u5de6\u4e0b\uff0c\u53f3\u4e0a\uff0c\u53f3\u4e0b
  public PVector setViewPivotLT(int v)        { return _setViewPivot(v, 1); }
  public PVector setViewPivotLT(String label) { return setViewPivotLT(getViewNumber(label)); }
  public PVector setViewPivotLT()             { return setViewPivotLT(cvNumber); }
  public PVector setViewPivotLB(int v)        { return _setViewPivot(v, 2); }
  public PVector setViewPivotLB(String label) { return setViewPivotLB(getViewNumber(label)); }
  public PVector setViewPivotLB()             { return setViewPivotLB(cvNumber); }
  public PVector setViewPivotRT(int v)        { return _setViewPivot(v, 3); }
  public PVector setViewPivotRT(String label) { return setViewPivotRT(getViewNumber(label)); }
  public PVector setViewPivotRT()             { return setViewPivotRT(cvNumber); }
  public PVector setViewPivotRB(int v)        { return _setViewPivot(v, 4); }
  public PVector setViewPivotRB(String label) { return setViewPivotRB(getViewNumber(label)); }
  public PVector setViewPivotRB()             { return setViewPivotRB(cvNumber); }
  public PVector setViewPivotCT(int v)        { return _setViewPivot(v, 5); }
  public PVector setViewPivotCT(String label) { return setViewPivotCT(getViewNumber(label)); }
  public PVector setViewPivotCT()             { return setViewPivotCT(cvNumber); }
  public PVector setViewPivotCB(int v)        { return _setViewPivot(v, 6); }
  public PVector setViewPivotCB(String label) { return setViewPivotCB(getViewNumber(label)); }
  public PVector setViewPivotCB()             { return setViewPivotCB(cvNumber); }
  public PVector setViewPivotLC(int v)        { return _setViewPivot(v, 7); }
  public PVector setViewPivotLC(String label) { return setViewPivotLC(getViewNumber(label)); }
  public PVector setViewPivotLC()             { return setViewPivotLC(cvNumber); }
  public PVector setViewPivotRC(int v)        { return _setViewPivot(v, 8); }
  public PVector setViewPivotRC(String label) { return setViewPivotRC(getViewNumber(label)); }
  public PVector setViewPivotRC()             { return setViewPivotRC(cvNumber); }

  public viewportClass viewPivotLT(int v)        { return _viewPivot(v, 1); }
  public viewportClass viewPivotLT(String label) { return viewPivotLT(getViewNumber(label)); }
  public viewportClass viewPivotLT()             { return viewPivotLT(cvNumber); }
  public viewportClass viewPivotLB(int v)        { return _viewPivot(v, 2); }
  public viewportClass viewPivotLB(String label) { return viewPivotLB(getViewNumber(label)); }
  public viewportClass viewPivotLB()             { return viewPivotLB(cvNumber); }
  public viewportClass viewPivotRT(int v)        { return _viewPivot(v, 3); }
  public viewportClass viewPivotRT(String label) { return viewPivotRT(getViewNumber(label)); }
  public viewportClass viewPivotRT()             { return viewPivotRT(cvNumber); }
  public viewportClass viewPivotRB(int v)        { return _viewPivot(v, 4); }
  public viewportClass viewPivotRB(String label) { return viewPivotRB(getViewNumber(label)); }
  public viewportClass viewPivotRB()             { return viewPivotRB(cvNumber); }
  public viewportClass viewPivotCT(int v)        { return _viewPivot(v, 5); }
  public viewportClass viewPivotCT(String label) { return viewPivotCT(getViewNumber(label)); }
  public viewportClass viewPivotCT()             { return viewPivotCT(cvNumber); }
  public viewportClass viewPivotCB(int v)        { return _viewPivot(v, 6); }
  public viewportClass viewPivotCB(String label) { return viewPivotCB(getViewNumber(label)); }
  public viewportClass viewPivotCB()             { return viewPivotCB(cvNumber); }
  public viewportClass viewPivotLC(int v)        { return _viewPivot(v, 7); }
  public viewportClass viewPivotLC(String label) { return viewPivotLC(getViewNumber(label)); }
  public viewportClass viewPivotLC()             { return viewPivotLC(cvNumber); }
  public viewportClass viewPivotRC(int v)        { return _viewPivot(v, 8); }
  public viewportClass viewPivotRC(String label) { return viewPivotRC(getViewNumber(label)); }
  public viewportClass viewPivotRC()             { return viewPivotRC(cvNumber); }

  // ----------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8996\u70b9\u306e\u56de\u8ee2\u89d2\u5ea6
  // ----------------------------
  // (a) \u73fe\u5728\u306e\u89d2\u5ea6\u3092\u8fd4\u3059
  public float viewRotate(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewRotate();
  }
  public float viewRotate(String label) { return viewRotate(getViewNumber(label)); }
  public float viewRotate()             { return viewRotate(cvNumber); }
  // (b) \u8996\u70b9\u306e\u89d2\u5ea6\u3092\u8a2d\u5b9a\u3059\u308b\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float setViewRotate(int v, float a) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setViewRotate(a);
  }
  public float setViewRotate(String label, float a) { return setViewRotate(getViewNumber(label), a); }
  public float setViewRotate(float a)               { return setViewRotate(cvNumber, a); }
  public viewportClass viewRotate(int v, float a) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewRotate(a);
  }
  public viewportClass viewRotate(String label, float a) { return viewRotate(getViewNumber(label), a); }
  public viewportClass viewRotate(float a)               { return viewRotate(cvNumber, a); }
  // (c) \u8996\u70b9\u306e\u89d2\u5ea6\u3092\u5897\u6e1b\u3059\u308b\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float setViewRotateRel(int v, float a) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setViewRotateRel(a);
  }
  public float setViewRotateRel(String label, float a) { return setViewRotateRel(getViewNumber(label), a); }
  public float setViewRotateRel(float a)               { return setViewRotateRel(cvNumber, a);  }
  public viewportClass viewRotateRel(int v, float a) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewRotateRel(a);
  }
  public viewportClass viewRotateRel(String label, float a) { return viewRotateRel(getViewNumber(label), a); }
  public viewportClass viewRotateRel(float a)               { return viewRotateRel(cvNumber, a);  }
  // (d) \u5168\u3066\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u56de\u8ee2\u89d2\u5ea6\u3092\u5909\u66f4\u3059\u308b
  public viewportClass viewRotateAll(float a)    { for (int i = 0; i < viewMax; i++) viewRotate(i, a);    return crowbar.cv; }
  public viewportClass viewRotateRelAll(float a) { for (int i = 0; i < viewMax; i++) viewRotateRel(i, a); return crowbar.cv; }

  // --------
  // \u500d\u7387\u95a2\u4fc2
  // --------
  // (a) \u73fe\u5728\u306e\u500d\u7387\u3092\u8fd4\u3059\uff1a\u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7\u306e\u5834\u5408\u306f1.0\u3092\u8fd4\u3059
  public float viewScale(int v) {
    if (isValidViewNumber(v) == false) return 1.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewScale();
  }
  public float viewScale(String label) { return viewScale(getViewNumber(label)); }
  public float viewScale()             { return viewScale(cvNumber); }
  // (b) \u500d\u7387\u306e\u5024\u3092\u5909\u66f4\u3059\u308b\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09
  public float setViewScale(int v, float a) {
    if (isValidViewNumber(v) == false) return 1.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).setViewScale(a);
  }
  public float setViewScale(String label, float a) { return setViewScale(getViewNumber(label), a); }
  public float setViewScale(float a)               { return setViewScale(cvNumber, a); }
  public viewportClass viewScale(int v, float a) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewScale(a);
  }
  public viewportClass viewScale(String label, float a) { return viewScale(getViewNumber(label), a); }
  public viewportClass viewScale(float a)               { return viewScale(cvNumber, a); }
  // (c) \u5168\u3066\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u500d\u7387\u3092\u6307\u5b9a\u3057\u305f\u500d\u7387\u306b\u5909\u66f4\u3059\u308b
  public viewportClass viewScaleAll(float a) { for (int i = 0; i < viewMax; i++) viewScale(i, a); return crowbar.cv; }

  // ----------------
  // \u30aa\u30d5\u30bb\u30c3\u30c8\u91cf\u95a2\u4fc2
  // ----------------
  // (a) \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30aa\u30d5\u30bb\u30c3\u30c8\u91cf\u3092\u8fd4\u3059
  // (a-1) \uff58\u65b9\u5411
  public float viewOffsetX(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewOffsetX();
  }
  public float viewOffsetX(String label) { return viewOffsetX(getViewNumber(label)); }
  public float viewOffsetX()             { return viewOffsetX(cvNumber); }
  // (a-2) \uff59\u65b9\u5411\uff08\u4e0a\u3092\u6b63\u3068\u3057\u3066\u3044\u308b\u70b9\u306b\u6ce8\u610f\uff09
  public float viewOffsetY(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewOffsetY();
  }
  public float viewOffsetY(String label) { return viewOffsetY(getViewNumber(label)); }
  public float viewOffsetY()             { return viewOffsetY(cvNumber); }
  // (b) \u30aa\u30d5\u30bb\u30c3\u30c8\u91cf\u3092\u5909\u66f4\u3059\u308b\uff08\uff0b\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059\uff09\uff1a\u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8
  // (b-1) \uff58\u65b9\u5411
  public float setViewOffsetX(int v, float offset) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    float oldoffset = getView(v).viewOffsetX();
    getView(v).setViewOffsetX(offset);
    return oldoffset;
  }
  public float setViewOffsetX(String label, float offset) { return setViewOffsetX(getViewNumber(label), offset); }
  public float setViewOffsetX(float offset)               { return setViewOffsetX(cvNumber, offset); }
  public viewportClass viewOffsetX(int v, float offset) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewOffsetX(offset);
  }
  public viewportClass viewOffsetX(String label, float offset) { return viewOffsetX(getViewNumber(label), offset); }
  public viewportClass viewOffsetX(float offset)               { return viewOffsetX(cvNumber, offset); }
  // (b-2) \uff59\u65b9\u5411\uff08\u4e0a\u3092\u6b63\u3068\u3057\u3066\u3044\u308b\u70b9\u306b\u6ce8\u610f\uff09
  public float setViewOffsetY(int v, float offset) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    float oldoffset = getView(v).viewOffsetY();
    getView(v).setViewOffsetY(offset);
    return oldoffset;
  }
  public float setViewOffsetY(String label, float offset) { return setViewOffsetY(getViewNumber(label), offset); }
  public float setViewOffsetY(float offset)               { return setViewOffsetY(cvNumber, offset); }
  public viewportClass viewOffsetY(int v, float offset) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewOffsetY(offset);
  }
  public viewportClass viewOffsetY(String label, float offset) { return viewOffsetY(getViewNumber(label), offset); }
  public viewportClass viewOffsetY(float offset)               { return viewOffsetY(cvNumber, offset); }
  // (b-3) \uff58\u65b9\u5411\uff0f\uff59\u65b9\u5411\u540c\u6642
  public viewportClass viewOffset(int v, float offx, float offy) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    float oldoffset;
    getView(v).setViewOffsetX(offx);
    getView(v).setViewOffsetY(offy);
    return crowbar.cv;
  }
  public viewportClass viewOffset(String label, float offx, float offy) { return viewOffset(getViewNumber(label), offx, offy); }
  public viewportClass viewOffset(float offx, float offy)               { return viewOffset(cvNumber, offx, offy); }
/*
  viewportClass setViewOffset(int v, float offx, float offy) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    getView(v).viewOffsetX(offx);
    return getView(v).setViewOffsetY(offy);
  }
  viewportClass setViewOffset(String label, float offx, float offy) { return setViewOffset(getViewNumber(label), offx, offy); }
  viewportClass setViewOffset(float offx, float offy)               { return setViewOffset(cvNumber, offx, offy); }
*/
  // \u5168\u3066\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8a2d\u5b9a\u3092\u5909\u66f4\u3059\u308b
  public viewportClass viewOffsetXAll(float offset) {
    viewportClass oldcv = cv;
    for (int i = 0; i < viewMax; i++) viewOffsetX(i, offset);
    return oldcv;
  }
  public viewportClass viewOffsetYAll(float offset) {
    viewportClass oldcv = cv;
    for (int i = 0; i < viewMax; i++) viewOffsetY(i, offset);
    return oldcv;
  }
  public viewportClass viewOffsetAll(float offx, float offy) {
    viewportClass oldcv = cv;
    for (int i = 0; i < viewMax; i++) viewOffset(i, offx, offy);
    return oldcv;
  }

  // --------------------
  // \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u306e\u8a2d\u5b9a
  // --------------------
  // \u3010\u53c2\u7167\u3011
  // (a) \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u306e\u8a2d\u5b9a\u5024\u306e\u53c2\u7167\uff1a\u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u6307\u5b9a\u3055\u308c\u305f\u5834\u5408\u306f0.0\u3092\u8fd4\u3059
  // (a-1) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u6307\u5b9a
  public float minX(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).world_minX();
  }
  public float maxX(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).world_maxX();
  }
  public float minY(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).world_minY();
  }
  public float maxY(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).world_maxY();
  }
  // (a-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a
  public float minX(String label) { return minX(getViewNumber(label)); }
  public float maxX(String label) { return maxX(getViewNumber(label)); }
  public float minY(String label) { return minY(getViewNumber(label)); }
  public float maxY(String label) { return maxY(getViewNumber(label)); }
  // (a-3) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public float minX() { return cv.world_minX(); }
  public float maxX() { return cv.world_maxX(); }
  public float minY() { return cv.world_minY(); }
  public float maxY() { return cv.world_maxY(); }
  // \u3010\u5909\u66f4\u3011
  // (a) \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u7cfb\u306e\u5909\u66f4\uff1a\u6210\u529f\u3057\u305f\u5834\u5408\u306ftrue\u3092\u8fd4\u3059
  // (a-1) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u6307\u5b9a
  public viewportClass world(int v, float x1, float y1, float x2, float y2) {
    if (isValidViewNumber(v) == false) {  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a\u3055\u308c\u305f\u5834\u5408\u306a\u3069\uff0c\u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "world()\u3067\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63", str(v), true);
      return null;
    }
    return getView(v).world(x1, y1, x2, y2);
  }
  // (a-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a
  public viewportClass world(String label, float x1, float y1, float x2, float y2) { return world(getViewNumber(label), x1, y1, x2, y2); }
  // (a-3) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public viewportClass world(float x1, float y1, float x2, float y2) {
    if (cv == null) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "world()\u304c\u547c\u3070\u308c\u307e\u3057\u305f\u304c\uff0c\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306f\u4e00\u3064\u3082\u5b58\u5728\u3057\u307e\u305b\u3093", null, true);
      return null;
    }
    return cv.world(x1, y1, x2, y2);
  }
  // (b) \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\uff58\uff0c\uff59\u305d\u308c\u305e\u308c\u306e\u6700\u5c0f\u5024\uff0f\u6700\u5927\u5024\u3092\u500b\u5225\u306b\u5909\u66f4\uff1a\u6210\u529f\u3057\u305f\u5834\u5408\u306ftrue\u3092\u8fd4\u3059
  // (b-1) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u6307\u5b9a
  public viewportClass minX(int v, float x) { return world(v, x, minY(v), maxX(v), maxY(v)); }
  public viewportClass maxX(int v, float x) { return world(v, minX(v), minY(v), x, maxY(v)); }
  public viewportClass minY(int v, float y) { return world(v, minX(v), y, maxX(v), maxY(v)); }
  public viewportClass maxY(int v, float y) { return world(v, minX(v), minY(v), maxX(v), y); }
  public viewportClass worldX(int v, float xmin, float xmax) { return world(v, xmin, minY(v), xmax, maxY(v)); }
  public viewportClass worldY(int v, float ymin, float ymax) { return world(v, minX(v), ymin, maxX(v), ymax); }
  // (b-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a
  public viewportClass minX(String label, float x) { return world(label, x, minY(label), maxX(label), maxY(label)); }
  public viewportClass maxX(String label, float x) { return world(label, minX(label), minY(label), x, maxY(label)); }
  public viewportClass minY(String label, float y) { return world(label, minX(label), y, maxX(label), maxY(label)); }
  public viewportClass maxY(String label, float y) { return world(label, minX(label), minY(label), maxX(label), y); }
  public viewportClass worldX(String label, float xmin, float xmax) { return world(label, xmin, minY(label), xmax, maxY(label)); }
  public viewportClass worldY(String label, float ymin, float ymax) { return world(label, minX(label), ymin, maxX(label), ymax); }
  // (b-3) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public viewportClass minX(float x) { return world(x, minY(), maxX(), maxY()); }
  public viewportClass maxX(float x) { return world(minX(), minY(), x, maxY()); }
  public viewportClass minY(float y) { return world(minX(), y, maxX(), maxY()); }
  public viewportClass maxY(float y) { return world(minX(), minY(), maxX(), y); }
  public viewportClass worldX(float xmin, float xmax) { return world(xmin, minY(), xmax, maxY()); }
  public viewportClass worldY(float ymin, float ymax) { return world(minX(), ymin, maxX(), ymax); }
  // \u3010\u5909\u66f4\uff0b\u8a2d\u5b9a\u524d\u306e\u5024\u3011
  // (b) \u6307\u5b9a\u3057\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\uff58\uff0c\uff59\u305d\u308c\u305e\u308c\u306e\u6700\u5c0f\u5024\uff0f\u6700\u5927\u5024\u3092\u500b\u5225\u306b\u5909\u66f4\uff1a\u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059
  // (c-1) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u6307\u5b9a
  public float setMinX(int v, float x) { float oldvalue = minX(v); world(v, x, minY(v), maxX(v), maxY(v)); return oldvalue; }
  public float setMaxX(int v, float x) { float oldvalue = maxX(v); world(v, minX(v), minY(v), x, maxY(v)); return oldvalue; }
  public float setMinY(int v, float y) { float oldvalue = minY(v); world(v, minX(v), y, maxX(v), maxY(v)); return oldvalue; }
  public float setMaxY(int v, float y) { float oldvalue = maxY(v); world(v, minX(v), minY(v), maxX(v), y); return oldvalue; }
  // (c-2) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a
  public float setMinX(String label, float x) { float oldvalue = minX(label); world(label, x, minY(label), maxX(label), maxY(label)); return oldvalue; }
  public float setMaxX(String label, float x) { float oldvalue = maxX(label); world(label, minX(label), minY(label), x, maxY(label)); return oldvalue; }
  public float setMinY(String label, float y) { float oldvalue = minY(label); world(label, minX(label), y, maxX(label), maxY(label)); return oldvalue; }
  public float setMaxY(String label, float y) { float oldvalue = maxY(label); world(label, minX(label), minY(label), maxX(label), y); return oldvalue; }
  // (c-3) \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public float setMinX(float x) { float oldvalue = minX(); world(x, minY(), maxX(), maxY()); return oldvalue; }
  public float setMaxX(float x) { float oldvalue = maxX(); world(minX(), minY(), x, maxY()); return oldvalue; }
  public float setMinY(float y) { float oldvalue = minY(); world(minX(), y, maxX(), maxY()); return oldvalue; }
  public float setMaxY(float y) { float oldvalue = maxY(); world(minX(), minY(), maxX(), y); return oldvalue; }
  
  // \u3010\u5909\u66f4\u3011 \u30d4\u30af\u30bb\u30eb\u6bd4\u306e\u307f\u3092\u6307\u5b9a\uff08\u5f15\u6570\u306a\u3057\uff1d\u30d4\u30af\u30bb\u30eb\u6bd4\u306f\u5909\u3048\u306a\u3044\uff09
  // \u4ee5\u4e0b\u516b\u65b9\u4f4d\uff080:\u4e2d\u592e, 1:\u5de6\u4e0a, 2:\u5de6\u4e0b, 3:\u53f3\u4e0a, 4: \u53f3\u4e0b, 5:\u4e2d\u592e\u4e0a, 6:\u4e2d\u592e\u4e0b, 7:\u5de6\u4e2d\u592e, 8:\u53f3\u4e2d\u592e
  public viewportClass _world(int v, int pos) {
    if (isValidViewNumber(v) == false) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "_world()\u3067\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63", str(v), true);
      return null;
    }
    switch (pos) {
      case 0: return getView(v).worldOrigin();
      case 1: return getView(v).worldLT();
      case 2: return getView(v).worldLB();
      case 3: return getView(v).worldRT();
      case 4: return getView(v).worldRB();
      case 5: return getView(v).worldCT();
      case 6: return getView(v).worldCB();
      case 7: return getView(v).worldLC();
      case 8: return getView(v).worldRC();
    }
    crowbar.errorMessage("\u30b7\u30b9\u30c6\u30e0\u30a8\u30e9\u30fc", "_world()\u306e\u30dd\u30b8\u30b7\u30e7\u30f3\u6307\u793a\u304c\u7570\u5e38\u3067\u3059", str(pos), true);
    return null;
  }
  public viewportClass _world(int v, float ratio, int pos) {
    if (isValidViewNumber(v) == false) {
      crowbar.errorMessage("\u30a8\u30e9\u30fc", "_world()\u3067\u6307\u5b9a\u3055\u308c\u305f\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u304c\u4e0d\u6b63", str(v), true);
      return null;
    }
    switch (pos) {
      case 0: return getView(v).worldOrigin(ratio);
      case 1: return getView(v).worldLT(ratio);
      case 2: return getView(v).worldLB(ratio);
      case 3: return getView(v).worldRT(ratio);
      case 4: return getView(v).worldRB(ratio);
      case 5: return getView(v).worldCT(ratio);
      case 6: return getView(v).worldCB(ratio);
      case 7: return getView(v).worldLC(ratio);
      case 8: return getView(v).worldRC(ratio);
    }
    crowbar.errorMessage("\u30b7\u30b9\u30c6\u30e0\u30a8\u30e9\u30fc", "_world()\u306e\u30dd\u30b8\u30b7\u30e7\u30f3\u6307\u793a\u304c\u7570\u5e38\u3067\u3059", str(pos), true);
    return null;
  }
  // (a) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u592e\u3092\u539f\u70b9
  public viewportClass worldOrigin(int v)                     { return _world(v, 0); }
  public viewportClass worldOrigin(int v, float ratio)        { return _world(v, ratio, 0); }
  public viewportClass worldOrigin(String label)              { return worldOrigin(getViewNumber(label)); }
  public viewportClass worldOrigin(String label, float ratio) { return worldOrigin(getViewNumber(label), ratio); }
  public viewportClass worldOrigin()                          { return worldOrigin(cvNumber); }
  public viewportClass worldOrigin(float ratio)               { return worldOrigin(cvNumber, ratio); }
  // (b) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5de6\u4e0a\u3092\u539f\u70b9
  public viewportClass worldLT(int v)                     { return _world(v, 1); }
  public viewportClass worldLT(int v, float ratio)        { return _world(v, ratio, 1); }
  public viewportClass worldLT(String label)              { return worldLT(getViewNumber(label)); }
  public viewportClass worldLT(String label, float ratio) { return worldLT(getViewNumber(label), ratio); }
  public viewportClass worldLT()                          { return worldLT(cvNumber); }
  public viewportClass worldLT(float ratio)               { return worldLT(cvNumber, ratio); }
  // (c) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5de6\u4e0b\u3092\u539f\u70b9
  public viewportClass worldLB(int v)                     { return _world(v, 2); }
  public viewportClass worldLB(int v, float ratio)        { return _world(v, ratio, 2); }
  public viewportClass worldLB(String label)              { return worldLB(getViewNumber(label)); }
  public viewportClass worldLB(String label, float ratio) { return worldLB(getViewNumber(label), ratio); }
  public viewportClass worldLB()                          { return worldLB(cvNumber); }
  public viewportClass worldLB(float ratio)               { return worldLB(cvNumber, ratio); }
  // (d) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u53f3\u4e0a\u3092\u539f\u70b9
  public viewportClass worldRT(int v)                     { return _world(v, 3); }
  public viewportClass worldRT(int v, float ratio)        { return _world(v, ratio, 3); }
  public viewportClass worldRT(String label)              { return worldRT(getViewNumber(label)); }
  public viewportClass worldRT(String label, float ratio) { return worldRT(getViewNumber(label), ratio); }
  public viewportClass worldRT()                          { return worldRT(cvNumber); }
  public viewportClass worldRT(float ratio)               { return worldRT(cvNumber, ratio); }
  // (e) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u53f3\u4e0b\u3092\u539f\u70b9
  public viewportClass worldRB(int v)                     { return _world(v, 4); }
  public viewportClass worldRB(int v, float ratio)        { return _world(v, ratio, 4); }
  public viewportClass worldRB(String label)              { return worldRB(getViewNumber(label)); }
  public viewportClass worldRB(String label, float ratio) { return worldRB(getViewNumber(label), ratio); }
  public viewportClass worldRB()                          { return worldRB(cvNumber); }
  public viewportClass worldRB(float ratio)               { return worldRB(cvNumber, ratio); }
  // (f) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u592e\u4e0a\u3092\u539f\u70b9
  public viewportClass worldCT(int v)                     { return _world(v, 5); }
  public viewportClass worldCT(int v, float ratio)        { return _world(v, ratio, 5); }
  public viewportClass worldCT(String label)              { return worldCT(getViewNumber(label)); }
  public viewportClass worldCT(String label, float ratio) { return worldCT(getViewNumber(label), ratio); }
  public viewportClass worldCT()                          { return worldCT(cvNumber); }
  public viewportClass worldCT(float ratio)               { return worldCT(cvNumber, ratio); }
  // (g) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e2d\u592e\u4e0b\u3092\u539f\u70b9
  public viewportClass worldCB(int v)                     { return _world(v, 6); }
  public viewportClass worldCB(int v, float ratio)        { return _world(v, ratio, 6); }
  public viewportClass worldCB(String label)              { return worldCB(getViewNumber(label)); }
  public viewportClass worldCB(String label, float ratio) { return worldCB(getViewNumber(label), ratio); }
  public viewportClass worldCB()                          { return worldCB(cvNumber); }
  public viewportClass worldCB(float ratio)               { return worldCB(cvNumber, ratio); }
  // (h) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5de6\u4e2d\u592e\u3092\u539f\u70b9
  public viewportClass worldLC(int v)                     { return _world(v, 7); }
  public viewportClass worldLC(int v, float ratio)        { return _world(v, ratio, 7); }
  public viewportClass worldLC(String label)              { return worldLC(getViewNumber(label)); }
  public viewportClass worldLC(String label, float ratio) { return worldLC(getViewNumber(label), ratio); }
  public viewportClass worldLC()                          { return worldLC(cvNumber); }
  public viewportClass worldLC(float ratio)               { return worldLC(cvNumber, ratio); }
  // (i) \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u53f3\u4e2d\u592e\u3092\u539f\u70b9
  public viewportClass worldRC(int v)                     { return _world(v, 8); }
  public viewportClass worldRC(int v, float ratio)        { return _world(v, ratio, 8); }
  public viewportClass worldRC(String label)              { return worldRC(getViewNumber(label)); }
  public viewportClass worldRC(String label, float ratio) { return worldRC(getViewNumber(label), ratio); }
  public viewportClass worldRC()                          { return worldRC(cvNumber); }
  public viewportClass worldRC(float ratio)               { return worldRC(cvNumber, ratio); }
  
  // \u3010\u5909\u66f4\u3011\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u306e\u30aa\u30d5\u30bb\u30c3\u30c8\u91cf\u3068\u30d4\u30af\u30bb\u30eb\u6bd4\u3092\u6307\u5b9a
  // \u3064\u307e\u308a\u3053\u306e\u6307\u5b9a\u3057\u305f\u5ea7\u6a19\u304c\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e2d\u592e\u306b\u8868\u793a\u3055\u308c\u308b\u3088\u3046\u306b\u30de\u30c3\u30d4\u30f3\u30b0\u3055\u308c\u308b
  /// \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u6307\u5b9a
  public viewportClass worldCenter(int v, float x, float y) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).worldCenter(x, y);
  }
  public viewportClass worldCenter(int v, float x, float y, float ratio) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).worldCenter(x, y, ratio);
  }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a
  public viewportClass worldCenter(String label, float x, float y)              { return worldCenter(getViewNumber(label), x, y); }
  public viewportClass worldCenter(String label, float x, float y, float ratio) { return worldCenter(getViewNumber(label), x, y, ratio); }
  // \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public viewportClass worldCenter(float x, float y)              { return worldCenter(cvNumber, x, y); }
  public viewportClass worldCenter(float x, float y, float ratio) { return worldCenter(cvNumber, x, y, ratio); }

  // \u3010\u5909\u66f4\u3011\u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19\u3092\uff58\u8ef8\uff0c\uff59\u8ef8\u65b9\u5411\u306b\u76f8\u5bfe\u7684\u306b\u52d5\u304b\u3059\uff08\u30d4\u30af\u30bb\u30eb\u6bd4\u306f\u5909\u66f4\u3057\u306a\u3044\uff09
  // (e-1) \uff58\uff59\u8ef8\u540c\u6642\u306b\u52d5\u304b\u3059
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u6307\u5b9a
  public viewportClass worldMove(int v, float dx, float dy) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).worldMove(dx, dy);
  }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a
  public viewportClass worldMove(String label, float dx, float dy) { return worldMove(getViewNumber(label), dx, dy); }
  // \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public viewportClass worldMove(float dx, float dy)               { return worldMove(cvNumber, dx, dy); }
  // (e-2) \uff58\u8ef8\u65b9\u5411\u306b\u52d5\u304b\u3059
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u6307\u5b9a
  public viewportClass worldMoveX(int v, float dx)                 { return worldMoveX(v, dx); }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a
  public viewportClass worldMoveX(String label, float dx)          { return worldMoveX(getViewNumber(label), dx); }
  // \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public viewportClass worldMoveX(float dx)                        { return worldMoveX(cvNumber, dx); }
  // (e-3) \uff59\u8ef8\u65b9\u5411\u306b\u52d5\u304b\u3059
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u756a\u53f7\u3092\u6307\u5b9a
  public viewportClass worldMoveY(int v, float dy)                 { return worldMoveY(v, dy); }
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u30e9\u30d9\u30eb\u3092\u6307\u5b9a
  public viewportClass worldMoveY(String label, float dy)          { return worldMoveY(getViewNumber(label), dy); }
  // \u73fe\u5728\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u5b9a
  public viewportClass worldMoveY(float dy)                        { return worldMoveY(cvNumber, dy); }

  // --------------------------------------------------
  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u8868\u793a\uff0f\u975e\u8868\u793a\u306e\u30c0\u30a4\u30ca\u30df\u30c3\u30af\u306a\u5207\u308a\u66ff\u3048
  // --------------------------------------------------
  // \u72b6\u614b
  public boolean isViewVisible(int v) {
    if (isValidViewNumber(v) == false) return false;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).isViewVisible();
  }
  public boolean isViewVisible(String label) { return isViewVisible(getViewNumber(label)); }
  public boolean isViewVisible()             { return isViewVisible(cvNumber); }
  // (a) \u8868\u793a
  public viewportClass viewVisible(int v) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewVisible();
  }
  public viewportClass viewVisible(String label) { return viewVisible(getViewNumber(label)); }
  public viewportClass viewVisible()             { return viewVisible(cvNumber); }
  // (b) \u975e\u8868\u793a
  public viewportClass viewUnvisible(int v) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).viewUnvisible();
  }
  public viewportClass viewUnvisible(String label) { return viewUnvisible(getViewNumber(label)); }
  public viewportClass viewUnvisible()             { return viewUnvisible(cvNumber);             }
  // (c) \u5f15\u6570\u306b\u3088\u308b\u6307\u5b9a
  public viewportClass viewVisible(int v, boolean flag) {
    if (isValidViewNumber(v) == false) return null;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    if (flag) return viewVisible(v); else return viewUnvisible(v);
  }
  public viewportClass viewVisible(String label, boolean flag) { return viewVisible(getViewNumber(label), flag); }
  public viewportClass viewVisible(boolean flag)               { return viewVisible(cvNumber, flag); }
  // (d) \u30c8\u30b0\u30eb\u52d5\u4f5c\uff08\u5909\u66f4\u5f8c\u306e\u72b6\u614b\u3092\u8fd4\u3059\uff09
  public boolean toggleViewVisible(int v) {
    if (isValidViewNumber(v) == false) return false;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).toggleViewVisible();
  }
  public boolean toggleViewVisible(String label) { return toggleViewVisible(getViewNumber(label)); }
  public boolean toggleViewVisible()             { return toggleViewVisible(cvNumber); }
  // (e) \u5909\u66f4\u524d\u306e\u5024\u3092\u8fd4\u3059
  public boolean setViewVisible(int v, boolean flag) {
    if (isValidViewNumber(v) == false) return false;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    boolean oldflag = isViewVisible(v);
    if (flag) viewVisible(v); else viewUnvisible(v);
    return oldflag;
  }
  public boolean setViewVisible(String label, boolean flag) { return setViewVisible(getViewNumber(label), flag); }
  public boolean setViewVisible(boolean flag)               { return setViewVisible(cvNumber, flag); }

  // --------------------------------------------------------
  // \u30de\u30a6\u30b9\u306b\u3088\u308b\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u5185\u30af\u30ea\u30c3\u30af\u306b\u5bfe\u3059\u308b\u30ec\u30b9\u30dd\u30f3\u30b9\u95a2\u4fc2
  // --------------------------------------------------------
  // (a) \u30de\u30a6\u30b9\u30dd\u30a4\u30f3\u30bf\u30fc\u304c\u3053\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u4e0a\u306b\u3042\u308b\u304b\uff1f\uff08\u4e0a\u306b\u5225\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u304c\u91cd\u306a\u3063\u3066\u3044\u308b\u304b\u3069\u3046\u304b\u306f\u6c17\u306b\u3057\u306a\u3044\uff0e\u30af\u30ea\u30c3\u30af\u3055\u308c\u305f\u304b\u3069\u3046\u304b\u3082\u95a2\u4fc2\u306a\u3044\uff09
  //     \u30af\u30ea\u30c3\u30af\u3055\u308c\u305f\u304b\u3069\u3046\u304b\u306fuserClicked()\u3067\u30a4\u30d9\u30f3\u30c8\u99c6\u52d5\u306b\u3059\u308b\uff0e
  public boolean mouseover(int v) {
    if (isValidViewNumber(v) == false) return false;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).mouseover();
  }
  public boolean mouseover(String label) { return mouseover(getViewNumber(label)); }
  public boolean mouseover()             { return mouseover(cvNumber);            }
  // (b) \u30de\u30a6\u30b9\u30dd\u30a4\u30f3\u30bf\u30fc\u306e\u5ea7\u6a19\u3092\u8fd4\u3057\u307e\u3059\uff0e\u9818\u57df\u5916\u3067\u3042\u3063\u3066\u3082\u8fd4\u3057\u307e\u3059\uff08\u8ca0\u306e\u5024\u3092\u8fd4\u3059\u5834\u5408\u3082\u3042\u308a\u307e\u3059\uff09\uff0e
  // (b-1) \u30d4\u30af\u30bb\u30eb\u5ea7\u6a19
  public int _viewMouseX(int v) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v)._viewMouseX();
  }
  public int _viewMouseX(String label) { return _viewMouseX(getViewNumber(label)); }
  public int _viewMouseX()             { return _viewMouseX(cvNumber);             }
  public int _viewMouseY(int v) {
    if (isValidViewNumber(v) == false) return -1;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v)._viewMouseY();
  }
  public int _viewMouseY(String label) { return _viewMouseY(getViewNumber(label)); }
  public int _viewMouseY()             { return _viewMouseY(cvNumber);             }
  // (b-2) \u30ef\u30fc\u30eb\u30c9\u5ea7\u6a19
  public float viewMouseX(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).rpx(_viewMouseX(v));
  }
  public float viewMouseX(String label) { return viewMouseX(getViewNumber(label)); }
  public float viewMouseX()             { return viewMouseX(cvNumber);             }
  public float viewMouseY(int v) {
    if (isValidViewNumber(v) == false) return 0.0f;  // \u4e0d\u6b63\u306a\u30d3\u30e5\u30fc\u756a\u53f7
    return getView(v).rpy(_viewMouseY(v)); 
  }
  public float viewMouseY(String label) { return viewMouseY(getViewNumber(label)); }
  public float viewMouseY()             { return viewMouseY(cvNumber);             }
  // \u4e0e\u3048\u3089\u308c\u305f\u5ea7\u6a19\uff08\u30de\u30a6\u30b9\u30af\u30ea\u30c3\u30af\u306a\u3069\uff09\u306f\u3069\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u6307\u3057\u3066\u3044\u308b\u306e\u304b\uff1f
  // \uff08\u3069\u306e\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3082\u542b\u307e\u308c\u306a\u3044\u306a\u3089\u3070-1\uff09
  // trans == true \u306e\u5834\u5408\u306f\u80cc\u666f\u304c\u900f\u660e\u306a\u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u3092\u7121\u8996\u3059\u308b
  public int detectActiveView()             { return detectActiveView(mouseX, mouseY, true); }
  public int detectActiveView(int x, int y) { return detectActiveView(x, y, true); }
  public int detectActiveView(int x, int y, boolean trans) {
    int [] order = getViewOrderList();
    int x1, y1, x2, y2;
    viewportClass vp;
    for (int i = viewMax - 1; i >= 0; i--) {
      vp = viewStack[order[i]];
      if (vp.isViewVisible() == false) continue;  // \u975e\u8868\u793a\u306f\u7121\u8996
      if (vp.transparency == 0)        continue;  // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u4e0d\u900f\u660e\u5ea6\u304c\u30bc\u30ed\u3082\u7121\u8996
      // \u30d3\u30e5\u30fc\u30dd\u30fc\u30c8\u306e\u80cc\u666f\u304c\u900f\u660e
      if (vp.transparentView == true) {
        if (trans == true) continue;
        int col = vp.pg.get(x - vp.vx, y - vp.vy);
        if ((col & 0x0ff000000) == 0) continue;  // \u3082\u3057\u63cf\u753b\u3055\u308c\u3066\u3044\u306a\u3044\u306a\u3089\u3070\u7121\u8996
      }
      x1 = vp.vx;
      y1 = vp.vy;
      x2 = x1 + vp.width;
      y2 = y1 + vp.height;
      if ((x1 <= x) && (x <= x2) && (y1 <= y) && (y <= y2)) return order[i];
    }
    return -1;
  }

// =========================================================================================================

  // -----------------------------------------------
  // \u30d3\u30e5\u30fc\u306e\u5408\u6210\uff08crowbarClass.pde\u306edraw()\u306b\u3066\u4f7f\u7528\uff09
  // -----------------------------------------------
  public void refreshView() {
    if (tomahawkMode == 0) return;
//  if (tomahawkMode == 2) background(_BGCOLOR);
    if (crowbar.status == 10) {
      // \u30d3\u30e5\u30fc\u306e\u5408\u6210
      int i;
      int [] order = getViewOrderList();
      // \u8868\u793a\u9806\u306e\u30ea\u30b9\u30c8\u4f5c\u6210\uff08\u304d\u3061\u3093\u3068\u6b20\u756a\uff0c\u91cd\u8907\u306a\u304f\u4e26\u3093\u3067\u3044\u308b\u3053\u3068\u306f\u4e0a\u4e0b\u95a2\u4fc2\u306e\u64cd\u4f5c\u6642\u306b\u78ba\u8a8d\u6e08\u307f\u3068\u3044\u3046\u524d\u63d0\uff09
      viewportClass vp;
      for (i = 0; i < viewMax; i++) {
        vp = viewStack[order[i]];
        if (vp.isViewVisible() == false) continue;
        if (vp.drawFrame) {
          vp.pg.endDraw();
          vp.pg.beginDraw();
          vp.pg.noFill();
          vp.pg.stroke(vp.frameColor, 255);
          vp.pg.strokeWeight(vp.frameWidth);
          vp.pg.rectMode(CORNER);
          vp.pg.rect(vp.frameWidth / 2, vp.frameWidth / 2, vp.width - vp.frameWidth, vp.height - vp.frameWidth);
          vp.pg.stroke(vp.cdSet.strokeColor, vp.cdSet.strokeTrans);
          vp.pg.strokeWeight(vp.cdSet.strokeWeight);
        }
        vp.pg.endDraw();
        blend(vp.pg, 0, 0, vp.width, vp.height, vp.vx, vp.vy, vp.width, vp.height, BLEND);
      }
    }
    if (tomahawkMode == 2) blend(crowbar.screenSetting.pgText, 0, 0, crowbar.screenSetting.gwx, crowbar.screenSetting.gwy, 0, 0, crowbar.screenSetting.gwx, crowbar.screenSetting.gwy, BLEND);
  }
}


  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "RE_Decoder" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
